<?php
/** pavel.rudol 9.4.2020 */

namespace RonPortal\Sklad;

use Exception;
use Ron\Http\HtmlHeaders;
use RonPortal\RonPortalSettings;
use RonPortal\RonPortalUtils;
use Ron\StringUtils;
use Ron\TextManager;

class NovaObjednavkaController extends ObjednavkyController
{
    public function handleAction($action)
    {
        TextManager::getInstance()->loadStrings('sklad.ini');
        HtmlHeaders::getInstance()
            ->addCss('css/sklad.css')
            ->addScript('script/sklad.js');

        if (!$this->jePravo())
            RonPortalUtils::neniPravoException();

        if (!RonPortalSettings::getIntValue('vydanaobjednavka_filtrovat_stredisko_tr'))
            throw new Exception(StringUtils::fromUTF8('Není nastaven typ rozdělení pro filtrování středisek objednávky!'));


        return $this->formularObjednavky('new');
    }

}

return new NovaObjednavkaController($this->database);