<?php
/**
 * stanislav.elbl, 25.01.2021
 */

namespace RonPortal\Common;

use Exception;
use Ron\Controls\Browser;
use Ron\DB\Database;
use Ron\MessageManager;
use Ron\MVC\BrowserController;
use Ron\MVC\DialogPartialView;
use Ron\MVC\HttpController;
use Ron\MVC\JsonController;
use Ron\MVC\JsonOutputObject;
use Ron\MVC\PartialView;
use Ron\StringUtils;
use Ron\TextManager;
use RonPortal\NeniPravoException;
use RonPortal\Prava;

//class PoznamkyKeDniController extends JsonController
//{
//    /** @var Database */
//    public $database;
//
//    /**
//     * PoznamkyKeDniController constructor.
//     * @param Database $database
//     */
//    public function __construct($database)
//    {
//        $this->database = $database;
//    }
//
//
//    /**
//     * @param JsonOutputObject $output
//     * @throws Exception
//     */
//    private function loadData($output)
//    {
//        $form = new PoznamkyKeDniFormular($this ->database);
//        $output ->addData('data', $form ->getJsonData());
//    }
//
//
//    /**
//     * @param JsonOutputObject $output
//     * @throws Exception
//     */
//    private function storeData($output)
//    {
//        $form = new PoznamkyKeDniFormular($this ->database);
//        $form ->utf8 = true;
//        $form ->handleAction();
//
//        $output ->addMessages(MessageManager::getInstance());
//    }
//
//
//    /**
//     * @throws Exception
//     */
//    public function handleJsonAction($action, $output)
//    {
//        switch ($_GET['action']) {
//            case 'loaddata' :
//                $this ->loadData($output);
//                break;
//
//            case 'storedata' :
//                $this ->storeData($output);
//                break;
//        }
//    }
//
//
//    /**
//     * @throws NeniPravoException
//     * @throws Exception
//     */
//    public function handleAction($action)
//    {
//        TextManager::getInstance() ->loadStrings('dochazka.ini');
//        if (!Prava::jsouNejakePrava('poznamkykedni')) {
//            throw new NeniPravoException();
//        }
//
//        if (isset($_GET['action'])) {
//            return parent::handleAction($action);
//        }
//
//        if (isset($_GET['record'])) {
//            $form = new PoznamkyKeDniFormular($this ->database);
//            $form ->loadData(false);
//            return new DialogPartialView($form);
//        }
//
//        $result = new PoznamkyKeDniBrowser($this ->database, 'poznamkykedni');
//        $result ->load();
//        return $result;
//    }
//}

//return new PoznamkyKeDniController($this ->database);

class PoznamkyKeDniController extends BrowserController
{
    public function __construct($database)
    {
        parent::__construct($database, 'poznamkykedni');
    }

    function createBrowser()
    {
        return new PoznamkyKeDniBrowser($this ->database, $this ->action);
    }


    function createForm($formAction = 'new')
    {
        return new PoznamkyKeDniFormular($this ->database, $formAction);
    }


    public function handleAction($action)
    {
        if (!Prava::jsouNejakePrava('poznamkykedni')) {
            throw new NeniPravoException();
        }

        TextManager::getInstance() ->loadStrings('dochazka.ini');

        return parent::handleAction($action);
    }
}


return new PoznamkyKeDniController($this ->database);

//return new BrowserController(
//    $this ->database,
//    'poznamkykedni',
//    function() {
//        ;
//    },
//    function($formAction = 'new') {
//        return new PoznamkyKeDniFormular($this ->database, $formAction);
//    }
//);
