<?php

namespace RonPortal;

use Ron\MVC\Controller;
use Ron\MVC\Redirect;

class RedirectController implements Controller
{

//    private function getKey()
//    {
//        if (isset($_POST['kod_karty'])) {
//            $id = $_POST['kod_karty'];
//            $salt = bin2hex(random_bytes(8));
//            $timeStr = date('Y-m-d H:i:s');
//
////        // verze bez sifrovani
////        $hashText = "$id;$timeStr;$salt";
////        $hash = sha1($hashText);
////        header("Location: app.php?idlogin={$id}&time={$timeStr}&salt={$salt}&key={$hash}");
//
//            // verze se sifrovanim
//            $encodeText = "{$id};{$timeStr};{$salt}";
//            $urlText = urlencode(openssl_encrypt($encodeText, 'AES-128-CTR', 'blabla$ble4x'));
//            header("Location: app.php?idlogin={$urlText}&session@lang={$_POST['lang']}");
//
//
//    }


    private function getUrlParams($loginOptions)
    {
        $salt = bin2hex(random_bytes(8));
        $id = User::getLoginName();
        $timeStr = date('Y-m-d H:i:s');

        $hashKey = Security::getIdLoginHashKey($loginOptions, $id, $timeStr, $salt);
//var_dump($loginOptions);
        if ($loginOptions['passphrase'] ?? false) {
            // data budou zasifrovana
            $encodeText = "{$id};{$timeStr};{$salt};{$hashKey}";

            return  "idlogin=" . urlencode(openssl_encrypt(
                    $encodeText,
                    $loginOptions['cipher_algo'] ?? 'AES-128-CBC',
                    $loginOptions['passphrase'],
                    0,
                    $loginOptions['iv'] ?? ''));
        } else {
            return "idlogin={$id}&time={$timeStr}&salt={$salt}&key={$hashKey}";
        }
    }


    public function handleAction($action)
    {
        if (User::isLoggedAs()) { // nelze pouzivat pri "prihlaseni jako"
            throw new NeniPravoException();
        }

        $extApps = require ("_extapps.php");
        $app = $extApps[$_GET['appid']] ?? null;

        if (!$app) {
            throw new \Exception("Neplatny kod aplikace!");
        }

        if (!$app['url']) {
            throw new \Exception("Neni zadana URL aplikace!");
        }

//        if (!$app['idLoginOptions']) {
//            throw new \Exception("Nejsou zadany parametry idLoginOptions!");
//        }

//        $this->getUrlParams($app['idLoginOptions']);
//        die();
        return new Redirect($app['url'] . $this->getUrlParams($app['idLoginOptions']));
    }
}

return new RedirectController();

/*
        if ($idloginOptions['passphrase'] ?? false) {
            // data jsou zasifrovana, tj. url parametr id obsahuje base64 retezec ve formatu <id>;<time>
            $data = openssl_decrypt($id,
                $idloginOptions['cipher_algo'] ?? 'AES-128-CBC',
                $idloginOptions['passphrase'],
                0,
                $idloginOptions['iv'] ?? ''
            );

            $items = explode($idloginOptions['separator'] ?? ';', $data);

            $id = $items[0] ?? '';
            $timeStr = $items[1] ?? '';
            $salt = $items[2] ?? '';
            $key = $items[3] ?? '';
        } else {
            $timeStr = $_GET['time'] ?? '';
            $salt = $_GET['salt'] ?? '';
            $key = $_GET['key'] ?? '';
        }

 */
