<?php
/**
 * stanislav.elbl, 12.11.2018
 */

namespace RonPortal\System;

use Ron\MVC\JsonController;
use Ron\MVC\JsonOutputObject;
use Ron\StringUtils;

class TaskController extends JsonController
{

    /**
     * @param JsonOutputObject $output
     * @param string $taskId
     * @throws \Exception
     */
    function getTaskStatus($output, $taskId)
    {
        $task = TaskManager::getInststance()->findTask($taskId);

        if (!$task) {
            throw new \Exception("Proces se zadanym ID nebyl nalezen!");
        }

        if ($task ->isRunning) {
            TaskManager::getInststance() ->updateTask($task);
        }

        $taskResult = [
            'isRunning' => $task ->isRunning ? 1 : 0,
            'abortAvailable' => $task ->abortAvailable ? 1 : 0,
            'progressMax' => $task ->progressMax,
            'progressCurrent' => $task ->progressCurrent,
            'progressMessage' => StringUtils::jsonText($task ->progressMessage),
            'errorMessage' => StringUtils::jsonText($task ->errorMessage)
        ];

        $output ->addData('tasks', [$taskId => $taskResult]);
    }


    function handleJsonAction($action, $output)
    {
        if ($_GET['taskId'] ?? null) {
            $this ->getTaskStatus($output, $_GET['taskId']);
        }
    }
}

return new TaskController();
