<?php
/**
 * stanislav.elbl, 02.06.2017
 */

namespace RonPortal;

use Ron\MVC\Model;
use Ron\MVC\Redirect;
use Ron\DB\Database;
use RonPortal\XML\RonPortalXMLForm;
use RonPortal\XML\XMLFormController;
use RonPortal\XML\XMLFormViewObject;


/**
 * Controller obsluhuje zobrazeni xml formulare bez prihlaseni (menuid=xmllogin)
 * Formular musi mit popis LOGIN_PAGE....
 */
class LoginXmlFormController extends XMLFormController
{
    /**
     * LoginXMLFormController constructor.
     * @param Database $database
     */
    public function __construct(Database $database)
    {
        parent::__construct($database);

        $this->database = $database;
        $this->enableAccessWithoutLogin = true;
    }


    function processXml()
    {
        if (!isset($_POST['ronxmlform'])  ||  !$_POST['ronxmlform']) {
            return new Redirect(null, '?menuid=xmllogin&record=' . $_GET['record']);
        }

        $xmlForm = new RonPortalXMLForm($this->database);

        $xmlForm->nactiOdeslanyFormular();
        $xmlForm->loadXML(); // vytvori elementy
        $xmlForm->process();

        if ($xmlForm->isError()) {
            $viewObject = new XMLFormViewObject($xmlForm);
            $viewObject ->loadHtml();
            Model::addViewObject($viewObject);
            // zobrazeni bez menu atd.
            return 'view/appview_frame.php';
        }

        if ($xmlForm->redirect) {
            return $xmlForm->redirect;
        }

        return new Redirect(null, '?menuid=xmllogin&record=' . $xmlForm ->idSablony);
    }


    public function handleAction($action)
    {
        //if (isset($_POST['xmlaction'])  &&  $_POST['xmlaction'] == 'submit') {
        if (isset($_POST['xmlaction'])  &&  $_POST['xmlaction']) {
            return $this ->processXml();
        }

        if (isset($_GET['action'])  &&  $_GET['action'] == 'process') {
            return $this ->processXml();
        }

        global $login_xml_id; // pouzije se pri internal redirect z LoginController::loginPage
        $xmlId = $_GET['record'] ?? $login_xml_id;

        $result = XMLFormViewObject::zobrazXmlSablonu($this ->database, (int)$xmlId);
        if (is_string($result)) return $result;

        //Model::addViewObject(XMLFormViewObject::zobrazXmlSablonu($this ->database, (int)$xmlId));
        Model::addViewObject($result);

        // zobrazeni bez menu atd.
        return 'view/appview_frame.php';
    }
}


return new LoginXmlFormController($this ->database);
