<?php

/**
 * Nastaveni autimatickeho prihlasovani proklikem z jednoho Portalu do jineho
 *
 * Odkaz na jiny Portal se pak vlozi napr do XML formulare takto:
 *   <a href="?menuid=redirect&appid=ronportal2">RonPortal 2</a>
 * V appid je kod portalu (viz nize)
 */


return [
    // nastaveni pro konkretni portal, do ktereho se ma prihlasovat - musi byt stejne jako nastaveni prihlasovani v prislusnem portalu
    // indexy v poli jsou kody, ktere se pouziji v URL adrese (viz ukazka URL nahore)
    'ronportal2' => [
        'url' => 'http://localhost/ronportal2/index.php?',  // url musi koncit znakem ? nebo & (na konec se pridaji dalsi parametry)
        'idLoginOptions' => [
            'passphrase' => '................', // 16 znaku
            'cipher_algo' => 'AES-128-CBC',     // lze pouzit i jiny algoritmus - v tom pripade ale mohou platit jina pravidla pro heslo a iv
            'iv' => '................',         // 16 znaku
        ]
    ],

    // stejnym zpusobem lze pridat dalsi ...
    'ronportal3' => [
        'url' => 'http://localhost/ronportal3/index.php?',
        'idLoginOptions' => [
            'passphrase' => '................',
            'cipher_algo' => 'AES-128-CBC',
            'iv' => '................',
        ]
    ],
];