<?php
/** Roman.Szablatura 29.3.2016 */

namespace RonPortal\Settings;

use Ron\Controls\Preference;


return [
    'caption' => 'nastaveni_personalistiky',
    'category' => 'nastaveni_sekce_personalistika',
    'name'  => 'personalistika',
    'index' => 300,
    'storage' => 'nastaveniPersonalistiky',
    'strings' => 'preferences_personalistika.ini',
    'items' =>
        [
            [
                'type'  => Preference::CATEGORY,    'title' => 'personalni_agendy'
            ],

            [
                'name'  => 'person_pocet_mesicu_dopredu', 'type'  => Preference::TEXT,    'title' => 'personalni_agendy_pocet_mesicu',
                'defaultValue' => 0,
                'infoText' => 'personalni_agendy_pocet_mesicu_info'
            ],
            [
                'type'  => Preference::CATEGORY,    'title' => 'lekarske_prohlidky'
            ],
            [
                'name'  => 'lekprohl_typdokumentu', 'type'  => Preference::SQL_COMBOBOX,    'title' => 'typ_dokumentu',
                'sql'   => 'SELECT Kod, Popis FROM TypDokumentu WHERE KategorieDokumentu = 3 ORDER BY Kod',
                'defaultValue' => ''
            ],
            [
                'name'  => 'lekprohl_poznamka', 'type'  => Preference::CHECKBOX,    'title' => 'Poznamka',
                'defaultValue' => 0,
                'infoText' => 'lekprohl_poznamka_info'
            ],
            [
                'name'  => 'lekprohl_doplnujici_text', 'type'  => Preference::CHECKBOX,    'title' => 'doplnujici_text_pozvanky',
                'defaultValue' => 0,
                'infoText' => 'lekprohl_dop_text_pozvanky_info'
            ],
            [
                'name'  => 'lekprohl_vysledek_prohlidky', 'type'  => Preference::CHECKBOX,    'title' => 'vysledek_prohlidky',
                'defaultValue' => 0,
                'infoText' => 'lekprohl_vysledek_prohlidky_info'
            ],
            [
                'name'  => 'lekprohl_rezervovany', 'type'  => Preference::CHECKBOX,    'title' => 'rezervovany_cas_prohlidky',
                'defaultValue' => 0,
                'infoText' => 'lekprohl_rezervovany_cas_prohlidky_info'
            ],
            [
                'name' => 'otevreni_detailu', 'type' => Preference::COMBOBOX,   'title' => 'otevreni_detailu',
                'options' => [ 0 => 'odkaz_otevrit_zde', 1 => 'odkaz_otevrit_v_novem_panelu'],
                'defaultValue' => '0',
                'infoText' => 'otevreni_detailu_info'
            ],

            [
                'type'  => Preference::CATEGORY,    'title' => 'ukoly'
            ],
            [
                'name' => 'urovne_schvalovani', 'type' => Preference::COMBOBOX,   'title' => 'Nastaveni_urovne_schvalovani',
                'options' => [ 0 => 'bez_schvalovani', 1 => 'zobrazit_1_uroven_schvalovani', 2 => 'zobrazit_2_uroven_schvalovani'],
                'defaultValue' => '0',
                'infoText' => 'zobrazeni_urovne_schvalovani_detailu'
            ],

            [
                'name'  => 'typ_tlacitka', 'type'  => Preference::CHECKBOX,    'title' => 'zmena_funkce_OK',
                'defaultValue' => 0,
                'infoText' => 'zmena_funkce_OK_info'
            ],

            [
                'name'  => 'zobrazit_odmenu', 'type'  => Preference::CHECKBOX,    'title' => 'zobrazit_odmenu',
                'defaultValue' => 0,
                'infoText' => 'zobrazit_odmenu_info'
            ],

            [
                'name'  => 'zobrazit_body', 'type'  => Preference::CHECKBOX,    'title' => 'zobrazit_body',
                'defaultValue' => 0,
                'infoText' => 'zobrazit_body_info'
            ],

            [
                'type'  => Preference::CATEGORY,    'title' => 'dovednosti'
            ],
            [
                'type'  => Preference::INFO_TEXT,    'infoText' => 'dovednosti_zmena_nastaveni',

            ],

            // smaze stare nastaveni, ktere bylo puvodne v Personalistice
            [
                'name'  => 'nacistxmldomenu',      'type'  => Preference::DELETE
            ],

//            [
//                'name'  => 'dovednosti_typ_rozdeleni_filtr1', 'type'    => Preference::SQL_COMBOBOX, 'title' => 'dovednosti_typ_rozdeleni_filtr1',
//                'sql'   => 'SELECT Kod, Popis FROM TypRozdeleni WHERE Aktivni = 1 ORDER BY Kod',
//                'defaultValue' => '',
//                'infoText' => 'dovednosti_typ_rozdeleni_filtr1_info'
//            ],
//            [
//                'name'  => 'dovednosti_typ_rozdeleni_tpm', 'type'    => Preference::SQL_COMBOBOX, 'title' => 'dovednosti_typ_rozdeleni_tpm',
//                'sql'   => 'SELECT Kod, Popis FROM TypRozdeleni WHERE Aktivni = 1 AND VazbaNaTypRozdeleni IS NOT NULL AND TypRozdeleni.SynchronizovatPodleVazby = 0 ORDER BY Kod',
//                'defaultValue' => '',
//                'infoText'  => 'dovednosti_typ_rozdeleni_tpm_info'
//            ],
//
//            [
//                'name'  => 'dovednosti_sloupce_foto', 'type'    => Preference::COMBOBOX, 'title' => 'dovednosti_sloupce_foto',
//                'options' => [ 0 => 'dovednosti_sloupec_nezobrazovat', 1 => 'dovednosti_foto_info', 2 => 'dovednosti_foto_obrazek'],
//                'defaultValue' => '1',
//            ],
//            [
//                'name'  => 'dovednosti_sloupce_typ_pp', 'type'    => Preference::COMBOBOX, 'title' => 'dovednosti_sloupce_typ_pp',
//                'options' => [ 0 => 'dovednosti_sloupec_nezobrazovat', 1 => 'dovednosti_sloupec_kod',],
//                'defaultValue' => '1',
//            ],
//            [
//                'name'  => 'dovednosti_sloupce_prac_misto', 'type'    => Preference::COMBOBOX, 'title' => 'dovednosti_sloupce_prac_misto',
//                'options' => [ 0 => 'dovednosti_sloupec_nezobrazovat', 1 => 'dovednosti_sloupec_kod', 2 => 'dovednosti_sloupec_popis'],
//                'defaultValue' => '1',
//            ],
//            [
//                'name'  => 'dovednosti_sloupce_rozdeleni', 'type'    => Preference::COMBOBOX, 'title' => 'dovednosti_sloupce_rozdeleni',
//                'options' => [ 0 => 'dovednosti_sloupec_nezobrazovat', 1 => 'dovednosti_sloupec_kod', 2 => 'dovednosti_sloupec_popis'],
//                'defaultValue' => '1',
//            ],
//            [
//                'name'  => 'dovednosti_sloupce_kalendar', 'type'    => Preference::COMBOBOX, 'title' => 'dovednosti_sloupce_kalendar',
//                'options' => [ 0 => 'dovednosti_sloupec_nezobrazovat', 1 => 'dovednosti_sloupec_kod', 2 => 'dovednosti_sloupec_popis'],
//                'defaultValue' => '1',
//            ],
//            [
//                'name'  => 'dovednosti_sloupce_pritomnost', 'type'    => Preference::COMBOBOX, 'title' => 'dovednosti_sloupce_pritomnost',
//                'options' => [ 0 => 'dovednosti_sloupec_nezobrazovat', 1 => 'dovednosti_sloupec_zobrazovat'],
//                'defaultValue' => '0',
//            ],
//            [
//                'name'  => 'dovednosti_typ_zobrazeni_urovne', 'type'    => Preference::COMBOBOX, 'title' => 'dovednosti_typ_zobrazeni_urovne',
//                'options' => [ 0 => 'dovednosti_sloupec_kod', 1 => 'dovednosti_sloupec_popis'],
//                'defaultValue' => '0',
//            ],

            [
                'type'  => Preference::CATEGORY,    'title' => 'nahlasene_zmeny'
            ],
//            [  UPRAVA SE 28.5.2024 - upozorneni se zobrazuje vzdy
//                'name'  => 'zobrazit_upozorneni_uctu', 'type'  => Preference::CHECKBOX,    'title' => 'zobrazit_upozorneni_uctu',
//                'infoText' => 'zobrazit_upozorneni_uctu_info',
//                'defaultValue' => 0
//            ],
            [
                'name'  => 'hlaseni_zmeny_typdokumentu', 'type'  => Preference::SQL_COMBOBOX,    'title' => 'typ_dokumentu',
                'sql'   => 'SELECT Kod, Popis FROM TypDokumentu ORDER BY Kod',
                'defaultValue' => '0', // dokument
            ],
            [
                'type'  => Preference::CATEGORY,    'title' => 'skoleni'
            ],
            [
                'name'  => 'skoleni_zobrazit_obsah', 'type'  => Preference::CHECKBOX,    'title' => 'skoleni_zobrazit_obsah',
                'infoText' => 'skoleni_zobrazit_obsah_info',
                'defaultValue' => 0
            ],
            [
                'name'  => 'skoleni_zobrazit_poznamku', 'type'  => Preference::CHECKBOX,    'title' => 'skoleni_zobrazit_poznamku',
                'infoText' => 'skoleni_zobrazit_poznamku_info',
                'defaultValue' => 0
            ],
            [
                'name'  => 'skoleni_ponechat_navrh', 'type'  => Preference::CHECKBOX,    'title' => 'skoleni_ponechat_navrh',
                'infoText' => 'skoleni_ponechat_navrh_info',
                'defaultValue' => 0
            ],
            [
                'name'  => 'skoleni_typ_dokumentu', 'type'  => Preference::SQL_COMBOBOX,    'title' => 'typ_dokumentu',
                'sql'   => 'SELECT Kod, Popis FROM TypDokumentu WHERE KategorieDokumentu = 7 ORDER BY Kod',
                'defaultValue' => ''
            ],
        ]
];