<?php
/**
 * Created by PhpStorm.
 * User: pavel.rudol
 * Date: 29.3.2016
 * Time: 8:50
 */

namespace RonPortal\Settings;

use Ron\Controls\Preference;

return [
    'caption' => 'nastaveni_pokladnikniha',
    'category' => 'nastaveni_sekce_dalsi_agendy',
    'name'  => 'pokladnikniha',
    'index' => 701,
    'storage' => 'nastaveni',
    'strings' => 'pokladnikniha.ini',

    'items' =>
        [
            // typ dokumentu pro vkladane dokumenty
            [
                'name'  => 'poklk_typ_dokumentu', 'type'  => Preference::SQL_COMBOBOX,    'title' => 'PoklK_typ_dokumentu',
                'sql'   => 'SELECT Kod, Popis FROM TypDokumentu WHERE zobrazitNaIntrawebu = 1 ORDER BY popis', 'defaultValue' => 0
            ],

            // kontrolovat casovou posloupnost schvaleni
            [
                'name'  => 'poklk_posloupnost_schvalovani', 'type'  => Preference::CHECKBOX,    'title' => 'PoklK_posloupnost_schvalovani',
                'defaultValue' => 0
            ],
            // pouzivat vraceni
            [
                'name'  => 'poklk_pouzivat_vraceni', 'type'  => Preference::CHECKBOX,    'title' => 'PoklK_pouzivat_vraceni',
                'defaultValue' => 0
            ],

            // vychozi mena
            [
                'name'  => 'poklk_vychozi_mena', 'type'  => Preference::SQL_COMBOBOX,    'title' => 'PoklK_vychozi_mena',
                'sql'   => 'SELECT Mena.KodISO, Mena.KodISO FROM Mena WHERE Mena.Aktivni = 1'
            ],
            // rozdeleni
            [
                'type'  => Preference::CATEGORY,    'title' => 'Nastaveni_rozdeleni'
            ],
            [
                'name'  => 'typrozdelenipoklk',    'type'  => Preference::SQL_COMBOBOX,    'title' => 'Typ_rozdeleni_poklk',
                'defaultValue' => '',
                'sql'   => 'SELECT Kod, Popis FROM TypRozdeleni WHERE Aktivni = 1 ORDER BY Kod'
            ],
            [
                'name'  => 'rozdelenipoklk_pouzevlastni',   'type'  => Preference::CHECKBOX,    'title' => 'Rozdeleni_poklk_pouze_vlastni',
                'defaultValue' => 0
            ],
            [
                'name'  => 'rozdelenipoklk_vychozihodnota',   'type'  => Preference::COMBOBOX,     'title' => 'Rozdeleni_poklk_vychozi_hodnota',
                'options' => [
                    0 => 'Rozdeleni_poklk_nepriradit', 1 => 'Rozdeleni_poklk_priradit',  2 => 'Rozdeleni_poklk_priradit_hlavni'
                ],
                'defaultValue' => '0'
            ],
            [
                'type'  => Preference::CATEGORY,    'title' => 'Nastaveni_rozdeleni2'
            ],
            [
                'name'  => 'typrozdelenipoklk2',    'type'  => Preference::SQL_COMBOBOX,    'title' => 'Typ_rozdeleni_poklk2',
                'defaultValue' => '',
                'sql'   => 'SELECT Kod, Popis FROM TypRozdeleni WHERE Aktivni = 1 ORDER BY Kod'
            ],
            [
                'name'  => 'rozdelenipoklk2_pouzevlastni',   'type'  => Preference::CHECKBOX,    'title' => 'Rozdeleni_poklk_pouze_vlastni',
                'defaultValue' => 0
            ],
            [
                'name'  => 'rozdelenipoklk2_vychozihodnota',   'type'  => Preference::COMBOBOX,     'title' => 'Rozdeleni_poklk_vychozi_hodnota',
                'options' => [
                    0 => 'Rozdeleni_poklk_nepriradit', 1 => 'Rozdeleni_poklk_priradit',  2 => 'Rozdeleni_poklk_priradit_hlavni'
                ],
                'defaultValue' => '0'
            ],
            [
                'type'  => Preference::CATEGORY,    'title' => 'Nastaveni_rozdeleni3'
            ],
            [
                'name'  => 'typrozdelenipoklk3',    'type'  => Preference::SQL_COMBOBOX,    'title' => 'Typ_rozdeleni_poklk3',
                'defaultValue' => '',
                'sql'   => 'SELECT Kod, Popis FROM TypRozdeleni WHERE Aktivni = 1 ORDER BY Kod'
            ],
            [
                'name'  => 'rozdelenipoklk3_pouzevlastni',   'type'  => Preference::CHECKBOX,    'title' => 'Rozdeleni_poklk_pouze_vlastni',
                'defaultValue' => 0
            ],
            [
                'name'  => 'rozdelenipoklk3_vychozihodnota',   'type'  => Preference::COMBOBOX,     'title' => 'Rozdeleni_poklk_vychozi_hodnota',
                'options' => [
                    0 => 'Rozdeleni_poklk_nepriradit', 1 => 'Rozdeleni_poklk_priradit',  2 => 'Rozdeleni_poklk_priradit_hlavni'
                ],
                'defaultValue' => '0'
            ],
            [
                'type'  => Preference::CATEGORY,    'title' => 'Nastaveni_rozdeleni4'
            ],
            [
                'name'  => 'typrozdelenipoklk4',    'type'  => Preference::SQL_COMBOBOX,    'title' => 'Typ_rozdeleni_poklk4',
                'defaultValue' => '',
                'sql'   => 'SELECT Kod, Popis FROM TypRozdeleni WHERE Aktivni = 1 ORDER BY Kod'
            ],
            [
                'name'  => 'rozdelenipoklk4_pouzevlastni',   'type'  => Preference::CHECKBOX,    'title' => 'Rozdeleni_poklk_pouze_vlastni',
                'defaultValue' => 0
            ],
            [
                'name'  => 'rozdelenipoklk4_vychozihodnota',   'type'  => Preference::COMBOBOX,     'title' => 'Rozdeleni_poklk_vychozi_hodnota',
                'options' => [
                    0 => 'Rozdeleni_poklk_nepriradit', 1 => 'Rozdeleni_poklk_priradit',  2 => 'Rozdeleni_poklk_priradit_hlavni'
                ],
                'defaultValue' => '0'
            ],
        ]
];