/* 
 * Pavel Rudol, RON Software
 *  5.10.2015
 */


/* global ron, debugMode */

var zamestnanci = { };

zamestnanci.rozdeleni = {
    /** @type {string} kod rozdeleni */
    kod : '',
    /** @type {string} popis rozdeleni */
    popis : ''
};

zamestnanci.nastavSkryvaniSekci = function () {
    
    prepniZobrazeni = function () {    
        var link = $(this);
        var sectionContainer = $(this).closest('.detailosoby_sekce');
        var novyStav = $(sectionContainer).data('zobrazit') ? 0 : 1;
        
        $(sectionContainer).children('form, table').toggle(200);
         
        $(sectionContainer).data('zobrazit',novyStav);
        
        var url = window.location.href.substr(0,window.location.href.indexOf('#'))+'&action=json&jsonaction=nastaveni&'+$(sectionContainer).prop('id')+'='+novyStav;
        
        $.ajax(url).success(function (data) {
            if (data.result === 'OK') {
                $(link).text(data.text);
            }
            ron.debugLog('Vysledek nastaveni ' + $(sectionContainer).prop('id') + ' na ' + novyStav + ': ' + data.result);
        });
        return false;        
    };
    
    $('.detailosoby_zobrazeni_sekce').on('click', prepniZobrazeni);
    $('.detailosoby_sekce').each(function (index, element) {
        var zobrazit = $(element).data('zobrazit');
        var obsahSekce = $(element).children('div').next();
        if (zobrazit === 1) {
            $(obsahSekce).show();  
        }  
        else {
            $(obsahSekce).hide();
        }
    });    
};

zamestnanci.vyberRozdeleni = function () {
    
    var nactiRozdeleni = function () {
        var kodTR = 0;
        
        if (typeof arguments[0] === 'number') {
            kodTR = arguments[0];
        }
        else {            
            kodTR = $(this).val();
        }
        
        if (kodTR !== 0) {
            $.ajax({
                url: '?menuid=zamestnanec&action=json&jsonaction=seznamrozdeleni',
                method: 'GET',
                data: {
                    'typrozdeleni' : kodTR
                },
                /**
                 * 
                 * @param {zamestnanci.rozdeleni} data json se seznamem rozdeleni
                 * @returns {undefined}
                 */
                success: function (data) {
                    var combo = $('#detailosoby_rozdeleni_kod');
                    
                    $(combo).empty(); 
                    $.each(data.rozdeleni, function(value,key) {
                      $(combo).append($("<option></option>")
                         .attr("value", key.kod).text(key.popis));                      
                    });
                },
                //pri odesilani pozadavku doslo k chybe
                error : function (jqXHR, textStatus) {
                   console.log(textStatus);
                }
            });
        }
    };

    var $typRozdeleni = $('#detailosoby_typrozdeleni');
    $typRozdeleni.on('change', nactiRozdeleni);
    nactiRozdeleni(parseInt($typRozdeleni.val()));
};

zamestnanci.utils = {
    mzdovyStupen : function () {
        var $this = $(this);

        var select2 = $this.data('ron-vymer-mzdovy-stupen');
        var vymer = $this.data('ron-vymer-mzdovy-vymer');
        if (select2) {
            var $mzdovyStupen = $("." + select2);

            // pro hodinova tarifni a mesicni tarifni se zobrazi vyber mzdoveho stupne
            if (($this.val() == 0) || ($this.val() == 2)) {
                $mzdovyStupen.show();
            }
            else {
                $mzdovyStupen.hide();
            }
        }

        if (vymer) {
            var $vymer = $('.'+vymer);

            // pro hodinova tarifni a mesicni tarifni se skryje mzdovy vymer
            if (($this.val() == 0) || ($this.val() == 2)) {
                $vymer.hide();
            }
            else {
                $vymer.show();
            }
        }

    },
    mzdovyStupenInit : function () {
        var $selectVymer = $('select[data-ron-vymer-mzdovy-stupen]');

        $.each($selectVymer, function () {
            var select2 = $(this).data('ron-vymer-mzdovy-stupen');
            var vymer = $(this).data('ron-vymer-mzdovy-vymer');
            if (select2) {
                var $mzdovyStupen = $("." + select2);

                // pro hodinova tarifni a mesicni tarifni se zobrazi vyber mzdoveho stupne
                if (($(this).val() == 0) || ($(this).val() == 2)) {
                    $mzdovyStupen.show();
                }
                else {
                    $mzdovyStupen.hide();
                }
            }

            if (vymer) {
                var $vymer = $('.'+vymer);

                // pro hodinova tarifni a mesicni tarifni se skryje mzdovy vymer
                if (($(this).val() == 0) || ($(this).val() == 2)) {
                    $vymer.hide();
                }
                else {
                    $vymer.show();
                }
            }
        });
    },

    nastavAdresuOsoby : function () {
        var $this = $(this);
        console.log($this.hasClass('adresaObec'));
        console.log($this.hasClass('adresaMesto'));
        console.log($this.hasClass('adresaPSC'));
        console.log($this.hasClass('adresaStat'));

        console.log($this.val());

        var aktualniHodnota = $this.val();

        var selectMesto = $('[name=' + $this.data('adresa-select-mesto') + ']');

        //TODO: ulozit si vsechny optiony a misto skryti zrusit vsechny ostatni

        if ($this.hasClass('adresaPSC')) {
            $(selectMesto).find('option').each(function () {
                if ($(this).data('adresa-psc') == aktualniHodnota) {
                    $(this).show();
                }
                else {
                    $(this).hide();
                }
            });
        }
    }
    //TODO: prepinani adresy podle mesta
};
$( function() {
    $("body")
    // select - mzdovy stupen je pro vybrane typy mzdy
        .on("change", "select", zamestnanci.utils.mzdovyStupen)
        .on("change", '[class*="adresa"]', zamestnanci.utils.nastavAdresuOsoby);

    zamestnanci.utils.mzdovyStupenInit();
});