<?php

namespace Ron\Controls;


/**
 * Rozhrani definujici tridu, ktera se umi vyrenderovat jako dialog
 */
interface DialogRenderer
{
    /**
     * Vraci titulek dialogu (jen text)
     * @return string|null
     */
    public function getDialogTitle(): ?string;


    /**
     * Renderuje hlavicku dialogu (napr. Title)
     * @return void
     */
    public function renderDialogHeader();

    /**
     * Renderuje obsah dialogu
     * @return void
     */
    public function renderDialogBody();

    /**
     * Renderuje paticku dialogu (tlacitka)
     * @return void
     */
    public function renderDialogFooter();


//    /**
//     * Vraci asociativni pole atributu html formulare (tagu <form>). Pokud vrati null, tak se <form> nebude generovat
//     * @return [string]|null
//     */
//    public function getFormAttributes();
}