<?php

namespace Ron\Controls;

use Ron\MessageManager;
use Ron\TextManager;

class MessageManagerDialogRenderer implements DialogRenderer
{
    /** @var MessageManager */
    private $messageManager;

    /**
     * @param MessageManager|null $messageManager
     */
    public function __construct(MessageManager $messageManager = null)
    {
        $this->messageManager = $messageManager ?? MessageManager::getInstance();
    }


    public function getDialogTitle(): ?string
    {
        return $this ->messageManager ->isError()
            ? TextManager::_('Chyba')
            : TextManager::_('Oznameni');
    }


    public function renderDialogHeader()
    {
        echo $this ->getDialogTitle();
    }


    public function renderDialogBody()
    {
        $this ->messageManager ->showMessages();
    }


    public function renderDialogFooter()
    {
        echo '<input type="button" class="button close-dialog" value="' . TextManager::_('OK') . '"/>';
    }
}
