<?php
/**
 * stanislav.elbl, 02.07.2021 17:20
 */

namespace Ron\Controls;

class Preference
{
    const DELETE = -1; // slouzi pro odstraneni starych nepouzivanych nastaveni
    const CATEGORY = 1;
    const CHECKBOX = 2;
    const TEXT = 3;
    const MEMO = 4;
    const COMBOBOX = 5;
    const SQL_COMBOBOX = 6;
    const COLOR = 7;

    const INFO_TEXT = 10;
    /**  jen readonly nastaveni - meni se jinym zpusobem, napr. v aplikaci */
    const READONLY = 11;

    //const CUSTOM = 100;  ?

    /** @var string     jmeno, ktere se uklada do textu ({$name}=...) */
    public $name;

    /** @var int    typ - viz konstanty vyse */
    public $type;

    /** @var string     zobrazeny titulek (preklada se pomoci ronText!) */
    public $title;
    /** @var string     dodatecny text zobrazeny za editacnim prvkem */
    public $infoText;
    public $readOnly;
    /** @var bool       Priznak, ze se nema zobrazovat nadpis a polozka bude pres oba sloupce (napr. pro memo) */
    public $noTitle;

    /** @var string     Class pro color-indicator - pouziva se kvuli zobrazeni vychozi barvy */
    public $indicatorClass;

    /** @var array  pro combo box - asociativni pole "hodnota" => "nadpis" */
    public $options = [];
    /** @var        string pro SQL_COMBOBOX  */
    public $sql;
    /** @var bool   priznak, jestli muze byt zadana prazdna hodnota v SQL_COMBOBOX */
    public $enableEmpty = true;

    // parametry pole v HTML
    public $id;
    public $htmlParams = '';

    public $defaultValue;
    public $storeDefaultValue = false;

    /** @var string  Slouzi pro presun stareho nastaveni - resi se v aplikaci */
    public $oldPrefName;
    /** @var string  Muze byt v jinem umisteni nez zbytek preferenci */
    public $storage = null;

    /**
     * @var mixed $value   Skutecna hodnota
     */
    public $value;


    public function init($initArray)
    {
        foreach ($initArray as $key => $value) {
            $this ->{$key} = $value;
        }

        $this ->value = $this ->defaultValue;
    }


    /**
     * Vraci html parametry - pokud nejsou explicitne zadany, vraci defaultni podle typu
     * @return string
     */
    public function getHtmlParams()
    {
        $result = $this ->htmlParams;

        if (!$result  &&  $this ->readOnly) {
            switch ($this ->type) {
                case self::SQL_COMBOBOX :
                case self::COMBOBOX :
                    $result = 'disabled="disabled"';
                    break;

                default : $result = 'readonly="readonly"';
            }

        }

        if ($this ->id) {
            $result .= ' id="' . $this ->id . '"';
        }

        return $result;
    }
}
