<?php

namespace Ron\MVC;

use Ron\Controls\DialogFormRenderer;
use Ron\Controls\DialogRenderer;
use Ron\GuiUtils;

class DialogPartialView extends PartialView
{
    /**
     * @var DialogRenderer
     */
    protected $dialogRenderer;

    /**
     * @param DialogRenderer $dialogRenderer
     */
    public function __construct(DialogRenderer $dialogRenderer)
    {
        parent::__construct(null);
        $this->dialogRenderer = $dialogRenderer;
    }


    public function render()
    {
        if ($this ->dialogRenderer instanceof DialogFormRenderer) {
            $this ->dialogRenderer ->renderFormStart();
        }

        // title
        echo '<div class="modal-header">';
        $this ->dialogRenderer ->renderDialogHeader();
        echo "</div>\n";

        echo '<div class="modal-body">';
        $this ->dialogRenderer ->renderDialogBody();
        echo "</div>\n";

        echo '<div class="modal-footer">';
        $this ->dialogRenderer ->renderDialogFooter();
        echo "</div>\n";

        if ($this ->dialogRenderer instanceof DialogFormRenderer) {
            $this ->dialogRenderer ->renderFormEnd();
        }
    }
}
