<?php
/**
 * stanislav.elbl, 19.02.2021
 */

namespace Ron\MVC;


use Ron\Http\HtmlHeaders;
use Ron\Http\HttpRequest;
use Ron\TextManager;

abstract class HttpController implements Controller
{
    /** @var bool   V samotnem MVC se nepouziva, protoze autentizace je resena az v samotne aplikaci! Slouzi pro pouziti v aplikaci. */
    public $enableAccessWithoutLogin;

    /** @var bool   Umoznuje vypnout prodlouzeni platnosti session - napr. pro nejake javascriptove requesty. */
    public $enlargeSessionValidity = true;

    /** @var HttpRequest?   Aktualni HttpRequest - vytvori se pri prvnim pouziti */
    private $httpRequest = null;


    /**
     * Vraci aktualni HttpRequest
     * @return HttpRequest
     */
    public function getRequest()
    {
        if (!$this ->httpRequest) {
            $this ->httpRequest = new HttpRequest();
        }

        return $this ->httpRequest;
    }


    function translations()
    {
        return new TranslationsOutputObject();
    }


    public function addTranslationsScript($menuId)
    {
        $lang = TextManager::getInstance() ->translationLang;
        HtmlHeaders::getInstance()->addScript('','translations',
            "?menuid=$menuId&action=translations&lang=$lang&ver=" . HtmlHeaders::getInstance() ->versionId);
    }


}
