<?php
/**
 * stanislav.elbl, 24.03.2021
 */

namespace Ron\MVC;

use Ron\CalendarItem;
use Ron\Http\HttpResponse;

class IcalOutputObject implements OutputObject
{
    /** @var  CalendarItem|CalendarItem[] */
    var $items;
    /** @var string */
    var $fileName;

    /**
     * @param CalendarItem|CalendarItem[] $items
     * @param string $fileName
     */
    function __construct($items, $fileName = 'calendar.ics')
    {
        $this ->items = $items;
        $this ->fileName = $fileName;
    }


    /**
     * @return void
     */
    public function output()
    {
        HttpResponse::getInstance() ->getHeaders() ->addHeadersForContent($this ->fileName);
        HttpResponse::renderHeaders();

        echo CalendarItem::getICalFileContent($this ->items);
//
//        echo CalendarItem::iCalHeader();
//
//        if (is_array($this ->items)) {
//            foreach($this ->items as $item) {
//                echo $item ->getICalEvent();
//            }
//        } else {
//            echo $this ->items ->getICalEvent();
//        }
//
//        echo CalendarItem::iCalFooter();
    }

}
