<?php

namespace Ron\MVC;

/**
 * PartialView je specialni druh ViewObjectu - pokud je vracen z controlleru,
 * tak se vyrenderuje samostatne (bez vychoziho layoutu aplikace). Pouziva se napriklad pro renderovani dynamickych formularu.
 */
class PartialView implements ViewObject
{
    protected $view;

    /**
     * @param string|ViewObject $view
     */
    public function __construct($view)
    {
        $this->view = $view;
    }


    public function render()
    {
        if ($this ->view instanceof ViewObject) {
            $this ->view ->render();
        } else if (is_string($this ->view)) {
            require ($this ->view);
        }
    }
}
