<?php
/**
 * stanislav.elbl, 23.12.2020
 */

namespace Ron;

use Ron\Controls\Dialog;


class ProgressDialog extends Dialog
{
    /** @var string     Titulek dialogu */
    public $title;
    /** @var string     HTML id dialogu */
    public $id = 'progress_dialog';

    /** @var string     Text zobrazeny nad progressbarem */
    public $caption;

    public function __construct($title, $view = 'ron/view_progress.php')
    {
        parent::__construct($view);

        $this ->title = $title;
        $this ->buttons = true;
    }

    /**
     * @param string $title
     * @return ProgressDialog
     */
    public function setTitle($title)
    {
        $this->title = $title;
        return $this;
    }

    /**
     * @param string $id
     * @return ProgressDialog
     */
    public function setId($id)
    {
        $this->id = $id;
        return $this;
    }

    public function renderButtons()
    {
        echo "<input type='button' class='button' id='{$this ->id}_cancel' value='" . TextManager::_('Cancel') . "'/>";
        echo "<input type='button' class='button d-none' id='{$this ->id}_close' value='" . TextManager::_('Zavrit') . "'/>";
        // parent::renderButtons(); // TODO: Change the autogenerated stub
    }


    /**
     * @param $title
     * @param mixed[] $options
     */
    public static function renderProgressDialog($title, $options = null)
    {
        $progress = new static($title);

        if ($options  &&  is_array($options)) {
            foreach ($options as $key => $value) {
                switch ($key) {
                    case 'title' :
                    case 'id' :
                    case 'caption' :
                    default :
                        $progress ->{$key} = $value;
                }
            }
        }

        $progress ->render();
    }
}
