<?php
/**
 * UTF8
 * stanislav.elbl, 02.10.2015
 */

namespace Ron;

class RonException extends \Exception
{
    public $fieldName;
    public $errorDescription;

    public $responseCode;


    /**
     * @param string $message
     * @param string $fieldName
     * @param string $errorDescription
     * @param int    $code
     * @param \Exception $previous
     */
    public function __construct($message, $fieldName = null, $errorDescription = null, $code = 0, $previous = null)
    {
        parent::__construct($message, 0, $previous);

        $this ->fieldName = $fieldName;
        $this ->errorDescription = $errorDescription;
    }

    /**
     * @return null|string
     */
    public function getFieldName()
    {
        return $this->fieldName;
    }


    public function getErrorDescription() {
        return $this ->errorDescription;
    }

    /**
     * @return ?int
     */
    public function getResponseCode(): ?int
    {
        return $this->responseCode;
    }

    /**
     * @param mixed $responseCode
     * @return RonException
     */
    public function setResponseCode($responseCode): RonException
    {
        $this->responseCode = $responseCode;
        return $this;
    }
}
