<?php

namespace RonPortal\Ankety;

use Ron\Controls\RozdeleniList;
use Ron\MVC\Model;
use Ron\StringUtils;
use Ron\TextManager;
use RonPortal\Controls\FormReportsListView;

/** @var Anketa $anketa */
$anketa = Model::getInstance() ->getData('anketa');
/** @var RozdeleniList $rozdeleniList */
$rozdeleniList = Model::getInstance() ->getData('rozdeleniList');
$reportList = Model::getInstance() ->getData('reportList');

?>
<div class="form large-form">
    <div class="form-content">
        <div class="row">
            <div class="col-12 col-sm-3 caption"></div>
            <div class="col-12 col-sm-9 font-weight-bold"><?= StringUtils::htmlTextConvert($anketa ->nazev) ?></div>
        </div>
        <div class="row">
            <div class="col-12 col-sm-3 caption"></div>
            <div class="col-12 col-sm-9 poznamka"><?= StringUtils::longTextToHtml($anketa ->popis, false) ?></div>
        </div>

        <?php if ($anketa ->platnostOd) { ?>
        <div class="row">
            <div class="col-12 col-sm-3 caption"><?= TextManager::_('Platnost_od') ?></div>
            <div class="col-12 col-sm-9"><?= StringUtils::format('date', $anketa ->platnostOd) ?></div>
        </div>
        <?php } ?>

        <?php if ($anketa ->platnostDo) { ?>
        <div class="row">
            <div class="col-12 col-sm-3 caption"><?= TextManager::_('Platnost_do') ?></div>
            <div class="col-12 col-sm-9"><?= StringUtils::format('date', $anketa ->platnostDo) ?></div>
        </div>
        <?php } ?>

        <div class="row">
            <div class="col-12 col-sm-3 caption"></div>
            <div class="col-12 col-sm-9">
                <a href="?menuid=anketa&record=<?= $anketa ->id ?>&action=form"><?= TextManager::_('Upravit') ?></a>
            </div>
        </div>

        <div class="form-section"><?= TextManager::_('Rozdeleni') ?></div>

        <div class="row">
            <div class="col-12 col-sm-3 caption"></div>
            <div class="col-12 col-sm-9">
                <?php $rozdeleniList ->render(); ?>

                <div>
                    <a class="vyber-rozdeleni" href="#" data-after-close="reload"><?= TextManager::_('Priradit_rozdeleni')  ?></a>
                </div>
            </div>
        </div>

        <?php if ($reportList) { ?>
        <div class="form-section"><?= TextManager::_('Sestavy') ?></div>

        <div class="row">
            <div class="col-12 col-sm-3 caption"></div>
            <div class="col-12 col-sm-9">
                <?php
                    FormReportsListView ::renderReportList($reportList,'?menuid=anketa&action=report&record=' . $anketa ->id);
                ?>
            </div>
        </div>
        <?php } ?>
    </div>
</div>
