<?php
/**
 * stanislav.elbl, 11.04.2022 16:17
 */

namespace RonPortal\Benefity;

use Ron\DB\Database;

class Benefit
{
    /** @var int */
    public $id;
    /** @var string */
    public $popis;
    /** @var int */
    public $platnostOd;
    /** @var int */
    public $platnostDo;

    /** @var string */
    public $typBenefitu;
    /** @var string */
    public $popisDetail;
    /** @var int */
    public $pocetCelkem;
    /** @var int    Priznak, jestli je pocet benefitu omezen */
    public $neomezenyPocet;
    /** @var int */
    public $hodnotaVBodech;
    /** @var int    Priznak, jestli muze uzivatel zadat hodnotu */
    public $variabilniHodnotaVBodech;
    /** @var double */
    public $doplatekCastka;
    /** @var int */
    public $maxPocetJedenZam;
    /** @var int    Priznak, jestli je mozne cerpat neomezeny pocet */
    public $neomezenyPocetJedenZam;
    /** @var int    Priznak ... */
    public $jednProCerpaniMaxPoctu;
    /** @var int */
    public $pocetJednotekProCerpani;
    /** @var int */
    public $idDokumentu;
    /** @var int    Priznak, jestli se automaticky schvaluje */
    public $automatickeSchvaleni;
//    public $automatickeSchvaleni_popis;
//    public $jizRezervovano;


    /**
     * @param Database $database
     * @param $id
     * @return Benefit
     * @throws \Exception
     */
    public static function nactiBenefit($database, $id)
    {
        $params = $database->createParameters();

        $sql =
            'SELECT ID, Popis, TypBenefitu, PlatnostOd, PlatnostDo, ' . $database->castWideMemo('PopisDetail') . ',' .  //0..5
            ' PocetCelkem, NeomezenyPocet, HodnotaVBodech, VariabilniHodnotaVBodech, DoplatekCastka,' .                 //6..10
            ' MaxPocetJedenZam, NeomezenyPocetJedenZam, JednProCerpaniMaxPoctu, PocetJednotekProCerpani, idDokumentu, AutomatickeSchvaleni' .   //11..16
            ' FROM Benefit' .
            ' WHERE ID = ' . $params->addParameter($id);

        $cursor = $database->getSqlResult($sql, $params);
        $row = $cursor ->fetch();
        $cursor ->close();

        if (!$row){
            throw new \Exception(\Ron\ronText('benefit_neexistuje'));
        }

        $benefit = new static();
        $benefit->load($database, $row);

        return $benefit;
    }


    /**
     * @param Database $database
     * @param $row
     */
    private function load($database, $row)
    {
        $this->id = (int)$row[0];
        $this->popis = $row[1];
        $this->typBenefitu = $row[2];
        $this->platnostOd = $database->stringToTimestamp($row[3]);
        $this->platnostDo = $database->stringToTimestamp($row[4]);
        $this->popisDetail = $row[5];
        $this->pocetCelkem = (int)$row[6];
        $this->neomezenyPocet = (int)$row[7];
        $this->hodnotaVBodech = (int)$row[8];
        $this->variabilniHodnotaVBodech = (int)$row[9];
        $this->doplatekCastka = (double)$row[10];
        $this->maxPocetJedenZam = (int)$row[11];
        $this->neomezenyPocetJedenZam = (int)$row[12];
        $this->jednProCerpaniMaxPoctu = (int)$row[13];
        $this->pocetJednotekProCerpani = (int)$row[14];
        $this->idDokumentu = isset($row[15]) ? (int)$row[15] : null;
        $this->automatickeSchvaleni = (int)$row[16];
    }
}
