<?php
/**
 * UTF8
 * Roman.Szablatura RON Software 11.4.2017
 */

namespace RonPortal\Common;

use Ron\GuiUtils;
use Ron\Http\Csrf;
use Ron\MessageManager;
use RonPortal\Controls\FormReportsListView;
use function Ron\ronText;
use Ron\StringUtils;
use Ron\MVC\Model;
use RonPortal\Prava;
use RonPortal\PravaNaOsoby;
use RonPortal\RonPortalSettings;

$model = Model::getInstance();

/** @var Navsteva $navsteva */
$navsteva = $model->getData('navsteva');

/** @var PravaNaOsoby $pravo_schvaleni */
$pravo_schvaleni = Prava::vratPrava('navstevy_schvaleni');

$reportList = $model->getData('reportlist');
?>

<h1 ><?= ronText('detail_navstevy')?> - <?=  $navsteva->typNavstevyPopis?></h1>

<?php MessageManager::getInstance() ->showMessages(); ?>

<div class="form large-form">

    <div class="form-content">
        <div class="row">
            <div class="col col-6 col-sm-3 caption" id="Rozdeleni_VratnicePopis"><strong><?= ronText('vratnice') ?></strong></div>
            <div class="col col-6 col-sm-9"><h3><?= StringUtils::htmlTextConvert($navsteva->rozdeleni_VratnicePopis ) ?></h3></div>
        </div>


        <div class="row form-section" id="navstivena_osoba">
            <div class="col col-12 col-sm-3 caption"> <strong><?= ronText('navstivena_osoba') ?></strong></div>
        </div>

        <div class="row">
            <div class="col col-12 col-sm-3 caption"></div>
            <div class="col col-12 col-sm-9"> <strong><?= StringUtils::htmlTextConvert($navsteva->jmenoNavstiveneOsoby) ?></strong></div>
        </div>

        <?php if ($navsteva->typNavstevy == 1){ ?>
            <div class="row form-section" id="navstivena_osoba">
                <div class="col col-12 col-sm-3 caption"> <strong><?= ronText('navsteva_zamestnanec_jako_navsteva') ?></strong></div>
            </div>

            <div class="row" id="zamestnanec" >
                <div class="col col-12 col-sm-3 caption"> <strong><?= ronText('zamestnanec') ?></strong></div>
            </div>

            <div class="row">
                <div class="col col-12 col-sm-3 caption"></div>
                <div class="col col-12 col-sm-9"> <strong><?= StringUtils::htmlTextConvert($navsteva->zamestnanecPrijmeniJmenoTitul) ?></strong></div>
            </div>

        <?php } ?>



        <div class="row form-section">
            <div class="col col-12 col-sm-3 caption"> <strong><?= ronText('navsteva') ?></strong></div>
        </div>

        <div class="row">
            <div class="col col-6 col-sm-3 caption"> <?= ronText('ocekavany_prichod') ?></div>
            <div class="col col-6 col-sm-9"> <?= StringUtils::format('datetime',$navsteva->ocekavanyPrichod) ?></div>
        </div>

        <div class="row">
            <div class="col col-6 col-sm-3 caption"> <?= ronText('prichod') ?></div>
            <div class="col col-6 col-sm-9"> <strong><?= StringUtils::format('datetime',$navsteva->prichod) ?></strong></div>
        </div>

        <div class="row">
            <div class="col col-6 col-sm-3 caption"> <?= ronText('odchod') ?></div>
            <div class="col col-6 col-sm-9"> <strong><?= StringUtils::format('datetime',$navsteva->odchod) ?></strong></div>
        </div>

        <?php if ($navsteva->odchod) { ?>
            <div class="row">
                <div class="col col-6 col-sm-3 caption"> <?= ronText('doba_navstevy') ?></div>
                <div class="col col-6 col-sm-9"><?= StringUtils::format('minuty', ($navsteva->odchod - $navsteva->prichod) / 60) ?></div>
            </div>
        <?php } ?>

        <div class="row margin-top-2">
            <div class="col col-6 col-sm-3 caption"> <?= ronText('oznaceni_media') ?></div>
            <div class="col col-6 col-sm-9"> <?= StringUtils::htmlTextConvert($navsteva->oznaceniMedia) ?></div>
        </div>

        <?php if ($navsteva->kod) { ?>
        <div class="row">
            <div class="col col-6 col-sm-3 caption"> <?= ronText('Kod') ?></div>
            <div class="col col-6 col-sm-9"> <?= StringUtils::htmlTextConvert($navsteva->kod) ?></div>
        </div>
        <?php } ?>

        <div class="row margin-top-2">
            <div class="col col-6 col-sm-3 caption"> <?= ronText('Titul') ?></div>
            <div class="col col-6 col-sm-9"> <?= StringUtils::htmlTextConvert($navsteva->titul) ?></div>
        </div>

        <div class="row">
            <div class="col col-6 col-sm-3 caption"> <?= ronText('Prijmeni') ?></div>
            <div class="col col-6 col-sm-9"> <strong><?= StringUtils::htmlTextConvert($navsteva->prijmeni) ?></strong></div>
        </div>

        <div class="row">
            <div class="col col-6 col-sm-3 caption"> <?= ronText('Jmeno') ?></div>
            <div class="col col-6 col-sm-9"> <?= StringUtils::htmlTextConvert($navsteva->jmeno) ?></div>
        </div>

        <div class="row">
            <div class="col col-6 col-sm-3 caption"> <?= ronText('doklad') ?></div>
            <div class="col col-6 col-sm-9"> <?= StringUtils::htmlTextConvert($navsteva->doklad) ?></div>
        </div>

        <div class="row margin-top-2">
            <div class="col col-6 col-sm-3 caption"> <?= ronText('vozidlo') ?></div>
            <div class="col col-6 col-sm-9"> <?= StringUtils::htmlTextConvert($navsteva->vozidlo) ?></div>
        </div>

        <div class="row">
            <div class="col col-6 col-sm-3 caption"> <?= ronText('firma') ?></div>
            <div class="col col-6 col-sm-9"><?= StringUtils::htmlTextConvert($navsteva->firma) ?></div>
        </div>

        <div class="row">
            <div class="col col-6 col-sm-3 caption" id="duvodNavstevy"><?= ronText('duvod_navstevy_ciselnik') ?></div>
            <div class="col col-6 col-sm-9"><?= StringUtils::htmlTextConvert($navsteva->duvodNavstevy2) ?></div>
        </div>

        <div class="row">
            <div class="col col-12 col-sm-3 caption" id="duvodNavstevy"> <?= ronText('duvod_navstevy') ?></div>
            <div class="col col-12 col-sm-9 poznamka"><?= StringUtils::htmlTextConvert($navsteva->duvodNavstevy) ?></div>
        </div>

        <div class="row margin-top-2">
            <div class="col col-6 col-sm-3 caption"> <?= ronText('zaznam_vlozil') ?></div>
            <div class="col col-6 col-sm-9"> <?= StringUtils::htmlTextConvert($navsteva->insert_UserName) ?></div>
        </div>

        <div class="row">
            <div class="col col-6 col-sm-3 caption"> <?= ronText('datum_vlozeni') ?></div>
            <div class="col col-6 col-sm-9"> <?= StringUtils::format('datetime',$navsteva->insert_Timestamp) ?></div>
        </div>

        <div class="row">
            <div class="col col-6 col-sm-3 caption"> <?= ronText('naposled_editoval') ?></div>
            <div class="col col-6 col-sm-9"> <?= StringUtils::htmlTextConvert($navsteva->update_UserName) ?></div>
        </div>

        <div class="row">
            <div class="col col-6 col-sm-3 caption"> <?= ronText('datum_editace') ?></div>
            <div class="col col-6 col-sm-9"> <?= StringUtils::format('datetime',$navsteva->update_Timestamp) ?></div>
        </div>

        <div class="row">
            <div class="col col-6 col-sm-3 caption"> <?= ronText('prichod_zapsal') ?></div>
            <div class="col col-6 col-sm-9"> <strong><?= StringUtils::htmlTextConvert($navsteva->prichodZapsalRC) ?></strong></div>
        </div>


        <?php if($pravo_schvaleni->jsouNejakePrava()) { ?>

            <div class="row form-section">
                <div class="col col-12 col-sm-3 caption"> <strong><?= ronText('schvaleni_navstevy') ?></strong></div>
            </div>

            <?php if ($navsteva->navstevuSchvalil) { ?>
                <div class="row">
                    <div class="col col-12 col-sm-3 caption"> <?= ronText('Schvalil') ?></div>
                    <div class="col col-12 col-sm-9"> <strong><?= StringUtils::htmlTextConvert($navsteva->navstevuSchvalil) ?></strong></div>
                </div>


                <div class="row">
                    <div class="col col-12 col-sm-3 caption"> <?= ronText('datum_schvaleni') ?></div>
                    <div class="col col-12 col-sm-9"> <strong><?= StringUtils::format("datetime", $navsteva->navstevuSchvalilDatum) ?></strong></div>
                </div>

            <?php } elseif (($navsteva->predemOcekavanaNavsteva) && ($pravo_schvaleni->lzeZobrazitRC($navsteva->navstivenaOsobaRC))) { ?>
                <div class="row">
                    <div class="col col-12 col-sm-3"> </div>
                    <div class="col col-12 col-sm-9">
                        <?= GuiUtils::changeLocationQuest(ronText('Schvalit'), ronText('opravdu_schvalujete_navstevu'),
                                ' ?menuid=navstevy&action=schvaleninavstevy&id=' . $navsteva->id . Csrf::csrfUrlParameter()) ?>
                    </div>
                </div>

            <?php } ?>

        <?php }?>

        <div class="row form-section">
            <div class="col col-12 col-sm-3 caption"> <strong><?= ronText('ostatni_udaje') ?></strong></div>
        </div>

        <?php for ($i = 1; $i <= 10; $i++) { if ($navsteva->uzivatelskaPole[$i]) { ?>

            <div class="row">
                <div class="col col-6 col-sm-3 caption"> <?= RonPortalSettings::getValue("navstevy_uzivatelska$i") ?></div>
                <div class="col col-6 col-sm-9"> <?= StringUtils::htmlTextConvert($navsteva->uzivatelskaPole[$i]) ?></div>
            </div>

        <?php }
            }
        ?>
    </div>

    <div class='buttons'>
        <input type="button" class="submitbutton clickHref" data-ron-href='?menuid=navstevy'" value="<?= ronText('Zpet_na_seznam')?>">

        <?php if ( true ) { ?>
            <input type="button" class="submitbutton clickHref" data-ron-href='?menuid=navstevy&formaction=edit&record=<?= $navsteva->id ?>'" value="<?= ronText('Editovat')?>" >
        <?php } ?>
    </div>

</div>

<?php
    FormReportsListView::renderReportList($reportList,
        '?menuid=navstevy&action=report&id=' . $navsteva->id);
?>
