<?php
/**
 * stanislav.elbl, 18.03.2021
 */

namespace RonPortal\Common;

use Ron\Controls\FormField;
use Ron\TextManager;
use RonPortal\Controls\RonPortalForm;
use RonPortal\User;

class VzkazFormular extends RonPortalForm
{

    /**
     * @param \Ron\DB\Database $database
     */
    function __construct($database)
    {
        parent::__construct($database, 'new');

        $this ->htmlAction = '?menuid=vzkazy&action=odeslatvzkaz';
        $this ->stornoAction = '?menuid=vzkazy';

        $this ->title = TextManager::_('Odeslat_vzkaz');
        $this ->sqlTableName = 'Vzkaz';

        $this ->code = 'formvzkaz';

        $this ->setXmlEventsName('VZKAZ');

        $this ->addField(FormField::FIELD_TYPE_ID)
            ->setFieldName('Id') ->setPrimary(true);

        $this -> addField(FormField::FIELD_TYPE_CONSTANT)
            ->setFieldName('RCOdesilatele') ->setMaxLength(15) ->setReadOnly(true)
            ->setCode('field-rcodesilatele')
            ->setDefaultValue(User::getRC());

        $this -> addField(FormField::FIELD_TYPE_ACTUAL_TIME)
            ->setFieldName('DatumCas') ->setReadOnly(true);

        $this ->addField(FormField::FIELD_TYPE_SELECT)
            ->setFieldName('KodPrijemce') ->setCaption('Prijemce')
            ->setCode('field-kodprijemce')
            ->setRequired(true)
            ->setSelectSql(
                'SELECT Kod, Popis FROM PrijemceVzkazu WHERE %FILTER% ORDER BY %ORDER%',
                '1 = 1', 'Popis'
            );

        $this ->addField()
            ->setFieldName('Predmet') ->setCaption('Predmet')
            ->setCode('field-predmet')
            ->setMaxLength(60) ->setRequired(1);

        $this ->addField(FormField::FIELD_TYPE_MEMO)
            ->setFieldName('Popis')
            ->setCode('field-popis');
    }
}
