<?php
/**
 * stanislav.elbl, 08.03.2021
 */

namespace RonPortal\Controls;

use Ron\Controls\FormField;
use Ron\DB\Database;
use RonPortal\Dokument;

/**
 * Class DokumentyFormField
 */
class DokumentyFormField extends FormField
{
    /** @var Dokument[] */
    var $dokumenty;

    /** @var string */
    var $downloadUrl;


    function __construct($dokumenty, $downloadUrl)
    {
        parent::__construct(self::FIELD_TYPE_TEXT);

        $this->dokumenty = $dokumenty;
        $this->downloadUrl = $downloadUrl;
    }


    /**
     * @param Dokument[] $dokumenty
     * @return DokumentyFormField
     */
    public function setDokumenty($dokumenty)
    {
        $this->dokumenty = $dokumenty;
        return $this;
    }

    /**
     * @param string $downloadUrl
     * @return DokumentyFormField
     */
    public function setDownloadUrl($downloadUrl)
    {
        $this->downloadUrl = $downloadUrl;
        return $this;
    }



    /**
     * @param Database $database
     * @param mixed $value
     * @param bool $canEdit
     * @param bool $insert
     * @param array $rowData
     */
    function showFieldContent($database, $value, $canEdit, $insert, $rowData)
    {
        $params = $this ->getHtmlParams();
        echo "<div $params>";

        if ($this->dokumenty) {
            Dokument::renderTable($this ->dokumenty, $this ->downloadUrl);
        }

        echo '</div>';
    }
}
