<?php
/**
 * stanislav.elbl, 23.02.2021
 */

namespace RonPortal\Controls;

use Ron\MVC\ViewObject;
use Ron\StringUtils;
use RonPortal\System\Report;


class FormReportsListView implements ViewObject
{
    /** @var Report[] */
    public $reportList;

    /** @var  string */
    public $action;

    /** @var bool */
    //public $usePOST;

    /**
     * FormReportsListView constructor.
     * @param Report[] $reportList
     * @param string $action
    //* @param bool $usePOST
     */
    public function __construct($reportList, $action) // , $usePOST = false)
    {
        $this->reportList = $reportList;
        $this->action = $action;
        //$this->usePOST = $usePOST;
    }


    public function render()
    {
        if ( !count($this ->reportList) ) {
            return;
        }

        echo '<div class="reportlist">';

        foreach ($this ->reportList as $report) {
            //$reportNameParam = urlencode($report ->kod);
            //$reportNameParam = urlencode(StringUtils::htmlTextConvert($report ->kod));
            $reportNameParam = StringUtils::htmlTextConvert(urlencode($report ->kod));

            if (!$report ->formaty) {
                // pouze defaultni format (PDF)
                echo '<div class="report text_link">';
                echo '<a target="_blank" href="' . $this ->action . '&reportname=' . $reportNameParam . '">' . StringUtils::htmlTextConvert($report ->nazev) . '</a>';
                echo "</div>\n";
            } else {
                echo '<div class="report">';
                $first = true;

                foreach ($report ->nazvyFormatu as $format) {
                    echo '<SPAN class="text_link">';
                    echo '<a target="_blank" href="' . $this ->action . '&format=' . strtolower($format) . '&reportname=' . $reportNameParam . '">' .
                        ($first
                            ? StringUtils::htmlTextConvert($report ->nazev)     // '<i class="fa inline-glyph glyph-report"></i> ' .
                            : \Ron\ronText($format) ) .
                        '</a>';
                    echo "</SPAN>\n";
                    $first = false;
                }

                echo '</div>';
            }
        }

        echo '</div>';
    }


    /**
     * @param Report[] $reportList
     * @param string $action
     */
    public static function renderReportList($reportList, $action)
    {
        $view = new static($reportList, $action);
        $view ->render();
    }
}
