<?php
/**
 * stanislav.elbl, 20.05.2022 15:56
 */

namespace RonPortal\Controls;

use Ron\Controls\BrowserField;
use Ron\TextManager;

class FotoOsobyBrowserField extends BrowserField
{
    /** @var int|string Index pole  */
    private $indexIDOsoby;

    /** @var string URL pro stazeni fotografie - na konec se prida jeste id osoby (hodnota pole se zadanym indexem) */
    private $url;

    /** @var bool   Priznak urcuje, jestli se ma zobrazit primo fotografie, nebo jen odkaz */
    private $showFoto;

    /**
     * FotoZamestnanceField constructor.
     * @param int $indexIdOsoby
     */
    public function __construct($indexIdOsoby, $url, $showFoto = true)
    {
        parent::__construct();

        $this->indexIDOsoby = $indexIdOsoby;
        $this->url = $url;
        $this->showFoto = $showFoto;

        $this ->setAlign('center');
    }


    function loadConfigurationItem($key, $value)
    {
        if ($key === 'showFoto') {
            $this ->showFoto = (int)$value;
            return $this;
        } else {
            return parent::loadConfigurationItem($key, $value);
        }
    }


    function getViewText($value, $rowNumber, $recordId, $rowData)
    {
        if ($value  &&  $rowData[$this->indexIDOsoby]) {
            if ($this ->showFoto) {
                return
                    '<div class="position-relative">' .
                    '<div class="browserfoto ronFoto">' .
                    '<img src="' . $this->url . $rowData[$this->indexIDOsoby] . '" alt="foto osoby"/>' .
                    '</div>' .
                    '</div>';
            }

            return '<a target="ads_foto" class="link_foto" href="' . $this ->url . $rowData[$this ->indexIDOsoby] . '">' . TextManager::_('Foto') . '</a>';
        }

        return '';
    }
}
