<?php
/**
 * stanislav.elbl, 08.04.2022 17:43
 */

namespace RonPortal\Controls;

use Ron\Controls\FormField;
use Ron\StringUtils;

/**
 * Readonly pole, ktere zobrazuje jmeno osoby
 * Class JmenoPrijmeniFormField
 * @package RonPortal\Controls
 */
class JmenoPrijmeniFormField extends FormField
{
    /** @var int    Index pole se jmenem v SQL dotazu */
    public $sqlFieldIndexJmeno = null;

    /** @var int    Index pole s titulem v SQL dotazu */
    public $sqlFieldIndexTitul = null;

    /** @var int    Index pole s titulem 2 v SQL dotazu */
    public $sqlFieldIndexTitul2 = null;



    public function __construct($sqlFieldIndexPrijmeni, $sqlFieldIndexJmeno, $sqlFieldIndexTitul = null, $sqlFieldIndexTitul2 = null)
    {
        parent::__construct(self::FIELD_TYPE_TEXT);

        $this ->sqlFieldIndex = $sqlFieldIndexPrijmeni;
        $this ->sqlFieldIndexJmeno = $sqlFieldIndexJmeno;
        $this ->sqlFieldIndexTitul = $sqlFieldIndexTitul;
        $this ->sqlFieldIndexTitul2 = $sqlFieldIndexTitul2;
    }


    protected function showFieldContent($database, $value, $canEdit, $insert, $rowData)
    {
        if (!$rowData) {
            return;
        }

        if (isset($this ->sqlFieldIndexTitul)  &&  $rowData[$this ->sqlFieldIndexTitul]) {
            echo StringUtils::htmlTextConvert($rowData[$this ->sqlFieldIndexTitul]) . ' ';
        }

        if (isset($this ->sqlFieldIndexJmeno)  &&  $rowData[$this ->sqlFieldIndexJmeno]) {
            echo StringUtils::htmlTextConvert($rowData[$this ->sqlFieldIndexJmeno]) . ' ';
        }

        if (isset($rowData[$this ->sqlFieldIndex])) {
            echo StringUtils::htmlTextConvert($rowData[$this ->sqlFieldIndex]);
        }

        if (isset($this ->sqlFieldIndexTitul2)  &&  $rowData[$this ->sqlFieldIndexTitul2]) {
            echo ', ' . StringUtils::htmlTextConvert($rowData[$this ->sqlFieldIndexTitul2]);
        }
    }
}
