<?php
/**
 * User: stanislav.elbl
 * 17.05.2021 23:44
 */

namespace RonPortal\Controls;

use Ron\Controls\FormField;
use RonPortal\User;

class UserLoginFormField extends FormField
{
    /**
     * @param bool $readOnly
     * @param string $fieldName
     */
    function __construct($readOnly, $fieldName = null)
    {
        parent::__construct(FormField::FIELD_TYPE_CONSTANT);

        if (!$fieldName) {
            $fieldName = $readOnly
                ? 'Insert_UserName'
                : 'Update_UserName';
        }

        $this->sqlFieldName = $fieldName;
        $this->maxLength = 25;
        $this->setReadOnly($readOnly);
        $this->defaultValue = User::getLoginName();
    }
}
