<?php

namespace RonPortal\Dochazka;

use Ron\DB\Database;
use Ron\DB\DBException;
use Ron\DB\SqlStatement;

/**
 * Data z tabulky MesicniVysledek_R nebo MesicniVysledek_R_E
 */
class MesicniVysledekR extends MesicniVysledek
{
    /** @var int */
    public $kodTypuRozdeleni;

    /** @var string */
    public $rozdeleni;


    protected static function getSelectPart($tableName)
    {
        return
            static::getDefaultSelectPart($tableName, $tableName === 'MesicniVysledek_R_E') .
            ", $tableName.KodTypuRozdeleni, $tableName.Rozdeleni"; // 10,11
    }


    /**
     * @param Database $database
     * @param array $row
     */
    protected function load($database, $row)
    {
        $this ->loadDefaultData($database, $row);

        $this ->kodTypuRozdeleni = $row[10];
        $this ->rozdeleni = $row[11];
    }


    /**
     * Nacte mesicni vysledky R. Pokud se nacitaji data jen pro jednu osobu a mesic, tak vraci asociativni pole indexovane typem.
     * @param Database $database
     * @param int|int[] $idPP
     * @param int $mesic
     * @param string|string[]|null $typCasoveSlozkyMzdy
     * @return MesicniVysledek[]
     * @throws DBException
     */
    public static function nactiMesicniVysledkyR($database, $idPP, $mesic, $kodTypuRozdeleni, $rozdeleni, $typCasoveSlozkyMzdy = null)
    {
//        $params = $database ->createParameters();
//        $filter = new SqlStatement(
//            'MesicniVysledek_R.KodTypuRozdeleni = ' . $params ->addParameter($kodTypuRozdeleni) .
//            ' AND MesicniVysledek_R.Rozdeleni = ' . $params ->addParameter($rozdeleni),
//            $params
//        );
        return static::nactiZaznamy($database, 'MesicniVysledek_R', $idPP, $mesic, $typCasoveSlozkyMzdy, false);
    }


    /**
     * Nacte mesicni vysledky R_E. Pokud se nacitaji data jen pro jednu osobu a mesic, tak vraci asociativni pole indexovane typem.
     * @param Database $database
     * @param int|int[] $idPP
     * @param int $mesic
     * @param string|string[]|null $typCasoveSlozkyMzdy
     * @return MesicniVysledek[]
     * @throws DBException
     */
    public static function nactiMesicniVysledkyRE($database, $idPP, $mesic, $kodTypuRozdeleni, $rozdeleni, $typCasoveSlozkyMzdy = null)
    {
//        $params = $database ->createParameters();
//        $filter = new SqlStatement(
//            'MesicniVysledek_R_E.KodTypuRozdeleni = ' . $params ->addParameter($kodTypuRozdeleni) .
//            ' AND MesicniVysledek_R_E.Rozdeleni = ' . $params ->addParameter($rozdeleni),
//            $params
//        );
        return static::nactiZaznamy($database, 'MesicniVysledek_R_E', $idPP, $mesic, $typCasoveSlozkyMzdy, false);
    }

}
