<?php
/**
 * UTF8
 * stanislav.elbl, 28.08.2015
 *
 * Rozsirena funkcnost vkladani historie - nedokumentovana funkce (na zakazku)
 */

namespace RonPortal\Dochazka;

use Ron\Controls\ComboBox;
use Ron\DateUtils;
use Ron\DB\Database;
use Ron\DB\DBUtils;
use Ron\MVC\Model;
use RonPortal\Controls\ComboBoxZamestnanec;
use RonPortal\RonPortalSession;
use RonPortal\RonPortalSettings;

$model = Model::getInstance();

/** @var \Ron\DB\Cursor $historie */
$historie = $model ->getData('historie');
/** @var ComboBoxZamestnanec $comboOsoba */
$comboOsoba = $model ->getData('comboOsoba');
/** @var ComboBox $comboOperace */
$comboOperace = $model ->getData('comboOperace');
/** @var Database $database */
$database = $model ->getData('database');

$datumoperace = isset($_POST['datumoperace']) ? $_POST['datumoperace'] : null;
if (!$datumoperace) {
    // Nastavi datum podle uzavirky - podle toho jestli je jeste mozno vkladat na dnes
    //if ( timeof(time()) < S_GetCasHistorie()   ||  S_GetCasHistorie() == 0 )
    if (DateUtils::startOfTheDay(time()) + 3600 * RonPortalSettings::getIntValue(RonPortalSettings::HISTORIE_POCET_HODIN) >= time()) {
        $datumoperace = date("j.n.Y");
    } else {
        $datumoperace = date("j.n.Y", DateUtils::incDay(DateUtils::startOfTheDay(time()), 1));
    }
}

?>

<?php if ( RonPortalSettings::getValue(RonPortalSettings::HISTORIE_NADPIS) ) { ?>
    <h1><?= RonPortalSettings::getValue(RonPortalSettings::HISTORIE_NADPIS) ?></h1>
<?php } ?>

<form method="POST" action="?menuid=historierozsirena">
<?php
    $comboOsoba ->render();
?>
    <input type="submit" class="submitbutton" value="Vybrat" />
</form>
<?php
    if ($historie) {
?>
    <!-- seznam zaznamu -->
    <table class="browser">
        <tbody>
        <tr class="browserheader">
            <th><?= \Ron\ronText('Date') ?></th>
            <th><?= \Ron\ronText('Operace') ?></th>
        </tr>

        <?php
            $row1 = $historie ->fetch();
            while ($row1) {
                $row2 = $historie ->fetch();
                if (!$row2) {
        ?>
                    <tr class="browsercolor1">
                        <td><?= DBUtils::getFormatedValue($database, 'date', $row1[0]) ?></td>
                        <td><?= $row1[3] ?></td>
                    </tr>
        <?php
                } else {
                    $date1 = DateUtils::startOfTheDay($historie ->stringToTimestamp($row1[0]));
                    $date2 = DateUtils::startOfTheDay($historie ->stringToTimestamp($row2[0]));
                    if ($date1 < $date2) {
                        // $row1 je posledni zaznam pro den
        ?>
                    <tr class="browsercolor1">
                        <td><?= DBUtils::getFormatedValue($database, 'date', $row1[0]) ?></td>
                        <td><?= $row1[3] ?></td>
                    </tr>
        <?php
                    }
                }

                $row1 = $row2;
            }
        ?>
        </tbody>
    </table>

    <br/><br/>
<?php } ?>


<form method="post" name="vkladaniformular" action="?menuid=historierozsirena">
    <input type="hidden" name="vkladaniaction" value="vlozdohistorie">
    <input type="hidden" name="osoba" value="<?= RonPortalSession::vybranaOsoba() ?>">

    <table class='inputtable'>

        <!-- Zadani data -->
        <tr>
            <td class="formtablecaption"><?= \Ron\ronText('Date') ?>: </td>
            <td>
                <input type="text" name="datumoperace" value="<?= $datumoperace ?>" maxlength="10">
            </td>
        </tr>

        <!-- Vyber operace -->
        <tr>
            <td class="formtablecaption"><?= \Ron\ronText('Operace') ?>: </td>
            <td>
                <?php $comboOperace ->render(); ?>
            </td>
        </tr>

        <tr>
            <td></td>
            <td>
                <input type="submit" class="submitbutton" value="<?= \Ron\ronText('form.Insert') ?>">
            </td>
        </tr>
    </table>

</form>
