<?php
/**
 * stanislav.elbl, 28.3.2018
 */

namespace RonPortal\Dochazka;

use Ron\Http\Csrf;
use Ron\MessageManager;
use Ron\MVC\Model;
use Ron\StringUtils;
use Ron\TextManager;
use RonPortal\PracovniPomer;
use RonPortal\RonPortalSettings;
use RonPortal\User;

/** @var OperaceDochazky[] $operaceList */
$operaceList = Model::getInstance() ->getData('operace');
/** @var PracovniPomer[] $pracovniPomery */
$pracovniPomery = Model::getInstance() ->getData('pracovniPomery');
/** @var int $vybranyPP */
$vybranyPP = Model::getInstance() ->getData('vybranyPP');

$backaction = Model::getInstance()->getData('backaction');

$vybranyTerminal = Model::getInstance() ->getData('vybranyTerminal');
?>
<h1><?= \Ron\ronText('Vkladani_operace') ?></h1>

<?php MessageManager::getInstance() ->showMessages(); ?>

<div id="vlozeni_s_podrobnostmi" class="vkladani_link margin-top-2"><a href="?menuid=vlozeni&terminalmode=0<?= $backaction ? "&backaction=$backaction" : "" ?>"><?= \Ron\ronText('Vlozeni_s_podrobnostmi') ?></a></div>

<form method="POST">

    <input type="hidden" name="vkladaniaction" value="terminal" />
    <input type="hidden" name="backaction" value="<?= $backaction ?>" />
    <input type="hidden" id="idpp" name="idpp" value="<?= $vybranyPP ?>" />

    <?= Csrf::csrfHiddenInput('vkladani_terminal') ?>

    <div id="terminalVkladani" class="terminalVkladani" data-potvrdit-ok="<?= RonPortalSettings::getIntValue('vkladani_potvrdit') ?>">
        <!-- tlacitko OK -->
        <?php if (RonPortalSettings::getIntValue('vkladani_potvrdit')) { ?>
            <input type="submit" class="submitbutton" id="vkladani_tlacitko_ok" value="<?= \Ron\ronText('OK') ?>" />
        <?php } ?>

        <!-- displej -->
        <div id="display" class="vkladani_display<?= RonPortalSettings::getIntValue('vkladani_potvrdit') ? ' display_s_potvrzenim' : '' ?>">
            <!-- display -->
            <div id="time"><!-- aktualni cas --></div>
            <div id="display1" class="displayline"><?= StringUtils::htmlTextConvert(User::getUserName()) ?></div>
            <div id="display2" class="displayline">
                <?php if (count($pracovniPomery) > 1) { ?>
                    <?php foreach($pracovniPomery as $pp) { ?>
                        <button name="idpp_<?= $pp ->idPP ?>" data-ron-idpp="<?= $pp ->idPP ?>" class="button tlacitko_pp<?= ($pp ->idPP == $vybranyPP) ? ' active' : ''?>">
                            <?= StringUtils::htmlTextConvert($pp ->typPP) ?>
                        </button>
                    <?php } ?>
                <?php } else { ?>
                    <?= \Ron\ronText('Osobni_cislo') ?> <?= StringUtils::htmlTextConvert($pracovniPomery[0]->osobniCislo) ?>
                <?php } ?>
            </div>
        </div>

        <!-- Poznamka -->
        <div>
            <label for="poznamka"><?= \Ron\ronText('Poznamka') ?></label>
        </div>
        <div>
            <input id="poznamka" name="poznamka" maxlength="250"/>
        </div>

        <!-- Kod a popis terminalu -->
        <?php if ($vybranyTerminal) { ?>
        <div class="margin-top-2">
            <?= TextManager::_('Terminal') ?>: <?= StringUtils::htmlTextConvert($vybranyTerminal['popis']) ?> (<?= StringUtils::htmlTextConvert($vybranyTerminal['kod']) ?>)
        </div>
        <?php } ?>

        <!-- Tlacitka -->
        <div>
            <input type="hidden" name="kodOperace" id="kodOperace"/>

            <?php foreach ($operaceList as $operace) { ?>
                <button name="tlacitko_operace_<?= StringUtils::htmlTextConvert($operace ->kod) ?>" id="tlacitko_operace_<?= StringUtils::htmlTextConvert($operace ->kod) ?>"
                        class="button tlacitko_operace"
                        data-ron-kodOperace="<?= StringUtils::htmlTextConvert($operace ->kod) ?>"><?= StringUtils::htmlTextConvert($operace ->popisProDochazku) ?></button>
            <?php } ?>
        </div>

    </div>
</form>
