<?php
/**
 * pavel.rudol, 01.11.2022 17:58
 */

namespace RonPortal\Dovednosti;

use Exception;
use Ron\DB\Database;

class DovednostOsoby
{
    /** @var string */
    public $typ;
    /** @var string */
    public $typPopis;
    /** @var string  */
    public $kod;
    /** @var string  */
    public $popis;
    /** @var int */
    public $uroven;
    /** @var  string */
    public $popisUrovne;

    /** @var array  */
    public $specifikaceUrovne;

    /** @var DovednostOsoby[] */
    public $podrizeneDovednosti;

    public $urovneDovednosti;

    public $platnostDo;

    /** @var string[] */
    public $htmlPopisUrovni = [];

    /**
     * DovednostOsoby konstruktor, nastavi zakladni vlastnosti.
     * @param string $kod kod Dovednosti
     * @param string $popis popis Dovednosti
     * @param int $uroven nejvyssi uroven Dovednosti pro zamestnance
     */
    function __construct($kod, $popis = '', $uroven = 0)
    {
        $this -> kod = $kod;
        $this -> popis = $popis;
        $this -> uroven = $uroven;

        $this->specifikaceUrovne = [];
    }

    /**
     * Nacita seznam vsech urovni dovednosti pro nacteni AJAXem do vyberu urovni dovednosti po vybrani konkretni dovednosti
     * @param Database $database
     * @throws Exception
     */
    function nactiUrovne($database)
    {
        $params = $database->createParameters();

        $sql = "SELECT KodUrovne, Popis FROM UrovenDovednosti WHERE PovolitRucniZadani = 1 AND KodDovednosti = " . $params->addParameter($this->kod);

        $cursor = $database ->getSqlResult($sql, $params);
        if ($cursor) {
            $row = $cursor->fetch();

            if (!$row) {
                throw new Exception('Chyba - úrovně dovednosti: ' . $this->kod . ' nebyly nalezeny!');
            }
            else {
                $urovne = array();
                $urovne[$row[0]] = $row[1];
            }

            while ($row = $cursor->fetch()) {
                $urovne[$row[0]] = $row[1];
            }

            $this ->urovneDovednosti = $urovne;

            $cursor->close();
        }
    }
}