<?php
/**
 * stanislav.elbl, 26.02.2021
 */

namespace RonPortal\Editace;

use Ron\DB\Database;
use Ron\DB\DBRecordField;
use RonPortal\RonPortalDBRecord;

class RozdeleniDennichVysledkuRecord extends RonPortalDBRecord
{
    /* @var int     kod typu rozdeleni */
    public $typRozdeleni;

    /* @public DBRecordField */
    public $fRozdeleni;
    /* @public DBRecordField */
    public $fSlozka;
    /* @public DBRecordField */
    public $fHodnota;
    /* @public DBRecordField */
    public $fPoznamka;

    public $jeZmena;


    /**
     * @param Database $database
     * @param string $typRozdeleni
     * @param string $rc
     * @param $osobniCislo
     * @param $datumNastupu
     * @param $den
     * @param $logDescription
     */
    function __construct($database, $typRozdeleni, $rc, $osobniCislo, $datumNastupu, $den, $logDescription)
    {
        parent::__construct($database, 'DenniVysledek_R_E');

        $this ->logDescription = $logDescription;
        $this ->jeZmena = false;

        $this ->typRozdeleni = (int)$typRozdeleni;

        $this ->addStringField('RC', true, 15, $rc);
        $this ->addStringField('OsobniCislo', true, 15, $osobniCislo);
        $this ->addDateField('DatumNastupu', true, $datumNastupu);

        $this ->addDateField('Den', true, $den);

        $this ->addIntField('KodTypuRozdeleni', true, $this ->typRozdeleni);

        $this ->fRozdeleni = $this ->addStringField('Rozdeleni', true, 30, null);

        $this ->fSlozka = $this ->addStringField('TypCasoveSlozkyMzdy',  true, 10, null);

        $this ->fHodnota = $this ->addFloatField('Hodiny', false, null); // readonly=false

        $this ->fPoznamka = $this ->addStringField('Poznamka', true, 250);
        

        $params = $this ->database ->createParameters();
        $this ->setWhere(
            'RC = ' . $params->addParameter($rc) .
            ' AND OsobniCislo = ' . $params->addParameter($osobniCislo) .
            ' AND DatumNastupu = ' . $params ->addParameter($database ->dateToParam($datumNastupu)) .
            ' AND Den = ' . $params->addParameter($database ->dateToParam($den)) .
            ' AND KodTypuRozdeleni = ' . $params ->addParameter((int)$this ->typRozdeleni),
            $params);
    }
}
