<?php
/**
 * UTF8
 * 30.12.2014, Formular pro editaci jednoho zaznamu dochazky
 */

namespace RonPortal\Editace;

/** @var EditaceDochazkyFormular $this */
use Ron\DateUtils;
use Ron\Http\Csrf;
use Ron\MessageManager;
use Ron\StringUtils;
use Ron\TextManager;
use RonPortal\RonPortalSettings;
use RonPortal\Security;

$readonlystr = $this->readOnly ? ' disabled="disabled" ' : '';

?>
<h1><?= TextManager::_('Editace_dochazky') ?></h1>

<?php MessageManager::getInstance() ->showMessages(); ?>

<form enctype="multipart/form-data" method="post" name="editacedochazkyform" action="?menuid=editacedochazky&action=<?= $this ->action ?>&idpp=<?= $this ->zaznam ->f_pp ->idPP ?>">
    <input type="hidden" name="zapsatZaznam" value="1" />
    <input type="hidden" name="idpp" value="<?= (int)$this ->zaznam ->f_pp ->idPP ?>" />
    <input type="hidden" name="datumcaspocatku" value="<?= $this->zaznam->fDatumCasPocatku ->value ?>" />
    <input type="hidden" name="datumpocatku" value="<?= date('j.n.Y', $this->zaznam->fDatumCasPocatku ->value) ?>" /> <!-- pro js -->

    <?= Csrf::csrfHiddenInput('editacedochazky_' . $this->zaznam->f_pp->idPP . '_' . DateUtils::dateToUrlString($this->zaznam->fDatumCasPocatku->value)) ?>

    <div class="form form-sm middle-form">
        <div class="form-content keyInputMove" id="editaceZaznamu">
            <div class="row">
                <div class="col col-12 col-sm-3" style="white-space:nowrap">
                    <?php $this->zobrazSchvaleni($this->zaznam->fDatumCasPocatku ->value); ?>
                </div>
                <div class="col col-12 col-sm-9">
                    <strong><?= $this->zaznam->f_pp ->jmenoPrijmeni ?></strong>
                </div>
            </div>


            <!-- datum od - (do) -->
            <div class="row">
                <div class="col col-3 d-xs-none"></div>
                <div class="col col-4 col-sm-2">
                    <strong><?= TextManager::_('Day_short_' . date('w', $this->zaznam->fDatumCasPocatku->value)) ?>  <?= date('j.n.Y', $this->zaznam->fDatumCasPocatku ->value) ?></strong>
                    <?php if ($this->obdobiUzavreno) { ?> <i class="inline-glyph fa glyph-lock"></i><?php } ?>
                </div>

                <?php if (!$this->readOnly && $this ->action == 'new') {
                    $displaylink = $this->zaznam->f_ViceDnu ? 'none' : 'inline';
                    $displayedit = $this->zaznam->f_ViceDnu ? 'inline' : 'none';
                    ?>
                    <div class="col col-2 col-sm-1 caption"><span id="datumdocaption" style="display:<?= $displayedit ?>"><?= TextManager::_('Do') ?></span></div>

                    <div class="col col-6">
                        <span id="vicednu_link" style="display:<?= $displaylink ?>"><a href=""><?= TextManager::_('Vice_dnu') ?></a></span>
                        <span id="datumdo" style="display:<?= $displayedit ?>">
                            <input type="hidden" name="provicednu" id="provicednu" value="<?= (int)$this->zaznam->f_ViceDnu ?>" />

                            <input type="text" class="<?= $this->zaznam->chybaDatumDo ? 'app_input_error' : 'app_input' ?> inputDate" name="datumdo"
                                   maxlength="10" size="10" <?= $readonlystr ?>
                                   value="<?= $this->zaznam->f_DatumDoStr ? $this->zaznam->f_DatumDoStr : date("j.n.Y", $this->zaznam->fDatumCasPocatku->value) ?>"
                                   data-roncalendar-mindate="<?= date('j.n.Y', DateUtils::firstDayOfMonth($this ->zaznam ->fDatumCasPocatku ->value) ) ?>"

                                />
                            <i class="showcalendar inline-glyph glyph-button fa glyph-calendar" data-roncalendar-inputname="datumdo"></i>
                        </span>
                    </div>
                <?php } ?>
            </div>

            <!-- zobrazeny cas od    ...       do      ...   = ...(zobrazena doba) -->
            <div class="row">
                <div class="col col-12 col-sm-3 caption"><?= TextManager::_(RonPortalSettings::getIntValue(ZaznamDochazky::SETTINGS_SKRYT_ZAPOCTENY) ? 'Cas_od' : 'Zobrazeny_cas_od') ?></div>
                <div class="col col-3 col-sm-2">
                    <input type="text" class="<?= $this->zaznam->chybaCasPocatku ? 'app_input_error' : 'app_input' ?> inputTime" name="caspocatku"
                           maxlength="5" size="5" <?= $readonlystr ?> value="<?= $this->zaznam->casPocatkuStr ?>" />
                </div>
                <div class="col col-3 col-sm-1 caption"><?= TextManager::_('Do') ?></div>
                <div class="col col-3 col-sm-2">
                    <input type="text" class="<?= $this->zaznam->chybaCasKonce ? 'app_input_error' : 'app_input' ?> inputTime" name="casukonceni"
                           maxlength="5" size="5" <?= $readonlystr ?> value="<?= $this->zaznam->casKonceStr ?>" />
                </div>
                <div class="col col-3 col-sm-1">
                    <?php
                    if ($this->zaznam->fDatumCasUkonceni->value && $this->zaznam->fDatumCasPocatku->value) {
                        $dobastr = DateUtils::minutesToString(($this->zaznam->fDatumCasUkonceni->value - $this->zaznam->fDatumCasPocatku->value) / 60);
                    } else {
                        $dobastr = ''; // '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    }
                    ?>
                    <strong><span id='zobrazena_doba'><?= $dobastr ?></span></strong>
                </div>
                <div class="col col-2 d-xs-none">
                    (<?= TextManager::_('zobrazena_doba') ?>)
                </div>
                <?php if (!RonPortalSettings::getIntValue(ZaznamDochazky::SETTINGS_SKRYT_ZAPOCTENY)) { ?>
                    <div class="col col-1 d-xs-none">
                        <span class="inline-glyph glyph-button fa glyph-down" id="skutecnadoba" title="<?= TextManager::_('skutecna_doba') ?>"></span>
                    </div>
                <?php } ?>
            </div>


            <?php if (!RonPortalSettings::getIntValue(ZaznamDochazky::SETTINGS_SKRYT_ZAPOCTENY)) { ?>
                <!-- zapocteny cas od    ...       do      ...   = ...(zobrazena doba) -->
                <div class="row">
                    <div class="col col-12 col-sm-3 caption"><?= TextManager::_('Zapocteny_cas_od') ?></div>
                    <div class="col col-3 col-sm-2">
                        <input type="text" class="<?= $this->zaznam->chybaZapoctenyCasOd ? 'app_input_error' : 'app_input' ?> inputTime" name="zapoctenycasod"
                               maxlength="5" size="5" <?= $readonlystr ?> value="<?= $this->zaznam->zapoctenyCasOdStr ?>" />
                    </div>
                    <div class="col col-3 col-sm-1 caption"><?= TextManager::_('Do') ?></div>
                    <div class="col col-3 col-sm-2">
                        <input type="text" class="<?= $this->zaznam->chybaZapoctenyCasDo ? 'app_input_error' : 'app_input' ?> inputTime" name="zapoctenycasdo"
                               maxlength="5" size="5" <?= $readonlystr ?> value="<?= $this->zaznam->zapoctenyCasDoStr ?>">
                    </div>
                    <div class="col col-3 col-sm-1">
                        <?php
                        if ($this->zaznam->fDatumCasUkonceni ->value  &&  $this->zaznam->fDatumCasPocatku ->value) {
                            $dobastr = DateUtils::minutesToString(($this ->zaznam ->fDatumCasUkonceni ->value  +  $this ->zaznam ->deltaZaSec  -
                                    $this ->zaznam ->fDatumCasPocatku ->value  +  $this ->zaznam ->deltaPredSec) / 60);
                        } else {
                            $dobastr = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                        }
                        ?>
                        <span id='zapoctena_doba'><?= $dobastr ?></span>
                    </div>
                    <div class="col col-3 d-xs-none">
                        (<?= TextManager::_('zapoctena_doba') ?>)
                    </div>
                </div>
            <?php } ?>

            <!-- den prirazeni -->
            <div class="row">
                <div class="col col-6 col-sm-3 caption"><?= TextManager::_('Den_prirazeni') ?></div>
                <div class="col col-6 col-sm-9">
                    <input type="text" class="<?= $this->zaznam->chybaDen ? 'app_input_error' : 'app_input' ?> inputDate" name="den"
                           maxlength="10" size="10" <?= $readonlystr ?> value="<?= $this->zaznam->denStr ?>"
                           data-roncalendar-mindate="<?= date('j.n.Y', DateUtils::incDayStart($this ->zaznam ->fDatumCasPocatku ->value, -1) ) ?>"
                           data-roncalendar-maxdate="<?= date('j.n.Y', DateUtils::incDayStart($this ->zaznam ->fDatumCasPocatku ->value, 1) ) ?>"
                        />
                    <i class="showcalendar inline-glyph glyph-button fa glyph-calendar" data-roncalendar-inputname="den"></i>
                </div>
            </div>

            <!-- operace             ...........   ... -->
            <div class="row">
                <div class="col col-12 col-sm-3 caption"><?= TextManager::_('Operace') ?></div>
                <div class="col col-8 col-sm-6">
                    <?php $this->showVyberOperace($this->zaznam->fOperace ->value, '', false); ?>
                </div>
                <div class="col col-4 col-sm-3">
                    <?php $this->showVyberOperace($this->zaznam->fOperace ->value, '', true); ?>
                </div>
            </div>

            <!--  smena               ........... -->
            <div class="row">
                <div class="col col-12 col-sm-3 caption"><?= TextManager::_('Smena') ?></div>
                <div class="col col-12 col-sm-9">
                    <?php $this->showVyberSmeny($this ->zaznam, 'smena'); ?>
                </div>
            </div>

            <!-- rozdeleni -->
            <?php if (RonPortalSettings::getIntValue(RonPortalSettings::EDITACE_TYP_ROZDELENI)) { ?>
                <div class="row">
                    <div class="col col-12 col-sm-3 caption">
                        <?= RonPortalSettings::getValue(RonPortalSettings::EDITACE_NADPIS_ROZDELENI) ?: TextManager::_('Rozdeleni') ?>
                    </div>
                    <div class="col col-8 col-sm-6">
                        <?php $this->showVyberRozdeleni($this->zaznam, 'rozdelenidochazky', false); ?>
                    </div>
                    <div class="col col-4 col-sm-3">
                        <?php $this->showVyberRozdeleni($this->zaznam, 'rozdelenidochazky', true); ?>
                    </div>
                </div>
            <?php } ?>

            <!-- poznamka            ............................ -->
            <div class="row">
                <div class="col col-12 col-sm-3 caption"><?= TextManager::_('Poznamka') ?></div>
                <div class="col col-12 col-sm-9">
                    <input type="text" class="form-input" name="poznamka" maxlength="160" <?= $readonlystr ?> value="<?= StringUtils::htmlTextConvert($this->zaznam->poznamka) ?>" />
                </div>
            </div>

            <!-- zpracoval -->
            <div class="row">
                <div class="col col-4 col-sm-3 caption"><?= TextManager::_('Zpracoval') ?></div>
                <div class="col col-8 col-sm-9"><?= StringUtils::htmlTextConvert($this->zaznam->fZpracoval->originalValue) ?></div>
            </div>

            <?php if ( !$this->readOnly  &&  RonPortalSettings::getSpousteniADS()  &&  (!RonPortalSettings::getIntValue(RonPortalSettings::EDITACE_VKLADAT_PRESTAVKY)  ||  $this ->action == 'ulozzaznam') ) {
                // zaskrtavatko "automaticky vlozit prestavky" - pokud bude zaskrtnuto, tak po zapsani zaznamu zavola agenta
                ?>
                <div class="row">
                    <div class="col col-3 d-xs-none"></div>
                    <div class="col col-12 col-sm-9"><label><input class="app_check" type="checkbox" name="vlozitPrestavkyProDen" /> <?= TextManager::_('Automaticky_vlozit_prestavky') ?></label></div>
                </div>
            <?php } ?>

        </div>

        <div class="buttons">
            <div class="row">
                <div class="col col-3"><a href="?menuid=zpracovanadochazka&osoba=<?= $this ->zaznam ->f_pp ->idPP ?>"><?= TextManager::_('Zpet') ?></a></div>


                <?php if (!$this->readOnly) { ?>
                    <div class="col col-3">
                        <input type="submit" class="submitbutton" value="<?= TextManager::_('OK') ?>" />
                    </div>

                    <!-- dalsi tlacitka (zrusit, podle puvodni) -->
                    <div class="col col-6 align-right">

                        <?php if ($this ->action == 'new') { // podle puvodni a kalendare jen u noveho zaznamu ?>
                            <!-- podle puvodni dochazky -->
                            <input type="button" class="button confirmQuestion" name="podlepuvodni" id="btn_podlepuvodni" value="<?= TextManager::_('Podle_puvodni_dochazky') ?>"
                                   data-ron-href="?menuid=editacedne&action=podlepuvodni&idpp=<?= $this->zaznam->f_pp ->idPP ?>&datum=<?= $this->zaznam->fDatumCasPocatku ->value ?>"
                                   data-ron-confirm-id="Opravdu_podle_puvodni" data-ron-working-info="<?= TextManager::_('Probiha_zpracovani_dat') ?>"/>

                            <!-- vlozeni podle kalendare -->
                            <input type="button" class="button confirmQuestion" name="podlekalendare" value="<?= TextManager::_('Podle_kalendare') ?>"
                                   data-ron-href="?menuid=podlekalendare&idpp=<?= $this->zaznam->f_pp ->idPP ?>&datum=<?= DateUtils::dateToUrlString($this->zaznam->fDatumCasPocatku->value) ?>"
                                   data-ron-confirm-id="Opravdu_podle_kalendare"/>

                        <?php } else { /* tlacitko "zrusit" se u noveho nezobrazuje */ ?>
                            <input type="button" class="button confirmQuestion" name="zrusitzaznam" id="btn_zrusitzaznam" value="<?= TextManager::_('Zrusit_zaznam_dochazky') ?>"
                                   data-ron-href="?menuid=editacedochazky&action=zrusitzaznam&idpp=<?= $this->zaznam->f_pp ->idPP ?>&datumcas=<?= $this->zaznam->fDatumCasPocatku->value ?>"
                                   data-ron-confirm-id="Opravdu_smazat_zaznam_dochazky"/>
                        <?php } ?>

                    </div>
                <?php } ?>
            </div>
        </div>
    </div>
</form>

<?php $this ->showJsonData(); ?>

<script type="application/javascript">
    ronPortal.dochazka.editaceZaznamu();
</script>
