<?php
/**
 * stanislav.elbl, 18.06.2015
 */

namespace RonPortal\Editace;

/**
 * @var ZpracovanaDochazkaBrowser $this
 */

use Ron\Controls\Dialog;
use Ron\Controls\DialogButton;
use Ron\DateUtils;
use Ron\GuiUtils;
use Ron\Http\Csrf;
use Ron\Http\HttpHeaders;
use Ron\TextManager;
use RonPortal\Controls\FormReportsListView;
use RonPortal\Dochazka\VysledekKontroly;
use RonPortal\Kalendar;
use RonPortal\Prava;

$this ->jeEdit = true; // POZOR! Musi byt, aby byla videt tlacitka, pokud jsou nahore

?>
<style nonce="<?= HttpHeaders::getNonce() ?>">
    .graficka_timediv { width: <?= $this ->grafickaWidth ?>px }

    <?php if ($this ->denniVysledky ->style) {?>
        <?= $this ->denniVysledky ->style ?>
    <?php } ?>
</style>

<div id="zpracovanadochazka">
    <form class="sendPosition submitWorkingInfo" name="zpracovanadochazkaform" id="zpracovanadochazkaform" method="post" action="?menuid=zpracovanadochazka" >

        <input type="hidden" name="obdobi" value="<?= DateUtils::dateToUrlString($this ->denniVysledky ->datumOd) ?>" />
        <input type="hidden" name="osoba" value="<?= $this ->denniVysledky ->pp ->idPP ?>" />

        <input type="hidden" name="x" value="" />
        <input type="hidden" name="y" value="" />

        <?= Csrf::csrfHiddenInput("zpracovana_{$this ->denniVysledky ->pp ->idPP}_{$this ->denniVysledky ->datumOd}") ?>

        <!-- tlacitka nahore -->
        <div class="buttons">
            <input type="submit" style="width:0; height:0; margin:0; padding:0; border: 0" value="" /> <!-- defaultni submit kvuli enter -->
            <span class="zpracovana_tlacitka1">
                <?php $this ->zobrazTlacitka(1); // vlevo nahore  ?>
            </span>

            <?php $this ->volbaZobrazeni(); ?>

            <span class="float-right zpracovana_tlacitka2">
                <?php $this ->zobrazTlacitka(2); // vpravo nahore ?>
            </span>
        </div>


        <?php
            $this ->jeEdit = false;
            $this ->renderTableStart();
        ?>

        <thead class="floating-table-header">
            <tr>
                <?php
                    for ($i = 0; $i < count($this ->denniVysledky ->sloupce); $i++) {
                        if ($this ->denniVysledky ->sloupce[$i] ->typ  &&  $this ->denniVysledky ->sloupce[$i] ->lzeZobrazit) {
                            $this->zobrazHlavickuSloupce($i);
                        }
                    }
                ?>
            </tr>
        </thead>

        <tbody class="border-bottom">
            <?php if ($this ->denniVysledky ->zobrazitMesicniKontroly == 2  ||  $this ->denniVysledky ->zobrazitMesicniKontroly == 3) {
                $this->renderMesicniKontroly();
            } ?>

            <?php foreach ($this ->denniVysledky ->f_data as $index => $radek) {
                $cssClass = Kalendar::getStyleForDate($this ->database, $radek ->datum, true, $this ->denniVysledky ->kalendar);
                if ($radek ->cssClass) {
                    $cssClass .= ' ' . $radek ->cssClass;
                }

                $classStr = $cssClass ? "class='$cssClass'" : '';

                $styleStr = ($this ->denniVysledky ->obarvitKontroly  && isset($radek ->barvaRadku))
                    ? 'style="background-color: ' . GuiUtils::getHtmlColor($radek ->barvaRadku) . ' !important"'
                    : '';
            ?>
                <tr <?=$classStr?> <?= $styleStr ?> data-ron-datum="<?= date('j.n.Y', $radek ->datum) ?>">
                    <?php $this ->zobrazRadek($index); ?>
                </tr>
            <?php } ?>
        </tbody>

        <tbody>
            <?php $this ->renderTableFooter(); ?>
        </tbody>

        <?php $this ->renderTableEnd(); ?>

        <input type="hidden" name="zpracovana_dochazka" value="1" />

        <?php
            // (editovatelne) mesicni vysledky
            if ($this ->editaceMesicnich1) {
                echo '<div id="zpracovanadochazka_mv1">';
                $this ->editaceMesicnich1 ->zobrazData();
                echo '</div>';
            }

            if ($this ->editaceMesicnich2) {
                echo '<div id="zpracovanadochazka_mv2">';
                $this ->editaceMesicnich2 ->zobrazData();
                echo '</div>';
            }

            if ( $this ->editaceMesicnich1 || $this ->editaceMesicnich2 ) $this ->jeEdit = true;

            if ($this ->denniVysledky ->existujeTlacitko('vlozitdokument')) {
                // dokumenty - zobrazuje je jen kdyz je pro ne tlacitko
                //if ($this->f_povoliteditaci) { - podminka odstranena 22.6.2015 - neslo smazat dokumenty, i kdyz mel prava na vkladani
                    // smazani dokumentu (pole nastavuje javascript)
                    echo '<input type="hidden" name="deleteDocumentId" id="deleteDocumentId" value="" />';

                    $pravoDoc = Prava::vratPrava('editacedokument');
                    $jePravoDoc = $pravoDoc->lzeZobrazitPP($this ->denniVysledky ->pp ->idPP, $this ->denniVysledky ->datumOd, $this ->denniVysledky ->datumDo);
                //}
                DokumentyDochazkyBrowser::zobrazDokumentyDochazky($this ->database, $this->denniVysledky->pp, $this ->denniVysledky ->datumOd, $jePravoDoc);
            }
        ?>

        <!-- tlacitka dole -->
        <div class="buttons">
            <span class="zpracovana_tlacitka3">
                <?php $this ->zobrazTlacitka(3); ?>
            </span>

            <span class="float-right zpracovana_tlacitka4">
                <?php $this ->zobrazTlacitka(4); ?>
            </span>
        </div>

        <?php if ($this ->povolitEditaci) { ?>
        <div id="zpracovana_tlacitka_float" class="zpracovana_tlacitka_float" style="display:none">
            <div>
                <input name="smazatvybrane" class="button" type="submit" value="<?= \Ron\ronText('Smazat_vybrane') ?>">
            </div>
            <?php $this ->zobrazTlacitka(5); // v panelu  ?>
            <input type="hidden" name="vybranedny" value="">
        </div>
        <?php } ?>

    </form>

    <div id="zpracovana_reports">
        <!-- seznam reportu - musi byt mimo FORM! -->
        <?php
            FormReportsListView::renderReportList($this ->reportList,
                '?menuid=zpracovanadochazka&action=report&idpp=' . $this ->denniVysledky ->pp ->idPP . '&obdobi=' . DateUtils::dateToUrlString($this ->denniVysledky ->datumOd));
        ?>
    </div>

    <?php
    // dialog s vysledky kontrol
    if ( sizeof($this ->denniVysledky ->kontroly) ) {
        VysledekKontroly::zobrazDialogKontrol($this ->denniVysledky ->kontroly);
    }
    ?>

    <?php
    if ($this ->denniVysledky ->existujeTlacitko('pk_zmenitsmenu')) {
        $pk_dialog = (new Dialog())
            ->setTitle('Zmena_naplanovane_smeny')
            ->setId('zpracovana_pk_zmenitsmenu')
            ->setWaitMessage(true)
            ->addButton(
                (new DialogButton())
                    ->setId('btn_pk_OK')
                    ->setValue('Provest')
            )
            ->addButton(
                (DialogButton::cancelButton('btn_pk_Storno'))
            )
            ->setView('ronportal/dochazka/view_zmena_smeny_pk.php');

        $pk_dialog ->render();
    }
    ?>

    <?php
    if ($this ->denniVysledky ->existujeSloupec('COPY')) {
        $dialog = (new Dialog())
            ->addParameter('denniVysledky', $this ->denniVysledky)
            ->setTitle('Kopie_dne_dochazky')
            ->setId('kopie_dne_dochazky_dialog')
            ->addClass('ronform middle-form')
            ->setFormTag(['method' => 'POST'])
            ->addButton(
                (new DialogButton())
                    ->setId('kopie_dne_dochazky_ok')
                    ->setClass('actionButton submitbutton')
                    ->setValue('OK')
            )
            ->addButton(
                (DialogButton::cancelButton('kopie_dne_dochazky_storno', TextManager::_('Cancel')))
            )
            ->setView('ronportal/dochazka/view_kopie_dne_dochazky.php');

        $dialog ->render();
    }
    ?>
</div>

