<?php
/**
 * stanislav.elbl, 06.08.2015
 */

namespace RonPortal\ELearning;

use Ron\DB\DBException;
use Ron\Http\HttpResponse;
use Ron\MVC\OutputObject;


/**
 * OutputObject pro stahnuti prilohy z databaze
 * Class PrilohaOutputObject
 */
class PrilohaOutputObject implements OutputObject
{
    /** @var  \Ron\DB\Database */
    protected $database;
    /** @var  int */
    protected $idPrilohy;


    /**
     * @param \Ron\DB\Database $database
     * @param int  $idPrilohy
     */
    function __construct($database, $idPrilohy = null)
    {
        $this ->database = $database;
        $this ->idPrilohy = $idPrilohy;
    }


    /**
     * @return \Ron\DB\Cursor
     * @throws DBException
     * @throws \Exception
     */
    function getData()
    {
        if (!isset($this ->idPrilohy)) {
            throw new \Exception('Chyba v PrilohaOutputObject - neni zadani id prilohy!');
        }

        $params = $this ->database ->createParameters();
        $sql =
            'SELECT Nazev, Obsah FROM Priloha ' .
            ' WHERE Id = ' . $params ->addParameter((int)$this ->idPrilohy);

        return $this ->database ->getSqlResult($sql, $params);
    }

    /**
     * @return void
     * @throws \Exception
     */
    public function output()
    {
        $cursor = $this ->getData();

        if (!$row = $cursor ->fetch()) {
            throw new \Exception('Chyba! Pozadovana priloha neexistuje!');
        }

        // headers
        HttpResponse::getInstance() ->getHeaders() ->addHeadersForContent($row[0]);
        HttpResponse::renderHeaders();

        print $cursor ->stringToBinary($row[1]);
        exit;
    }
}
