<?php
/**
 * stanislav.elbl, 10.07.2015
 */

namespace RonPortal\ELearning;

use Ron\Http\App;
use Ron\Http\HtmlHeaders;
use Ron\Http\HttpResponse;
use Ron\MVC\Model;
use Ron\StringUtils;
use RonPortal\RonPortalSettings;

global $appDate;
global $appVersion;
global $copyrightYear;

$defaultQueryString = Model::getInstance()['ron@defaultQueryString'];

$langStr = RonPortalSettings::getValue('preklady', 'cz;sk;eng');
$langs = $langStr ? explode(';', $langStr) : ['cz', 'sk', 'eng'];

$editace = Model::getInstance() ->getData('editace');
?>
<!doctype html>
<html>
<head>
    <?php
    require('ron/apphead.php');
    require('view/apphead.php');

    if ( App::getDebugMode() ) {
        HttpResponse::getInstance() ->getHeaders() ->renderDebugScript();
    }
    ?>

</head>
<body class="<?= $editace ? 'editace' : '' ?>">
<!--<div class="pagecontent">-->
    <!-- hlavicka, aplikace, jazyk -->
    <?php
        require('view/apptitle.php');
    ?>

    <div id="topmenu" class="topmenu">
        <div class="appselect">
            <div class="appselect-item active"><a href="?"><?= \Ron\ronText('RON_Portal') ?></a></div>
            <div class="appselect-item active"><a href="?menuid=kurzy"><?= \Ron\ronText('Kurzy') ?></a></div>
        </div>
        <ul class="langselect inline-list list-slash">
            <?php foreach ($langs as $lang) { ?>
                <li id="lang_item_<?= $lang ?>" title="<?= \Ron\ronText('LANG_TITLE_' . strtolower($lang)) ?>">
                    <a href="?session@lang=<?= $lang ?>&<?= $defaultQueryString ?>"><?= \Ron\ronText('LANG_' . strtolower($lang)) ?></a>
                </li>
            <?php } ?>
        </ul>
    </div>

    <?php
        require('view/userpanel.php');
    ?>

    <?php if(!$editace) { ?>
    <div class="container">
    <?php } ?>

    <?php
    if (Model::getInstance() ->getViewObjects()) {
        foreach (Model::getInstance() ->getViewObjects() as $viewObject) {
            $viewObject ->render();
        }
    }
    ?>

    <?php if(!$editace) { ?>
    </div>
    <?php } ?>

            <!-- paticka -->
    <div class="footer">
        <div class="copyright">
            &copy; 2003-<?= $copyrightYear ?>, <?= StringUtils::fromUTF8('Všechna práva vyhrazena') ?>, <a href="http://www.ron.cz">RON Software</a>, s.r.o.
        </div>

        <div id="nojs"><a href="script/nojs.html"><?= \Ron\ronText('Adblock_nebo_vypnuty_javascript') ?></a></div>

        <div class='version' title='<?= $appDate ?>'><a href='verze.php' target='_blank'> <?= $appVersion ?></a></div>
    </div>

<!--</div>-->
</body>
</html>
