<?php
/**
 * stanislav.elbl, 10.03.2021
 */

namespace RonPortal\Kapacity;

use Ron\DB\Database;


class SchvaleniKapacitPP extends SchvaleniKapacit
{
    /** @var int */
    var $idPP;

    public function lzeSchvalovatDen($uroven, $datum)
    {
        $pravo = $this ->vratPravoProUroven($uroven);
        return $pravo ->lzeZobrazitPP($this ->idPP, $datum, $datum);
    }

    /**
     * Nacte datumy schvaleni kapacit osoby v zadanem obdobi
     * @param Database $database
     * @param int $obdobi
     * @param int $idPP
     * @return SchvaleniKapacitPP
     */
    public static function nactiSchvaleni($database, $obdobi, $idPP)
    {
        $result = new static();

        $result ->schvaleni1 = $result ->schvaleni2 = $result ->schvaleni3 = 0;
        $result ->schvaleniUprav1 = $result ->schvaleniUprav2 = $result ->schvaleniUprav3 = 0;

        $params = $database ->createParameters();

        $sql =
            'SELECT ZpracovanoDo, ZkontrolovanoDo, SchvalenoDo, UpravyZpracovanyDo, UpravyZkontrolovanyDo, UpravySchvalenyDo' .
            ' FROM SchvaleniKapacit, PracovniPomer' .
            ' WHERE PracovniPomer.Id = ' . $params ->addParameter($idPP) .
            ' AND SchvaleniKapacit.RC = PracovniPomer.RC' .
            ' AND SchvaleniKapacit.OsobniCislo = PracovniPomer.OsobniCislo' .
            ' AND SchvaleniKapacit.DatumNastupu = PracovniPomer.DatumNastupu' .
            " AND SchvaleniKapacit.Aplikace = 'ADS'" .
            ' AND SchvaleniKapacit.PocatekObdobi = ' . $params ->addParameter($database ->dateToParam($obdobi));

        $cursor = $database ->getSqlResult($sql, $params);

        $row = $cursor ->fetch();
        if ($row) {
            $result ->schvaleni1 = $row[0] ? $database ->stringToTimestamp($row[0]) : 0;
            $result ->schvaleni2 = $row[1] ? $database ->stringToTimestamp($row[1]) : 0;
            $result ->schvaleni3 = $row[2] ? $database ->stringToTimestamp($row[2]) : 0;

            $result ->schvaleniUprav1 = $row[3] ? $database ->stringToTimestamp($row[3]) : 0;
            $result ->schvaleniUprav2 = $row[4] ? $database ->stringToTimestamp($row[4]) : 0;
            $result ->schvaleniUprav3 = $row[5] ? $database ->stringToTimestamp($row[5]) : 0;
        }

        return $result;
    }
}
