<?php

/**
 * Dialog pro uzivatelske nastaveni v planovani kapacit
 * - vyber oblibenych smen
 * - nastaveni velikosti bunky
 */
namespace RonPortal\Kapacity;

use Ron\Controls\Dialog;
use Ron\Controls\DialogButton;
use Ron\MVC\Renderer;
use Ron\MVC\TextViewObject;
use Ron\TextManager;

$renderer = new Renderer(null);
$renderer ->start();
?>
    <ul id="kapacity_nastaveni_zalozky" class="rontabs">
        <li data-ron-tab="kapacity_zakladninastaveni"><a><?= TextManager::_('Nastaveni_vzhledu_kapacit')?></a></li>
        <li data-ron-tab="kapacity_smenyuzivatele"><a><?= TextManager::_('Vybrane_smeny_uzivatele') ?></a></li>
    </ul>

    <div id="kapacity_nastaveni_stranky" style="min-height:100px">
        <div id="kapacity_zakladninastaveni" class="kapacity_stranka_nastaveni padding-all-2">
            <div class="row">
                <label for="kapacity_nastaveni_sirka" class="col-3 align-right padding-right-2"><?= TextManager::_('Sirka_bunky') ?></label>
                <div class="col-9"><input class="form-control" id="kapacity_nastaveni_sirka"></div>
            </div>
            <div class="row">
                <label for="kapacity_nastaveni_vyska" class="col-3 align-right padding-right-2"><?= TextManager::_('Vyska_bunky') ?></label>
                <div class="col-9"><input class="form-control" id="kapacity_nastaveni_vyska"></div>
            </div>
        </div>
        <div id="kapacity_smenyuzivatele" class="kapacity_stranka_nastaveni"></div>
    </div>
<?php
$dialogContent =  $renderer ->stop();

(new Dialog())
    ->setView(new TextViewObject($dialogContent, null, null))
    ->setId('kapacity_nastaveni')
    ->setTitle('Uzivatelske_nastaveni_kapacit')
    //->addDialogClass('modal-lg')
    ->addButton(
        (new DialogButton())
            ->setValue('OK')
            ->setId('kapacity_vybersmen_ok')
    )
    ->addButton(DialogButton::cancelButton('kapacity_vybersmen_storno'))
    ->render();

