<?php
/**
 * stanislav.elbl, 16.07.2015
 */

namespace RonPortal\Kapacity;

use Ron\Controls\Dialog;
use Ron\Controls\DialogButton;
use Ron\DB\Database;
use Ron\Http\App;
use Ron\Http\Csrf;
use Ron\Http\HttpHeaders;
use Ron\Http\HttpResponse;
use Ron\MVC\Model;
use Ron\MVC\Renderer;
use Ron\MVC\TextViewObject;
use Ron\TextManager;
use RonPortal\NastaveniUzivatele;
use RonPortal\Prava;
use RonPortal\RonPortalSettings;
use RonPortal\RonPortalXMLEvents;
use RonPortal\System\Report;
use RonPortal\TypRozdeleni;
use Ron\StringUtils;
use RonPortal\XML\RonPortalXMLForm;
use RonPortal\XML\SablonaXmlFormulare;

/** @var TypRozdeleni $typRozdeleni2 */
$typRozdeleni2 = Model::getInstance() ->getData('typRozdeleni2');
/** @var Report[] $reportList */
$reportList = Model::getInstance() ->getData('reportList');
$sirkaBunky = Model::getInstance() ->getData('sirkaBunky');
$vyskaBunky = Model::getInstance() ->getData('vyskaBunky');
$provadetKontroly = Model::getInstance() ->getData('provadetKontroly');
$planovaniPoSlotech = Model::getInstance() ->getData('planovaniPoSlotech');
$rezimUprav = Model::getInstance() ->getData('rezimUprav');
$detailniZobrazeni = Model::getInstance() ->getData('detailniZobrazeni');
/** @var Database $database */
$database = Model::getInstance() ->getData('database');

$nonce = HttpHeaders::getNonce();

/** @var SablonaXmlFormulare[] $xmlAkce */
$xmlAkce = Model::getInstance() ->getData('xmlAkce');

$zobrazitFiltrOsoba = (int)NastaveniUzivatele::getUserSettingsItem($database, 'pk_zobrazit_filtr_osoby', 0)  ||  ($_GET['osoba'] ?? false);

?>
<!DOCTYPE html>
<html>
<head>
    <?php
    require('ron/apphead.php');
    require('view/apphead.php');

    if ( !RonPortalSettings::getIntValue(KapacitySettings::KAPACITY_EDITACE) ) { ?>
        <div class="errormsg">Tato funkce je vypnuta!</div>
    <?php
        die;
    }

    if ( App::getDebugMode() ) {
        // Do logu zapise headery, ktere odeslal
        HttpResponse::getInstance() ->getHeaders() ->renderDebugScript();
    }

    global $appVersion;
    $jsparam = '?param='.$appVersion;
    ?>

    <style id="row_colors_style" nonce="<?= $nonce ?>"></style>
</head>
<body class="bodykapacity <?= $detailniZobrazeni ? 'detailni-zobrazeni' : '' ?>">
<div class="planovani_window <?= $rezimUprav ? 'rezim_uprav' : 'rezim_planovani' ?> <?= $planovaniPoSlotech ? 'planovani-slotu' : '' ?>" id="planovani_window">

    <div id="kapacity_header" class="row m-0 flex-align-items-center">
        <!-- tlacitka (refresh, tisk) -->
        <div id="kapacity_buttons" class="col-auto margin-right-2">
            <div class="row flex-md-column">
                <div class="col p-0 mb-1">
                <i class="inline-glyph glyph-button fa glyph-refresh" id="kapacity_refresh"></i>
                </div>
                <div class="col p-0">
                <i class="xplanovani_button fa inline-glyph glyph-button glyph-print" id="kapacity_print"></i>
                <ul id="report_menu" class="popupmenu">
                    <?php foreach ($reportList as $report) { ?>
                        <li data-ron-kod="<?= StringUtils::htmlTextConvert($report ->kod) ?>"><?= StringUtils::htmlTextConvert($report ->nazev) ?></li>
                    <?php } ?>
                </ul>
                </div>
            </div>
            <?php if (count($reportList)) { ?>
<!--                <div class="row">-->
<!--                </div>-->
            <?php } ?>
        </div>

        <!-- tlacitko "zavrit" -->
        <div id="planovani_exit" class="col-auto margin-left-2 text-end">
            <input type="button" class="button clickHref" value="<?= TextManager::_('Zavrit_planovani') ?>" data-ron-href="?menuid=kapacity" />
        </div>

        <!-- filtr - obdobi, rozdeleni, osoba -->
        <div id="kapacity_filter">
            <!-- filtr obdobi -->
            <div class="row">
                <div class="col-3 align-right padding-right-2" id='nadpisobdobi'><?= TextManager::_('Obdobi') ?></div>
                <div class="col">
                    <div class="input-group">
                        <select id='obdobi_select' class="form-select"></select>
                        <span class="input-group-text p-1">
                            <i id="kapacity_uzamceno" class="inline-glyph padding-left fa glyph-lock"></i>
                        </span>
                    </div>
                </div>
            </div>

            <!-- filtr rozdeleni -->
            <div class="row">
                <div class="col-3 align-right padding-right-2"><?= TextManager::_('Rozdeleni_PK') ?></div>
                <div class="col">
                    <div class="input-group">
<!--                        <div class="col-3">-->
                            <input class="form-control" id="rozdeleni_kod" />
<!--                        </div>-->
<!--                        <div class="col">-->
                            <input class="form-control" id="rozdeleni_popis" />
<!--                        </div>-->
                        <button id="kapacity_filtrovat_osobu" class="btn btn-primary toggle-button X_input-group-text X_p-1 <?= $zobrazitFiltrOsoba ? 'active' : '' ?>" data-bs-toggle="button" aria-pressed="<?= $zobrazitFiltrOsoba ? 'true' : '' ?>">
                            <i class="xinline-glyph xpadding-left fa glyph-person"></i>
                        </button>
                    </div>
                </div>
            </div>

            <div class="row <?= !$zobrazitFiltrOsoba ? 'd-none' : '' ?>" id="filter_row_osoba">
                <div class="col-3 align-right padding-right-2"><?= TextManager::_('Osoba') ?></div>
                <div class="col">
                    <input class="form-control" id="filtr_osoba" data-columns="text;osobni-cislo"
                            data-items-url="?menuid=kapacityjs&action=osoby&rozdeleni=<?= StringUtils::htmlTextConvert($_GET['rozdeleni'] ?? '') ?>"/>
                        <!-- nedavat zadnou option, jinak se nenactou pri dropdown -->
<!--                    </input>-->
                </div>
            </div>
        </div>

        <!-- ovladaci prvky - tlacitka, menu -->
        <div class="col-12 col-md-6" id="kapacity_toolbar_panel">
            <div class="row planovani_toolbar position-relative" id="kapacity_toolbar">
                <div class="col-4">
                    <input type="button" class="button d-none w-100" id="tlacitkoprepocet" value="<?= TextManager::_('Prepocitat') ?>" />
                    <ul id="prepocet_menu" class="popupmenu">
                        <li data-ron-prepocet="1"><?= TextManager::_('Prepocitat_aktualni') ?></li>
                        <li data-ron-prepocet="2"><?= TextManager::_('Prepocitat_vybrane') ?></li>
                        <li><?= TextManager::_('Prepocitat_vse') ?></li>
                    </ul>
                </div>

                <div class="col-5">
                    <input type="button" class="button w-100" id="tlacitkopodlekalendare" value="<?= TextManager::_('Podle_kalendare') ?>" />
                </div>

                <div class="col-3">
                    <?php if($provadetKontroly  ||  $xmlAkce) { ?>
                        <input type="button" class="button w-100" id="tlacitkomenu" value="<?= TextManager::_('Dalsi_funkce_menu') ?>" />
                        <ul id="dalsi_funkce_menu" class="popupmenu">
                            <li id="provest_kontroly"><?= TextManager::_('Provest_kontroly') ?></li>
                            <!-- dalsi funkce - XML udalosti PK_Akce_... -->
                            <?php foreach ($xmlAkce as $akce) { ?>
                                <li <?= Csrf::csrfDataAttribute('pk_xmlakce_' . $akce ->id) ?> data-xml-id="<?= $akce ->id ?>" id="pk_xml_<?= $akce ->id ?>"><?= TextManager::_($akce ->menuText) ?></li>
                            <?php } ?>
                        </ul>
                    <?php } ?>
                </div>
            </div>

            <div class="planovani_toolbar row" id="kapacity_rezim">
                <?php if (RonPortalSettings::getIntValue(KapacitySettings::POVOLIT_REZIM_UPRAV)) { ?>
                    <div class="col-4">
                        <button class="planovani_rezim aktivni_rezim w-100" id="rezim_planovani" value="planovani" ><?= TextManager::_('Rezim_planovani') ?></button>
                    </div>
                    <div class="col-3">
                        <button class="planovani_rezim w-100" value="upravy" id="rezim_uprav" ><?= TextManager::_('Rezim_uprav') ?></button>
                    </div>
                <?php } ?>
                <div class="col-5">
                    <button class="planovani_rezim w-100" value="detailnizobrazeni" id="detailni_zobrazeni" ><?= TextManager::_('Detailni_zobrazeni') ?></button>
                </div>
            </div>
        </div>

        <div class="col-12 col-md-6 col-xl-12 col-xxl-auto flex-lg-fill no-wrap overflow-hidden" id="kapacity_info">
            <div class="row">
                <div class="col-2 info_caption"><?= TextManager::_('Kalendar') ?>: </div>
                <div class="col-2" id='info_kalendar'></div>

                <div class="col-2 info_caption" id="info_smena_caption"><?= TextManager::_('Smena') ?>:</div>
                <div class="col-6" id='info_smena'></div>
            </div>

            <div class="row">
                <div class="col-6 info_caption"><?= TextManager::_('Absence_udalost') ?>: </div>
                <div class="col-6" id='info_absence'></div>
            </div>
        </div>

        <!--<span id='info_text'></span>   K cemu to tu bylo? -->
    </div>

    <div id="kapacity_content">
        <!-- obsah - hlavicky, data, scrollbary -->
        <div id="horizontalscrollbar" class="scrollbar horizontalscroll d-none"></div>
        <div id="verticalscrollbar" class="scrollbar verticalscroll d-none"></div>
        <div id="patickascrollbar" class="scrollbar verticalscroll d-none"></div>

        <div id="kapacity_left">
            <!-- leva cast - nadpisy sloupcu a hlavicky radku -->

            <div id="kapacity_nadpisy" class="kapacity_dataheader">
                <!-- nadpisy sloupcu Os.cislo | Jmeno - pevna poloha -->
            </div>

            <div id="kapacity_rowheadercontainer">
                <div id='kapacity_rowheader' class='planovani_rowheader'>
                    <!-- hlavicka radku (jmena osob atd.) - vertikalni posun stejne jako data -->
                </div>
            </div>

            <div id="kapacity_nadpisypatickycontainer" class="planovani_footer">
                <div id="kapacity_nadpisy_paticky">
                    <!-- paticka (nadpis "celkem", nadpisy smen) -->
                </div>
            </div>
        </div>

        <div id="kapacity_dataframe">
            <!-- pevny div pro zobrazeni dat -->

            <div id="kapacity_container">
                <!-- kontejner pro nadpisy dnu, samotny obsah a paticku - posouva se horizontalne -->

                <div id="kapacity_nadpisydnu" class="kapacity_dataheader"></div>
                <!-- nadpisy dnu (kalendar) - vzdy nahore, pevna poloha v ramci nadrazeneho kontejneru -->

                <div id="kapacity_datacontainer">
                    <div id="kapacity_data"><!-- data planovani - vertikalni pousun --></div>
                </div>

                <div id="kapacity_patickacontainer" class="planovani_footer">
                    <div id="kapacity_paticka"></div>
                </div>
            </div>

        </div>
    </div>


    <!-- legenda - umisteni vpravo -->
    <div id='kapacity_legenda' class='planovani_legendadiv'>
        <!-- ovladani zuzeni legendy -->
        <div>
            <span id="kapacity_legenda_nastavvelikost2" class="inline-glyph glyph-button fa glyph-right"></span>
            <span id="kapacity_legenda_nastavvelikost1" class="inline-glyph glyph-button fa glyph-left"></span>
        </div>

        <!-- absence a udalosti -->
        <div class="planovani_obsahlegendy">
            <div class="planovani_legenda_caption"><?= TextManager::_('Absence_a_udalosti') ?></div>
            <table class="planovani_legenda" id="kapacity_legenda_absence"></table>
        </div>

        <!-- smeny -->
        <div class="planovani_obsahlegendy">
            <span id="kapacity_legenda_vybersmen" class="inline-glyph glyph-button fal fa-ellipsis-h"></span>
            <div class="planovani_legenda_caption"><?= TextManager::_('Smeny_PK') ?></div>
            <table class="planovani_legenda" id="kapacity_legenda_smeny"></table>
        </div>

        <div class="planovani_obsahlegendy" id="kapacity_harmonogramy">
            <div class="planovani_legenda_caption"><?= TextManager::_('Harmonogramy_PK') ?></div>
            <table class="planovani_legenda" id="kapacity_legenda_harmonogramy"></table>
        </div>

        <div class="planovani_obsahlegendy">
            <div class="planovani_legenda_caption"><?= TextManager::_('Podminky_planovani') ?></div>
            <table class="planovani_legenda" id="kapacity_legenda_podminky"></table>
        </div>
    </div>

</div>


<textarea cols="1" rows="1" style='position: absolute; left:-1000px;top:-1000px;width:0;height:0;' id='kapacity_clipboard'></textarea>
<!-- kopirovani do clipboardu -->


<div id='kapacity_progress' class='planovani_progress d-none'></div>


<!-- nastaveni variabilni smeny pri vkladani -->
<?php require('ronportal/kapacity/view_variabilni_smena.php'); ?>

<!-- nastaveni delene smeny pri vkladani -->
<?php require('ronportal/kapacity/view_delena_smena.php'); ?>

<!-- formular pro presun na jine rozdeleni -->
<?php if (RonPortalSettings::getIntValue(KapacitySettings::KAPACITY_TYP_ROZDELENI)  ||  RonPortalSettings::getIntValue(KapacitySettings::KAPACITY_TYP_ROZDELENI2)) {
    (new Dialog())
        ->setView('ronportal/kapacity/view_zmenarozdeleni.php')
        ->setTitle('Prerazeni_zamestnance')
        ->setId('kapacity_zmenarozdeleni')
        ->addButton(
            (new DialogButton())
                ->setValue('OK')
                ->setId('planovani_zmenarozdeleni_ok')
                ->addClass('submitbutton')
        )
        ->addButton(DialogButton::cancelButton('planovani_zmenarozdeleni_storno'))
        ->render();
}
?>

<!-- formular s detailem (poznamky atd.) -->
<?php require('ronportal/kapacity/view_detail.php'); ?>

<?php $renderer = (new Renderer(null)) ->start(); ?>
    <div id="kontrolyPlanovaniData">
        <table id="kontrolyPlanovaniTable" class="browser">
        </table>
    </div>
<?php
 $dialogContent = $renderer ->stop();
 (new Dialog())
     ->setView(new TextViewObject($dialogContent, null, null))
     ->setId('kontrolyPlanovani')
     ->setTitle('Kontroly')
     ->addButton(
         (new DialogButton())
            ->setId('kontrolyPlanovaniOK')
            ->setValue('OK')
     )
    ->render();
?>

<!-- formular pro vyber delky absence -->
<?php require('ronportal/kapacity/view_delkaabsence.php'); ?>

<!-- nastaveni, vyber oblibenych smen -->
<?php require('ronportal/kapacity/view_nastaveni.php'); ?>

<!-- popup menu -->
<ul id="kapacity_popupmenu" class="popupmenu">
    <!-- potvrzovani -->
    <li id="kapacity_menu_potvrdit"><?= TextManager::_('Potvrdit_plan') ?></li>
    <li id="kapacity_menu_zrusitpotvrzeni"><?= TextManager::_('Zrusit_potvrzeni_planu') ?></li>
    <?php if (RonPortalSettings::getIntValue(KapacitySettings::KAPACITY_TYP_ROZDELENI)) { ?>
        <li id="kapacity_menu_rozdeleni" class="margin-top"><?= TextManager::_('Presunout_na_rozdeleni') ?></li>
    <?php } ?>

    <?php if (RonPortalSettings::getIntValue(KapacitySettings::KAPACITY_TYP_ROZDELENI2)) { ?>
        <!-- doplnit separator, kdyz neni KAPACITY_TYP_ROZDELENI? -->
        <li id="kapacity_menu_rozdeleni2"><?= sprintf(TextManager::_('Presunout_na_rozdeleni_2'), $typRozdeleni2 ? $typRozdeleni2 ->popis : '') ?></li>
    <?php } ?>

    <!-- schvalovani -->
    <?php
    $jeSchvaleni = false;
    if ( Prava::vratPrava('kapac_schval1') ->jsouNejakePrava() ) {
        ?>
        <li id="kapacity_menu_schvaleni1" class="margin-top"><?= TextManager::_('Planovani_schvaleno_do_1') ?> <span id="kapacity_menu_hodnotaschvaleni1" class="textschvaleni1"></span></li>
    <?php $jeSchvaleni = true; } ?>
    <?php
    if ( Prava::vratPrava('kapac_schval2') ->jsouNejakePrava() ) {
        ?>
        <li id="kapacity_menu_schvaleni2" <?= $jeSchvaleni ? '' : 'class="margin-top"' ?>><?= TextManager::_('Planovani_schvaleno_do_2') ?> <span id="kapacity_menu_hodnotaschvaleni2" class="textschvaleni2"></span></li>
    <?php $jeSchvaleni = true; } ?>
    <?php
    if ( Prava::vratPrava('kapac_schval3') ->jsouNejakePrava() ) {
        ?>
        <li id="kapacity_menu_schvaleni3" <?= $jeSchvaleni ? '' : 'class="margin-top"' ?>><?= TextManager::_('Planovani_schvaleno_do_3') ?> <span id="kapacity_menu_hodnotaschvaleni3" class="textschvaleni3"></span></li>
    <?php $jeSchvaleni = true; } ?>

    <li id="kapacity_menu_podlekalendare" <?= $jeSchvaleni ? 'class="margin-top"' : '' ?>><?= TextManager::_('Podle_kalendare') ?></li>

    <li id="kapacity_menu_podrobnosti" class="margin-top"><?= TextManager::_('Podrobnosti') ?></li>
</ul>


<!-- obecny formular - obsah generovany javascriptem -->
<div id='kapacity_dialog' class='planovani_formcontainer d-none'>
    <table class="planovani_form">
        <tr><td><div id='kapacity_dialogcaption' class='planovani_formcaption'>dialog</div></td></tr>

        <tr><td><div id="kapacity_dialogcontent" class="kapacity_dialogcontent"></div></td></tr>
    </table>
</div>

<?php
// doplni pripadne uzivatelske funkce z XML formularu (dialogy, javascripty)
try {
    echo RonPortalXMLForm::xmlEvents($database, RonPortalXMLEvents::KAPACITY_SHOW, null, '', true);
} catch (\Exception $e) {
?>
    <div title="CHYBA" id="chyba_xml_info">
        Pri nacitani formulare PK_Show doslo k chybe!<br/>
        <div class="errortext"><?= $e ->getMessage() ?></div>
    </div>

    <script type="text/javascript">
        $( function() {
            $("#chyba_xml_info").dialog();
        });
    </script>
<?php
}
?>

<?php Model::getInstance() ->renderResources(); ?>

</body>
</HTML>
