<?php
/**
 * stanislav.elbl, 12.09.2019
 */

namespace RonPortal\Kapacity;

use Ron\DateUtils;
use Ron\GuiUtils;
use Ron\HttpUtils;
use Ron\StringUtils;
use RonPortal\Prava;

/** @var PlanovaniPodminekFormular $this */

echo "<style>\n";
foreach ($this ->barvySmen as $kod => $barva) {
    echo '.smena_' . StringUtils::cssName($kod) . ' { background-color: ' . GuiUtils::getHtmlColor($barva) . "; }\n";
}
echo "</style>\n";

?>
<?php if (Prava::jsouNejakePrava('smenykalendare')) { ?>
<div>
    <a href="?menuid=smenykalendare&obdobi=<?= DateUtils::dateToUrlString(DateUtils::firstDayOfMonth($this ->datum)) ?>&rozdeleni=<?= StringUtils::htmlTextConvert($this ->rozdeleni ->kod) ?>"><?= \Ron\ronText('Upravit_povolene_smeny') ?></a>
</div>
<?php } ?>
<div class="row no-flex-wrap flex-align-items-stretch position-relative" id="planovaniPodminek" data-datum="<?= DateUtils::dateToUrlString($this ->datum) ?>">
    <div class="d-inline-block">
        <?php if (!$this ->seznamRozdeleni) { ?>
            <div class="errortext"><?= \Ron\ronText('Nejsou_nastavene_zadne_smeny') ?></div>
        <?php } ?>
        <?php foreach ($this ->seznamRozdeleni as $rozdeleniProPlanovani) { ?>
            <div class="row">
                <h2><?= StringUtils::htmlTextConvert($rozdeleniProPlanovani ->rozdeleni ->popis) ?></h2>

                <div class="buttons margin-left-2">
                    <input type="button" class="button kontroly-button" value="<?= \Ron\ronText('Provest_kontroly') ?>" data-rozdeleni="<?= StringUtils::htmlTextConvert($rozdeleniProPlanovani->rozdeleni->kod) ?>"/>
                    <input type="button" class="button kopie-button" value="<?= \Ron\ronText('Kopie_planu') ?>"
                           data-rozdeleni="<?= StringUtils::htmlTextConvert($rozdeleniProPlanovani->rozdeleni->kod) ?>"
                           data-popis-rozdeleni="<?= StringUtils::htmlTextConvert($rozdeleniProPlanovani->rozdeleni->popis) ?>"
                        />
                </div>
                <!-- kontroly -->
                <div class="pp-kontroly autoExpand expanded col col-12" id="pp_kontroly_<?= StringUtils::htmlTextConvert($rozdeleniProPlanovani ->rozdeleni ->kod) ?>"></div>
            </div>


            <table class="browser planovaniPodminekForm grid planovaniPodminekRozdeleni position-relative" data-rozdeleni="<?= StringUtils::htmlTextConvert($rozdeleniProPlanovani->rozdeleni->kod) ?>">
                <!-- hlavicka (popis smeny)-->
                <thead>
                <tr>
                    <th><?= \Ron\ronText('Popis_podminky') ?></th>
                    <?php foreach ($rozdeleniProPlanovani->smeny as $smena) { ?>
                        <th><?= StringUtils::htmlTextConvert($smena ->popis) ?></th>
                    <?php } ?>
                </tr>
                <?php if ($rozdeleniProPlanovani ->schvaleni  &&  $rozdeleniProPlanovani ->schvaleni ->jeSchvalenoPlanovani($this ->datum, $this ->rezimUprav)) { ?>
                    <tr class="schvaleni">
                        <td class="<?= $rozdeleniProPlanovani ->schvaleni ->getHtmlClassKapacity($this ->datum, $this ->rezimUprav) ?>"></td>
                        <?php foreach ($rozdeleniProPlanovani->smeny as $smena) { ?>
                            <td class="<?= $rozdeleniProPlanovani ->schvaleni ->getHtmlClassKapacity($this ->datum, $this ->rezimUprav) ?>"></td>
                        <?php } ?>
                    </tr>
                <?php } ?>
                </thead>

                <!-- data -->
                <tbody>
                <?php foreach ($rozdeleniProPlanovani ->radky as $radek) { ?>
                    <tr data-rozdeleni2="<?= StringUtils::htmlTextConvert($radek ->kodRozdeleni2) ?>">
                        <td title="<?= StringUtils::htmlTextConvert($radek ->popisRozdeleni2) ?>">
                            <a class="planovana-podminka cursor-pointer" data-kod-rozdeleni="<?= StringUtils::htmlTextConvert($radek ->kodRozdeleni2) ?>">
                                <?= StringUtils::htmlTextConvert($radek ->getPopis()) ?>
                            </a>
                        </td>

                        <?php foreach ($rozdeleniProPlanovani->smeny as $smena) {
//                            $barva = ($smena ->barva && isset($radek ->podminky[$smena ->kod] ->pocetMin))
//                                ? GuiUtils::getHtmlColor($smena ->barva)
//                                : null;
                            $smenaClass = ($smena ->barva && isset($radek ->podminky[$smena ->kod] ->pocetMin))
                                ? 'smena_' . StringUtils::cssName($smena ->kod)
                                : '';
                            ?>
                            <td data-smena="<?= StringUtils::htmlTextConvert($smena ->kod) ?>" class="<?= $smenaClass ?> <?= isset($radek ->podminky[$smena ->kod] ->pocetMin) ? 'drag-target' : ''?>">
                                <?php if (isset($radek ->podminky[$smena ->kod])) { ?>
                                    <?= $radek ->podminky[$smena ->kod] ->pocetMin ?>
                                <?php } ?>
                            </td>
                        <?php } ?>

                    </tr>
                <?php } ?>

                <!-- radek pro zobrazeni neprirazenych osob, ktere jsou na smene -->
                <tr data-rozdeleni2="" data-smeny="1">
                    <td><?= \Ron\ronText('Dalsi_osoby_na_smene') ?></td>

                    <?php foreach ($rozdeleniProPlanovani->smeny as $smena) { ?>
                        <td data-smena="<?= StringUtils::htmlTextConvert($smena ->kod) ?>" class="drag-target smena_<?= StringUtils::cssName($smena ->kod) ?>"></td>
                    <?php } ?>
                </tr>

                <!-- radek pro zobrazeni neprirazenych osob, ktere jsou na rozdeleni -->
                <tr data-rozdeleni2="" data-smeny="0">
                    <td><?= \Ron\ronText('Dalsi_osoby_na_rozdeleni') ?></td>
                    <td colspan="<?= count($rozdeleniProPlanovani->smeny)  ?>" data-smena=""></td>
                </tr>

                </tbody>

            </table>
        <?php } ?>
    </div>

    <div class="d-inline-block margin-left-2 position-relative" id="podrobnosti-container">
        <div class="force-visible">
            <div class="form middle-form">
                <div class="pp-detail-osoby">
                    <div class="form-row form-section" id="pp_detail_caption">
                        <?= \Ron\ronText('Podrobnosti_zamestnance') ?>
                    </div>
                    <div class="form-content" id="pp_data_osoby">
                        <div class="font-weight-bold font-size-relative-2" id="pp_osoba_jmeno">...</div>

                        <div class="form-section"><?= \Ron\ronText('Naplanovane_smeny_a_udalosti') ?></div>
                        <table id="pp_osoba_plan_table" class="plan-osoby planovanitable">
                            <tr>
                                <?php for ($i = 0;  $i < $this ->pocetDnuDetailu; $i++) {
                                    $datum = DateUtils::incDayStart($this ->prvniDenDetailu, $i); ?>
                                <th>
                                    <a href="?menuid=planovanipodminek&datum=<?= DateUtils::dateToUrlString($datum) ?>&rozdeleni=<?= HttpUtils::urlEncode($this ->rozdeleni ->kod) ?>&rozdeleni_vcetne_podrizenych=<?= $this ->vcetnePodrizenych ? '1' : '0' ?>">
                                        <?= date('j.n.', $datum) ?>
                                    </a>
                                </th>
                                <?php } ?>
                            </tr>
                            <tr id="pp_osoba_plan">
                                <?php for ($i = 0;  $i < 9;  $i++) { ?>
                                <td class="plan-osoby-bunka"></td>
                                <?php } ?>
                            </tr>
                        </table>

                        <div class="form-section margin-top"><?= \Ron\ronText('Prirazene_pozice_osoby') ?></div>
                        <div class="pp_osoba_pozice_container position-relative">
                            <div id="seznam_pozic_osoby_caption" class="row no-flex-wrap border-bottom pp_form_data_caption">
                                <div class="col col-1 no-wrap"><?= \Ron\ronText('Kod') ?></div>
                                <div class="col col-3 no-wrap"><?= \Ron\ronText('Popis') ?></div>
                                <div class="col col-2 no-wrap"><?= \Ron\ronText('Platnost_od') ?></div>
                                <div class="col col-2 no-wrap"><?= \Ron\ronText('do') ?></div>
                                <div class="col col-4 no-wrap"><?= \Ron\ronText('Poznamka') ?></div>
                            </div>

                            <div id="seznam_pozic_osoby" class="rowOver">

                            </div>
                        </div>
                    </div>
                </div>
            </div>

            <div class="form middle-form">
                <div class="pp-detail-pozice">
                    <div class="form-row form-section" id="pp_detail_pozice_caption">
                        <?= \Ron\ronText('Podrobnosti_pozice') ?>
                    </div>

                    <div class="form-content" id="pp_data_pozice">
                        <div class="font-weight-bold font-size-relative-2" id="pp_pozice_popis">...</div>

                        <div class="form-section margin-top"><?= \Ron\ronText('Osoby_pro_pozici') ?></div>
                        <div class="pp_osoba_pozice_container position-relative">
                            <div id="seznam_osob_caption" class="row no-flex-wrap border-bottom pp_form_data_caption">
                                <div class="col col-3 no-wrap"><?= \Ron\ronText('Jmeno') ?></div>
                                <div class="col col-2 no-wrap"><?= \Ron\ronText('Platnost_do') ?></div>
                                <div class="col col-4 no-wrap"><?= \Ron\ronText('Poznamka') ?></div>
                                <div class="col col-3 no-wrap"><?= \Ron\ronText('Smena') ?></div>
                            </div>

                            <div id="seznam_osob">

                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <!-- delete button -->
    <div id="pp_delete_button" class="inline-glyph glyph-button fa glyph-delete position-absolute background-inline-button border-form d-none"></div>


    <div id="pp_copy_dialog" class="rondialog middle-form" title="<?= \Ron\ronText('Kopie_planu') ?>">
        <div class="row">
            <div class="col col-3"><?= \Ron\ronText('Datum') ?></div>
            <div class="col col-9">
                <?= StringUtils::format('date', $this ->datum) ?>
            </div>
        </div>

        <div class="row">
            <div class="col col-3"><?= $this ->typRozdeleniLinka ->popis ?></div>
            <div class="col col-9" id="pp_copy_linka"></div>
        </div>

        <div class="row">
            <div class="col col-3"></div>
            <div class="col col-9 poznamka"><?= \Ron\ronText('Kopie_planu_vcetne_podrizenych') ?></div>
        </div>

        <!-- zdroj kopie -->
        <div class="row form-section">
            <?= \Ron\ronText('Zdroj_kopie_planu') ?>
        </div>

        <div class="row">
            <div class="col col-3"><?= \Ron\ronText('Datum') ?></div>
            <div class="col col-9">
                <input class="inputDate" size="10" id="pp_copy_datum1" value="<?= StringUtils::format('date', DateUtils::incDayStart($this ->datum, -1)) ?>">
                <i class="showcalendar inline-glyph glyph-button fa glyph-calendar" data-roncalendar-input="#pp_copy_datum1"></i>
            </div>
        </div>

        <div class="row">
            <div class="col col-3"><?= \Ron\ronText('Smena') ?></div>
            <div class="col col-9">
                <select class="form-input" id="pp_copy_smena1"></select>
            </div>
        </div>

        <!-- cil kopie -->
        <div class="row form-section">
            <?= \Ron\ronText('Cil_kopie_planu') ?>
        </div>

        <div class="row">
            <div class="col col-3"><?= \Ron\ronText('Smena') ?></div>
            <div class="col col-9">
                <select class="form-input" id="pp_copy_smena2"></select>
            </div>
        </div>

        <div class="buttons">
            <button id="pp_copy_ok" type="button" class="submitbutton"><?= \Ron\ronText('OK') ?></button>
            <button id="pp_copy_storno" type="button" class="button cancel"><?= \Ron\ronText('Cancel') ?></button>
        </div>

    </div>
</div>
