<?php
/**
 * stanislav.elbl, 24.03.2019
 */

namespace RonPortal\Kapacity;

use Exception;
use Ron\GuiUtils;
use Ron\StringUtils;
use Ron\TextManager;
use RonPortal\Controls\FormReportsListView;
use RonPortal\RonPortalSettings;

/** @var PrehledKapacitView $this */

$pocetZobrazenychSloupcu = $this ->pocetZobrazenychSloupcuHlavicky(true);

?>

<h1><?= TextManager::_('Prehled_planovanych_kapacit') ?></h1>

<?php $this ->renderFiltr(); ?>

<style>
    <?php
        foreach ($this ->data ->barvy as $kodRozdeleni => $barva) {
            if ($barva) {
                echo
                    ".pk_row_r_{$kodRozdeleni} th, .pk_row_r_{$kodRozdeleni} td { background-color: " . GuiUtils::getHtmlColor($barva) . "; }\n" .
                    ".pk_row_r_{$kodRozdeleni} td.planovani_vikend { background-color: " . GuiUtils::getHtmlColor($barva, 0.95) . "; }\n" // vikend tmavsi
                    ;
            }
        }

        $sirka = RonPortalSettings::getIntValue($this ->rezim === PrehledKapacitView::REZIM_KOMBINOVANE ? 'kapacity_sirka_kombi' : 'kapacity_sirka_pasivni');
        $vyska = RonPortalSettings::getIntValue($this ->rezim === PrehledKapacitView::REZIM_KOMBINOVANE ? 'kapacity_vyska_kombi' : 'kapacity_vyska_pasivni');

        echo
            ".planovani_htmldiv {" .
            " --sirka-bunky: " . ($sirka ? $sirka . 'px' : 'auto') . ";" .
            ($vyska ? " --vyska-bunky: {$vyska}px; }" : '') .
            "}";

    ?>
</style>

<?php if ($this ->data) {
    $className = 'planovani_htmldiv' . ($this ->data ->rezimUprav ? ' rezim_uprav' : '');
    $pocetRadkuPoznamek = PlanovaniKapacit_Den::pocetRadkuPoznamek($this ->data ->dny);
    ?>
    <div class="<?= $className ?>">
        <table class="planovanitable rowOver rowSelect fixedCols"  data-ron-fixed-cols="2" data-code="planovanikapacit">
            <thead class="floating-table-header-js">
                <?php $this ->zapisHlavickuHTML(); ?>
            </thead>

            <?php if ($pocetRadkuPoznamek) { ?>
                <tbody class="planovani_poznamky">
                <?php for($radek = 0;  $radek < $pocetRadkuPoznamek;  $radek++) { ?>
                    <tr class="poznamky-ke-dni<?= $radek === $pocetRadkuPoznamek - 1 ? ' last-section-row' : '' ?>">
                        <th></th>
                        <th class="last-section-col" colspan="<?=  (1 + $pocetZobrazenychSloupcu) ?>"></th>
                        <?= PlanovaniKapacit_Den::getPoznamkyHtml($this ->data ->dny, $radek, 'th') ?>
                    </tr>
                <?php } ?>
                </tbody>
            <?php } ?>

            <?php $this ->zapisSchvaleniRozdeleni(); ?>

            <tbody class="planovani_datarows">
                <?php $this ->renderData(); ?>
            </tbody>

            <tbody class="planovani_sums">
                <?php foreach ($this ->soucty as $radek) { ?>
                    <tr>
                        <th><!-- sloupec os.cislo --></th>
                        <th class="footercaptions last-section-col" colspan="<?=  (1 + $pocetZobrazenychSloupcu) ?>"><?= $radek ->nadpis ?></th>

                        <?php foreach ($radek ->data as $index => $sloupec_suma) { ?>
                        <th class="<?= (isset($radek ->classes[$index]) ?: '') ?><?= $index ? ' firstdatacol' : '' ?> align-center"><?= $sloupec_suma ?></th>
                        <?php } ?>

                    </tr>
                <?php } ?>
            </tbody>
        </table>
    </div>

    <?php if ($this ->reportList  &&  count($this ->reportList)) { ?>
        <div class="planovani_html_reports">
            <?php
                FormReportsListView::renderReportList($this ->reportList,
                '?menuid=kapacity&action=report&obdobi=' . date('j.n.Y', $this->data ->datumOd) .
                '&rozdeleni=' . StringUtils::htmlTextConvert($this ->data ->rozdeleni) .
                (RonPortalSettings::getIntValue(RonPortalSettings::ROZDELENI2_TYP) && $this ->data ->rozdeleni2 ? '&rozdeleni2=' . StringUtils::htmlTextConvert($this ->data ->rozdeleni2) : '')
                );
            ?>
        </div>
    <?php } ?>

    <?php
        if (RonPortalSettings::getIntValue(KapacitySettings::KAPACITY_EDITACE)) {
            $form = new SchvaleniKapacitForm($this ->database, $this ->rezim === 1);
            $form ->load($this ->data);
            $form ->render();
        }

        $filtrSmeny = $this ->data ->vratFiltrProPouziteSmeny('Kod');
        try {
            $this->zobrazLegendu($filtrSmeny);
        } catch (Exception $e) {
            echo "<div class='error'>Pri nacitani legendy doslo k chybe! {$e->getMessage()}</div>";
        }
    ?>
<?php } ?>
