<?php
/**
 * stanislav.elbl, 10.03.2021
 */

namespace RonPortal\Kapacity;

use Ron\DateUtils;
use Ron\StringUtils;
use Ron\TextManager;
use RonPortal\Prava;
use RonPortal\RonPortalSettings;

/** @var SmenyKalendareFormular $this */

$pouzivatSablony = RonPortalSettings::getIntValue('sablonyprodenkalendare');

$posledniRozdeleni = null;

$colCount = $this ->radky ? count($this ->radky[0] ->data) : 0;

?>
<!--<style>*:focus { background-color: lightyellow; } </style>-->

<div>
    <a href="?menuid=planovanipodminek&obdobi=<?= DateUtils::dateToUrlString($this ->obdobi ->zacatek) ?>&rozdeleni=<?= StringUtils::htmlTextConvert($this ->rozdeleni ->kod) ?>"><?= TextManager::_('Planovani_podminek') ?></a>
</div>


<form method="post">
    <div tabindex="1">
        <table class="smenyKalendareForm browser vertical-grid align-center oddEvenRows rowOver keyInputMove input-grid-form bg-transparent"
               id="smenyKalendareForm" data-pouzivat-sablony="<?= $pouzivatSablony ?>" data-obdobi="<?= DateUtils::dateToUrlString($this->obdobi->zacatek) ?>">
            <thead>
            </thead>
            <tbody>
            <?php foreach($this ->radky as $radek) { ?>
                <?php if (isset($posledniRozdeleni)  &&  $posledniRozdeleni != $radek ->kodRozdeleni) { /* mezera mezi rozdelenimi (neni pred prvnim) */ ?>
                    <tr class="bg-transparent no-grid"><td colspan="<?= 2 + $colCount ?>">&nbsp;</td></tr>
                <?php } ?>
                <?php if (!isset($posledniRozdeleni)  ||  $posledniRozdeleni != $radek ->kodRozdeleni) { // hlavicka
                    $posledniRozdeleni = $radek ->kodRozdeleni ?>
                    <tr class="browserhighlightrow border-bottom">
                        <th class="align-left"><?= $radek->kodRozdeleni ?></th>
                        <th class="align-left"><?= $radek->popisRozdeleni ?> <span class="kalendar-rozdeleni">(<?= $radek ->kodKalendare ?>)</span></th>
                        <?php foreach ($radek ->data as $index => $zaznam) { ?>
                            <th class="<?= $this ->cssClassProDen($zaznam->datum, $zaznam ->typDne) ?>"><?= date('j', $zaznam ->datum) ?></th>
                        <?php } ?>
                    </tr>

                    <!-- schvaleni -->
                    <?php if ($radek->schvaleni->jeSchvaleni()) { ?>
                        <tr class="schvaleni" data-rozdeleni="<?= StringUtils::htmlTextConvert($radek ->kodRozdeleni) ?>">
                            <th></th>
                            <th class="align-left"></th>
                            <?php foreach ($radek ->data as $index => $zaznam) { ?>
                                <th class="<?= $this ->cssClassProDen($zaznam->datum, $zaznam ->typDne) ?> <?= $radek->schvaleni ->getHtmlClass($zaznam->datum) ?>"
                                    data-den="<?= DateUtils::dateToUrlString($zaznam->datum) ?>"></th>
                            <?php } ?>
                        </tr>
                    <?php } ?>
                <?php } ?>
                <tr data-smena="<?= StringUtils::htmlTextConvert($radek ->kodSmeny) ?>"
                    data-kalendar="<?= StringUtils::htmlTextConvert($radek ->kodKalendare) ?>"
                    data-rozdeleni="<?= StringUtils::htmlTextConvert($radek ->kodRozdeleni) ?>">
                    <td class="align-left"><?= StringUtils::htmlTextConvert($radek ->kodSmeny) ?></td>
                    <td class="align-left last-section-col"><?= StringUtils::htmlTextConvert($radek ->popisSmeny) ?></td>
                    <?php foreach ($radek ->data as $index => $zaznam) { ?>
                        <td class="<?= $this ->cssClassProDen($zaznam->datum, $zaznam ->typDne) ?>"
                            data-den="<?= DateUtils::dateToUrlString($zaznam->datum) ?>"
                            title="<?= $zaznam->popisSablonyPodminek ?: '' ?>">
                            <?= $zaznam->zkratkaSablonyPodminek ?: ($zaznam ->jeSmena ? 'x' : '') ?>
                        </td>
                    <?php } ?>
                </tr>
            <?php } ?>
            </tbody>
        </table>
    </div>
</form>

<ul id="smenyKalendareMenu" class="popupmenu popupmenulist">
    <!-- sem se nactou povolene sablony -->
    <li class="border-top" id="smenyKalendare_vypnout"><?= \Ron\ronText('Zrusit_povolenou_smenu') ?></li>

    <?php
    $jeSchvaleni = false;
    if ( Prava::vratPrava('kapac_schval_poc1') ->jsouNejakePrava() ) {
        ?>
        <li id="smenyKalendare_schvaleni1" class="margin-top"><?= \Ron\ronText('Schvaleni_smen_1_do') ?> <span id="smenyKalendare_hodnotaschvaleni1" class="textschvaleni1"></span></li>
        <?php $jeSchvaleni = true; } ?>
    <?php
    if ( Prava::vratPrava('kapac_schval2') ->jsouNejakePrava() ) {
        ?>
        <li id="smenyKalendare_schvaleni2" <?= $jeSchvaleni ? '' : 'class="margin-top"' ?>><?= \Ron\ronText('Schvaleni_smen_2_do') ?> <span id="smenyKalendare_hodnotaschvaleni2" class="textschvaleni2"></span></li>
        <?php $jeSchvaleni = true; } ?>
    <?php
    if ( Prava::vratPrava('kapac_schval3') ->jsouNejakePrava() ) {
        ?>
        <li id="smenyKalendare_schvaleni3" <?= $jeSchvaleni ? '' : 'class="margin-top"' ?>><?= \Ron\ronText('Schvaleni_smen_3_do') ?> <span id="smenyKalendare_hodnotaschvaleni3" class="textschvaleni3"></span></li>
        <?php $jeSchvaleni = true; } ?>
</ul>
