<?php
/**
 * pavel.rudol, 21.08.2023 13:17
 */

use Ron\Http\Csrf;
use Ron\MessageManager;
use Ron\MVC\Model;
use Ron\StringUtils;
use Ron\TextManager;
use RonPortal\Controls\FormReportsListView;
use RonPortal\Mzdy\DaneController;
use RonPortal\Mzdy\VyuctovaniDaneForm;
use RonPortal\Prava;

$model = Model::getInstance();

/** @var VyuctovaniDaneForm $rocniVyuctovaniForm */
$rocniVyuctovaniForm = $model->getData('rocnivyuctovaniform');
$jednoduchyVzhled = $model->getData('jednoduchyVzhled');
$reportlist = $model->getData('reportlist');
$skrytDalsihoPoplatnika = $model->getData('skrytDalsihoPoplatnika');

if ($jednoduchyVzhled) {
    $classStr = 'class="dane_info_skryte"';
} else {
    $classStr = '';
}

$rok = date('Y', $rocniVyuctovaniForm->rok->value);

MessageManager::getInstance()->showMessages();
?>

<form method="post" id="formularProhlaseni" name="formularProhlaseni" enctype="multipart/form-data" action="?menuid=dane&action=ulozitprohlaseni">
    <input type="hidden" name="osoba" value="<?= $rocniVyuctovaniForm->pracovniPomer->idPP ?>">
    <input type="hidden" name="obdobi" value="<?= $rok ?>">
    <input type="hidden" name="zmenovacast" value="1">
    <?= Csrf::csrfHiddenInput('prohlaseni_' . $rocniVyuctovaniForm->pracovniPomer->idPP)?>

    <div class='form large-form prohlaseni-poplatnika'>

        <div class="row">
            <div class="col col-12 col-md-12 center">
                <h2><?= TextManager::_("Prohlaseni_podpisova_cast_zmenove_casti") ?></h2>
            </div>
        </div>

        <div class="form-content ram">
            <div class="row">
                <div class="col col-12 col-md-12 font-weight-bold">
                    <?= TextManager::_("identifikace_poplatnika") ?>
                </div>
            </div>

            <div class="row">
                <div class="col col-12 col-md-4 ">
                    <?= TextManager::_('prijmeni') . ": " ?><span class="font-weight-bold font-size-1"><?= StringUtils::htmlTextConvert($rocniVyuctovaniForm->pracovniPomer->prijmeni) ?></span>
                </div>

                <div class="col col-12 col-md-4">
                    <?= TextManager::_('Prohlaseni_jmeno_ditete') . ": " ?><span class="font-weight-bold font-size-1"><?= StringUtils::htmlTextConvert($rocniVyuctovaniForm->pracovniPomer->jmeno) ?></span>
                </div>

                <div class="col col-12 col-md-4">
                    <?= TextManager::_('rodne_cislo') . ": " ?><span class="font-weight-bold font-size-1"><?= StringUtils::htmlTextConvert($rocniVyuctovaniForm['RodneCislo']) ?></span>
                </div>
            </div>

            <div class="row">
                <div class="col col-12 col-md-12 font-weight-bold">
                    <?= TextManager::_("adresa_trvaleho_bydliste") ?>
                </div>
            </div>

            <div class="row">
                <div class="col col-12 col-md-3">
                    <?= TextManager::_('mesto') . ": " ?><span class="font-weight-bold"><?= StringUtils::htmlTextConvert($rocniVyuctovaniForm->bydliste->mesto) ?></span>
                </div>

                <div class="col col-12 col-md-3">
                    <?= TextManager::_('ulice') . ": " ?><span class="font-weight-bold"><?= StringUtils::htmlTextConvert($rocniVyuctovaniForm->bydliste->ulice) ?></span>
                </div>

                <div class="col col-12 col-md-3">
                    <?= TextManager::_('obec') . ": " ?><span class="font-weight-bold"><?= StringUtils::htmlTextConvert($rocniVyuctovaniForm->bydliste->obecPopis) ?></span>
                </div>

                <div class="col col-12 col-md-3">
                    <?= TextManager::_('psc') . ": " ?><span class="font-weight-bold"><?= StringUtils::htmlTextConvert($rocniVyuctovaniForm->bydliste->psc) ?></span>
                </div>
            </div>

            <br>

            <div class="row">
                <div class="col col-12 col-md-4">
                    <span class="font-weight-bold"><?= TextManager::_("nerezident_datum_narozeni") ?></span>
                    <span><?= TextManager::_('Datum_narozeni'); ?></span>
                </div>

                <div class="col col-12 col-md-2">
                    <?= $rocniVyuctovaniForm['DanovyNerezident'] ? StringUtils::format('date', $rocniVyuctovaniForm['OsobniUdaj.DatumNarozeni']) : '' ?>
                </div>
            </div>

            <div class="row">
                <div class="col col-12 col-md-4">
                    <?= TextManager::_("cislo_typ_dokladu") ?>
                </div>

                <div class="col col-12 col-md-2">
                    <?= StringUtils::htmlTextConvert($rocniVyuctovaniForm->cisloDokladuNerezidenta) ?>
                </div>

                <div class="col col-12 col-md-2">
                    <?= StringUtils::htmlTextConvert($rocniVyuctovaniForm->typDokladuNerezidenta) ?>
                </div>

                <div class="col col-12 col-md-3">
                    <?= TextManager::_("stat_nerezidenta") ?>
                </div>

                <div class="col col-12 col-md-1">
                    <?= StringUtils::htmlTextConvert($rocniVyuctovaniForm->statDokladuNerezidenta) ?>
                </div>
            </div>

            <div class="row">
                <div class="col col-12 col-md-4">
                    <?= TextManager::_("identifikace_ve_statu_danove_rezidence") ?>
                </div>

                <div class="col col-12 col-md-2">
                    <?= $rocniVyuctovaniForm['DanovyNerezident'] ? StringUtils::htmlTextConvert($rocniVyuctovaniForm['CisloDanoveIdentifikace']) : '' ?>
                </div>

                <div class="col col-12 col-md-2">
                    <?= $rocniVyuctovaniForm['DanovyNerezident'] ? StringUtils::htmlTextConvert($rocniVyuctovaniForm->typDanovehoIdentifikatoru_popis) : '' ?>
                </div>

                <div class="col col-12 col-md-3">
                    <?= TextManager::_("stat_danoveho_rezidenta") ?>
                </div>

                <div class="col col-12 col-md-1">
                    <?= $rocniVyuctovaniForm['DanovyNerezident'] ? StringUtils::htmlTextConvert($rocniVyuctovaniForm['StatDanoveRezidence']) : '' ?>
                </div>
            </div>
        </div>

        <div class="dane_info_doporuceni">
            <div><a target="_blank" href="?menuid=dane&action=formularprohlaseni&osoba=<?= $rocniVyuctovaniForm->pracovniPomer->idPP ?>&rok=<?= $rok ?>"><?= TextManager::_('Mzdy_prohlaseni'); ?></a></div>
            <?php if ($rocniVyuctovaniForm->pracovniPomer->lzeZobrazitPP(Prava::vratPrava('prohl_osobni'), $rocniVyuctovaniForm['rok'], $rocniVyuctovaniForm['rok'])) { ?>
                <div><a target="_blank" href="?menuid=osobniudaje&osoba=<?= $rocniVyuctovaniForm->pracovniPomer->idPP ?>"><?= TextManager::_('Prohlaseni_info_osobni_udaje'); ?></a></div>
            <?php } ?>
        </div>

        <br>

        <?php if ($rocniVyuctovaniForm['ProhlaseniPortalStav'] == 1 && $rocniVyuctovaniForm['ProhlaseniPortalZmenaStav'] == 2) { ?>
            <div class="errortext align-center">
                <?= StringUtils::htmlTextConvert($rocniVyuctovaniForm['PoznamkaProZamestnance'] ?? TextManager::_('Prohlaseni_vychozi_poznamka_vraceni')) ?>
            </div>
            <br>
        <?php } ?>

        <div class="row">
            <div class="col col-12 col-md-12 center">
                <h2><?= TextManager::_("Prohlaseni_historie_zmen_v_prubehu_roku") ?></h2>
            </div>
        </div>

        <div class="form-content ram">

            <div class="row">
                <div class="col col-12 col-md-3 center">
                    <?= TextManager::_("Prohlaseni_druh_zmeny") ?>
                </div>

                <div class="col col-12 col-md-2 center">
                    <?= TextManager::_("Prohlaseni_kalendarni_mesic_rozhodnuti_zmeny") ?>
                </div>

                <div class="col col-12 col-md-3 center">
                    <?php echo sprintf(TextManager::_("Prohlaseni_podpis_poplatnika_zmeny"), '<sup>10)</sup>') ?>
                </div>

                <div class="col col-12 col-md-4 center">
                    <?php echo sprintf(TextManager::_("Mzdy_overeni_platcem_dane"), '<sup>9)</sup> <sup>10)</sup>') ?>
                </div>
            </div>

            <hr class="oddelovac">

            <?php
            if (!is_null($rocniVyuctovaniForm->zmenyOdpoctu)) {
                foreach ($rocniVyuctovaniForm->zmenyOdpoctu as $zmenaOdpoctu) { ?>
                    <div class="row align-center">
                        <div class="col col-12 col-md-3">
                            <div class="align-left">
                                <?= $zmenaOdpoctu->popis ?>
                            </div>
                        </div>

                        <div class="col col-12 col-md-2">
                            <div> <?= StringUtils::format('date', $zmenaOdpoctu->zmenaOd) ?> </div>
                        </div>

                        <div class="col col-12 col-md-3">
                            <div> <?= StringUtils::htmlTextConvert($zmenaOdpoctu->elektronickyPodpis) ?> </div>
                        </div>

                        <div class="col col-12 col-md-4">
                            <div> <?= StringUtils::htmlTextConvert($zmenaOdpoctu->elektronickyPodpisUcetni) ?>  </div>
                        </div>
                    </div>

                <?php }
            } ?>
        </div>

        <br>

        <div class="row">
            <div class="col col-12 col-md-12 center">
                <h2><?= TextManager::_("Prohlaseni_zmenova_cast") ?></h2>
            </div>
        </div>

        <div class="col col-12 col-md-12 center">
            <h3><?= TextManager::_("Prohlaseni_dle_paragrafu_38_odst_8") ?></h3>
        </div>

        <div class="form-content ram">
            <div class="row">

                <div class="col col-12 col-md-2 ">
                    <?= TextManager::_('aktualni_stav') ?>
                </div>

                <div class="col col-12 col-md-2 ">
                    <?= TextManager::_('pozaduji_zmenu') ?>

                    <?php
                    $pozadujeZmenyVPrubehuRoku = (isset($_POST['pozaduji_upravu_slev']) && ($_POST['pozaduji_upravu_slev'] == 1)) ? "checked" : "";
                    ?>
                    <input type="checkbox" name="pozaduji_upravu_slev" value="1" class="daneToggleDisabled" data-selector=".zmeny_odecet" <?= $pozadujeZmenyVPrubehuRoku ?> >
                </div>

                <div class="col col-12 col-md-8 ">
                    <?= TextManager::_("Prohlaseni_mesic_zmeny") . "&nbsp;" ?>
                    <?php $rocniVyuctovaniForm->renderComboMesicZmeny('mesic_zmeny', (int)($_POST['mesic_zmeny'] ?? date('n', $rocniVyuctovaniForm->odpocetNavrhDatumOd)), true, ['class' => 'zmeny_odecet']); ?>
                </div>

            </div>

            <div class="row">
                <div class="col col-12 col-md-2 ">
                    <label>
                        <?php $rocniVyuctovaniForm->renderComboOdpocet('zmeny_zakladni_odecet', $rocniVyuctovaniForm->odpocetZakladni) ?>
                    </label>
                </div>


                <div class="col col-12 col-md-2 ">

                    <label>
                        <?php
                        $rocniVyuctovaniForm->renderComboOdpocet('sleva_zakladni_nova', (int)($_POST['sleva_zakladni_nova'] ?? $rocniVyuctovaniForm->odpocetNavrhZakladni), false,
                            [
                                'class' => 'zmeny_odecet',
                            ]);
                        ?>
                    </label>

                </div>

                <div class="col col-12 col-md-8 font-weight-bold">
                    <?= TextManager::_("zakladni_sleva_poplatnika") ?>
                </div>
            </div>

            <div class="row">
                <div class="col col-12 col-md-2 ">
                    <label>
                        <?php $rocniVyuctovaniForm->renderComboOdpocet('zmeny_zdravotni_stav1', $rocniVyuctovaniForm->odpocetZdravotniStav); ?>
                    </label>
                </div>


                <div class="col col-12 col-md-2 ">
                    <label>
                        <?php if ($rocniVyuctovaniForm->zdravotniStav->stav == 1) {
                            $rocniVyuctovaniForm->renderComboOdpocet('sleva_na_zdravotni_stav1', (int)($_POST['sleva_na_zdravotni_stav1'] ?? $rocniVyuctovaniForm->odpocetNavrhZdravotniStav),false,
                                [
                                    'class' => 'zmeny_odecet',
                                ]);
                        } ?>
                    </label>
                </div>


                <div class="col col-12 col-md-8 info">
                    <div class="font-weight-bold float-left"><?= TextManager::_("zakladni_sleva_na_invaliditu") ?></div>
                    <?php if ($jednoduchyVzhled) { ?>
                        <div class="fa inline-glyph glyph-info dane_info" data-selector="#dane_info_skryte11"></div>
                    <?php } ?>

                    <div id="dane_info_skryte11" <?= $classStr ?>>
                        <?= TextManager::_("zakladni_sleva_na_invaliditu_info") ?>
                    </div>
                </div>
            </div>

            <div class="row">
                <div class="col col-12 col-md-2 ">
                    <label>
                        <?php $rocniVyuctovaniForm->renderComboOdpocet('zmeny_zdravotni_stav2', $rocniVyuctovaniForm->odpocetZdravotniStav == 2 ? 1 : 0); ?>
                    </label>
                </div>

                <div class="col col-12 col-md-2 ">
                    <label>
                        <?php if ($rocniVyuctovaniForm->zdravotniStav->stav == 2) {
                            $rocniVyuctovaniForm->renderComboOdpocet('sleva_na_zdravotni_stav2', (int)($_POST['sleva_na_zdravotni_stav2'] ?? $rocniVyuctovaniForm->odpocetNavrhZdravotniStav == 2 ? 1 : 0),false,
                                [
                                    'class' => 'slevaNaInvaliditu zmeny_odecet',
                                ]);
                        } ?>
                    </label>
                </div>

                <div class="col col-12 col-md-8 info">
                    <div class="font-weight-bold float-left"><?= TextManager::_("rozsirenou_sleva_na_invaliditu") ?></div>

                    <?php if ($jednoduchyVzhled) { ?>
                        <div class="fa inline-glyph glyph-info dane_info" data-selector="#dane_info_skryte12"></div>
                    <?php } ?>

                    <div id="dane_info_skryte12" <?= $classStr ?>>
                        <?= TextManager::_("rozsirenou_sleva_na_invaliditu_info") ?>
                    </div>
                </div>
            </div>

            <div class="row">
                <div class="col col-12 col-md-2 ">
                    <label>
                        <?php $rocniVyuctovaniForm->renderComboOdpocet('zmeny_ztpp', $rocniVyuctovaniForm->odpocetZTPP); ?>
                    </label>
                </div>


                <div class="col col-12 col-md-2 ">
                    <label>
                        <?php if ($rocniVyuctovaniForm->zdravotniStav->drzitelPrukazuZTTP) {
                            $rocniVyuctovaniForm->renderComboOdpocet('sleva_ztpp', (int)($_POST['sleva_ztpp'] ?? $rocniVyuctovaniForm->odpocetNavrhZTPP),false,
                                [
                                    'class' => 'zmeny_odecet',
                                ]);
                        } ?>
                    </label>
                </div>


                <div class="col col-12 col-md-8 info">
                    <div class="font-weight-bold float-left"><?= TextManager::_("slevu_na_ztp") ?></div>

                    <?php if ($jednoduchyVzhled) { ?>
                        <div class="fa inline-glyph glyph-info dane_info" data-selector="#dane_info_skryte13"></div>
                    <?php } ?>

                    <div id="dane_info_skryte13" <?= $classStr ?>>
                        <?= TextManager::_("slevu_na_ztp_info") ?>
                    </div>
                </div>
            </div>

            <?php if ($rok < 2024) { //od roku 2024 se sleva na studenta neuplatnuje?>
            <div class="row">
                <div class="col col-12 col-md-2 ">
                    <label>
                        <?php $rocniVyuctovaniForm->renderComboOdpocet('zmeny_odpocet_student', $rocniVyuctovaniForm->odpocetStudent); ?>
                    </label>
                </div>


                <div class="col col-12 col-md-2 ">
                    <label>
                        <?php
                        $rocniVyuctovaniForm->renderComboOdpocet('sleva_na_studenta_nova', (int)($_POST['sleva_na_studenta_nova'] ?? $rocniVyuctovaniForm->odpocetNavrhStudent),false,
                            [
                                'class' => 'zmeny_odecet'
                            ]);
                        ?>
                    </label>
                </div>


                <div class="col col-12 col-md-8 info">
                    <div class="font-weight-bold float-left"><?= TextManager::_("slevu_na_studenta") ?></div>

                    <?php if ($jednoduchyVzhled) { ?>
                        <div class="fa inline-glyph glyph-info dane_info" data-selector="#dane_info_skryte14"></div>
                    <?php } ?>

                    <div id="dane_info_skryte14" <?= $classStr ?>>
                        <?= TextManager::_("slevu_na_studenta_info") ?>
                    </div>
                </div>
            </div>
            <?php } ?>
        </div>

        <?php if ($jednoduchyVzhled) { ?>
            <div class="fa inline-glyph glyph-info dane_info" data-selector="#dane_info_skryte15"></div>
        <?php } ?>

        <div id="dane_info_skryte15" <?= $classStr ?>>
            <div class="info"><sup>10)</sup>&nbsp;<?= TextManager::_("Prohlaseni_dle_paragrafu_38_za_10") ?></div>
        </div>

        <?php
        DaneController::zobrazDokumenty($rocniVyuctovaniForm->database, $rok, $rocniVyuctovaniForm->pracovniPomer, 'odecet', true,
            (($rocniVyuctovaniForm->zdravotniStav->stav > 0) || ($rocniVyuctovaniForm->zdravotniStav->drzitelPrukazuZTTP == 1) || ($rocniVyuctovaniForm->odpocetStudent == 1)));
        ?>

        <div class="info"><?= TextManager::_("Prohlaseni_zmenova_cast_naroku_na_deti_info") ?></div>


        <div class="row">
            <div class="col col-12 col-md-12 center">
                <h2><?= TextManager::_("Prohlaseni_historie_zmen_slev_na_deti") ?></h2>
            </div>
        </div>

        <div class="form-content ram">

            <div class="row">
                <div class="col col-12 col-md-2 center">
                    <?= TextManager::_("Prohlaseni_jmeno_ditete") ?>
                </div>

                <div class="col col-12 col-md-2 center">
                    <?= TextManager::_("Prohlaseni_poradi_ditete") ?>
                </div>

                <div class="col col-12 col-md-1 center">
                    <?= TextManager::_("Prohlaseni_kalendarni_mesic_rozhodnuti_zmeny") ?>
                </div>

                <div class="col col-12 col-md-3 center">
                    <?php echo sprintf(TextManager::_("Prohlaseni_podpis_poplatnika_zmeny"), '<sup>10)</sup>') ?>
                </div>

                <div class="col col-12 col-md-4 center">
                    <?php echo sprintf(TextManager::_("Mzdy_overeni_platcem_dane"), '<sup>9)</sup> <sup>10)</sup>') ?>
                </div>
            </div>

            <hr class="oddelovac">

            <?php
            if (!is_null($rocniVyuctovaniForm->zmenyPoradiDeti)) {
                foreach ($rocniVyuctovaniForm->zmenyPoradiDeti as $dite) { ?>
                    <div class="row align-center">
                        <div class="col col-12 col-md-2">
                            <div class="font-weight-bold">
                                <?= StringUtils::htmlTextConvert($dite->jmeno) ?>&nbsp;<?= StringUtils::htmlTextConvert($dite->prijmeni) ?>
                            </div>
                        </div>

                        <div class="col col-12 col-md-2">
                            <div class="">
                                <?= $dite->poradDiteteNavrh == 0 ? 'N' : $dite->poradDiteteNavrh ?>
                            </div>
                        </div>


                        <div class="col col-12 col-md-1">
                            <div> <?= StringUtils::format('date', $dite->zmenaOd) ?> </div>
                        </div>

                        <div class="col col-12 col-md-3">
                            <div> <?= StringUtils::htmlTextConvert($dite->elektronickyPodpis) ?> </div>
                        </div>

                        <div class="col col-12 col-md-4">
                            <div> <?= StringUtils::htmlTextConvert($dite->elektronickyPodpisUcetni) ?>  </div>
                        </div>
                    </div>

                <?php }
            } ?>
        </div>


        <br>
        <br>


        <div class="row">
            <div class="col col-12 col-md-12 center">
                <h2><?= TextManager::_("Prohlaseni_zmenova_cast_poradi_deti") ?></h2>
            </div>
        </div>


        <div class="form-content ram">


            <div class="row">
                <div class="col col-12 col-md-2 "></div>
                <div class="col col-12 col-md-2 ">
                    <?= TextManager::_('pozaduji_zmenu') ?>

                    <input type="checkbox" id="pozaduji_upravu_poradi_ditete" name="pozaduji_upravu_poradi_ditete" class="daneToggleDisabled" data-selector=".zmenyporadi" value="1">
                </div>

                <div class="col col-12 col-md-4">
                    <?= TextManager::_("Prohlaseni_mesic_zmeny") . "&nbsp;" ?>
                    <?php
                    $mesic = null;
                    if (isset($_POST['mesic_zmeny_deti'])) {
                        $mesic = $_POST['mesic_zmeny_deti'];
                    } elseif (!is_null($rocniVyuctovaniForm->deti)) {
                        foreach ($rocniVyuctovaniForm->deti as $dite) {
                            if (!is_null($dite->zmenaOd)) {
                                $mesic = $dite->zmenaOd;
                            }
                        }
                        $mesic = date('n', $mesic);
                    }
                    $rocniVyuctovaniForm->renderComboMesicZmeny('mesic_zmeny_deti', $mesic, true, ['class' => 'zmenyporadi']); ?>
                </div>

                <div class="col col-12 col-md-4 center"></div>
            </div>


            <br>


            <div class="row">
                <div class="col col-12 col-md-2 ">
                    <?= TextManager::_("Prohlaseni_jmeno_ditete") ?>
                </div>

                <div class="col col-12 col-md-2 ">
                    <?= TextManager::_("rc") ?>
                </div>

                <div class="col col-12 col-md-3 ">
                    <?= TextManager::_("uplatnuji_narok") ?><sup>11)</sup>
                </div>


                <div class="col col-12 col-md-3 center">
                    <?= TextManager::_("Prohlaseni_zmena_poradi") ?>
                </div>


                <div class="col col-12 col-md-1 center">
                    <?= TextManager::_("ZTP/P") ?><sup>4)</sup>
                </div>

                <div class="col col-12 col-md-1 center">
                    <?= TextManager::_("zletile_dite") ?><sup>4)</sup>
                </div>

            </div>

            <hr class="oddelovac">

            <?php
            $i = 0;

            if (!is_null($rocniVyuctovaniForm->deti)) {

                $uplatnujeOdpocetNaDeti = false;
                foreach ($rocniVyuctovaniForm->deti as $dite) {
                    if ($dite->poradDitete > 0) {
                        $uplatnujeOdpocetNaDeti = true;
                    }

                    ?>

                    <div class="row">
                        <div class="col col-12 col-md-2">
                            <input type="hidden" name="dite_<?= $i ?>" value="<?= $dite->id; ?>">
                            <?= StringUtils::htmlTextConvert($dite->jmeno) ?>&nbsp;<?= StringUtils::htmlTextConvert($dite->prijmeni) ?>
                        </div>

                        <div class="col col-12 col-md-2">
                            <?= StringUtils::htmlTextConvert($dite->rodneCislo) ?>
                        </div>

                        <div class="col col-12 col-md-3 center">
                            <?= ($dite->poradDitete == 0) ? "N" : $dite->poradDitete ?>
                            <?= $dite->zmenaOd > time() ? sprintf(TextManager::_('Prohlaseni_zmena_od'), date('n/Y', $dite->zmenaOd)) : '' ?>
                        </div>

                        <div class="col col-12 col-md-3 center">

                            <label title="<?= TextManager::_('zruseni_nahlaseni_zmeny_poradi_info') ?>">
                                <?php
                                $rocniVyuctovaniForm->renderComboPoradiDitete("dite_poradi_navrh_$i", (int)($_POST["dite_poradi_navrh_$i"] ?? $dite->poradDiteteNavrh), true,
                                    ['class' => 'danovezvyhodneniporadiditete zmenyporadi'], true);
                                ?>
                            </label>

                        </div>

                        <div class="col col-12 col-md-1 center">
                            <label>
                                <input type="checkbox" <?= $dite->ztpp ? 'checked' : "" ?> value="1" disabled>
                            </label>
                        </div>

                        <div class="col col-12 col-md-1 center">
                            <label>
                                <input type="checkbox" <?= $dite->vekNaZacatkuRoku->y >= 18 ? 'checked' : "" ?> value="1" disabled>
                            </label>
                        </div>

                    </div>

                    <?php $i++;
                }
            } ?>
            <input type="hidden" name="pocetDetiZmenyPoradi" value="<?= $i ?>">
        </div>

        <?php if ($jednoduchyVzhled) { ?>
            <div class="fa inline-glyph glyph-info dane_info" data-selector="#dane_info_skryte16"></div>
        <?php } ?>

        <div id="dane_info_skryte16" <?= $classStr ?>>
            <div class="info"><sup>11)</sup>&nbsp;<?= TextManager::_("Prohlaseni_dle_paragrafu_38_za_11") ?></div>
        </div>

        <?php
        DaneController::zobrazDokumenty($rocniVyuctovaniForm->database, $rok, $rocniVyuctovaniForm->pracovniPomer, 'deti', true, $i > 0 && $uplatnujeOdpocetNaDeti);
        ?>

        <?php if ($skrytDalsihoPoplatnika == 0) { ?>

            <div class="col col-12 col-md-12 center">
                <h3><?= TextManager::_("Prohlaseni_dle_paragrafu_38") ?></h3>
            </div>


            <div class="font-weight-bold">a)&nbsp;<?= TextManager::_("Prohlaseni_dle_paragrafu_38_za_a") ?></span></div>
            <div class="font-weight-bold">b)&nbsp;<?= TextManager::_("Prohlaseni_dle_paragrafu_38_za_b") ?></div>
            <div class="font-weight-bold">c)&nbsp;<?= TextManager::_("Prohlaseni_dle_paragrafu_38_za_c") ?>
                <label for="vyzivujeJinyPoplatnik"></label>
                <?php $rocniVyuctovaniForm->renderComboAnoNe('vyzivujeJinyPoplatnik', (int)($_POST['vyzivujeJinyPoplatnik'] ?? $rocniVyuctovaniForm['VyzivujeJinyPoplatnik']), false,
                    ['class' => 'daneToggleDisabled zmenyporadi', 'data-selector' => '.jiny-poplatnik']); ?>
                <sup class="padding-left">6)</sup><sup>6a)</sup>
            </div>

            <br>

            <div class="form-content ram">
                <div class="row">
                    <div class="col col-12 col-md-2 center">
                        <?= TextManager::_("Jmeno") ?>
                    </div>

                    <div class="col col-12 col-md-4 center">
                        <?= TextManager::_("Prijmeni") ?>
                    </div>

                    <div class="col col-12 col-md-3 center">
                        <?= TextManager::_("rodne_cislo") ?>*
                    </div>

                    <div class="col col-12 col-md-2 center">
                        <?= TextManager::_("Prohlaseni_dle_paragrafu_38_uplatnuje") ?>
                    </div>

                    <div class="col col-12 col-md-1 center">
                        <?= TextManager::_("Prohlaseni_dle_paragrafu_38_zamestnani") ?><sup>7)</sup>
                    </div>
                </div>

                <hr class="oddelovac">

                <div class="row">
                    <div class="col col-12 col-md-2">
                        <label>
                            <input type="text"
                                   class="pole-zadosti jiny-poplatnik"
                                   id="jinyPoplatnikJmenoVisible"
                                   value="<?= StringUtils::htmlTextConvert($rocniVyuctovaniForm['JinyPoplatnikJmeno']) ?>"
                                   data-poplatnik-hidden="<?= isset($rocniVyuctovaniForm->partnerPoplatnika) ? StringUtils::htmlTextConvert($rocniVyuctovaniForm->partnerPoplatnika->jmeno) : '' ?>"
                                   name="jinyPoplatnikJmeno"
                                   readonly="readonly">
                        </label>
                    </div>

                    <div class="col col-12 col-md-4">
                        <label>
                            <input type="text"
                                   class="pole-zadosti jiny-poplatnik"
                                   id="jinyPoplatnikPrijmeniVisible"
                                   value="<?= StringUtils::htmlTextConvert($rocniVyuctovaniForm['JinyPoplatnikPrijmeni']) ?>"
                                   data-poplatnik-hidden="<?= isset($rocniVyuctovaniForm->partnerPoplatnika) ? StringUtils::htmlTextConvert($rocniVyuctovaniForm->partnerPoplatnika->prijmeni) : '' ?>"
                                   name="jinyPoplatnikPrijmeni"
                                   readonly="readonly">
                        </label>
                    </div>


                    <div class="col col-12 col-md-3">
                        <label>
                            <input type="text"
                                   class="pole-zadosti jiny-poplatnik"
                                   id="jinyPoplatnikRCVisible"
                                   value="<?= StringUtils::htmlTextConvert($rocniVyuctovaniForm['JinyPoplatnikRC']) ?>"
                                   data-poplatnik-hidden="<?= isset($rocniVyuctovaniForm->partnerPoplatnika) ? StringUtils::htmlTextConvert($rocniVyuctovaniForm->partnerPoplatnika->rodneCislo) : '' ?>"
                                   name="jinyPoplatnikRC"
                                   readonly="readonly">
                        </label>
                    </div>

                    <div class="col col-12 col-md-2">

                        <label for="partner_zamestnan"></label>
                        <?php $rocniVyuctovaniForm->renderComboAnoNe('jinyPoplatnikUplatnujeZv', isset($_POST['jinyPoplatnikUplatnujeZv']) ? (int)$_POST['jinyPoplatnikUplatnujeZv'] : ($rocniVyuctovaniForm['JinyPoplatnikUplatnujeZv'] ?? 0), false,
                            ['class' => 'pole-zadosti jiny-poplatnik prohlaseni-poplatnika-dane']); ?>

                    </div>

                    <div class="col col-12 col-md-1">
                        <?php $rocniVyuctovaniForm->renderComboAnoNe('jinyPoplatnikZamestnani', isset($_POST['jinyPoplatnikZamestnani']) ? (int)$_POST['jinyPoplatnikZamestnani'] : ($rocniVyuctovaniForm['JinyPoplatnikZamestnani'] ?? 0), false,
                            ['class' => 'pole-zadosti jiny-poplatnik prohlaseni-poplatnika-dane daneToggleDisabled', 'data-selector' => '.jiny-poplatnik-zamestnavatel']); ?>
                    </div>

                </div>


                <hr class="oddelovac">

                <div class="row align-center">
                    <div class="col col-12 col-md-3 align-left">
                        <div><?= TextManager::_('Prohlaseni_platce_dane_partner_adresa') ?> </div>
                    </div>

                    <div class="col col-12 col-md-1 align-right">
                        <div><?= TextManager::_('Prohlaseni_jinyPoplatnikObec') . '&nbsp;' ?> </div>
                    </div>

                    <div class="col col-12 col-md-8">
                        <input type="text" class="pole-zadosti jiny-poplatnik adresa-poplatnika prohlaseni-poplatnika-dane"
                               name="jinyPoplatnikObec" data-poplatnik-hidden="<?= $rocniVyuctovaniForm->bydliste->obecPopis ?>"
                               value="<?= isset($_POST["jinyPoplatnikObec"]) ? StringUtils::htmlTextConvert($_POST["jinyPoplatnikObec"]) : $rocniVyuctovaniForm['JinyPoplatnikObec'] ?>" disabled>
                    </div>
                </div>


                <div class="row align-center">
                    <div class="col col-12 col-md-3">
                        <div></div>
                    </div>

                    <div class="col col-12 col-md-1 align-right">
                        <div><?= TextManager::_('Prohlaseni_jinyPoplatnikUlice') . '&nbsp;' ?> </div>
                    </div>

                    <div class="col col-12 col-md-8">
                        <input type="text" class="pole-zadosti jiny-poplatnik adresa-poplatnika prohlaseni-poplatnika-dane"
                               name="jinyPoplatnikUlice" data-poplatnik-hidden="<?= $rocniVyuctovaniForm->bydliste->ulice ?>"
                               value="<?= isset($_POST["jinyPoplatnikUlice"]) ? StringUtils::htmlTextConvert($_POST["jinyPoplatnikUlice"]) : $rocniVyuctovaniForm['JinyPoplatnikUlice'] ?>" disabled>
                    </div>
                </div>

                <div class="row align-center">
                    <div class="col col-12 col-md-3">
                        <div></div>
                    </div>

                    <div class="col col-12 col-md-1 align-right">
                        <div><?= TextManager::_('Prohlaseni_jinyPoplatnikPSC') . '&nbsp;' ?> </div>
                    </div>

                    <div class="col col-12 col-md-8">
                        <label title="<?= TextManager::_('') ?>">
                            <input type="text" class="pole-zadosti jiny-poplatnik adresa-poplatnika prohlaseni-poplatnika-dane"
                                   name="jinyPoplatnikPSC" data-poplatnik-hidden="<?= $rocniVyuctovaniForm->bydliste->psc ?>"
                                   value="<?= isset($_POST["jinyPoplatnikPSC"]) ? StringUtils::htmlTextConvert($_POST["jinyPoplatnikPSC"]) : $rocniVyuctovaniForm['JinyPoplatnikPSC'] ?>" disabled>
                        </label>
                    </div>
                </div>

                <hr class="oddelovac">

                <div class="row align-center">
                    <div class="col col-12 col-md-3 align-left">
                        <div><?= TextManager::_('Prohlaseni_platce_dane_partner_zamestnavatel_nazev') ?> <sup>7)</sup></div>
                    </div>

                    <div class="col col-12 col-md-1">
                        <div></div>
                    </div>


                    <div class="col col-12 col-md-8">
                        <label title="<?= TextManager::_('') ?>">
                            <input type="text" class="pole-zadosti jiny-poplatnik jiny-poplatnik-zamestnavatel zamestnavatel-udaje prohlaseni-poplatnika-dane"
                                   name="jinyPoplatnikNazevPlatce"
                                   value="<?= isset($_POST["jinyPoplatnikNazevPlatce"]) ? StringUtils::htmlTextConvert($_POST["jinyPoplatnikNazevPlatce"]) : $rocniVyuctovaniForm['JinyPoplatnikNazevPlatce'] ?>" disabled>
                        </label>
                    </div>
                </div>

                <hr class="oddelovac">

                <div class="row align-center">
                    <div class="col col-12 col-md-3 align-left">
                        <div><?= TextManager::_('Prohlaseni_platce_dane_partner_zamestnavatel_adresa') ?> <sup>7)</sup></div>
                    </div>

                    <div class="col col-12 col-md-1 align-right">
                        <div><?= TextManager::_('Prohlaseni_jinyPoplatnikObec') . '&nbsp;' ?> </div>
                    </div>

                    <div class="col col-12 col-md-8">
                        <label title="<?= TextManager::_('') ?>">
                            <input type="text" class="pole-zadosti jiny-poplatnik jiny-poplatnik-zamestnavatel zamestnavatel-udaje prohlaseni-poplatnika-dane"
                                   name="jinyPoplatnikObecPlatce"
                                   value="<?= isset($_POST["jinyPoplatnikObecPlatce"]) ? StringUtils::htmlTextConvert($_POST["jinyPoplatnikObecPlatce"]) : $rocniVyuctovaniForm['JinyPoplatnikObecPlatce'] ?>" disabled>
                        </label>
                    </div>
                </div>

                <div class="row align-center">
                    <div class="col col-12 col-md-2">
                        <div></div>
                    </div>

                    <div class="col col-12 col-md-2 align-right">
                        <div><?= TextManager::_('Prohlaseni_jinyPoplatnikUlice') . '&nbsp;' ?> </div>
                    </div>

                    <div class="col col-12 col-md-8">
                        <input type="text" class="pole-zadosti jiny-poplatnik jiny-poplatnik-zamestnavatel zamestnavatel-udaje prohlaseni-poplatnika-dane"
                               name="jinyPoplatnikUlicePlatce"
                               value="<?= isset($_POST["jinyPoplatnikUlicePlatce"]) ? StringUtils::htmlTextConvert($_POST["jinyPoplatnikUlicePlatce"]) : $rocniVyuctovaniForm['JinyPoplatnikUlicePlatce'] ?>" disabled>
                    </div>
                </div>

                <div class="row align-center">
                    <div class="col col-12 col-md-2">
                        <div></div>
                    </div>

                    <div class="col col-12 col-md-2 align-right">
                        <div><?= TextManager::_('Prohlaseni_jinyPoplatnikPSC') . '&nbsp;' ?> </div>
                    </div>

                    <div class="col col-12 col-md-8">
                        <label title="<?= TextManager::_('') ?>">
                            <input type="text" class="pole-zadosti jiny-poplatnik jiny-poplatnik-zamestnavatel zamestnavatel-udaje prohlaseni-poplatnika-dane"
                                   name="jinyPoplatnikPSCPlatce"
                                   value="<?= isset($_POST["jinyPoplatnikPSCPlatce"]) ? StringUtils::htmlTextConvert($_POST["jinyPoplatnikPSCPlatce"]) : $rocniVyuctovaniForm['JinyPoplatnikPSCPlatce'] ?>" disabled>
                        </label>
                    </div>
                </div>

            </div>

            <?php if ($jednoduchyVzhled) { ?>
                <div class="fa inline-glyph glyph-info dane_info" data-selector="#dane_info_skryte8"></div>
            <?php } ?>

            <div id="dane_info_skryte8" <?= $classStr ?>>
                <div class="info">*<sup>)</sup>&nbsp;<?= TextManager::_("Prohlaseni_dle_paragrafu_38_doplneni_partnera") ?></div>
                <div class="info"><sup>6)</sup>&nbsp;<?= TextManager::_("Prohlaseni_dle_paragrafu_38_za_6") ?></div>
                <div class="info"><sup>6a)</sup>&nbsp;<?= TextManager::_("Prohlaseni_dle_paragrafu_38_za_6a") ?></div>
                <div class="info"><sup>7)</sup>&nbsp;<?= TextManager::_("Prohlaseni_dle_paragrafu_38_za_7") ?></div>

                <br>

                <div class="info"><?= TextManager::_("Prohlaseni_dle_paragrafu_38_zmena") ?></div>
                <br>
                <div class="info"><?= TextManager::_("Prohlaseni_dle_paragrafu_38_nepravdive_prohlaseni") ?></div>

            </div>

            <?php
            DaneController::zobrazDokumenty($rocniVyuctovaniForm->database, $rok, $rocniVyuctovaniForm->pracovniPomer, 'partner', $rocniVyuctovaniForm->lzeEditovatProhlaseni(), isset($rocniVyuctovaniForm->partnerPoplatnika->id));
            ?>
        <?php } ?>

<!--TODO: podpisova cast u zmenoveho formulare??? -->
        <br>
        <?php if ($jednoduchyVzhled) { ?>
            <div class="fa inline-glyph glyph-warning dane_info" data-selector="#dane_info_skryte10"></div>
        <?php } ?>

        <div id="dane_info_skryte10" <?= $classStr ?>>
            <div class="info font-weight-bold"><?= TextManager::_("Prohlaseni_upozorneni_zmenova_cast_tucne") ?></div>
            <div class="info"><?= TextManager::_("Prohlaseni_upozorneni_zmenova_cast") ?></div>
        </div>

        <div class="buttons">
            <input type="button" class="button clickHref" data-ron-href="?menuid=dane&osoba=<?= $rocniVyuctovaniForm->pracovniPomer->idPP ?>" value="<?= TextManager::_('zpet') ?>">

            <button type="submit" class="button" id="zmenovaCastProhlaseni" name="zmenovaCastProhlaseni" value="1"><?= TextManager::_('Prohlaseni_zmenova_cast_ulozit') ?></button>

        </div>

    </div>
</form>

<?php
FormReportsListView::renderReportList($reportlist, '?menuid=dane&action=report&typ=prohlaseni&idpp=' . $rocniVyuctovaniForm->pracovniPomer->idPP . '&rok=' . $rok);
?>
