<?php
/** roman.Szablatura 29.11.2016  */

namespace RonPortal\Napady;

use Ron\MessageManager;
use Ron\MVC\Model;
use Ron\StringUtils;
use Ron\TextManager;
use RonPortal\Dokumenty\DokumentUploadForm;
use RonPortal\PravaNaOsoby;
use RonPortal\RonPortalSettings;
use RonPortal\User;

$model = Model::getInstance();
/** @var Napad $napad */
$napad = $model->getData('napad');

/** @var PravaNaOsoby $pravaNapadu */
$pravaNapadu = $model->getData('pravaNapadu');

/** @var PravaNaOsoby $pravaNapaduAdmin */
$pravaNapaduAdmin = $model->getData('pravaNapaduAdmin');
$dokumentBrowserNapadu = $model->getData('dokumentBrowserNapadu');
$spoluautori = $model ->getData('spoluautori');
$comboSpoluautori = $model->getData('comboSpoluautori');

?>
<h1><?= TextManager::_('detail_napadu')?> - <?= StringUtils::htmlTextConvert($napad->nazev) ?></h1>

<?php MessageManager::getInstance() ->showMessages(); ?>

<div class="form middle-form">
    <div class="form-content">

        <div class="row" id="row_stav_napadu">
            <div class="col-4 caption" id="stav_napadu_popisek"><?= TextManager::_('stav_napadu') ?></div>
            <div class="col-8">
                <strong><?= StringUtils::htmlTextConvert($napad->stavNapaduPopis) ?></strong>
            </div>
        </div>

        <?php if (trim($napad->pilotPrijmeniJmeno) != ''  ||  $pravaNapaduAdmin->jsouNejakePrava())  { //Pokud se jedna o administratora nebo pilota ?>
            <div class="row" id="row_pilot_napadu">
                <div class="col-4 caption"><?= TextManager::_('pilot') ?></div>

                <div class="col-8">
                <?php if (trim($napad->pilotPrijmeniJmeno) != '') { ?>
                    <strong><?= StringUtils::htmlTextConvert($napad->pilotPrijmeniJmeno) ?></strong>
                <?php } else { ?>
                    <?php if ($pravaNapaduAdmin->jsouNejakePrava()) { ?>
                    <a id="odkaz_pilot" href="?menuid=napady&formaction=edit&record=<?= $napad->id?>"><?= TextManager::_('prirazeni_pilota')  ?></a>
                    <?php } ?>
                <?php }?>
                </div>
            </div>
        <?php } ?>

        <div class="row" id="row_autor_napadu">
            <div class="col-4 caption"><?= TextManager::_('autor') ?></div>

            <div class="col-8">
                <strong><?= StringUtils::htmlTextConvert($napad->autorPrijmeniJmeno) ?></strong>
            </div>
        </div>


        <div class="form-section" id="napad_section_detaily">
            <?= TextManager::_('detaily') ?>
        </div>


        <div class="row" id="row_oblast_napadu">
            <div class="col-4 caption"><?= TextManager::_('oblast_napadu') ?></div>
            <div class="col-8">
                <?= StringUtils::htmlTextConvert($napad->oblastNapaduPopis) . ($napad->oblast ? ' (' . StringUtils::htmlTextConvert($napad->oblast) . ')' : '') ?>
            </div>
        </div>

        <div class="row" id="row_priorita_napadu">
            <div class="col-4 caption"><?= TextManager::_('priorita') ?></div>
            <div class="col-8"><strong><?= StringUtils::htmlTextConvert($napad->priorita) ?></strong></div>
        </div>

        <div class="row margin-top-2" id="row_popis_napadu">
            <div class="col-12 col-sm-4 caption"><?= TextManager::_('podrobny_popis') ?></div>
            <div class="col-12 col-sm-8 poznamka"><?= StringUtils::longTextToHtml(StringUtils::htmlTextConvert($napad->podrobnyPopis)) ?></div>
        </div>

        <div class="row margin-top-2" id="row_vyjadreni_pilota_napadu">
            <div class="col-12 col-sm-4 caption" id="popis_vyjadreni" ><?= TextManager::_('vyjadreni_pilota') ?></div>
            <div class="col-12 col-sm-8 poznamka"><?= StringUtils::longTextToHtml(StringUtils::htmlTextConvert($napad->vyjadreniPilota)) ?></div>
        </div>

        <div class="row margin-top-2" id="row_rozpocet_napadu">
            <div class="col col-4 caption"><?= TextManager::_('rozpocet') ?></div>
            <div class="col col-8"><?= StringUtils::format('number_2', $napad->rozpocet) ?></div>
        </div>

        <div class="row" id="row_odmena_napadu">
            <div class="col-4 caption"><?= TextManager::_('odmena') ?></div>
            <div class="col-8"><?= StringUtils::format('number_2', $napad->odmenaCastka) ?></div>
        </div>

        <div class="row border-bottom" id="row_obdobi_odmeny_napadu">
            <div class="col-4 caption"><?= TextManager::_('obdobi_vyplaceni_odmeny') ?></div>
            <div class="col-8"><?= StringUtils::format('date', $napad->odmenaVyplacenaVObdobi) ?></div>
        </div>

        <div class="row" id="row_napad_vlozil">
            <div class="col-4 caption"><?= TextManager::_('zaznam_vlozil') ?></div>
            <div class="col-8">
                <?= StringUtils::htmlTextConvert($napad->insert_UserName) ?>
                <?= $napad->insert_Timestamp ? '(' . StringUtils::format('datetime', $napad->insert_Timestamp) . ')' : '' ?>
            </div>
        </div>

        <div class="row" id="row_napad_editoval">
            <div class="col-4 caption"><?= TextManager::_('naposled_editoval') ?></div>
            <div class="col-8">
                <?= StringUtils::htmlTextConvert($napad->update_UserName) ?>
                <?= $napad->update_Timestamp ? '(' . StringUtils::format('datetime', $napad->update_Timestamp) . ')' : '' ?>
            </div>
        </div>

        <?php if ($spoluautori || $pravaNapadu->lzeZobrazitRC($napad->autorRC) || $pravaNapaduAdmin->lzeZobrazitRC($napad->autorRC)) { ?>
            <div id="spoluautori_napadu" class="margin-top-2">
                <div class="form-section" id="napad_section_detaily">
                    <?= TextManager::_('spoluautori') ?>
                </div>

                <?php foreach ($spoluautori as $spoluautor) { ?>
                <div class="row spoluautor-napadu">
                    <div class="col-0 col-sm-4 caption"></div>
                    <div class="col-12 col-sm-8">
                        <span class="margin-right-2">
                            <?= StringUtils::htmlTextConvert($spoluautor['titul'] ?: '') ?> <?= StringUtils::htmlTextConvert($spoluautor['prijmeni']) ?> <?= StringUtils::htmlTextConvert($spoluautor['jmeno']) ?>
                        </span>
                        <?php if ($pravaNapadu->lzeZobrazitRC($napad->autorRC) || $pravaNapaduAdmin->lzeZobrazitRC($napad->autorRC)) { ?>
                        <a href="?menuid=napady&action=spoluautordelete&idnapadu=<?= $napad ->id ?>&idosoby=<?= $spoluautor['id'] ?>">
                            <i class="inline-glyph glyph-button fa glyph-delete" title="<?= TextManager::_('odebrat_spoluautora') ?>"></i>
                        </a>
                        <?php } ?>
                    </div>
                </div>
                <?php } ?>

                <?php if ($pravaNapadu->lzeZobrazitRC($napad->autorRC) || $pravaNapaduAdmin->lzeZobrazitRC($napad->autorRC)) { ?>
                <div class="row" id="row_novy_spoluautor_napadu">
                    <div class="col-0 col-sm-4 caption"></div>
                    <div class="col-12 col-sm-8">
                        <form name="novy_autor" action="?menuid=napady&action=novyspoluautor" method="post">
                            <input type="hidden" name="id_napadu" value="<?= $napad->id ?>">

                            <div>
                                <?php $comboSpoluautori->render(); ?>
                            </div>
                            <div>
                                <input type="submit" class="button" value="<?= TextManager::_('vlozit_spoluautora') ?>">
                            </div>
                        </form>
                    </div>
                </div>
                <?php } ?>
            </div>
        <?php } ?>
    </div>

    <div class="buttons">
        <div class="row">
            <div class="col-4">
                <a href="?menuid=napady"><?= TextManager::_('zpet_na_seznam')?></a>
            </div>

            <div class="col-8">
                <?php if ( ($napad->vyjadreniPilota == '' || $pravaNapaduAdmin->jsouNejakePrava() || $napad->pilotRC == User::getRC()) ) { ?>
                    <a href="?menuid=napady&formaction=edit&record=<?= $napad->id?>"><?= TextManager::_('editovat')?></a>
                <?php } else { ?>
                    <?= TextManager::_('vlozeno_vyjadreni_pilota') ?>
                <?php } ?>
            </div>
        </div>
    </div>
</div>

<div id="dokumenty_napadu">
    <?php if ($pravaNapadu->lzeZobrazitRC($napad->autorRC) || $pravaNapaduAdmin->lzeZobrazitRC($napad->autorRC)) { ?>
        <?php $dokumentBrowserNapadu->render();  ?>

        <?php if(RonPortalSettings::getIntValue('pocetdokumentuknapadu',1) > $napad->pocetDokumentu) { ?>
            <a class="show-dokument-dialog" href="#" title="<?= TextManager::_('mozny_pocet_dokumentu') . ': ' . RonPortalSettings::getIntValue('pocetdokumentuknapadu',1) ?>"><?= TextManager::_('novy_dokument_napadu') ?></a>
        <?php }?>
        <?php
        /** @var DokumentUploadForm $form */
        $form = $model->getData('dokumentUploadForm');
        $form ->render();
        ?>
    <?php } ?>
</div>

