<?php
/**
 * UTF-8
 * Created by PhpStorm.
 * User: pavel.rudol
 * Date: 18.3.2016
 * Time: 14:01
 */

namespace RonPortal\PokladniKniha;

use Ron\Http\Csrf;
use Ron\MessageManager;
use Ron\MVC\Model;
use Ron\TextManager;
use RonPortal\Controls\FormReportsListView;
use RonPortal\Prava;
use RonPortal\PravaNaOsoby;
use RonPortal\RonPortalSettings;
use Ron\StringUtils;
use function Ron\ronText;

$model = Model::getInstance();

/** @var PokladniKniha $pokladniKnihaZaznam */
$pokladniKnihaZaznam = $model->getData('pokladnikniha');

/** @var DokumentyPokladniKnihyBrowser $dokumentyBrowser */
$dokumentyBrowser = $model->getData('dokumentyBrowser');

/** @var RadekPokladniKnihyBrowser $radkyPokladniKnihyBrowser */
$radkyPokladniKnihyBrowser = $model->getData('radkyBrowser');
/** @var RadekPokladniknihyDialog $dialogRadku */
$dialogRadku = $model->getData('dialogRadku');

/** @var bool $vraceni */
$vraceni = $model->getData('vraceni');

/** @var SeznamPolozekPokladniKnihy $seznamPolozekPoklK */
$seznamPolozekPoklK = $model->getData('seznamPolozekPoklK');

$typPolozky = $seznamPolozekPoklK->vratTypPolozky($pokladniKnihaZaznam->typPolozkyKod);

// zauctovani
$prava_z = Prava::vratPrava('pkniha_zauct');
$lzezauctovat = $prava_z->lzeZobrazitPP($pokladniKnihaZaznam->idPP, $pokladniKnihaZaznam->datumPohybu);


$reports = $model->getData('reports');
?>

<h1><?= ronText('pokladni_kniha_zaznam' . ($seznamPolozekPoklK->cislo != 1 ? "_$seznamPolozekPoklK->cislo" : '')) . ' ' . $pokladniKnihaZaznam->vratID() ?></h1>

<?php MessageManager::getInstance() ->showMessages(); ?>


<div class="form middle-form" id="hlavickapokladniknihy">
    <div class="form-content" id="pokladniknihatable">

        <div class="row" id="hlavickapoklk_osoba">
            <div class="col col-3 d-xs-none"></div>
            <div class="col col-12 col-sm-9">
                <strong><?= StringUtils::htmlTextConvert($pokladniKnihaZaznam->vratJmenoPrijmeni()) ?></strong>, <?= ronText('Osobni_cislo') . ' ' . StringUtils::htmlTextConvert($pokladniKnihaZaznam->osobniCislo) ?>
            </div>
        </div>
        <div class="row" id="hlavickapoklk_datum">
            <div class="col col-12 col-sm-3 caption"><?= ronText('datum_pohybu') ?></div>
            <div class="col col-12 col-sm-9">
                <?= StringUtils::format('date',$pokladniKnihaZaznam->datumPohybu) ?>
            </div>
        </div>
        <div class="row" id="hlavickapoklk_typpohybu">
            <div class="col col-12 col-sm-3 caption"><?= ronText('typ_polozky') ?></div>
            <div class="col col-12 col-sm-9">
                <?=StringUtils::htmlTextConvert(TextManager::_("db_typpolozkypokladniknihy_popis_$pokladniKnihaZaznam->typPolozkyKod", $pokladniKnihaZaznam->typPolozky)) ?>
            </div>
        </div>
        <div class="row" id="hlavickapoklk_popis">
            <div class="col col-12 col-sm-3 caption">
                <?= ronText('popis' . ($seznamPolozekPoklK->cislo != 1 ? "_$seznamPolozekPoklK->cislo" : '')) ?>
            </div>
            <div class="col col-12 col-sm-9">
                <?= StringUtils::htmlTextConvert($pokladniKnihaZaznam->popis) ?>
            </div>
        </div>
        <?php if (isset($pokladniKnihaZaznam->rozdeleni)) { ?>
        <div class="row" id="hlavickapoklk_rozdeleni">
            <div class="col col-12 col-sm-3 caption">
                <?= StringUtils::htmlTextConvert($pokladniKnihaZaznam->typRozdeleniPopis) ?>
            </div>
            <div class="col col-12 col-sm-9">
                <?= StringUtils::htmlTextConvert($pokladniKnihaZaznam->rozdeleni->popis) ?>
            </div>
        </div>
        <?php } ?>
        <?php if (isset($pokladniKnihaZaznam->rozdeleni2)) { ?>
        <div class="row" id="hlavickapoklk_rozdeleni2">
            <div class="col col-12 col-sm-3 caption">
                <?= StringUtils::htmlTextConvert($pokladniKnihaZaznam->typRozdeleni2Popis) ?>
            </div>
            <div class="col col-12 col-sm-9">
                <?= StringUtils::htmlTextConvert($pokladniKnihaZaznam->rozdeleni2->popis) ?>
            </div>
        </div>
        <?php } ?>
        <?php if (isset($pokladniKnihaZaznam->rozdeleni3)) { ?>
        <div class="row" id="hlavickapoklk_rozdeleni3">
            <div class="col col-12 col-sm-3 caption">
                <?= StringUtils::htmlTextConvert($pokladniKnihaZaznam->typRozdeleni3Popis) ?>
            </div>
            <div class="col col-12 col-sm-9">
                <?= StringUtils::htmlTextConvert($pokladniKnihaZaznam->rozdeleni3->popis) ?>
            </div>
        </div>
        <?php } ?>
        <?php if (isset($pokladniKnihaZaznam->rozdeleni4)) { ?>
        <div class="row" id="hlavickapoklk_rozdeleni4">
            <div class="col col-12 col-sm-3 caption">
                <?= StringUtils::htmlTextConvert($pokladniKnihaZaznam->typRozdeleni4Popis) ?>
            </div>
            <div class="col col-12 col-sm-9">
                <?= StringUtils::htmlTextConvert($pokladniKnihaZaznam->rozdeleni4->popis) ?>
            </div>
        </div>
        <?php } ?>
        <?php if ($typPolozky->lzeZobrazitCastkuBezDPH()) { ?>
        <div class="row" id="hlavickapoklk_castka_bez_dph">
            <div class="col col-12 col-sm-3 caption">
                <?= ronText('castkaBezDPH') ?>
            </div>
            <div class="col col-12 col-sm-9">
                <?= StringUtils::format('number2',$pokladniKnihaZaznam->castkaBezDPH) ?>  <?= StringUtils::htmlTextConvert($pokladniKnihaZaznam->mena) ?>
            </div>
        </div>
        <?php } ?>
        <?php if ($typPolozky->lzeZobrazitCastkuDPH()) { ?>
        <div class="row" id="hlavickapoklk_castka_dph">
            <div class="col col-12 col-sm-3 caption">
                <?= ronText('castkaDPH') ?>
            </div>
            <div class="col col-12 col-sm-9">
                <?= StringUtils::format('number2',$pokladniKnihaZaznam->castkaDPH) ?>  <?= StringUtils::htmlTextConvert($pokladniKnihaZaznam->mena) ?>
            </div>
        </div>
        <?php } ?>
        <div class="row" id="hlavickapoklk_castka">
            <div class="col col-12 col-sm-3 caption">
                <?= ronText('castka') ?>
            </div>
            <div class="col col-12 col-sm-9">
                <strong><?= StringUtils::format('number2',$pokladniKnihaZaznam->castka) ?></strong>  <?= StringUtils::htmlTextConvert($pokladniKnihaZaznam->mena) ?>
            </div>
        </div>
        <div class="row" id="hlavickapoklk_zpusobplatby">
            <div class="col col-12 col-sm-3 caption">
                <?= ronText('PoklK_zpusobplatby') ?>
            </div>
            <div class="col col-12 col-sm-9">
                <?= StringUtils::htmlTextConvert($pokladniKnihaZaznam->zpusobPlatbyPopis) ?>
            </div>
        </div>

        <?php if ($typPolozky->t1Popis) { ?>
        <div class="row" id="hlavickapoklk_t1">
            <div class="col col-12 col-sm-3 caption">
                <?= ronText(StringUtils::htmlTextConvert($typPolozky->t1Popis)) ?>
            </div>
            <div class="col col-12 col-sm-9">
                <?= StringUtils::htmlTextConvert($pokladniKnihaZaznam->t1) ?>
            </div>
        </div>
        <?php } ?>
        <?php if ($typPolozky->t2Popis) { ?>
        <div class="row" id="hlavickapoklk_t2">
            <div class="col col-12 col-sm-3 caption">
                <?= ronText(StringUtils::htmlTextConvert($typPolozky->t2Popis)) ?>
            </div>
            <div class="col col-12 col-sm-9">
                <?= StringUtils::htmlTextConvert($pokladniKnihaZaznam->t2) ?>
            </div>
        </div>
        <?php } ?>
        <?php if ($typPolozky->t3Popis) { ?>
        <div class="row" id="hlavickapoklk_t3">
            <div class="col col-12 col-sm-3 caption">
                <?= ronText(StringUtils::htmlTextConvert($typPolozky->t3Popis)) ?>
            </div>
            <div class="col col-12 col-sm-9">
                <?= StringUtils::htmlTextConvert($pokladniKnihaZaznam->t3) ?>
            </div>
        </div>
        <?php } ?>
        <?php if ($typPolozky->t4Popis) { ?>
        <div class="row" id="hlavickapoklk_t4">
            <div class="col col-12 col-sm-3 caption">
                <?= ronText(StringUtils::htmlTextConvert($typPolozky->t4Popis)) ?>
            </div>
            <div class="col col-12 col-sm-9">
                <?= StringUtils::htmlTextConvert($pokladniKnihaZaznam->t4) ?>
            </div>
        </div>
        <?php } ?>
        <?php if ($typPolozky->t5Popis) { ?>
        <div class="row" id="hlavickapoklk_t5">
            <div class="col col-12 col-sm-3 caption">
                <?= ronText(StringUtils::htmlTextConvert($typPolozky->t5Popis)) ?>
            </div>
            <div class="col col-12 col-sm-9">
                <?= StringUtils::htmlTextConvert($pokladniKnihaZaznam->t5) ?>
            </div>
        </div>
        <?php } ?>
        <?php if ($typPolozky->i1Popis) { ?>
        <div class="row" id="hlavickapoklk_i1">
            <div class="col col-12 col-sm-3 caption">
                <?= ronText(StringUtils::htmlTextConvert($typPolozky->i1Popis)) ?>
            </div>
            <div class="col col-12 col-sm-9">
                <?= StringUtils::format('int' ,$pokladniKnihaZaznam->i1) ?>
            </div>
        </div>
        <?php } ?>
        <?php if ($typPolozky->i2Popis) { ?>
        <div class="row" id="hlavickapoklk_i2">
            <div class="col col-12 col-sm-3 caption">
                <?= ronText(StringUtils::htmlTextConvert($typPolozky->i2Popis)) ?>
            </div>
            <div class="col col-12 col-sm-9">
                <?= StringUtils::format('int' ,$pokladniKnihaZaznam->i2) ?>
            </div>
        </div>
        <?php } ?>
        <?php if ($typPolozky->i3Popis) { ?>
        <div class="row" id="hlavickapoklk_i3">
            <div class="col col-12 col-sm-3 caption">
                <?= ronText(StringUtils::htmlTextConvert($typPolozky->i3Popis)) ?>
            </div>
            <div class="col col-12 col-sm-9">
                <?= StringUtils::format('int' ,$pokladniKnihaZaznam->i3) ?>
            </div>
        </div>
        <?php } ?>
        <?php if ($typPolozky->f1Popis) { ?>
        <div class="row" id="hlavickapoklk_f1">
            <div class="col col-12 col-sm-3 caption">
                <?= ronText(StringUtils::htmlTextConvert($typPolozky->f1Popis)) ?>
            </div>
            <div class="col col-12 col-sm-9">
                <?= StringUtils::format('float' ,$pokladniKnihaZaznam->f1) ?>
            </div>
        </div>
        <?php } ?>
        <?php if ($typPolozky->f2Popis) { ?>
        <div class="row" id="hlavickapoklk_f2">
            <div class="col col-12 col-sm-3 caption">
                <?= ronText(StringUtils::htmlTextConvert($typPolozky->f2Popis)) ?>
            </div>
            <div class="col col-12 col-sm-9">
                <?= StringUtils::format('float' ,$pokladniKnihaZaznam->f2) ?>
            </div>
        </div>
        <?php } ?>
        <?php if ($typPolozky->f3Popis) { ?>
        <div class="row" id="hlavickapoklk_f3">
            <div class="col col-12 col-sm-3 caption">
                <?= ronText(StringUtils::htmlTextConvert($typPolozky->f3Popis)) ?>
            </div>
            <div class="col col-12 col-sm-9">
                <?= StringUtils::format('float' ,$pokladniKnihaZaznam->f3) ?>
            </div>
        </div>
        <?php } ?>

        <div class="row" id="hlavickapoklk_poznamka">
            <div class="col col-12 col-sm-3 caption">
                <?= ronText('poznamka' . ($seznamPolozekPoklK->cislo != 1 ? "_$seznamPolozekPoklK->cislo" : '')) ?>
            </div>
            <div class="col col-12 col-sm-9">
                <?= StringUtils::htmlTextConvert($pokladniKnihaZaznam->poznamka) ?>
            </div>
        </div>
        <div class="row form-section" id="hlavickapoklk_schvaleni">
            <div class="col col-12">
                <?= ronText('PoklK_schvaleni') ?>
            </div>
        </div>

        <?php

        if (!$pokladniKnihaZaznam ->jeZaznamSchvalen(2) && $pokladniKnihaZaznam ->schvaleni[1]) $urovenvraceni = 1; // 1. je schvalena, dalsi ne => uzivatel na urovni 2 muze vratit
        else if (!$pokladniKnihaZaznam ->jeZaznamSchvalen(3) && $pokladniKnihaZaznam ->schvaleni[2]) $urovenvraceni = 2; // 2. je schvalena, dalsi ne => uzivatel na urovni 3 muze vratit
        else if (!$pokladniKnihaZaznam ->jeZaznamSchvalen(4) && $pokladniKnihaZaznam ->schvaleni[3]) $urovenvraceni = 3; // 3. je schvalena, dalsi ne => uzivatel na urovni 4 muze vratit
        else $urovenvraceni = 0;

        $posloupnostZapnuta = RonPortalSettings::getIntValue('poklk_posloupnost_schvalovani');

        for ($uroven = 1; $uroven <= 4; $uroven++) { ?>
            <div class="row schvaleni_poklk_<?= $uroven ?>">
                <div class='col col-12 col-sm-3 caption'><span class='textschvaleni<?= $uroven ?>'><?= ronText('PoklK_schvaleni_uroven'.$uroven . ($seznamPolozekPoklK->cislo != 1 ? "_$seznamPolozekPoklK->cislo" : '')) ?></span></div>
                <div class="col col-12 col-sm-9">

                    <?php

                    $datumVraceni = isset($pokladniKnihaZaznam->datumVraceni[$uroven]) ? $pokladniKnihaZaznam->datumVraceni[$uroven] : null;
                    $lzeVratit = false;

                    if ($uroven > 1) {
                        switch ($uroven) {
                            case 2:
                                $lzeVratit = $urovenvraceni == 1;
                                break;
                            case 3:
                                $lzeVratit = $urovenvraceni == 2;
                                break;
                            case 4:
                                $lzeVratit = $urovenvraceni == 3;
                                break;
                        }
                    }

                    /** @var PravaNaOsoby $pravaSchvalit */
                    $pravaSchvalit = $model->getData('pravaSchvalit'.$uroven);

                    if ($pokladniKnihaZaznam->schvaleni[$uroven]) { ?>
                        <span class="textschvaleni<?= $uroven ?>"><?= StringUtils::format('date',$pokladniKnihaZaznam->schvaleni[$uroven]) . ' ' .
                            StringUtils::htmlTextConvert($pokladniKnihaZaznam->schvalil[$uroven])  ?>
                        </span>

                        <?php if (!$pravaSchvalit ->priznak) {
                            // nelze zrusit datum schvaleni pokud je jiz obdobi (podle datumPohybu) uzavreno

                            if (($uroven == 4 || !$pokladniKnihaZaznam->jeZaznamSchvalen($uroven + 1)) && // pokud je vyssi uroven schvaleni, tak nesmi zrusit tuto
                                $pravaSchvalit->lzeZobrazitPP($pokladniKnihaZaznam->idPP, $pokladniKnihaZaznam->datumPohybu, $pokladniKnihaZaznam->datumPohybu)
                            ) {
                                ?>
                                &nbsp;&nbsp;&nbsp;<A href='?menuid=pokladnikniha&action=zrusschvaleni<?= $uroven?>&record=<?= $pokladniKnihaZaznam->vratID() . Csrf::csrfUrlParameter() ?>'>
                                    <?= ronText('PoklK_zrusschvaleni_uroven'.$uroven) ?></A>
                            <?php }
                        }
                    } else {
                        if ( (!$posloupnostZapnuta || $lzeVratit  ||  $uroven == 1)  && $pravaSchvalit->lzeZobrazitPP($pokladniKnihaZaznam->idPP, $pokladniKnihaZaznam->datumPohybu, $pokladniKnihaZaznam->datumPohybu)) {

                            ?>

                            <A href='?menuid=pokladnikniha&action=schval<?= $uroven ?>&record=<?= $pokladniKnihaZaznam->vratID() . Csrf::csrfUrlParameter() ?>'><?= ronText('PoklK_provedschvaleni_uroven'.$uroven) ?></A>

                            <?php
                            if (RonPortalSettings::getIntValue('poklk_pouzivat_vraceni') && $lzeVratit) {
                                // mezera
                                ?>
                                <span style="display:inline-block; width:50px;"></span>

                                <A href='?menuid=pokladnikniha&action=vrat&record=<?= $pokladniKnihaZaznam->vratID() . Csrf::csrfUrlParameter() ?>' class="vraceni_pokladni_knihy_link">
                                    <?= ronText('PoklK_vratschvaleni_uroven'.$uroven) ?>
                                </A>
                                <?php
                            }
                        }

                        if ($datumVraceni  &&  ($uroven == 1  || $pokladniKnihaZaznam->jeZaznamSchvalen($uroven - 1))) {
                            if ($pokladniKnihaZaznam->poznamkaKVraceni) {
                                echo '<div class="poznamkaKVraceni">' . StringUtils::htmlTextConvert($pokladniKnihaZaznam->poznamkaKVraceni) . ' (' . StringUtils::format('datetime', $datumVraceni) . ')</div>';
                            }
                        }
                    }
                    ?>

                </div>
            </div>
        <?php } ?>

        <?php if ($pokladniKnihaZaznam->lzeEditovat(false)) { ?>
            <div class="row" id="hlavickapoklk_editace">
                <div class="col col-3 d-xs-none"></div>
                <div class="col col-12 col-sm-9">
                    <a href="?menuid=pokladnikniha&formaction=edit&record=<?= $pokladniKnihaZaznam->vratID() ?>"><?= ronText('Edit') ?></a>
                </div>
            </div>
        <?php } ?>

        <?php if (RonPortalSettings::getIntValue('poklk_pouzivat_vraceni') && $urovenvraceni) { // pouziva se vraceni - div pro zapsani poznamky k vraceni
            $value = '';
            if (isset($_POST['poznamkakvraceni'])) $value = $_POST['poznamkakvraceni'];
            ?>
            <div class="row">
                <div class="col col-12">
                    <div id="vracenipokladniknihy" <?php if (!$vraceni) echo 'style="display:none"'; /* zobrazi se az po kliknuti na "vratit" */ ?> >
                        <form method="post" name="vracenipoklkform" action="?menuid=pokladnikniha&action=vrat&record=<?= $pokladniKnihaZaznam ->vratID() ?>">
                            <input type="hidden" name="urovenvraceni" value="<?= $urovenvraceni ?>" />
                            <?= Csrf::csrfHiddenInput() ?>

                            <label>
                                <strong><?= ronText('PoklK_poznamka_k_vraceni') ?></strong><br/>
                                <textarea name="poznamkakvraceni" rows="8" style="width:100%"><?= StringUtils::htmlTextConvert($value) ?></textarea><br/>
                            </label>
                            <input type="submit" class="submitbutton" value="OK">

                        </form>
                    </div>
                </div>
            </div>
        <?php } ?>

        <!-- zauctovani -->
        <?php if ($pokladniKnihaZaznam ->zauctovanoStr || $lzezauctovat) { ?>
            <div class="row" id="hlavickapoklk_zauctovani">
                <div class="col col-sm-3 dis-xs d-xs-none"></div>
                <div class="col col-12 col-sm-9"><?php

                    if ($pokladniKnihaZaznam->zauctovanoStr) echo StringUtils::htmlTextConvert($pokladniKnihaZaznam->zauctovanoStr);

                    // zrusit zauctovani // zauctovat
                    if ($lzezauctovat) {
                        if ($pokladniKnihaZaznam->zauctovano) echo " - <A href='?menuid=pokladnikniha&action=zrusitzauctovani&record={$pokladniKnihaZaznam->vratID()}" . Csrf::csrfUrlParameter() . "'>" . TextManager::_('Zruzit_zauctovani_poklK') . '</A>';
                        else echo "<A href='?menuid=pokladnikniha&action=zauctovat&record={$pokladniKnihaZaznam->vratID()}" . Csrf::csrfUrlParameter() . "'>". TextManager::_('Zauctovat_poklK') .'</A>';
                    }
                    ?>

                </div>
            </div>
        <?php } ?>

        <div class="row" id="hlavickapoklk_historie">
            <div class="col col-3 d-xs-none"></div>
            <div class="col col-12 col-sm-9">
                <div id="historie_poklk" class="autoExpand xhistorie_poklk_1">

                    <?= StringUtils::longTextToHtml(trim($pokladniKnihaZaznam ->historieSchvalovani ?? '')) ?>
                </div>
            </div>
        </div>
    </div>
</div>

<?php
    FormReportsListView::renderReportList($reports, '?menuid=pokladnikniha&action=report&record=' . $pokladniKnihaZaznam->vratID());
?>

<br />

<?php
    if ($typPolozky->editovatRadky) {
        $radkyPokladniKnihyBrowser->render();

        $dialogRadku->render();
    }
?>

<br />

<?php
    $dokumentyBrowser->render();
?>

<br />

<?php if ($pokladniKnihaZaznam->lzeEditovat(false)) { ?>
    <div>
        <a href='#' class="show-dokument-dialog"><?= ronText('PoklK_novy_dokument') ?></a>
        <?php
        $form = $model->getData('dokumentForm');
        $form ->render();
        ?>
    </div>
<?php } ?>

<br />

<a href="?menuid=pokladnikniha&browser=<?= $seznamPolozekPoklK->cislo ?>"><?= ronText('Zpet_na_seznam') ?></a>

