<?php
/**
 * stanislav.elbl, 21.02.2021
 */

namespace RonPortal;

use Ron\DB\Database;
use Ron\DB\DBException;
use Ron\DB\DBUtils;
use Ron\MessageManager;
use Ron\TextManager;

class RonPortalSettings
{
    const ZOBRAZIT_VYBER_APLIKACE = 'zobrazitvyberaplikace';
    const NACIST_XML_DO_MENU = 'nacistxmldomenu';

    // obecne
    const VYCHOZI_OBRAZOVKA = 'vychoziobrazovka';
    const VYCHOZI_MENA = 'vychozimena';
    const ZOBRAZIT_OSOBNI = 'zobrazitosobni';
    const UZIVATELSKE_STRANKY = 'uzivatelske';
    const ZOBRAZIT_VZKAZY = 'zobrazitvzkazy';

    const ROZDELENI_TYP = 'typrozdeleni';   // vyber ve filtrech
    const ROZDELENI_JEN_VLASTNI = 'jenvlastnirozdeleni';
    const ROZDELENI_NADPIS = 'nadpisrozdeleni';
    const ROZDELENI2_TYP = 'typrozdeleni2';
    const ROZDELENI2_JEN_VLASTNI = 'jenvlastnirozdeleni2';
    const ROZDELENI2_NADPIS = 'nadpisrozdeleni2';

    const ROZDELENI_ZOBRAZENI_TYP = 'typrozdelenizobrazeni';  // zobrazi se v seznamech
    const ROZDELENI_ZOBRAZENI_NADPIS = 'nadpisrozdelenizobrazeni';
    const ROZDELENI_ZOBRAZENI_CO_ZOBRAZIT = 'cozobrazitrozdeleni';

    const VYBER_OSOB_POLE1 = 'vyberosob_dalsipole1';
    const VYBER_OSOB_POLE2 = 'vyberosob_dalsipole2';

    const ADS_AGENT_HOST = 'ads_agenthost';
    const ADS_AGENT_PORT = 'ads_agentport';
    const ADS_AGENT_CESTA = 'cestakdochazce';

    const POVOLIT_ICAL = 'povolit_ical';

    // dochazka
    const POVOLIT_DOCHAZKU = 'povolitdochazku';
    const POVOLIT_PUVODNI = 'povolitpuvodnidochazku';
    const POVOLIT_HISTORII_PRUCHODU = 'povolithistoriipruchodu';
    const POVOLIT_ZPRACOVANOU = 'povolitzpracovanoudochazku';
    const POVOLIT_DENNI_VYSLEDKY = 'povolitvysledky';
    const POVOLIT_MESICNI_VYSLEKDY = 'povolitmesicnivysledky';
    const POVOLIT_MESICNI_R = 'povolitmesicnir';
    const POVOLIT_VARIABILNI = 'povolitvariabilni';
    const POVOLIT_VARIABILNI_DENNI = 'povolitvariabilnidenni';
    const POVOLIT_MZDOVE_POLOZKY = 'ads_mzdovepolozky';

    const ZOBRAZIT_KALENDAR_SMEN = 'zobrazitkalendar';

    const HISTORIE_NADPIS = 'historiepruchodunadpis';
    const HISTORIE_TERMINAL = 'historiepruchoduterminal';
    const HISTORIE_POCET_HODIN = 'historiepruchoduhodin';
    const HISTORIE_MENU = 'historiepruchodumenu';

    const MESICNI_VYSLEDKY_ZOBRAZIT = 'zobrazovatnastavenemv'; // 0=vse, 1=jen vybrane, 2=jen vybrane, povolit vzorce
    const MESICNI_VYSLEDKY_RADKY = 'radkymesicnichvysledku';

    const OMEZENI_DOCHAZKY =  'omezenidochazky';

    const MODUL_PLUS = 'module_plus';

    const EDITACE_POVOLENA = 'povoliteditacidochazky';
    const EDITACE_TYP_ROZDELENI = 'typrozdelenieditace';
    const EDITACE_NADPIS_ROZDELENI = 'nadpisrozdelenieditace';
    const EDITACE_VKLADAT_PRESTAVKY = 'editacevkladatprestavky';
    const EDITACE_VKLADANI_DNU = 'vkladanizpracovane_dnu';
    // pocet dnu od aktualniho data, na ktere lze jeste vkladat zaznamy zpracovane dochazky
    // napr: 0 - je mozne vkladat maximalne na aktualni den (vychozi hodnota)
    //       5 - je mozne vkladat maximalne na 5 dnu dopredu
    //      -1 - je mozne vkladat maximalne na "vcerejsek"
    const DV_TYP_ROZDELENI = 'dv_typrozdeleni';
    const DV_CASOVE_SLOZKY = 'dv_casoveslozky';
    const DV_POVOLIT_PRIRAZENI_ROZDELENI = 'dv_povolitprirazenir';
    const DV_CASOVA_SLOZKA_SOUCET = 'dv_casovaslozkasoucet';
    const DV_MINIMALNI_CAS = 'dv_minimalnicas';

    // absence
    const ABSENCE_SCHVALOVANI = 'schvalovaniabsence';

    const POVOLIT_KAPACITY = 'planovanikapacit';
    //const KAPACITY_TYP_ROZDELENI = 'kapacity_typrozdeleni';
    //const KAPACITY_PREPOCET = 'kapacity_provadetprepocet'; // jestli se ma provadet prepocet zpracovanych dnu (0=ne, 1=ano, 2=podle puvodni) - nepouziva se?

    // predavaci procesy, hodnoceni, xml
    const MAPOVANI_XML = 'mapovanixml';  // mozna se pouziva v hodnoceni!
    const PREDAVANI_TYP_ROZDELENI = 'typrozdeleniprohodnoceni';
    const PREDAVANI_JEN_VLASTNI_ROZDELENI = 'jenvlastnirozdelenihodnoceni'; // 0=vse, 1=vlastni a podrizena, 2=podrizena
    const ZOBRAZIT_VYSLEDKY_HODNOCENI = 'zobrazitvysledkyhodnoceni'; // 0=nic, 1=znamka, 2=koeficient, 3=oboji
    const AGENT_HODNOCENI = 'agenthodnoceni';

    // personalistika
    const POVOLIT_PERSONALISTIKU = 'povolitpersonalistiku';
    const POVOLIT_HODNOCENI = 'povolithodnoceni';
    const POVOLIT_UCHAZECE = 'povolituchazece';
    const ZOBRAZIT_SKOLENI = 'zobrazitskoleni';
    const POVOLIT_POMUCKY = 'povolitpomucky';
    const ZOBRAZIT_DOVEDNOSTI = 'zobrazitdovednosti';
    const ZAKAZAT_PREVZIT_HODNOCENI = 'zakazatprevzithodnoceni';
    const HODNOCENI_UKOLU = 'hodnoceniukolu';
    const ZOBRAZIT_DOKUMENTY = 'zobrazitdokumenty';

    // jidelna
    const POVOLIT_JIDELNU = 'povolitjidelnu';
    const BURZA_POVOLENA = 'povolitburzu';
    const ZOBRAZIT_STRAVENKY = 'zobrazitstravenky';
    const ZOBRAZIT_JIDELNICEK = 'zobrazitjidelnicek';

    // elearning
    const ELEARNING_POVOLEN = 'povolitelearning';

    /** @var mixed[]  Asociativni pole s daty */
    var $data;

    /** @var RonPortalSettings   Globalni instance nastaveni */
    private static $nastaveni = null;


    private function __construct()
    {
        global $zakazatprevzithodnoceni;

        $this ->data = [
            //self::ELEARNING_POVOLEN => $_povolit_e_learning,
            self::POVOLIT_UCHAZECE => 1,

            self::ZOBRAZIT_VYBER_APLIKACE => 1,
            self::ROZDELENI_NADPIS => TextManager::_('Rozdeleni'),  // nastavit natvrdo? Stejne je to nastaveno uzivatelem!
            self::ZOBRAZIT_VYSLEDKY_HODNOCENI => 1,   // znamka
            self::ZAKAZAT_PREVZIT_HODNOCENI => $zakazatprevzithodnoceni,
            self::POVOLIT_PUVODNI => 1,
            self::POVOLIT_HISTORII_PRUCHODU => 1,
            self::POVOLIT_ZPRACOVANOU => 1,
            self::POVOLIT_DENNI_VYSLEDKY => 1,
            self::POVOLIT_MESICNI_VYSLEKDY => 1,
            self::ZOBRAZIT_KALENDAR_SMEN => 1,

            self::MAPOVANI_XML => []        // mapovani standardnich funkci na XML formulare
        ];
    }

    public function setItemValue($itemName, $value)
    {
        if ($itemName == self::MAPOVANI_XML) {
            $this ->nastavMapovaniXML($value);
        } else {
            $this ->data[$itemName] = $value;
        }
    }


    private function loadData($settingsStr)
    {
        $str_settings = explode("\n", $settingsStr ?? '');

        foreach ($str_settings as $setStr) {
            $pom = sscanf($setStr, '%[^=]=%[^$]'); // , &$key, &$value
            $key = isset($pom[0]) ? strtolower(trim($pom[0])) : '';
            $value = isset($pom[1]) ? trim($pom[1]) : null;
            if ($key != '') {
                $this ->setItemValue($key, $value);
            }
        }
    }


    /**
     * Nacte nastaveni z DB
     * @param Database $database
     * @throws DBException
     */
    public function loadFromDB($database)
    {
//        $sql = 'SELECT ' .
//            $database ->castWideMemo('nastaveni') . ', ' .
//            $database ->castWideMemo('nastaveniJidelny') . ', ' .
//            $database ->castWideMemo('nastaveniPersonalistiky') . ', ' .
//            $database ->castWideMemo('nastaveniSpolecne') .
//            ' FROM NastaveniProIntraweb';

        $sql =
            'SELECT {fn_CASTWIDEMEMO(nastaveni)}, {fn_CASTWIDEMEMO(nastaveniJidelny)}, ' .
            '{fn_CASTWIDEMEMO(nastaveniPersonalistiky)}, {fn_CASTWIDEMEMO(nastaveniSpolecne)} ' .
            ' FROM NastaveniProIntraweb';

        $cursor = $database ->getSqlResult($sql, null, TextManager::_('Nelze_nacist_nastaveni'));

        $row = $cursor ->fetch();
        $cursor ->close();

        if ($row) {
            $this ->loadData($row[0]); // dochazka
            $this ->loadData($row[1]); // jidelna
            $this ->loadData($row[2]); // personalistika
            $this ->loadData($row[3]); // spolecne

//            MessageManager::addDebugLog($row[0]);
//            MessageManager::addDebugLog($row[1]);
//            MessageManager::addDebugLog($row[2]);
//            MessageManager::addDebugLog($row[3]);
        } else {
            MessageManager::addDebugLog('Nepovedlo se nacist nastaveni z DB (zaznam neexistuje)');
        }

        $_SESSION['ronportalsettings_timestamp'] = time();
        $_SESSION['ronportalsettings'] = $this ->data;
    }


    /**
     * Nacte nastaveni z session. Vraci true, pokud nastaveni v session bylo ulozeno
     * @return bool
     */
    function loadFromSession()
    {
        if (isset($_SESSION['ronportalsettings'])) {
            $this ->data = $_SESSION['ronportalsettings'];
            return true;
        }

        return false;
    }


    /**
     * Nacte nastaveni z session nebo databaze
     * @param \Ron\DB\Database $database
     */
    function load($database)
    {
        global $_allwaysloadsettings;

        if (isset($_allwaysloadsettings) && $_allwaysloadsettings) {
            $this ->loadFromDB($database);
            return;
        }

        if (isset($_SESSION['ronportalsettings'])) {
            if ($_SESSION['ronportalsettings_timestamp'] > time() - 900) {
                if ($this ->loadFromSession()) {
                    return;
                }
            }
        }

        $this ->loadFromDB($database);
    }


    public static function getInstance()
    {
        if (!self::$nastaveni) {
            self::$nastaveni = new RonPortalSettings();
        }

        return self::$nastaveni;
    }


    public static function getValue($itemName, $defaultValue = null)
    {
        $data = self::getInstance() ->data;
        $itemName = strtolower($itemName);

        return $data[$itemName] ?? $defaultValue;
    }


    public static function getIntValue($itemName, $defaultValue = 0)
    {
        $data = self::getInstance() ->data;
        $itemName = strtolower($itemName);

        return (int)($data[$itemName] ?? $defaultValue);
    }



    public static function getFloatValue($itemName, $defaultValue = 0)
    {
        $data = self::getInstance() ->data;
        $itemName = strtolower($itemName);

        return (float)($data[$itemName] ?? $defaultValue);
    }



    function nastavMapovaniXML($mapovaniStr)
    {
        $this ->data[self::MAPOVANI_XML] = [];

        $poma = explode('\n', $mapovaniStr); // v textu je primo '\n'  ne  "\n" !!!
        foreach ($poma as $row) {
            $data = explode('=', $row);
            if ($data && $data[0] && $data[1]) $this ->data[self::MAPOVANI_XML][$data[0]] = $data[1];
        }
    }


    public static function setValue($itemName, $value)
    {
        self::getInstance() ->setItemValue($itemName, $value);
    }


    public static function getMultilineValue($itemName)
    {
        $result = isset(self::getInstance() ->data[$itemName]) ? self::getInstance() ->data[$itemName] : '';
        return str_replace('\n', "\n", $result);
    }

    public static function setMultilineValue($itemName, $value)
    {
        $value = str_replace("\n", '\n', $value);
        self::getInstance() ->data[$itemName] = $value;
    }


    /**
     * Vraci ID XML formulare, ktery se ma zobrazit pro zadane menuId
     * @param string $menuId
     * @return int|null
     */
    public static function getMapovaniXML($menuId)
    {
        if (!$menuId) return null;

        $mapovani = self::getValue(self::MAPOVANI_XML);
        return ($mapovani  &&  isset($mapovani[$menuId])) ? $mapovani[$menuId] : null;
    }


    /**
     * Vraci true, pokud je nejakym zpusobem povoleno spousteni agentu
     * @return bool
     */
    public static function getSpousteniADS()
    {
        $settings = self::getInstance();
        return $settings ->getValue(self::ADS_AGENT_HOST)  ||  $settings ->getValue(self::ADS_AGENT_CESTA);
    }


    public static function getPouzivatRozdeleniDV()
    {
        $settings = self::getInstance();
        return $settings ->getIntValue(self::DV_TYP_ROZDELENI)  &&  $settings ->getValue(self::DV_CASOVE_SLOZKY);
    }


    /**
     * @param Database $database
     * @param string $name
     * @param string $defaultValue
     * @return string
     * @throws DBException
     */
    public static function getBvarSettings($database, $name, $defaultValue = '')
    {
        $params = $database ->createParameters();
        $value = DBUtils::getSqlValue($database,
            'SELECT Val FROM SYS_BVAR_GLOBAL WHERE Name = ' . $params ->addParameter($name),
            //'SELECT CAST(Val AS VARCHAR(MAX)) FROM SYS_BVAR_GLOBAL WHERE Name = ' . $params ->addParameter($name), - toto by se dalo pouzit pro automatickou konverzi znakove sady
            $params);

        if (!$value) {
            return $defaultValue;
        }

        // v pripade potreby provede konverzi znakove sady, protoze u blob pole neprobiha automaticky
        global $db_target_charset;
        if ($db_target_charset) {
            $charset = TextManager::getInstance() ->getCharSet();
            if ($db_target_charset != $charset) {
                $value = iconv($db_target_charset, $charset, $value);
            }
        }
        return $value;
    }


    /**
     * Vraci nastaveni logout timeru v sekundach
     * @return int
     */
    public static function getLogoutTimer()
    {
        global $logoutTimer;
        if (isset($logoutTimer)  &&  $logoutTimer) {
            return $logoutTimer;
        }

        return self::getIntValue('logouttimer') * 60;
    }
}
