<?php
/**
 * pavel.rudol, 11.04.2020
 */
namespace RonPortal\Sklad;

use Ron\MessageManager;
use Ron\MVC\Model;
use RonPortal\RonPortalSettings;
use RonPortal\TypRozdeleni;
use Ron\StringUtils;
use function Ron\ronText;

/** @var Firma $firma */
$firma = Model::getInstance() ->getData('firma');
$database = Model::getInstance() ->getData('database');
?>
<h1><?= ronText('Firma') ?></h1>

<?php MessageManager::getInstance() ->showMessages(); ?>

<div class="form small-form" id="detail_firmy">
    <div class="form-content">
        <div class="row">
            <div class="col col-5 caption"><strong><?= ronText('Nazev1') ?></strong></div>
            <div class="col col-7"><?= StringUtils::htmlTextConvert($firma->nazev1) ?></div>
        </div>

        <div class="row">
            <div class="col col-5 caption"><strong><?= ronText('Nazev2') ?></strong></div>
            <div class="col col-7"><?= StringUtils::htmlTextConvert($firma->nazev2) ?></div>
        </div>

        <div class="row">
            <div class="col col-5 caption"><strong><?= ronText('ICO') ?></strong></div>
            <div class="col col-7"><?= StringUtils::htmlTextConvert($firma->ico) ?></div>
        </div>

        <div class="row">
            <div class="col col-5 caption"><strong><?= ronText('DIC') ?></strong></div>
            <div class="col col-7"><?= StringUtils::htmlTextConvert($firma->dic) ?></div>
        </div>

        <div class="row">
            <div class="col col-5 caption"><strong><?= ronText('Mesto') ?></strong></div>
            <div class="col col-7"><?= StringUtils::htmlTextConvert($firma->mesto) ?></div>
        </div>

        <div class="row">
            <div class="col col-5 caption"><strong><?= ronText('Ulice') ?></strong></div>
            <div class="col col-7"><?= StringUtils::htmlTextConvert($firma->ulice) ?></div>
        </div>

        <div class="row">
            <div class="col col-5 caption"><strong><?= ronText('Stat') ?></strong></div>
            <div class="col col-7"><?= StringUtils::htmlTextConvert($firma->statPopis) ?></div>
        </div>

        <div class="row">
            <div class="col col-5 caption"><strong><?= ronText('Firma_ucet') ?></strong></div>
            <div class="col col-7"><?= $firma->ucet ? StringUtils::htmlTextConvert($firma->ucet) . '/' . StringUtils::htmlTextConvert($firma->kodBanky) . ' (' . StringUtils::htmlTextConvert($firma->popisBanky) . ')' : '' ?></div>
        </div>

        <div class="row">
            <div class="col col-5 caption"><strong><?= ronText('Web') ?></strong></div>
            <div class="col col-7"><a href="<?= StringUtils::htmlTextConvert($firma->web) ?>" target="_blank"><?= StringUtils::htmlTextConvert($firma->web) ?></a></div>
        </div>

        <div class="row">
            <div class="col col-5 caption"><strong><?= ronText('Poznamka') ?></strong></div>
            <div class="col col-7"><?= StringUtils::htmlTextConvert($firma->poznamka) ?></div>
        </div>

        <div class="row">
            <div class="col col-5 caption"><strong><?= ronText('Klicova_slova') ?></strong></div>
            <div class="col col-7"><?= StringUtils::htmlTextConvert($firma->klicovaSlova) ?></div>
        </div>

        <?php for ($i = 1; $i <= 9; $i++) {
            if (RonPortalSettings::getValue("firma_uzivatelska$i") != '') {
                ?>
                <div class="row">
                    <div class="col col-5 caption"><strong><?= RonPortalSettings::getValue("firma_uzivatelska$i") ?></strong></div>
                    <div class="col col-7"><?= StringUtils::htmlTextConvert($firma->uzivatelskaData[$i]) ?></div>
                </div>
            <?php }
        } ?>

        <?php for ($i = 1; $i <= 4; $i++) { ?>
            <div class="row form-section">
                <div class="col col-12">
                    <?= ronText('Kontakni_osoba' . $i) ?>
                </div>
            </div>
            <div class="row">
                <div class="col col-5 caption"><strong><?= ronText('Jmeno_a_prijmeni') ?></strong></div>
                <div class="col col-7"><?= StringUtils::htmlTextConvert($firma->kontaktniOsoba[$i]) ?></div>
            </div>
            <div class="row">
                <div class="col col-5 caption"><strong><?= ronText('Kontakt_telefon') ?></strong></div>
                <div class="col col-7"><?= StringUtils::htmlTextConvert($firma->telefon[$i]) ?></div>
            </div>
            <div class="row">
                <div class="col col-5 caption"><strong><?= ronText('Kontakt_email') ?></strong></div>
                <div class="col col-7"><?= StringUtils::htmlTextConvert($firma->e_mail[$i]) ?></div>
            </div>
        <?php }

        if (!empty($firma->rozdeleni)) {
            $typRozdeleniPom = null;

            foreach ($firma->rozdeleni as $rozdeleni) {
                /** @var TypRozdeleni $typRozdeleni */
                $typRozdeleni = $rozdeleni->typ;

                if ($typRozdeleniPom != $typRozdeleni->kod) { ?>
                    <div class="row form-section">
                        <div class="col col-12">
                            <?= StringUtils::htmlTextConvert($typRozdeleni->popis) ?>
                        </div>
                    </div>
                    <?php
                }
                ?>
                <div class="row">
                    <div class="col col-5 caption"><strong><?= ronText('Kod') ?></strong></div>
                    <div class="col col-7"><?= StringUtils::htmlTextConvert($rozdeleni->kod) ?></div>
                </div>
                <div class="row">
                    <div class="col col-5 caption"><strong><?= ronText('Popis') ?></strong></div>
                    <div class="col col-7"><?= StringUtils::htmlTextConvert($rozdeleni->popis) ?></div>
                </div>
                <?php

                $typRozdeleniPom = $typRozdeleni->kod;
            }
        }

        ?>
        <div class="row form-section">
            <div class="col col-12">
                <?= ronText('Dokumenty') ?>
            </div>
        </div>
        <?php DokumentyFirmyBrowser::zobrazDokumenty($database, $firma->kodFirmy); ?>
    </div>

</div>
