<?php
/** pavel.rudol 9.4.2020 */

namespace RonPortal\Sklad;


use Exception;
use Ron\DateUtils;
use Ron\DB\Database;
use Ron\DB\DBException;
use Ron\DB\SQLUtils;
use Ron\MessageManager;
use RonPortal\PracovniPomer;
use RonPortal\Prava;
use RonPortal\PravaNaOsoby;
use RonPortal\RonPortalDBRecord;
use RonPortal\RonPortalSettings;
use RonPortal\RonPortalXMLEvents;
use RonPortal\Rozdeleni;
use RonPortal\User;
use Ron\StringUtils;
use function Ron\ronText;

class VydanaObjednavka
{
    const SETTINGS_UZIVATELSKA1 = 'vydanaobjednavka_uzivatelska1';
    const SETTINGS_UZIVATELSKA2 = 'vydanaobjednavka_uzivatelska2';
    const SETTINGS_UZIVATELSKA3 = 'vydanaobjednavka_uzivatelska3';
    const SETTINGS_UZIVATELSKA4 = 'vydanaobjednavka_uzivatelska4';
    const SETTINGS_UZIVATELSKA5 = 'vydanaobjednavka_uzivatelska5';

    public $cisloObjednavky;
    public $stredisko;
    public $strediskoPopis;
    public $datumVystaveni;
    public $terminDodani;
    public $popis;
    public $dodavatel;
    public $dodavatelPopis;
    public $dodavatelUzivatelskeData;
    public $vystavil;
    public $vystavilJmenoPrijmeni;
    public $odeslano;
    public $datumCasOdeslani;
    public $vyrizeno;
    public $odeslatMail;
    public $vyzadovatSchvaleni;
    public $schvaleno;
    public $poznamka = '';
    public $cenaCelkem;
    public $cenaCelkem_DM;
    public $cenaCelkem_DM_mena;
    public $schvaleni1Jmeno;
    public $schvaleni1Datum;
    public $schvaleni1RC;
    public $schvaleni1NastavSchvalovatele;
    public $nastavenySchvalovatel1;
    public $schvaleni1Stav;
    public $schvaleni2Jmeno;
    public $schvaleni2Datum;
    public $schvaleni2RC;
    public $schvaleni2NastavSchvalovatele;
    public $nastavenySchvalovatel2;
    public $schvaleni2Stav;
    public $schvaleni3Jmeno;
    public $schvaleni3Datum;
    public $schvaleni3RC;
    public $schvaleni3NastavSchvalovatele;
    public $nastavenySchvalovatel3;
    public $schvaleni3Stav;
    public $predpokladanaCena;
    public $soucetCen;
    public $uzivatelska1;
    public $uzivatelska2;
    public $uzivatelska3;
    public $uzivatelska4;
    public $uzivatelska5;
    public $mena;

    public $poznamkaKeSchvaleni;
    public $historieSchvalovani;

    /** @var RadekVydaneObjednavky[] */
    public $radky;

    public $pocetNovychRadku = 0;

    public $povolitZmenuDodavatele = true;
    public $readOnly = false;
    public $poleProEditaci = null;

    public $prekrocenaCenaFaktury = false;
    public $nesouhlasiPocetKusu = false;

    public $jeSablona = false;

    /** @var FakturaPrijata[] */
    public $faktury;

    /** @var Rozdeleni */
    public $rozdeleni1;
    /** @var Rozdeleni */
    public $rozdeleni2;
    /** @var Rozdeleni */
    public $rozdeleni3;
    /** @var Rozdeleni */
    public $rozdeleni4;
    /** @var Rozdeleni */
    public $rozdeleni5;

    /**
     * @param Database $database
     * @param $row
     */
    protected function nactiRadek($database, $row)
    {
        $this->cisloObjednavky = $row[0];
        $this->stredisko = $row[1];
        $this->strediskoPopis = $row[29];
        $this->datumVystaveni = $database->stringToTimestamp($row[2]);
        $this->terminDodani = $database->stringToTimestamp($row[5]);
        $this->popis = $row[6];
        $this->dodavatel = $row[7];
        $this->dodavatelPopis = $row[30];
        if (ObjednavkyController::$indexUzivatelskehoFiltruDodavatele)
            $this->dodavatelUzivatelskeData = $row[38];
        $this->vystavil = $row[8];
        $this->vystavilJmenoPrijmeni = $row[57] . ' ' . $row[58];
        $this->odeslano = (bool)$row[9];
        $this->datumCasOdeslani = $database->stringToTimestamp($row[20]);
        $this->vyrizeno = (bool)$row[10];
        $this->schvaleno = (bool)$row[44];
        $this->odeslatMail = (bool)$row[46];
        $this->vyzadovatSchvaleni = (bool)$row[56];
        $this->poznamka = $row[12];
        $this->cenaCelkem = $row[13];
        $this->schvaleni1Jmeno = $row[14];
        $this->schvaleni1Datum = $database->stringToTimestamp($row[15]);
        $this->schvaleni1Stav = $row[39];
        $this->schvaleni1RC = $row[26];
        $this->nastavenySchvalovatel1 = $row[32] . ' ' . $row[31];
        $this->schvaleni2Jmeno = $row[16];
        $this->schvaleni2Datum = $database->stringToTimestamp($row[17]);
        $this->schvaleni2Stav = $row[40];
        $this->schvaleni2RC = $row[27];
        $this->nastavenySchvalovatel2 = $row[34] . ' ' . $row[33];
        $this->schvaleni3Jmeno = $row[18];
        $this->schvaleni3Datum = $database->stringToTimestamp($row[19]);
        $this->schvaleni3Stav = $row[41];
        $this->schvaleni3RC = $row[28];
        $this->nastavenySchvalovatel3 = $row[36] . ' ' . $row[35];
        $this->poznamkaKeSchvaleni = $row[42];
        $this->historieSchvalovani = $row[43];
        $this->predpokladanaCena = $row[37];
        $this->uzivatelska1 = $row[21];
        $this->uzivatelska2 = $row[22];
        $this->uzivatelska3 = $row[23];
        $this->uzivatelska4 = $row[24];
        $this->uzivatelska5 = $row[25];
        $this->mena = $row[45];

        $this->jeSablona = $row[59];

        $pomRozdeleni = new Rozdeleni();
        $pomRozdeleni->typ = $row[47];
        $pomRozdeleni->kod = $row[48];
        $pomRozdeleni->popis = $row[49];
        $this->rozdeleni1 = $pomRozdeleni;
        $pomRozdeleni = new Rozdeleni();
        $pomRozdeleni->typ = $row[50];
        $pomRozdeleni->kod = $row[51];
        $pomRozdeleni->popis = $row[52];
        $this->rozdeleni2 = $pomRozdeleni;
        $pomRozdeleni = new Rozdeleni();
        $pomRozdeleni->typ = $row[53];
        $pomRozdeleni->kod = $row[54];
        $pomRozdeleni->popis = $row[55];
        $this->rozdeleni3 = $pomRozdeleni;
        $pomRozdeleni = new Rozdeleni();
        $pomRozdeleni->typ = $row[60];
        $pomRozdeleni->kod = $row[61];
        $pomRozdeleni->popis = $row[62];
        $this->rozdeleni4 = $pomRozdeleni;
        $pomRozdeleni = new Rozdeleni();
        $pomRozdeleni->typ = $row[63];
        $pomRozdeleni->kod = $row[64];
        $pomRozdeleni->popis = $row[65];
        $this->rozdeleni5 = $pomRozdeleni;

        $this->cenaCelkem_DM = $row[66];
        $this->cenaCelkem_DM_mena = $row[67];
    }

    public function novyRadekObjednavky()
    {
        $novyRadek = new RadekVydaneObjednavky();
        $novyRadek->novyRadek = true;
        $novyRadek->cisloRadku = 'novy_radek_1';
        $this->radky[] = $novyRadek;
        $this->pocetNovychRadku = 1;
    }

    public static function vratPopisStavuSchvaleni($stav, $uroven = null)
    {
        switch ($stav) {
            case 1:
                if (is_null($uroven)) {
                    $stavPopis = ronText('Schvaleno');
                } else {
                    $stavPopis = sprintf(ronText('Stav_schvaleno'), $uroven);
                }
                break;
            case 2:
            case 5:
                $stavPopis = ronText('Vraceno');
                break;
            case 3:
                $stavPopis = ronText('Zamitnuto');
                break;
            case 4:
                $stavPopis = ronText('Ceka_na_schvaleni');
                break;
            case 0:
            default:
                $stavPopis = '';
        }

        return $stavPopis;
    }

    /**
     * @param $database
     * @param $vystavil
     * @param $datum
     * @return bool
     * @throws Exception
     */
    public static function jePravoNaObjednavku($database, $vystavil, $datum)
    {
        Prava::nastavObdobiProPrava($datum);

        $prava = Prava::nactiPravaUzivatele($database, User::getRC(), 'objednavka_vydana_prohl');
        if ($prava && $prava->lzeZobrazitRC($vystavil)) return true;

        $prava = Prava::nactiPravaUzivatele($database, User::getRC(), 'objednavka_vydana_vlozeni');
        if ($prava && $prava->lzeZobrazitRC($vystavil)) return true;

        $prava = Prava::nactiPravaUzivatele($database, User::getRC(), 'objednavka_vydana_schvaleni1');
        if ($prava && $prava->lzeZobrazitRC($vystavil)) return true;

        $prava = Prava::nactiPravaUzivatele($database, User::getRC(), 'objednavka_vydana_schvaleni2');
        if ($prava && $prava->lzeZobrazitRC($vystavil)) return true;

        $prava = Prava::nactiPravaUzivatele($database, User::getRC(), 'objednavka_vydana_schvaleni3');
        if ($prava && $prava->lzeZobrazitRC($vystavil)) return true;

        $prava = Prava::nactiPravaUzivatele($database, User::getRC(), 'objednavka_vydana_faktura');
        if ($prava && $prava->lzeZobrazitRC($vystavil)) return true;

        return false;
    }

    /**
     * @param PravaNaOsoby|PravaNaOsoby[] $prava
     * @return bool
     * @throws Exception
     */
    public function jePravo($prava)
    {
        Prava::nastavObdobiProPrava($this->datumVystaveni);

        if (is_array($prava)) {
            foreach ($prava as $pravaNaOsoby) {
                if ($pravaNaOsoby->lzeZobrazitRC($this->vystavil))
                    return true;
            }
        } else {
            if (is_null($this->cisloObjednavky)) {
                if ($prava->jsouNejakePrava())
                    return true;
            } elseif ($prava->lzeZobrazitRC($this->vystavil))
                return true;
        }

        //pokud je uzivatel prirazen jako schvalovatel ma pravo
        if (($this->schvaleni1RC == User::getRC()) || ($this->schvaleni2RC == User::getRC()) || ($this->schvaleni3RC == User::getRC()))
            return true;

        return false;
    }

    /**
     * @return bool
     * @throws Exception
     */
    public function lzeEditovat()
    {
        Prava::nastavObdobiProPrava($this->datumVystaveni);

        $pravaVlozit = Prava::vratPrava('objednavka_vydana_vlozeni');
        $prava1 = Prava::vratPrava('objednavka_vydana_schvaleni1');
        $prava2 = Prava::vratPrava('objednavka_vydana_schvaleni2');
        $prava3 = Prava::vratPrava('objednavka_vydana_schvaleni3');

        if ($this->schvaleno) {
            return false;
        }

        //schvalena nebo zamitnuta na 3 nelze
        if (($this->schvaleni3Stav == 1) || ($this->schvaleni3Stav == 3)) {
            return false;
        } elseif ((($this->schvaleni3Stav == 0) || ($this->schvaleni3Stav == 2)) && ($this->schvaleni2Stav == 1)) {
            if ($prava3->lzeZobrazitRC($this->vystavil) && $prava3->priznak)
                return true;
        } elseif (($this->schvaleni2Stav == 2) && ($prava2->lzeZobrazitRC($this->vystavil) && $prava2->priznak)) {
            return true;
        } elseif ((($this->schvaleni3Stav == 0) || ($this->schvaleni3Stav == 2)) && (($this->schvaleni2Stav == 0) || ($this->schvaleni2Stav == 2)) && ($this->schvaleni1Stav == 1)) {
            if (($prava3->lzeZobrazitRC($this->vystavil) && $prava3->priznak) || ($prava2->lzeZobrazitRC($this->vystavil)) && $prava2->priznak)
                return true;
        } /*elseif ((($this->schvaleni1Stav == 2) || ($this->schvaleni1Stav == 5)) && ($pravaVlozit->lzeZobrazitRC($this->vystavil) && $pravaVlozit->priznak)) {
                return true;
        }*/ elseif ((($this->schvaleni3Stav == 0) || ($this->schvaleni3Stav == 2)) && //neschvaleno nebo vraceno
            (($this->schvaleni2Stav == 0) || ($this->schvaleni2Stav == 2)) && //neschvaleno nebo vraceno
            (($this->schvaleni1Stav == 0) || ($this->schvaleni1Stav == 2) || ($this->schvaleni1Stav == 5))) { //neschvaleno nebo vraceno (5 = z vyssi urovne)
            if (($prava3->lzeZobrazitRC($this->vystavil) && $prava3->priznak) || ($prava2->lzeZobrazitRC($this->vystavil) && $prava2->priznak) || ($prava1->lzeZobrazitRC($this->vystavil)  && $prava1->priznak)
                || ($pravaVlozit->lzeZobrazitRC($this->vystavil)  && $pravaVlozit->priznak && ($this->schvaleni1Stav != 4))) //zadavatel jen pokud jeste nepredal ke schvaleni
                return true;
        }

        return false;
    }

    /** Pole dodano mnozstvi muze editovat zadavatel po schvaleni objednavky do uzavreni.
     * @return bool
     * @throws Exception
     */
    public function lzeEditovatDodano()
    {
        $pravaVlozit = Prava::vratPrava('objednavka_vydana_vlozeni');

        if ($this->schvaleno && !$this->vyrizeno && ($this->vystavil == User::getRC()) && $pravaVlozit->priznak)
            return true;

        return false;
    }

    public function lzeEditovatDatumDodani()
    {
        $pravaEditovat = Prava::vratPrava('objednavka_vydana_dodani');

        if (!$this->vyrizeno && $pravaEditovat->prava == 3)
            return true;

        return false;
    }

    /**
     * @param bool $vypsatChybu
     * @return bool
     * @throws Exception
     */
    public function lzeFakturovat($vypsatChybu = true)
    {
        Prava::nastavObdobiProPrava($this->datumVystaveni);

        $pravaFakturovat = Prava::vratPrava('objednavka_vydana_faktura');

        if (!$this->schvaleno) {
            if ($vypsatChybu)
                MessageManager::addErrorMessage(ronText('Objednavka_neni_schvalena'));
            return false;
        }

        if ($this->vyrizeno)
            return false;

        if ($pravaFakturovat->lzeZobrazitRC($this->vystavil)) {
            return true;
        }

        return false;
    }

    /**
     * @param $uroven
     * @return bool
     * @throws Exception
     */
    public function lzeSchvalit($uroven)
    {
//        if ((($uroven == 1) && ($stavSchvaleni == 4)) || (($uroven > 1) && ($stavSchvaleni == 0))) {

        switch ($uroven) {
            case 1 :
                if (($this->schvaleni3Datum && ($this->schvaleni3Stav == 1)) || ($this->schvaleni2Datum && ($this->schvaleni2Stav == 1)))
                    return false;
                if ($this->schvaleni1RC !== User::getRC())
                    return false;
                //pokud je schvaleno (1) nebo zamitnuto (3) jiz nelze schvalovat, jen pro nerozhodnuto (0) nebo predano ke schvaleni (4)
                if (($this->schvaleni1Datum) && (($this->schvaleni1Stav == 1) || ($this->schvaleni1Stav == 2) || ($this->schvaleni1Stav == 3)))
                    return false;
                //cekani na schvaleni a vraceno z vyssi urovne lze schvalit
                if (!($this->schvaleni1Stav == 4))
                    return false;
                break;
            case 2 :
                if (($this->schvaleni3Datum && ($this->schvaleni3Stav == 1)))
                    return false;
                if ($this->schvaleni2RC !== User::getRC())
                    return false;
                if (($this->schvaleni2Datum) && (($this->schvaleni2Stav != 0)))
                    return false;
                //predchozi uroven musi byt schvalena
                if ($this->schvaleni1Stav != 1)
                    return false;
                break;
            case 3 :
                if (($this->schvaleni3Datum) && (($this->schvaleni3Stav != 0)))
                    return false;
                if ($this->schvaleni3RC !== User::getRC())
                    return false;
                //predchozi uroven musi byt schvalena
                if ($this->schvaleni2Stav != 1)
                    return false;
                break;
        }

        $prava = Prava::vratPrava('objednavka_vydana_schvaleni' . $uroven);
        Prava::nastavObdobiProPrava($this->datumVystaveni);
        if ($prava->lzeZobrazitRC($this->vystavil))
            return true;

        //pokud je uzivatel prirazen jako schvalovatel ma pravo
        if (($this->schvaleni1RC == User::getRC()) || ($this->schvaleni2RC == User::getRC()) || ($this->schvaleni3RC == User::getRC()))
            return true;

        return false;
    }

    /** Overi, zda je mozne u objednavky zobrazit odkaz na predani ke schvaleni. Predanim se ukonci editaci a zobrazi se odkazy ke schvaleni.
     * @param $uroven
     * @return bool
     * @throws Exception
     */
    public function lzeSchvalovat($uroven)
    {
        $lzeSchvalovat = false;

        if ($uroven > 1)
            return false;

        if (($this->schvaleni3Stav == 1) || ($this->schvaleni3Stav == 3) || ($this->schvaleni2Stav == 1) || ($this->schvaleni2Stav == 3))
            return false;
        //pokud je schvaleno (1) nebo zamitnuto (3) jiz nelze schvalovat, jen pro nerozhodnuto (0) nebo vraceno (2)
        if (($this->schvaleni1Datum) && (($this->schvaleni1Stav == 1) || ($this->schvaleni1Stav == 3)))
            return false;

        if (($this->schvaleni1Stav == 0) && (($this->cenaCelkem > 0) || ($this->pocetKusuObjednavky() > 0)))
            $lzeSchvalovat = true;

        if (($this->schvaleni1Stav == 2) || ($this->schvaleni1Stav == 5))
            $lzeSchvalovat = true;

        //prava se nacitaji vzdy o uroven nize, na 1. se kontroluji prava pro vlozeni
        $prava = Prava::vratPrava('objednavka_vydana_vlozeni');
        Prava::nastavObdobiProPrava($this->datumVystaveni);
        if ($prava->lzeZobrazitRC($this->vystavil) && $lzeSchvalovat && ($this->vystavil == User::getRC()))
            return true;

        return false;

        /*
        switch ($uroven) {
            case 1 :
                if (($this->schvaleni3Datum) || ($this->schvaleni2Datum))
                    return false;
                //pokud je schvaleno (1) nebo zamitnuto (3) jiz nelze schvalovat, jen pro nerozhodnuto (0) nebo vraceno (2)
                if (($this->schvaleni1Datum) && (($this->schvaleni1Stav == 1) || ($this->schvaleni1Stav == 3)))
                    return false;

                if (($this->schvaleni1Stav == 0) && (($this->cenaCelkem > 0) || ($this->pocetKusuObjednavky() > 0)))
                    $lzeSchvalovat = true;

                if ($this->schvaleni1Stav == 2)
                    $lzeSchvalovat = true;

                $prava = Prava::vratPrava('objednavka_vydana_vlozeni');
                break;
            case 2 :
                if (($this->schvaleni3Datum))
                    return false;
                if (($this->schvaleni2Datum) && (($this->schvaleni2Stav == 1) || ($this->schvaleni2Stav == 3)))
                    return false;

                if ($this->schvaleni2Stav == 2)
                    $lzeSchvalovat = true;

                $prava = Prava::vratPrava('objednavka_vydana_schvaleni1');
                break;
            case 3 :
                if (($this->schvaleni3Datum) && (($this->schvaleni3Stav == 1) || ($this->schvaleni3Stav == 3)))
                    return false;

                if ($this->schvaleni3Stav == 2)
                    $lzeSchvalovat = true;

                $prava = Prava::vratPrava('objednavka_vydana_schvaleni2');
                break;
        }


        Prava::nastavObdobiProPrava($this->datumVystaveni);
        if ($prava->lzeZobrazitRC($this->vystavil) && $lzeSchvalovat)
            return true;

        return false;*/
    }

    /**
     * @param $uroven
     * @return bool
     * @throws Exception
     */
    public function lzeNastavitSchvalovatele($uroven)
    {
        if ($this->schvaleno)
            return false;

        switch ($uroven) {
            case 1 :
                if (($this->schvaleni3Datum) || ($this->schvaleni2Datum) || ($this->schvaleni1Datum))
                    return false;
                if (isset($this->schvaleni1RC))
                    return false;

                $prava = Prava::vratPrava('objednavka_vydana_vlozeni');
                Prava::nastavObdobiProPrava($this->datumVystaveni);
                if ($prava->lzeZobrazitRC($this->vystavil))
                    return true;
                break;
            case 2 :
                if (($this->schvaleni2Datum) || ($this->schvaleni3Datum))
                    return false;
                if (isset($this->schvaleni2RC))
                    return false;
                //musi byt schvalena 1.uroven
                if (!($this->schvaleni1Datum && ($this->schvaleni1Stav == 1)))
                    return false;

                //na predchozi urovni musi byt prihlaseny uzivatel
                if ($this->schvaleni1RC !== User::getRC())
                    return false;

                $prava = Prava::vratPrava('objednavka_vydana_schvaleni1');
                Prava::nastavObdobiProPrava($this->datumVystaveni);
                if ($prava->lzeZobrazitRC($this->vystavil))
                    return true;
                break;
            case 3 :
                if ($this->schvaleni3Datum)
                    return false;
                if (isset($this->schvaleni3RC))
                    return false;

                //na predchozi urovni musi byt prihlaseny uzivatel
                if ($this->schvaleni2RC !== User::getRC())
                    return false;

                $prava = Prava::vratPrava('objednavka_vydana_schvaleni2');
                Prava::nastavObdobiProPrava($this->datumVystaveni);
                if ($prava->lzeZobrazitRC($this->vystavil))
                    return true;
                break;
        }

        return false;
    }

    public function pocetKusuObjednavky()
    {
        if (!empty($this->radky)) {
            $suma = 0;
            foreach ($this->radky as $radekVydaneObjednavky) {
                $suma += $radekVydaneObjednavky->mnozstvi;
            }
            return $suma;
        }

        return 0;
    }

    public function zkontrolujFakturaci()
    {
        $tolerance = RonPortalSettings::getIntValue('vydanaobjednavka_schvaleni_procento_prekroceni');

        if (!is_null($this->faktury) && $tolerance) {
            $soucetFaktur = 0;
            foreach ($this->faktury as $fakturaPrijata) {
                $soucetFaktur += $fakturaPrijata->castka;
            }
            if ($soucetFaktur > $this->cenaCelkem * (1 + (int)$tolerance/100)) {
                $this->prekrocenaCenaFaktury = true;
                MessageManager::addErrorMessage(ronText('Prekrocena_cena_objednavky'), 'cena');
            }
        }
    }

    public function najdiFakturu($cisloFaktury)
    {
        foreach ($this->faktury as $fakturaPrijata) {
            if (($fakturaPrijata->cisloFaktury == $cisloFaktury) || (is_null($fakturaPrijata->cisloFaktury)))
                return $fakturaPrijata;
        }

        return null;
    }

    /**
     * @throws Exception
     */
    public function nactiPost()
    {
        if (isset($_POST['sablona']))
            $this->jeSablona = true;

        if (($_POST['stredisko'] == '') && !isset($this->stredisko))
            MessageManager::addErrorMessage(ronText('Chybi_stredisko'), 'stredisko');
        if (($_POST['dodavatel'] == '') && !isset($this->dodavatel))
            MessageManager::addErrorMessage(ronText('Chybi_dodavatel'), 'dodavatel');
        if (($_POST['popis'] == '') && !isset($this->popis))
            MessageManager::addErrorMessage(ronText('Chybi_popis'), 'popis');
        if (($_POST['mena'] == '') && !isset($this->mena))
            MessageManager::addErrorMessage(ronText('Chybi_mena'), 'mena');
        if (!$this->jeSablona && ($_POST['termin_dodani'] == '') && !isset($this->terminDodani))
            MessageManager::addErrorMessage(ronText('Chybi_termin'), 'termin_dodani');
        if (ObjednavkyController::$typRozdeleniVydaneObjednavky[1] && RonPortalSettings::getIntValue('vydanaobjednavka_rozdeleni1_zadani_povinne') && ($_POST['rozdeleni'] == '') && !isset($this->rozdeleni1))
            MessageManager::addErrorMessage(sprintf(ronText('Chybi_rozdeleni'), '' . StringUtils::htmlTextConvert($_POST['typrozdeleni_popis'])), 'rozdeleni');
        if (ObjednavkyController::$typRozdeleniVydaneObjednavky[2] && RonPortalSettings::getIntValue('vydanaobjednavka_rozdeleni2_zadani_povinne') && ($_POST['rozdeleni2'] == '') && !isset($this->rozdeleni2))
            MessageManager::addErrorMessage(sprintf(ronText('Chybi_rozdeleni'), '' . StringUtils::htmlTextConvert($_POST['typrozdeleni2_popis'])), 'rozdeleni2');
        if (ObjednavkyController::$typRozdeleniVydaneObjednavky[3] && RonPortalSettings::getIntValue('vydanaobjednavka_rozdeleni3_zadani_povinne') && ($_POST['rozdeleni3'] == '') && !isset($this->rozdeleni3))
            MessageManager::addErrorMessage(sprintf(ronText('Chybi_rozdeleni'), '' . StringUtils::htmlTextConvert($_POST['typrozdeleni3_popis'])), 'rozdeleni3');
        if (ObjednavkyController::$typRozdeleniVydaneObjednavky[4] && RonPortalSettings::getIntValue('vydanaobjednavka_rozdeleni4_zadani_povinne') && ($_POST['rozdeleni4'] == '') && !isset($this->rozdeleni4))
            MessageManager::addErrorMessage(sprintf(ronText('Chybi_rozdeleni'), '' . StringUtils::htmlTextConvert($_POST['typrozdeleni4_popis'])), 'rozdeleni4');
        if (ObjednavkyController::$typRozdeleniVydaneObjednavky[5] && RonPortalSettings::getIntValue('vydanaobjednavka_rozdeleni5_zadani_povinne') && ($_POST['rozdeleni5'] == '') && !isset($this->rozdeleni5))
            MessageManager::addErrorMessage(sprintf(ronText('Chybi_rozdeleni'), '' . StringUtils::htmlTextConvert($_POST['typrozdeleni5_popis'])), 'rozdeleni5');


        if (isset($_POST['datum_vystaveni'])) {
            $this->datumVystaveni = DateUtils::dateStringToTimestamp($_POST['datum_vystaveni']);
        }
        if ($_POST['termin_dodani'] != '')
            $this->terminDodani = DateUtils::dateStringToTimestamp($_POST['termin_dodani']);

        if (isset($_POST['stredisko']))
            $this->stredisko = $_POST['stredisko'];
        if (isset($_POST['dodavatel']))
            $this->dodavatel = $_POST['dodavatel'];
        if (isset($_POST['popis']))
            $this->popis = $_POST['popis'];

        if (isset($_POST['poznamka']))
            $this->poznamka = $_POST['poznamka'];
        if (isset($_POST['cenapredpoklad']))
            $this->predpokladanaCena = StringUtils::stringToFloat($_POST['cenapredpoklad']);
        if (isset($_POST['mena']))
            $this->mena = $_POST['mena'];
        if (isset($_POST['uzivatelska1']))
            $this->uzivatelska1 = $_POST['uzivatelska1'];
        if (isset($_POST['uzivatelska2']))
            $this->uzivatelska2 = $_POST['uzivatelska2'];
        if (isset($_POST['uzivatelska3']))
            $this->uzivatelska3 = $_POST['uzivatelska3'];
        if (isset($_POST['uzivatelska4']))
            $this->uzivatelska4 = $_POST['uzivatelska4'];
        if (isset($_POST['uzivatelska5']))
            $this->uzivatelska5 = $_POST['uzivatelska5'];

        $this->odeslano = isset($_POST['odeslano']);
        $this->vyrizeno = isset($_POST['vyrizeno']);
        $this->odeslatMail = isset($_POST['odeslatmail']);
        $this->vyzadovatSchvaleni = isset($_POST['vyzadovat_schvaleni']);

        if (isset($_POST['schvalovatel1'])) {
            $this->schvaleni1RC = $_POST['schvalovatel1'];
            $this->schvaleni1NastavSchvalovatele = true;
        }
        if (isset($_POST['schvalovatel2'])) {
            $this->schvaleni2RC = $_POST['schvalovatel2'];
            $this->schvaleni2NastavSchvalovatele = true;
        }
        if (isset($_POST['schvalovatel3'])) {
            $this->schvaleni3RC = $_POST['schvalovatel3'];
            $this->schvaleni3NastavSchvalovatele = true;
        }

        if (isset($_POST['typrozdeleni'])) {
            $this->rozdeleni1 = new Rozdeleni();
            $this->rozdeleni1->typ = $_POST['typrozdeleni'];
            $this->rozdeleni1->kod = $_POST['rozdeleni'];
        }
        if (isset($_POST['typrozdeleni2'])) {
            $this->rozdeleni2 = new Rozdeleni();
            $this->rozdeleni2->typ = $_POST['typrozdeleni2'];
            $this->rozdeleni2->kod = $_POST['rozdeleni2'];
        }
        if (isset($_POST['typrozdeleni3'])) {
            $this->rozdeleni3 = new Rozdeleni();
            $this->rozdeleni3->typ = $_POST['typrozdeleni3'];
            $this->rozdeleni3->kod = $_POST['rozdeleni3'];
        }
        if (isset($_POST['typrozdeleni4'])) {
            $this->rozdeleni4 = new Rozdeleni();
            $this->rozdeleni4->typ = $_POST['typrozdeleni4'];
            $this->rozdeleni4->kod = $_POST['rozdeleni4'];
        }
        if (isset($_POST['typrozdeleni5'])) {
            $this->rozdeleni5 = new Rozdeleni();
            $this->rozdeleni5->typ = $_POST['typrozdeleni5'];
            $this->rozdeleni5->kod = $_POST['rozdeleni5'];
        }

        $pocetNovychRadku = (int)$_POST['pocetnovychradku'];
        for ($i = 1; $i <= $pocetNovychRadku; $i++) {
            $novyRadek = new RadekVydaneObjednavky();
            $novyRadek->novyRadek = true;
            $novyRadek->cisloRadku = 'novy_radek_' . $i;
            $this->radky[] = $novyRadek;
        }
        $this->cenaCelkem = 0;
        $this->pocetNovychRadku = $pocetNovychRadku;
        foreach ($this->radky as $radekVydaneObjednavky) {
            $radekVydaneObjednavky->nactiPost();
            $this->cenaCelkem += $radekVydaneObjednavky->cena;
        }

        if (isset($_POST['pocetFaktur'])) {
            for ($i = 1; $i <= $_POST['pocetFaktur']; $i++) {
                if (isset($_POST["faktura_datum_vystaveni_$i"]) && ($_POST["faktura_datum_vystaveni_$i"] != '')) {
                    $cisloFaktury = $_POST["faktura_cislo_$i"];
                    $faktura = null;
                    $novaFaktura = false;

                    $faktura = $this->najdiFakturu($cisloFaktury);

                    if (is_null($faktura)) {
                        $faktura = new FakturaPrijata();
                        $novaFaktura = true;
                    }

                    $faktura->nactiPost($i);
                    $faktura->mena = $this->mena;

                    if ($novaFaktura)
                        $this->faktury[] = $faktura;
                }
            }
        }
    }


    /**
     * @param Database $database
     * @return false|mixed
     * @throws DBException
     */
    public function vlozObjednavku($database)
    {
        $obdobi = SkladUtils::getObdobiProDatum($database, $this->datumVystaveni);
        $nastaveniMasky = SkladUtils::getNastaveniCiselneRady($database, 'CR_ObjednavkaVydana', $this->stredisko, $obdobi);

        $database->beginTransaction();

        //pred vlozenim se k datum pricte aktualni cas, aby bylo mozne radit, nastaveno zde, aby se datum neaktulizovalo pri kazde aktualizaci
        $this->datumVystaveni = $this->datumVystaveni + (DateUtils::now() - DateUtils::startOfTheDay(DateUtils::now()));

        $rec = new VydanaObjednavkaRecord($database);
        $rec->findFieldByName('cisloVydaneObjednavky')->setNewValue(
            SQLUtils::getNextRecordSerialCode($database, 'ObjednavkaVydana', 'cisloVydaneObjednavky', $nastaveniMasky['maska'], $nastaveniMasky['min'], $nastaveniMasky['max']));
        $rec->findFieldByName('datumVystaveni')->setNewValue($this->datumVystaveni);
        $rec->findFieldByName('terminDodani')->setNewValue($this->terminDodani);
        $rec->findFieldByName('stredisko')->setNewValue($this->stredisko);
        $rec->findFieldByName('dodavatel')->setNewValue($this->dodavatel);
        $rec->findFieldByName('Popis')->setNewValue($this->popis);
        $rec->findFieldByName('poznamka')->setNewValue($this->poznamka);
        $rec->findFieldByName('cenaCelkem')->setNewValue($this->cenaCelkem);
        $rec->findFieldByName('predpokladanaCena')->setNewValue($this->predpokladanaCena);
        $rec->findFieldByName('mena')->setNewValue($this->mena);
        $rec->findFieldByName('odeslano')->setNewValue($this->odeslano);
        if ($this->odeslano)
            $rec->findFieldByName('datumCasOdeslani')->setNewValue(DateUtils::now());
        $rec->findFieldByName('vyrizeno')->setNewValue($this->vyrizeno);
        $rec->findFieldByName('odeslatMailem')->setNewValue($this->odeslatMail);
        $rec->findFieldByName('vyzadovatSchvaleni')->setNewValue($this->vyzadovatSchvaleni);

        $rec->findFieldByName('KodTypuRozdeleni')->setNewValue($this->rozdeleni1->typ);
        $rec->findFieldByName('Rozdeleni')->setNewValue($this->rozdeleni1->kod);
        $rec->findFieldByName('KodTypuRozdeleni2')->setNewValue($this->rozdeleni2->typ);
        $rec->findFieldByName('Rozdeleni2')->setNewValue($this->rozdeleni2->kod);
        $rec->findFieldByName('KodTypuRozdeleni3')->setNewValue($this->rozdeleni3->typ);
        $rec->findFieldByName('Rozdeleni3')->setNewValue($this->rozdeleni3->kod);
        $rec->findFieldByName('KodTypuRozdeleni4')->setNewValue($this->rozdeleni4->typ);
        $rec->findFieldByName('Rozdeleni4')->setNewValue($this->rozdeleni4->kod);
        $rec->findFieldByName('KodTypuRozdeleni5')->setNewValue($this->rozdeleni5->typ);
        $rec->findFieldByName('Rozdeleni5')->setNewValue($this->rozdeleni5->kod);

        $rec->findFieldByName('Uzivatelska1')->setNewValue($this->uzivatelska1);
        $rec->findFieldByName('Uzivatelska2')->setNewValue($this->uzivatelska2);
        $rec->findFieldByName('Uzivatelska3')->setNewValue($this->uzivatelska3);
        $rec->findFieldByName('Uzivatelska4')->setNewValue($this->uzivatelska4);
        $rec->findFieldByName('Uzivatelska5')->setNewValue($this->uzivatelska5);

        $rec->findFieldByName('vystavil')->setNewValue(User::getRC());

        $rec->findFieldByName('sablona')->setNewValue($this->jeSablona);

        try {
            $rec->insertRecord();
            $cisloObjednavky = $rec->findFieldByName('cisloVydaneObjednavky')->value;

            $cisloRadku = null;
            foreach ($this->radky as $radekVydaneObjednavky) {
                if ($radekVydaneObjednavky->kodZbozi || ($radekVydaneObjednavky->popis !== '')) {
                    $radekVydaneObjednavky->vlozRadek($database, $cisloObjednavky, $cisloRadku);
                }
            }

            if (!empty($this->faktury)) {
                foreach ($this->faktury as $fakturaPrijata) {
                    if ($fakturaPrijata->zapsat) {
                        $fakturaPrijata->zapisFakturu($database, $cisloObjednavky);
                    }
                }
            }

            $database->commitTransaction();
            $rec->xmlEvents(RonPortalXMLEvents::VYD_OBJEDNAVKA_AFTER_POST, 'insert');
            return $cisloObjednavky;
        }
        catch (Exception $exception) {
            $database->rollbackTransaction();
            throw $exception;
        }
    }

    /**
     * @param $database
     * @param $cisloObjednavky
     * @return bool
     * @throws DBException
     */
    public function aktualizujObjednavku($database, $cisloObjednavky)
    {
        $rec = new VydanaObjednavkaRecord($database, $cisloObjednavky);
        $rec->findFieldByName('datumVystaveni')->setNewValue($this->datumVystaveni);
        $rec->findFieldByName('terminDodani')->setNewValue($this->terminDodani);
        $rec->findFieldByName('stredisko')->setNewValue($this->stredisko);
        $rec->findFieldByName('dodavatel')->setNewValue($this->dodavatel);
        $rec->findFieldByName('Popis')->setNewValue($this->popis);
        $rec->findFieldByName('poznamka')->setNewValue($this->poznamka);
        $rec->findFieldByName('cenaCelkem')->setNewValue($this->cenaCelkem);
        $rec->findFieldByName('predpokladanaCena')->setNewValue($this->predpokladanaCena);
        $rec->findFieldByName('mena')->setNewValue($this->mena);
        $rec->findFieldByName('vyrizeno')->setNewValue($this->vyrizeno);
        $rec->findFieldByName('odeslatMailem')->setNewValue($this->odeslatMail);
        $rec->findFieldByName('vyzadovatSchvaleni')->setNewValue($this->vyzadovatSchvaleni);

        $rec->findFieldByName('KodTypuRozdeleni')->setNewValue($this->rozdeleni1->typ);
        $rec->findFieldByName('Rozdeleni')->setNewValue($this->rozdeleni1->kod);
        $rec->findFieldByName('KodTypuRozdeleni2')->setNewValue($this->rozdeleni2->typ);
        $rec->findFieldByName('Rozdeleni2')->setNewValue($this->rozdeleni2->kod);
        $rec->findFieldByName('KodTypuRozdeleni3')->setNewValue($this->rozdeleni3->typ);
        $rec->findFieldByName('Rozdeleni3')->setNewValue($this->rozdeleni3->kod);
        $rec->findFieldByName('KodTypuRozdeleni4')->setNewValue($this->rozdeleni4->typ);
        $rec->findFieldByName('Rozdeleni4')->setNewValue($this->rozdeleni4->kod);
        $rec->findFieldByName('KodTypuRozdeleni5')->setNewValue($this->rozdeleni5->typ);
        $rec->findFieldByName('Rozdeleni5')->setNewValue($this->rozdeleni5->kod);

        $rec->findFieldByName('Uzivatelska1')->setNewValue($this->uzivatelska1);
        $rec->findFieldByName('Uzivatelska2')->setNewValue($this->uzivatelska2);
        $rec->findFieldByName('Uzivatelska3')->setNewValue($this->uzivatelska3);
        $rec->findFieldByName('Uzivatelska4')->setNewValue($this->uzivatelska4);
        $rec->findFieldByName('Uzivatelska5')->setNewValue($this->uzivatelska5);

        $nastaveniSchvalovatele = null;

        if ($this->schvaleni1NastavSchvalovatele) {
            $pp = PracovniPomer::nactiPP($database, $this->schvaleni1RC);
            $this->schvaleni1RC = $pp->rc;
            $rec->RC_Schvalovatele1->setNewValue($this->schvaleni1RC);
            $nastaveniSchvalovatele[] = 1;
        }

        if ($this->schvaleni2NastavSchvalovatele) {
            $pp = PracovniPomer::nactiPP($database, $this->schvaleni2RC);
            $this->schvaleni2RC = $pp->rc;
            $rec->RC_Schvalovatele2->setNewValue($this->schvaleni2RC);
            $nastaveniSchvalovatele[] = 2;
        }

        if ($this->schvaleni3NastavSchvalovatele) {
            $pp = PracovniPomer::nactiPP($database, $this->schvaleni3RC);
            $this->schvaleni3RC = $pp->rc;
            $rec->RC_Schvalovatele3->setNewValue($this->schvaleni3RC);
            $nastaveniSchvalovatele[] = 3;
        }

        $chybaObjednavky = false;
        if (!is_null($nastaveniSchvalovatele)) {
            $result = true;

            $rec->loadRecord();

            if ($rec->findFieldByName('datumVystaveni')->isChanged()) {
                //pred vlozenim se k datu pricte aktualni cas, aby bylo mozne radit, nastaveno zde, aby se datum neaktulizovalo pri kazde aktualizaci
                $rec->findFieldByName('datumVystaveni')->setNewValue($rec->findFieldByName('datumVystaveni')->value + (DateUtils::now() - DateUtils::startOfTheDay(DateUtils::now())));
            }

            foreach ($nastaveniSchvalovatele as $uroven) {
                if ($rec->findFieldByName("RC_Schvalovatele{$uroven}")->isChanged()) {
                    if (!$rec->xmlEvents(RonPortalXMLEvents::VYD_OBJEDNAVKA_SCHVALENI, 'nastavenischvalovatele' . $uroven . '_before')) $chybaObjednavky = true;
                }
            }
            if (!$rec->updateRecord())
                $chybaObjednavky = true;
            foreach ($nastaveniSchvalovatele as $uroven) {
                if ($rec->findFieldByName("RC_Schvalovatele{$uroven}")->isChanged()) {
                    if (!$rec->xmlEvents(RonPortalXMLEvents::VYD_OBJEDNAVKA_SCHVALENI, 'nastavenischvalovatele' . $uroven . '_after')) $chybaObjednavky = true;
                }
            }
            if ($chybaObjednavky)
                $result = false;
        } else {
            $result = $rec->loadAndUpdateRecord();
            $rec->xmlEvents(RonPortalXMLEvents::VYD_OBJEDNAVKA_AFTER_POST, 'update');
        }

        $jeChyba = false;
        $cisloRadku = null;
        foreach ($this->radky as $radekVydaneObjednavky) {
            if ($radekVydaneObjednavky->kodZbozi || ($radekVydaneObjednavky->popis !== '')) {
                if ($radekVydaneObjednavky->novyRadek) {
                    $radekVydaneObjednavky->vlozRadek($database, $cisloObjednavky, $cisloRadku);
                } else {
                    $radekVydaneObjednavky->aktualizujRadek($database);
                }
            }
        }

        if (!empty($this->faktury)) {
            foreach ($this->faktury as $fakturaPrijata) {
                if ($fakturaPrijata->zapsat) {
                    $fakturaPrijata->zapisFakturu($database, $cisloObjednavky);
                }
            }
        }

        if ($result && !$jeChyba)
            return true;

        return false;
    }

    /**
     * @param int $nastaveniKopie 0 = vytvori kopii objednavky, 1 = vytvori sablonu z objednavky, 2 = vytvori objednavku ze sablony
     */
    public function nastavKopii($nastaveniKopie)
    {
        $this->cisloObjednavky = null;
        $this->schvaleni1Datum = null;
        $this->schvaleni1Jmeno = null;
        $this->schvaleni1RC = null;
        $this->schvaleni1Stav = null;
        $this->schvaleni2Datum = null;
        $this->schvaleni2Jmeno = null;
        $this->schvaleni2RC = null;
        $this->schvaleni2Stav = null;
        $this->schvaleni3Datum = null;
        $this->schvaleni3Jmeno = null;
        $this->schvaleni3RC = null;
        $this->schvaleni3Stav = null;
        $this->schvaleno = null;

        $this->pocetNovychRadku = count($this->radky);
        if (is_array($this->radky)) {
            foreach ($this->radky as $i => $radekVydaneObjednavky) {
                $radekVydaneObjednavky->cisloRadku = 'novy_radek_' . ($i+1);
                $radekVydaneObjednavky->novyRadek = true;
            }
        }

        $this->faktury = null;
        $this->odeslano = null;
        $this->datumCasOdeslani = null;
        $this->vyrizeno = null;

        if ($nastaveniKopie) {
            if ($nastaveniKopie == 1) {
                $this->jeSablona = true;
            } elseif ($nastaveniKopie == 2) {
                $this->jeSablona = false;
            }
        }
    }

    /**
     * @param Database $database
     * @param string $cisloObjednavky
     * @return VydanaObjednavka|null
     * @throws DBException
     */
    public static function nactiObjednavku($database, $cisloObjednavky)
    {
        $params = $database->createParameters();

        $index = ObjednavkyController::$indexUzivatelskehoFiltruDodavatele;
        if (!$index)
            $index = 1;

        $sql =
            "SELECT cisloVydaneObjednavky, ObjednavkaVydana.stredisko, datumVystaveni, formaUhrady, zpusobDopravy, terminDodani, " . // 0 - 5
            "   ObjednavkaVydana.Popis, dodavatel, vystavil, odeslano, vyrizeno, kodUctu, {fn_CASTWIDEMEMO(ObjednavkaVydana.poznamka)}, CenaCelkem, " . // 6 - 13
            "   schvaleni1_jmeno, schvaleni1_DT, schvaleni2_jmeno, schvaleni2_DT, schvaleni3_jmeno, schvaleni3_DT, datumCasOdeslani, " . // 14 - 20
            "   ObjednavkaVydana.Uzivatelska1, ObjednavkaVydana.Uzivatelska2, ObjednavkaVydana.Uzivatelska3, ObjednavkaVydana.Uzivatelska4, ObjednavkaVydana.Uzivatelska5, RC_Schvalovatele1, RC_Schvalovatele2, RC_Schvalovatele3, " . // 21 - 28
            "   Stredisko.popis, Firma.nazev1, Schvalovatel1.Prijmeni, Schvalovatel1.Jmeno, Schvalovatel2.Prijmeni, Schvalovatel2.Jmeno, Schvalovatel3.Prijmeni, Schvalovatel3.Jmeno, ObjednavkaVydana.predpokladanaCena, ". // 29 - 37
            "   Firma.userData{$index}, ObjednavkaVydana.schvaleni1_stav, ObjednavkaVydana.schvaleni2_stav, ObjednavkaVydana.schvaleni3_stav, ObjednavkaVydana.PoznamkaKschvaleni, {fn_CASTWIDEMEMO(ObjednavkaVydana.HistorieSchvalovani)}, " . // 38 - 43
            "   ObjednavkaVydana.schvaleno, ObjednavkaVydana.mena, ObjednavkaVydana.odeslatMailem, " . // 44 - 46
            "   R1.KodTypuRozdeleni, R1.Kod, R1.Popis, R2.KodTypuRozdeleni, R2.Kod, R2.Popis, R3.KodTypuRozdeleni, R3.Kod, R3.Popis, vyzadovatSchvaleni, Vystavil.Jmeno, Vystavil.Prijmeni, sablona, " . // 47 - 59
            "   R4.KodTypuRozdeleni, R4.Kod, R4.Popis, R5.KodTypuRozdeleni, R5.Kod, R5.Popis, ObjednavkaVydana.DM_Castka, ObjednavkaVydana.DM_KodMeny " . // 60 - 67
            "FROM ObjednavkaVydana JOIN Stredisko ON Stredisko.kod = ObjednavkaVydana.stredisko
                JOIN Firma ON Firma.kodFirmy = ObjednavkaVydana.dodavatel
                JOIN Osoba Vystavil ON Vystavil.RC = ObjednavkaVydana.Vystavil
                LEFT JOIN Osoba Schvalovatel1 ON Schvalovatel1.RC =  ObjednavkaVydana.RC_Schvalovatele1
                LEFT JOIN Osoba Schvalovatel2 ON Schvalovatel2.RC =  ObjednavkaVydana.RC_Schvalovatele2
                LEFT JOIN Osoba Schvalovatel3 ON Schvalovatel3.RC =  ObjednavkaVydana.RC_Schvalovatele3
                LEFT JOIN Rozdeleni R1 ON R1.KodTypuRozdeleni = ObjednavkaVydana.KodTypuRozdeleni AND R1.Kod = ObjednavkaVydana.Rozdeleni
                LEFT JOIN Rozdeleni R2 ON R2.KodTypuRozdeleni = ObjednavkaVydana.KodTypuRozdeleni2 AND R2.Kod = ObjednavkaVydana.Rozdeleni2
                LEFT JOIN Rozdeleni R3 ON R3.KodTypuRozdeleni = ObjednavkaVydana.KodTypuRozdeleni3 AND R3.Kod = ObjednavkaVydana.Rozdeleni3
                LEFT JOIN Rozdeleni R4 ON R4.KodTypuRozdeleni = ObjednavkaVydana.KodTypuRozdeleni4 AND R4.Kod = ObjednavkaVydana.Rozdeleni4
                LEFT JOIN Rozdeleni R5 ON R5.KodTypuRozdeleni = ObjednavkaVydana.KodTypuRozdeleni5 AND R5.Kod = ObjednavkaVydana.Rozdeleni5
            WHERE cisloVydaneObjednavky = " . $params->addParameter($cisloObjednavky);

        $cursor = $database->getSqlResult($sql, $params);

        $objednavka = null;

        if ($row = $cursor->fetch()) {
            $objednavka = new static();
            $objednavka->nactiRadek($database, $row);
            $objednavka->radky = RadekVydaneObjednavky::nactiRadky($database, $objednavka->cisloObjednavky);

            if (!empty($objednavka->radky)) {
                foreach ($objednavka->radky as $radekVydaneObjednavky) {
                    $objednavka->soucetCen += $radekVydaneObjednavky->cena;
                    if ($radekVydaneObjednavky->kodZbozi)
                        $objednavka->povolitZmenuDodavatele = false;
                    if (($radekVydaneObjednavky->dodanoMnozstvi > 0) && ($radekVydaneObjednavky->mnozstvi !== $radekVydaneObjednavky->dodanoMnozstvi) && $radekVydaneObjednavky->souhlasDodaneMnozstvi) {
                        $objednavka->nesouhlasiPocetKusu = true;
                        MessageManager::addErrorMessage(sprintf(ronText('Nesouhlasi_kusy'), StringUtils::htmlTextConvert($radekVydaneObjednavky->popis)), 'dodano_mnozstvi_' . $radekVydaneObjednavky->cisloRadku);
                    }
                }
            }

            $objednavka->faktury = FakturaPrijata::nactiFaktury($database, $cisloObjednavky);

            $objednavka->zkontrolujFakturaci();
            if (empty($objednavka->faktury)) {
                $objednavka->faktury[] = new FakturaPrijata();
            }
        }

        return $objednavka;
    }

}

class RadekVydaneObjednavky
{
    public $cisloObjednavky;
    public $cisloRadku;
    public $typZbozi;
    public $kodZbozi;
    public $popis;
    public $rozsirenyPopis = '';
    public $mnozstvi;
    public $jednotka;
    public $dodanoMnozstvi;
    public $cenaZaJednotku;
    public $cena;
    public $poznamka = '';
    public $predpokladaneDatumDodani;
    public $souhlasDodaneMnozstvi;
    public $novyRadek = false;
    public $smazat = false;

    /**
     * @param Database $database
     * @param $row
     */
    protected function nactiRadek($database, $row)
    {
        $this->cisloObjednavky = $row[0];
        $this->cisloRadku = (float)$row[1];
        $this->typZbozi = $row[2];
        $this->kodZbozi = $row[3];
        $this->popis = $row[4];
        $this->rozsirenyPopis = $row[5];
        $this->mnozstvi = $row[6];
        $this->jednotka = $row[7];
        $this->dodanoMnozstvi = $row[8];
        $this->cenaZaJednotku = $row[9];
        $this->poznamka = $row[10];
        $this->predpokladaneDatumDodani = $database->stringToTimestamp($row[11]);
        $this->souhlasDodaneMnozstvi = $row[12];

        $this->cena = $this->mnozstvi * $this->cenaZaJednotku;
    }

    /**
     * @throws Exception
     */
    public function nactiPost()
    {
        $varNameSuffix = $this->cisloRadku;

        if ($_POST['deleteRadek'] == $this->cisloRadku) {
            $this->smazat = true;
        } else {
            if (($_POST['popis_' . $varNameSuffix] == '') && !isset($this->popis))
                MessageManager::addErrorMessage(ronText('Chybi_popis_zbozi'), 'popis_' . $varNameSuffix);
            if (($_POST['mnozstvi_' . $varNameSuffix] == '') && !isset($this->popis))
                MessageManager::addErrorMessage(ronText('Chybi_mnozstvi_zbozi'), 'mnozstvi_' . $varNameSuffix);
            if (($_POST['cena_' . $varNameSuffix] == '') && !isset($this->popis))
                MessageManager::addErrorMessage(ronText('Chybi_cena_zbozi'), 'cena_' . $varNameSuffix);
        }

        if (isset($_POST['zbozi_' . $varNameSuffix]))
            $this->kodZbozi = $_POST['zbozi_' . $varNameSuffix];
        if (isset($_POST['popis_' . $varNameSuffix]))
            $this->popis = $_POST['popis_' . $varNameSuffix];
        if (isset($_POST['mnozstvi_' . $varNameSuffix]))
            $this->mnozstvi = StringUtils::stringToFloat($_POST['mnozstvi_' . $varNameSuffix]);
        if (isset($_POST['dodano_mnozstvi_' . $varNameSuffix]))
            $this->dodanoMnozstvi = StringUtils::stringToFloat($_POST['dodano_mnozstvi_' . $varNameSuffix]);
        if (isset($_POST['cena_' . $varNameSuffix]))
            $this->cenaZaJednotku = StringUtils::stringToFloat($_POST['cena_' . $varNameSuffix]);
        if ($_POST['datum_dodani_' . $varNameSuffix] != '')
            $this->predpokladaneDatumDodani = DateUtils::dateStringToTimestamp($_POST['datum_dodani_' . $varNameSuffix]);

        if (isset($_POST['rozsireny_popis_' . $varNameSuffix]))
            $this->rozsirenyPopis = $_POST['rozsireny_popis_' . $varNameSuffix];

        $this->souhlasDodaneMnozstvi = isset($_POST['souhlas_dodano_' . $varNameSuffix]);

        if ($this->smazat)
            $this->cena = 0;
        else
            $this->cena = (float)$this->mnozstvi * (float)$this->cenaZaJednotku;
    }

    /**
     * @param Database $database
     * @param $cisloObjednavky
     * @param $cisloRadku
     * @throws DBException
     */
    public function vlozRadek($database, $cisloObjednavky, &$cisloRadku)
    {
        $rec = new RonPortalDBRecord($database, 'RadekVydaneObjednavky');
        $rec->logDescription = StringUtils::fromUTF8('Vydaná objednávka');

        $filterParams = $database->createParameters();

        if (is_null($cisloRadku))
            $cisloRadku = SQLUtils::newSerialNumber($database, $rec->tableName, 'radekVydaneObjednavky', 'cisloVydaneObjednavky = ' . $filterParams->addParameter($cisloObjednavky), $filterParams);
        else
            $cisloRadku++;

        $rec->addField('cisloVydaneObjednavky', '', true, 20)->setNewValue($cisloObjednavky);
        $rec->addField('radekVydaneObjednavky', 'float', true)->setNewValue($cisloRadku);
        if (isset($this->kodZbozi)) {
            $rec->addField('kodZbozi', '', true, 30)->setNewValue($this->kodZbozi);
        }
        $rec->addField('popis', '', true, 60)->setNewValue($this->popis);
        $rec->addField('pokracovaniPopisu', 'memo', true)->setNewValue($this->rozsirenyPopis);
        $rec->addField('mnozstvi', 'float', true)->setNewValue($this->mnozstvi);
        $rec->addField('dodanoMnozstvi', 'float', true)->setNewValue($this->dodanoMnozstvi);
        $rec->addField('cenaZaJednotku', 'float', true)->setNewValue($this->cenaZaJednotku);
        $rec->addField('predpokladaneDatumDodani', 'timestamp', true)->setNewValue($this->predpokladaneDatumDodani);
        $rec->addField('souhlasSDodanymMnozstvim', 'int', true)->setNewValue($this->souhlasDodaneMnozstvi);

        $rec->insertRecord();
    }

    /**
     * @param Database $database
     * @throws DBException
     */
    public function aktualizujRadek($database)
    {
        $rec = new RonPortalDBRecord($database, 'RadekVydaneObjednavky');
        $rec->logDescription = StringUtils::fromUTF8('Vydaná objednávka');

        $params = $database->createParameters();

        $rec->addField('cisloVydaneObjednavky', '', true, 20);
        $rec->addField('radekVydaneObjednavky', 'float', true);

        if (isset($this->kodZbozi)) {
            $rec->addField('kodZbozi', '', true, 30)->setNewValue($this->kodZbozi);
        }
        $rec->addField('popis', '', true, 60)->setNewValue($this->popis);
        $rec->addField('pokracovaniPopisu', 'memo', true)->setNewValue($this->rozsirenyPopis);
        $rec->addField('mnozstvi', 'float', true)->setNewValue($this->mnozstvi);
        $rec->addField('dodanoMnozstvi', 'float', true)->setNewValue($this->dodanoMnozstvi);
        $rec->addField('cenaZaJednotku', 'float', true)->setNewValue($this->cenaZaJednotku);
        $rec->addField('predpokladaneDatumDodani', 'timestamp', true)->setNewValue($this->predpokladaneDatumDodani);
        $rec->addField('souhlasSDodanymMnozstvim', 'int', true)->setNewValue($this->souhlasDodaneMnozstvi);

        $rec->setWhere("cisloVydaneObjednavky = " . $params->addParameter($this->cisloObjednavky) . " AND radekVydaneObjednavky = " . $params->addParameter($this->cisloRadku), $params);

        if ($this->smazat) {
            $rec->deleteRecord();
        }

        $rec->updateOrInsert();
    }

    /**
     * @param Database $database
     * @param string $cisloOBjednavky
     * @return RadekVydaneObjednavky[]
     * @throws DBException
     */
    public static function nactiRadky($database, $cisloOBjednavky)
    {
        $params = $database->createParameters();

        $sql =
            "SELECT cisloVydaneObjednavky, radekVydaneObjednavky, typZbozi, kodZbozi, popis, {fn_CASTWIDEMEMO(pokracovaniPopisu)}, mnozstvi, " . // 0 - 6
            "   jednotka, dodanoMnozstvi, cenaZaJednotku, {fn_CASTWIDEMEMO(poznamka)}, predpokladaneDatumDodani, souhlasSDodanymMnozstvim " . // 7 - 12
            "FROM RadekVydaneObjednavky " .
            "WHERE cisloVydaneObjednavky = " . $params->addParameter($cisloOBjednavky) .
            " ORDER BY radekVydaneObjednavky";

        $cursor = $database->getSqlResult($sql, $params);

        $radky = [];

        while ($row = $cursor->fetch()) {
            $radek = new static();
            $radek->nactiRadek($database, $row);
            $radky[] = $radek;
        }

        return $radky;
    }
}