<?php
/**
 * stanislav.elbl, 29.07.2015
 */

namespace RonPortal\SluzebniCesty;

use Exception;
use Ron\DateUtils;
use Ron\DB\Database;
use Ron\DB\DBException;
use Ron\DB\DBUtils;
use Ron\DB\SQLUtils;
use Ron\MessageManager;
use Ron\TextManager;
use RonPortal\Obdobi;
use RonPortal\PracovniPomer;
use RonPortal\Prava;
use RonPortal\RonPortalDBRecord;
use RonPortal\RonPortalSettings;
use RonPortal\RonPortalXMLEvents;
use RonPortal\System\RecordNotFoundException;
use function Ron\ronText;


class SluzebniCesta
{
    const SETTINGS_UZIVATELSKA1 = 'slcesty_uzivatelska1';
    const SETTINGS_UZIVATELSKA2 = 'slcesty_uzivatelska2';
    const SETTINGS_UZIVATELSKA3 = 'slcesty_uzivatelska3';
    const SETTINGS_UZIVATELSKA4 = 'slcesty_uzivatelska4';
    const SETTINGS_UZIVATELSKA5 = 'slcesty_uzivatelska5';
    const SETTINGS_ZACATEK = 'zacatekslcesty';
    const SETTINGS_ZACATEK_NEMENIT = 'zacatekslcesty_nemenit';
    const SETTINGS_NEPOCITAT_ZAKLADNI_SAZBU = 'nepocitatzakladnisazbu';
    const SETTINGS_NEPOCITAT_ZS_NEMENIT = 'nepocitatzakladnisazbuzakazat';
    const SETTINGS_TYP_ROZDELENI_PRO_STAT = 'statslcesty_podletypurozdeleni';
    const SETTINGS_KONTROLA_DOKUMENTU = 'kontroladokumentunvv';             // 0=nekontrolovat, 1=jen kdyz je NVV, 2=dokument musi byt vzdy
    const SETTINGS_EDITACE_SCHVALENYCH = 'editaceschvalenychsc';
    /** @deprecated */
    const SETTINGS_EDITACE_V_UZAVRENEM = 'editacesluzebnichvuzavrenem';
    const SETTINGS_NESCHVALOVAT_ZAMESTNANCEM = 'neschvalovatsluzebnizam';
    /** @deprecated */
    const SETTINGS_EDITACE_SCHVALENE_NADRIZENYM = 'editacesc_schvalnad';    // jestli je mozne editovat SC schvalenou nadrizenym
    const SETTINGS_POSLOUPNOST_SCHVALOVANI = 'sc_posloupnostschvalovani';
    const SETTINGS_KOMPAKTNI_RADKY = 'kompaktniradkysc';
    const SETTINGS_CASY_PODLE_RADKU = 'casyscpodleradku';
    const SETTINGS_ZNAMENKO_UCTOVANI = 'znamenkouctovanisc';
    const SETTINGS_ZADAVAT_DATUM_KURZU =  'zadavatdatumkurzusc';
    const SETTINGS_PRENASET_DO_DOCHAZKY =  'prenasetsluzebnicesty';
    const SETTINGS_TYP_ROZDELENI = 'typrozdelenisc';
    const SETTINGS_ROZDELENI_POUZE_VLASTNI = 'rozdelenisc_pouzevlastni';
    const SETTINGS_ROZDELENI_VYCHOZI = 'rozdelenisc_vychozihodnota';
    const SETTINGS_TYP_ROZDELENI2 = 'typrozdelenisc2';
    const SETTINGS_TYP_ROZDELENI2Z = 'typrozdelenisc2_zahranicni';
    const SETTINGS_ROZDELENI2_POUZE_VLASTNI = 'rozdelenisc2_pouzevlastni';
    const SETTINGS_ROZDELENI_POVOLIT_VYBER = 'rozdelenisc_povolitprirazeni';
    const SETTINGS_VYPOCET_VZDALENOSTI = 'povolitvypocetvzdalenosti';
    const SETTINGS_ZADAVAT_DPH = 'zadavatdph_sc';
    const SETTINGS_STAT = 'statslcesty';

    public $id;

    /** @var PracovniPomer */
    public $f_PP;

    public $datumCasOd;
    /** @var string     Pro formular */
    public $datumOdStr;
    public $casOdStr;

    public $datumCasDo;
    public $datumDoStr;
    public $casDoStr;

    public $zahranicni;
    public $datumKurzu;
    public $datumKurzuStr;
    public $sazbaKapesneho;
    public $sazbaKapesnehoStr;

    public $prenasetDoDochazky;
    public $typPrenosuDoDochazky;
    public $pocatekKonecPodleRadku;

    public $popis;
    public $poznamka;

    public $uzivatelska1;
    public $uzivatelska2;
    public $uzivatelska3;
    public $uzivatelska4;
    public $uzivatelska5;

    public $ucel;
    public $ucelPopis; // lookup

    public $cilovyStat;
    public $cilovyStatPopis;
    /** @var string     vychozi stat - urcuje legislativu */
    public $f_stat;

    public $mistoZacatku;
    /** @var string     lookup podle mistoZacatku */
    public $mistoZacatkuPopis;
    /** @var string     zadano uzivatelem */
    public $popisZacatku;

    public $cil;
    /** @var string     lookup podle pole cil */
    public $cilPopis;
    /** @var string     popis zadany uzivatelem */
    public $popisCile;
    /** @var string     prujezdni mista */
    public $pres;

    public $kodTypuRozdeleni;
    public $rozdeleni;

    public $kodTypuRozdeleni2;
    public $rozdeleni2;

    public $dopravniProstredek;
    public $popisDopravnihoProstredku;
    public $registracniZnacka;
    public $popisVozidla;
    public $spotrebaVozidla;
    public $phmVozidla;

    public $schvalenoZamestnancem;
    public $sz_uzivatel;
    public $sz_datumcas;
    public $schvalenoNadrizenym;
    public $sn_uzivatel;
    public $sn_datumcas;
    public $schvalenoNadrizenym2;
    public $sn2_uzivatel;
    public $sn2_datumcas;
    public $schvalenoNadrizenym3;
    public $sn3_uzivatel;
    public $sn3_datumcas;
    public $schvalenoNadrizenym4;
    public $sn4_uzivatel;
    public $sn4_datumcas;

    public $schvaleni1;
    public $schvalil1;
    public $schvaleni2;
    public $schvalil2;
    public $schvaleni3;
    public $schvalil3;
    public $schvaleni4;
    public $schvalil4;
    public $datumVraceni1;
    public $datumVraceni2;
    public $datumVraceni3;
    //public $datumVraceni4;
    public $poznamkaKVraceni;

    /** @var float */
    public $vyuctovani;
    /** @var string */
    public $menaVyuctovani;
    /** @var int        Priznak, ze je zauctovana */
    public $zauctovano;
    public $zauctovanoStr;

    /** @var int        Ciselnik zpusobu vyplaceni */
    public $vyplatitHotove;
    /** @var string     Z tabulky S_ZpusobVyuctovaniSC */
    public $vyplatitHotoveStr;
    /** @var string */
    public $menaProVyplaceni;

    public $pozadovanaZaloha;
    public $pozadovanaZalohaHotovost;
    public $pozadovanaZalohaHotovostMena;
    public $pozadovanaZalohaUcet;
    public $pozadovanaZalohaUcetMena;
    public $pozadovanaZalohaIBAN;
    public $pozadovanaZalohaSWIFT;

    public $cisloUctuProZalohu;
    public $menaUctuProZalohu;

    public $urceneDenniStravne;
    public $urceneDenniStravneMena;
    public $urceneKapesne;
    public $urceneKapesneMena;

    public $historieSchvalovani;

    /** @var bool       Priznak, jestli je mozne s.cestu editovat. Pri inicializaci se nastavuje na false! */
    public $lzeEditovat;

    function __construct()
    {
        $this ->lzeEditovat = false;
    }


    /**
     * @param Database $database
     * @param int $id
     * @return array|bool|null
     * @throws DBException
     * @throws Exception
     */
    private static function vratHlavicku($database, $id)
    {
        $id = (int)$id;
        //if (!$id) return false;

        $params = $database ->createParameters();

        $sql =
            'SELECT RC, OsobniCislo, DatumNastupu, ' . // 0..2
            '    DatumCasOd, DatumCasDo, Stat.Popis, ' . // 3,4,5
            '    SluzebniCesta.Popis, ' . $database ->castWideMemo('SluzebniCesta.Poznamka') . ', ' . // 6,7
            '    MistoSluzebniCesty.Popis, UcelSluzebniCesty.Popis, ' . // 8,9
            '    Schvaleni1, Schvalil1, Schvaleni2, Schvalil2, Schvaleni3, Schvalil3, ' . // 10..15
            '    SluzebniCesta.Id, MZ.Popis, ' . // 16,17
            '    VlastniVozidlo, PopisMistaZacatku, PopisCile, ' . // 18..20
            '    RadekUctovaniSCesty.Castka, ' . // 21
            $database ->castWideMemo('HistorieSchvalovani') . ', SluzebniCesta.Pres, ' . // 22,23
            '    SluzebniCesta.Zauctovano, SluzebniCesta.Zauctovano_Uzivatel, SluzebniCesta.Zauctovano_DatumCas, ' . // 24-26
            '    SluzebniCesta.Uzivatelska1, SluzebniCesta.Uzivatelska2, SluzebniCesta.Uzivatelska3, SluzebniCesta.Uzivatelska4, SluzebniCesta.Uzivatelska5, ' . // 27-31
            '    SluzebniCesta.SchvalenoZamestnancem, SluzebniCesta.SZ_Uzivatel, SluzebniCesta.SZ_DatumCas, ' . //32..34
            '    SluzebniCesta.SchvalenoNadrizenym, SluzebniCesta.SN_Uzivatel, SluzebniCesta.SN_DatumCas, ' . // 35..37
            '    SluzebniCesta.DatumKurzu, SluzebniCesta.SazbaKapesneho, SluzebniCesta.PrenasetDoDochazky, SluzebniCesta.TypPrenosuDoDochazky,  ' . // 38..41
            '    SluzebniCesta.Ucel, SluzebniCesta.MistoZacatku, SluzebniCesta.Cil, SluzebniCesta.DopravniProstredek, SluzebniCesta.CilovyStat, '. // 42..46
            // rozdeleni
            'SluzebniCesta.Zahranicni, SluzebniCesta.KodTypuRozdeleni, SluzebniCesta.Rozdeleni, ' . // 47..49
            'SluzebniCesta.KodTypuRozdeleni2, SluzebniCesta.Rozdeleni2, ' . // 50..51
            // ucetni zalezitosti
            '    SluzebniCesta.PozadovanaZaloha, SluzebniCesta.PozadovanaZalohaHotovost, SluzebniCesta.PozadovanaZalohaHotMena, ' . // 52..54
            '    SluzebniCesta.PozadovanaZalohaUcet, SluzebniCesta.PozadovanaZalohaUcetMena, SluzebniCesta.CisloUctuProZalohu, SluzebniCesta.MenaUctuProZalohu, ' . // 55..58
            '    SluzebniCesta.UrceneDenniStravne, SluzebniCesta.UrceneDenniStravneMena, SluzebniCesta.UrceneKapesne, SluzebniCesta.UrceneKapesneMena, ' . // 59..62
            '    SluzebniCesta.Stat, ' . // 63 - vychozi stat (pro legislativu)
            '    SluzebniCesta.SchvalenoNadrizenym2, SluzebniCesta.SN2_Uzivatel, SluzebniCesta.SN2_DatumCas,' . // 64..66
            '    Schvaleni4, Schvalil4, SluzebniCesta.RegistracniZnacka, Vozidlo.Popis,' . // 67..70
            '    SluzebniCesta.DatumVraceni1, SluzebniCesta.DatumVraceni2, SluzebniCesta.DatumVraceni3, SluzebniCesta.DatumVraceni4,' . // 71..74  ? ma datumvraceni4 smysl?
            '    SluzebniCesta.SchvalenoNadrizenym3, SluzebniCesta.SN3_Uzivatel, SluzebniCesta.SN3_DatumCas,' . // 75..77
            '    SluzebniCesta.SchvalenoNadrizenym4, SluzebniCesta.SN4_Uzivatel, SluzebniCesta.SN4_DatumCas,' . // 78..80
            '    SluzebniCesta.PoznamkaKVraceni,' . // 81
            '    Vozidlo.DruhPHM, Vozidlo.Spotreba,' . // 82,83
            '    SluzebniCesta.PocatekKonecPodleRadku, RadekUctovaniSCesty.KodMeny,' . // 84,85
            '    SluzebniCesta.IBANUctuProZalohu, SluzebniCesta.SWIFTUctuProZalohu,' . // 86,87
            '    SluzebniCesta.VyplatitHotove, ZV.Popis, SluzebniCesta.ManaProVyplaceni,' . // 88..90
            // dalsi
            '    DopravniProstredek.Popis' . // 91

            ' FROM SluzebniCesta LEFT OUTER JOIN Stat' .
            '            ON Stat.Kod = SluzebniCesta.CilovyStat' .
            '          LEFT OUTER JOIN MistoSluzebniCesty' .
            '          ON MistoSluzebniCesty.Kod = SluzebniCesta.Cil' .
            '        LEFT OUTER JOIN MistoSluzebniCesty MZ' .
            '        ON MZ.Kod = SluzebniCesta.MistoZacatku' .
            '      LEFT OUTER JOIN UcelSluzebniCesty' .
            '      ON UcelSluzebniCesty.Kod = SluzebniCesta.Ucel' .
            '    LEFT OUTER JOIN RadekUctovaniSCesty' .
            '    ON RadekUctovaniSCesty.SluzebniCesta_Id = SluzebniCesta.Id' .
            '    AND RadekUctovaniSCesty.Typ = 3' .
            '  LEFT OUTER JOIN Vozidlo' .
            '  ON Vozidlo.RegistracniZnacka = SluzebniCesta.RegistracniZnacka' .
            '  LEFT OUTER JOIN S_ZpusobVyuctovaniSC ZV' .
            '  ON ZV.Kod = SluzebniCesta.VyplatitHotove' .
            '  LEFT OUTER JOIN DopravniProstredek' .
            '  ON DopravniProstredek.Kod = SluzebniCesta.DopravniProstredek' .

            ' WHERE SluzebniCesta.Id = ' . $params ->addParameter($id);

        MessageManager::addDebugLog($sql);

        $cursor = $database ->getSqlResult($sql, $params);

        if (!$row = $cursor ->fetch()) {
            throw new RecordNotFoundException('Sluzebni cesta se zadanym ID neexistuje, nebo byla smazana!');
        }

        $cursor ->close();

        return $row;
    }


    /**
     * @param Database $database
     * @param array $row
     * @throws Exception
     */
    private function nactiHlavicku($database, $row)
    {
        $this ->f_PP = new PracovniPomer();
        if (!$this ->f_PP ->nactiPPPodleRC($database, $row[0], $row[1], $database ->stringToTimestamp($row[2]))) {
            throw new Exception('Nenalezen pracovni pomer ke sluzebni ceste!');
        }

        $this ->id = $row[16];

        $this ->datumCasOd = $database ->stringToTimestamp($row[3]);
        $this -> datumOdStr = date('j.n.Y', $this ->datumCasOd);
        $this -> casOdStr = date('G:i', $this ->datumCasOd);

        $this ->datumCasDo = $database ->stringToTimestamp($row[4]);
        $this -> datumDoStr = date('j.n.Y', $this ->datumCasDo);
        $this -> casDoStr = date('G:i', $this ->datumCasDo);


        $this ->popis = $row[6];
        $this ->poznamka = $row[7];
        $this ->uzivatelska1 = $row[27];
        $this ->uzivatelska2 = $row[28];
        $this ->uzivatelska3 = $row[29];
        $this ->uzivatelska4 = $row[30];
        $this ->uzivatelska5 = $row[31];

        $this ->ucel = $row[42];
        $this ->ucelPopis = $row[9]; // lookup

        $this ->cilovyStat = $row[46]; // lookup
        $this ->cilovyStatPopis = TextManager::_('db_stat_popis_' . $row[46], $row[5]); // lookup
        $this ->mistoZacatku = $row[43];
        $this ->mistoZacatkuPopis = $row[43] ? TextManager::_('db_mistosluzebnicesty_popis_' . $row[43], $row[17]) : null;
        $this ->popisZacatku = $row[19]; // zadano uzivatelem
        $this ->cil = $row[44];
        //$this ->cilPopis = $row[8];
        $this ->cilPopis = $row[44] ? TextManager::_('db_mistosluzebnicesty_popis_' . $row[44], $row[8]) : null;
        $this ->popisCile = $row[20]; // popis zadany uzivatelem
        $this ->pres = $row[23];

        $this ->dopravniProstredek = $row[45];
        $this ->popisDopravnihoProstredku = $row[91];
        $this ->registracniZnacka = $row[69];
        $this ->popisVozidla = $row[70];
        $this ->phmVozidla = $row[82];
        $this ->spotrebaVozidla = isset($row[83]) ? (float)$row[83] : null;

        $this ->kodTypuRozdeleni = $row[48];
        $this ->rozdeleni = $row[49];

        $this ->kodTypuRozdeleni2 = $row[50];
        $this ->rozdeleni2 = $row[51];

        $this ->schvalenoZamestnancem = $row[32];
        $this ->sz_uzivatel = $row[33];
        $this ->sz_datumcas = $database ->stringToTimestamp($row[34]);

        $this ->schvalenoNadrizenym = $row[35];
        $this ->sn_uzivatel = $row[36];
        $this ->sn_datumcas = $database ->stringToTimestamp($row[37]);

        $this ->schvalenoNadrizenym2 = $row[64];
        $this ->sn2_uzivatel = $row[65];
        $this ->sn2_datumcas = $database ->stringToTimestamp($row[66]);

        $this ->schvalenoNadrizenym3 = $row[75];
        $this ->sn3_uzivatel = $row[76];
        $this ->sn3_datumcas = $database ->stringToTimestamp($row[77]);

        $this ->schvalenoNadrizenym4 = $row[78];
        $this ->sn4_uzivatel = $row[79];
        $this ->sn4_datumcas = $database ->stringToTimestamp($row[80]);

        $this ->schvaleni1 = $database ->stringToTimestamp($row[10]);
        $this ->schvalil1 = $row[11];
        $this ->schvaleni2 = $database ->stringToTimestamp($row[12]);
        $this ->schvalil2 = $row[13];
        $this ->schvaleni3 = $database ->stringToTimestamp($row[14]);
        $this ->schvalil3 = $row[15];
        $this ->schvaleni4 = $database ->stringToTimestamp($row[67]);
        $this ->schvalil4 = $row[68];
        $this ->datumVraceni1 = $database ->stringToTimestamp($row[71]);
        $this ->datumVraceni2 = $database ->stringToTimestamp($row[72]);
        $this ->datumVraceni3 = $database ->stringToTimestamp($row[73]);
        // datumVraceni4?
        $this ->poznamkaKVraceni = $row[81];

        $this ->vyuctovani = $row[21];
        $this ->menaVyuctovani = $row[85];

        $this ->zauctovano = $row[24];
        $this ->zauctovanoStr = $this ->zauctovano
            ? ronText('SC_zauctovana') . ' (' . DBUtils::getFormatedValue($database, 'finedatetime', $row[26]) . ', ' . $row[25] . ')'
            : '';

        $this ->historieSchvalovani = $row[22];

        $this ->zahranicni = $row[47];
        $this ->datumKurzu = $database ->stringToTimestamp($row[38]);
        $this ->datumKurzuStr = $this ->datumKurzu ? date('j.n.Y', $this ->datumKurzu) : '';

        $this ->sazbaKapesneho = (float)$row[39];
        $this ->sazbaKapesnehoStr = $this ->sazbaKapesneho ? $this ->sazbaKapesneho : '';

        $this ->prenasetDoDochazky = (int)$row[40];
        $this ->typPrenosuDoDochazky = (int)$row[41];
        $this ->pocatekKonecPodleRadku = (int)$row[84];

        $this ->pozadovanaZaloha = (int)$row[52];
        $this ->pozadovanaZalohaHotovost = $row[53];
        $this ->pozadovanaZalohaHotovostMena = $row[54];
        $this ->pozadovanaZalohaUcet = $row[55];
        $this ->pozadovanaZalohaUcetMena = $row[56];
        $this ->pozadovanaZalohaIBAN = $row[86];
        $this ->pozadovanaZalohaSWIFT = $row[87];

        $this ->cisloUctuProZalohu = $row[57];
        $this ->menaUctuProZalohu = $row[58];

        $this ->urceneDenniStravne = $row[59];
        $this ->urceneDenniStravneMena = $row[60];
        $this ->urceneKapesne = $row[61];
        $this ->urceneKapesneMena = $row[62];

        $this ->f_stat = $row[63]; // vychozi stat (pro legislativu)

        $this ->vyplatitHotove = $row[88];
        $this ->vyplatitHotoveStr = $row[89];
        $this ->menaProVyplaceni = $row[90];
    }

    /**
     * Nacte sluzebni cestu se zadanym ID
     * @param Database $database
     * @param int $id
     * @return SluzebniCesta
     * @throws Exception
     */
    public static function nactiSluzebniCestu($database, $id)
    {
        $row = self::vratHlavicku($database, $id);

        $sluzebniCesta = new SluzebniCesta();
        $sluzebniCesta ->nactiHlavicku($database, $row);
        Prava::nastavObdobiProPrava($sluzebniCesta ->datumCasOd, $sluzebniCesta ->datumCasDo);

        return $sluzebniCesta;
    }


    /**
     * Nacte sluzebni cestu se zadanym ID a zkontroluje, jestli ma uzivatel pravo na jeji editaci
     * @param int $id
     * @param bool $editaceHlavicky True, pokud se jedna o editaci hlavicky SC - v tom pripade se kontroluje i schvaleni nadrizeneho
     * @return SluzebniCesta
     * @throws Exception
     */
    public static function nactiSCProEditaci($database, $id)
    {
        $cesta = static::nactiSluzebniCestu($database, $id);
        $cesta->lzeEditovat($database, true); // raise exception = true
//
//        if ($editaceHlavicky) {
//            if (!$cesta->lzeEditovatHlavicku($database)) {
//                throw new \Exception(\Ron\ronText('Sluzebka_je_jiz_schvalena'));
//            };
//        }

        return $cesta;
    }


    /**
     * Vraci true, pokud je SC schvalena zadanym levelem nebo vyssim
     * @param $minimalniLevel
     * @return bool
     */
    function jeSchvalena($minimalniLevel = 1)
    {
        if ($minimalniLevel > 4) return false;

        if ($this ->schvaleni4) {
            return true;
        }

        if ($this ->schvaleni3) {
            return $minimalniLevel <= 3;
        }
        if ($this ->schvaleni2) {
            return $minimalniLevel <= 2;
        }
        if ($this ->schvaleni1) {
            return $minimalniLevel <= 1;
        }

        return false;
    }


    /**
     * @param $database
     * @return void
     * @throws Exception
     * @deprecated
     */
    function loadDefaultValues($database)
    {
// OK
//        $this->predpokladaneNaklady = PredpokladanyVydajSC::nactiPredpokladaneVydaje($database, 0);
//        $this->spolucestujici = [];
//
//        $this->zahranicni = RonPortalSettings::getIntValue('sc_zahranicni');
//        $this->mistoZacatku = RonPortalSettings::getValue(SluzebniCesta::SETTINGS_ZACATEK);
//        $this->datumCasOd = time();
//        $this->datumCasDo = time();
//        $this->datumOdStr = date('j.n.Y', time());
//        $this->datumDoStr = $this->datumOdStr;
    }


    /**
     * POZOR! Kontrola probiha pred vyuctovanim!
     * @param $database
     * @return bool
     * @throws DBException
     */
    function jsouVyplnenePovinne($database)
    {
        // OK
        if (RonPortalSettings::getIntValue(SluzebniCestyUtils::SETTINGS_POVINNY_UCEL) && !$this ->ucel) {
            return MessageManager::addErrorMessage(ronText('Neni_zadan_ucel_sc'), 'Ucel');
        }

        // OK
        if (!$this ->cil && $this ->ucel && SluzebniCestyUtils::jePovinnyCilProUcel($database, $this ->ucel)) {
            return MessageManager::addErrorMessage(ronText('Neni_zadan_cil_sc'), 'Cil');
        }

        return true;
    }


    /**
     * @param $kodPrava
     * @return bool
     * @throws Exception
     */
    public function jePravoNaSluzebniCestu($kodPrava)
    {
        return SluzebniCestyUtils::jePravoNaSluzebniCestu($kodPrava,
            $this ->f_PP ->idPP, $this ->zahranicni,
            $this ->datumCasOd, $this ->datumCasDo);
    }

    /**
     * Vraci true, pokud ma uzivatel pravo na zobrazeni sluzebni cesty (tj. ma kterekoliv pravo, ktere se sluzebnich cest tyka)
     * @return boolean
     * @throws Exception
     */
    function lzeZobrazitSluzebniCestu()
    {
        return SluzebniCestyUtils::jePravoNaSlCestuZamestnance(
            $this ->f_PP ->idPP, $this ->zahranicni,
            $this ->datumCasOd, $this ->datumCasDo);
    }


    /**
     * Vraci true, pokud je sluzebni cesta schvalena nejvyssi urovni, na kterou ma uzivatel pravo, nebo vyssi urovni
     * @return bool
     */
    function jeSchvalenaProUzivatele()
    {
        if ( !RonPortalSettings::getIntValue(self::SETTINGS_EDITACE_SCHVALENYCH, 1) ) {
            // nelze editovat schvalene - jakakoliv uroven zamyka editaci
            return $this ->schvaleni1 || $this ->schvaleni2 || $this ->schvaleni3 || $this ->schvaleni4;
        }

        if ($this ->schvaleni4) {
            // nejvyssi uroven zamyka vzdy
            return true;
        }

        if ($this ->jePravoNaSluzebniCestu('slcesty_schval4')) {
            // ma pravo na uroven 4
            return false;
        }

        if ($this ->schvaleni3) {
            return true;
        }

        //if ($this ->f_PP ->lzeZobrazitPP(Prava::vratPrava('slcesty_schval3'), $this ->datumCasOd, $this ->datumCasDo)) {
        if ($this ->jePravoNaSluzebniCestu('slcesty_schval3')) {
            // ma pravo na uroven 3
            return false;
        }

        if ($this ->schvaleni2) {
            return true;
        }

        //if ($this ->f_PP ->lzeZobrazitPP(Prava::vratPrava('slcesty_schval2'), $this ->datumCasOd, $this ->datumCasDo)) {
        if ($this ->jePravoNaSluzebniCestu('slcesty_schval2')) {
            // ma pravo na uroven 2
            return false;
        }

        return $this ->schvaleni1;
    }


    /**
     * Overi, jestli muze uzivatel zadanou sluzebni cestu editovat.
     * @param Database $database
     * @param bool $raise    Pokud je true, tak v pripade nemoznosti editovat vyhodi vyjimku, jinak vraci false
     * @return bool
     * @throws Exception
     */
    function lzeEditovat($database, $raise)
    {
        // kontrola zauctovani - nelze editovat zauctovane
        if ($this ->zauctovano) {
            if ($raise) {
                throw new Exception( ronText('Sluzebka_je_jiz_zauctovana') );
            }

            return false;
        }

        // kontrola schvaleni (nelze editovat schvalene, ale pokud mam pravo na vyssi uroven, tak muzu)
        $schvalena = $this ->jeSchvalenaProUzivatele();

        if ($schvalena) {
            if ($raise) {
                throw new Exception( ronText('Sluzebka_je_jiz_schvalena') );
            }

            return false;
        }

        // kontrola uzavreneho obdobi
        if (!RonPortalSettings::getIntValue(SluzebniCestyUtils::SETTINGS_EDITACE_V_UZAVRENEM) && Obdobi::jeObdobiUzavreno($database, 'ADS', $this ->datumCasOd, $this ->datumCasDo)) {
            if ($raise) {
                throw new Exception( ronText('Obdobi_uzavreno') );
            }

            return false;
        }

        // kontrola prav
        if (!$this ->jePravoNaSluzebniCestu('sluzebnicesty')) {
            if ($raise) {
                throw new Exception( ronText('Neni_pravo_editovat_sc') );
            }

            return false;
        }

        return true;
    }


    /**
     * POZOR! Kontroluje jen blokovani SC schvalene nadrizenym! Je nutne zaroven zkontrolovat lzeEditovat()
     * @return bool
     */
    function lzeEditovatHlavicku()
    {
        if (!$this ->schvalenoNadrizenym) {
            // jeste neni schvalena nadrizenym
            return true;
        }

        if (RonPortalSettings::getIntValue(self::SETTINGS_EDITACE_SCHVALENE_NADRIZENYM, 1)) {
            // editace sluzebni cesty schvalene nadrizenym je povolena
            return true;
        }

        // sc schvalena nadrizenym - muzu editovat jen kdyz jsem nadrizeny
        return $this ->jePravoNaSluzebniCestu('slcesty_nadriz');
    }


    /**
     * @param Database $database
     * @param bool $showMessages   Pokud je true, zobrazi se chybove hlasky (neni pravo a podobne)
     * @return bool
     */
    function lzeEditovatSluzebniCestu($database, $showMessages)
    {
        try {
            $result = $this->lzeEditovat($database, $showMessages);
        } catch (Exception $e) {
            return MessageManager::addErrorMessage($e ->getMessage());
        }

        return $result;
    }


    /**
     * @param Database $database
     * @param int $zahrnoutCas      Urcuje cas, ktery se ma taky zahrnout do teto SC (pouzije se pri editaci radku SC a automatickem nastavovani zacatku a konce)
     * @throws DBException
     * @throws Exception
     */
    function zkontrolujPrekryvaniSC($database, $zahrnoutCas = null)
    {
        SluzebniCestyUtils::kontrolaPrekryvaniSC($database, $this ->f_PP ->rc, $this ->datumCasOd, $this ->datumCasDo, $this ->id, $zahrnoutCas);
//        $params = $database ->createParameters();
//        $sql =
//            'SELECT DatumCasOd, DatumCasDo' .
//            ' FROM SluzebniCesta' .
//            ' WHERE RC = ' . $params ->addParameter($this ->f_PP ->rc) .
//            ' AND Id <> ' . $params ->addParameter((int)$this ->id ?: 0);
//
//        $casOd = $this ->datumCasOd;
//        $casDo = $this ->datumCasDo;
//
//        if ($zahrnoutCas) {
//            if ($zahrnoutCas < $casOd) {
//                $casOd = $zahrnoutCas;
//            }
//
//            if ($zahrnoutCas > $casDo) {
//                $casDo = $zahrnoutCas;
//            }
//        }
//
//        if (RonPortalSettings::getIntValue(self::SETTINGS_CASY_AUTOMATICKY)  &&  $casOd == $casDo) {
//            // casy se nastavuji automaticky a sluzebni cesta jeste nema nastaven cas
//            // => nekontroluje se prekryvani s SC, ktere zacinaji nebo konci ve stejny den
//            //    protoze po nastaveni casu se prekryvat nemusi
//            $sql .=
//                ' AND DatumCasOd < ' . $params->addParameter($database ->dateToParam($casDo)) .
//                ' AND DatumCasDo >= ' . $params->addParameter($database ->dateToParam(DateUtils::incDay($casOd, 1)));
//
//        } else {
//            $sql .=
//                ' AND DatumCasOd < ' . $params->addParameter($database ->timestampToParam($casDo)) .
//                ' AND DatumCasDo > ' . $params->addParameter($database ->timestampToParam($casOd));
//        }
//
//        $cursor = $database ->getSqlResult($sql, $params);
//        $row = $cursor ->fetch();
//        $cursor ->close();
//
//        if ($row) {
//            throw new Exception( ronText('Chyba_prekryvani_SC') );
//        }
    }


    /**
     * @param Database $database
     * @return bool
     * @throws Exception
     * @deprecated
     */
    function lzeVlozitSluzebniCestu($database)
    {
//        // kontrola uzavreneho obdobi
//        if (!RonPortalSettings::getIntValue(self::SETTINGS_EDITACE_V_UZAVRENEM)  &&  Obdobi::jeObdobiUzavreno($database, 'ADS', $this ->datumCasOd, $this ->datumCasDo)) {
//            return MessageManager::addErrorMessage( ronText('Obdobi_uzavreno'));
//        }
//
//        $pocetDnu = RonPortalSettings::getIntValue(self::SETTINGS_VKLADANI_POCET_DNU);
//        if ( $pocetDnu  &&  DateUtils::incDay($this ->datumCasOd, $pocetDnu) < DateUtils::startOfTheDay(time()) ) {
//            return MessageManager::addErrorMessage(sprintf( ronText('Nelze_vkladat_stare_sc'), $pocetDnu));
//        }
//
//        // kontrola prav - OK
//        if (!$this ->jePravoNaSluzebniCestu('sluzebnicesty')) {
//            return MessageManager::addErrorMessage( ronText('Neni_pravo_editovat_sc') );
//        }
//
//        // kontrola prekryvani
//        try {
//            $this->zkontrolujPrekryvaniSC($database);
//        } catch (Exception $e) {
//            return MessageManager::addErrorMessage($e);
//        }
//
//        return true;
    }


    /**
     * @param Database $database
     * @return bool
     * @throws DBException
     */
    function obsahujeNahrady($database)
    {
        $params = $database ->createParameters();
        $sql =
            'SELECT CisloRadku FROM RadekUctovaniSCesty, TypRUctovaniSlCesty ' .
            ' WHERE SluzebniCesta_ID = ' . $params ->addParameter((int)$this ->id) .
            '   AND TypRUctovaniSlCesty.Kod = RadekUctovaniSCesty.Typ ' .
            '   AND TypRUctovaniSlCesty.NahradaZaVlastniVozidlo = 1';

        $cursor = $database ->getSqlResult($sql, $params);
        $result = !!$cursor ->fetch();
        $cursor ->close();

        return $result;
    }


    /**
     * @param Database $database
     * @return bool
     * @throws DBException
     */
    function obsahujeDokument($database)
    {
        $params = $database ->createParameters();
        $sql =
            'SELECT Id FROM DokumentSluzebniCesty ' .
            ' WHERE SluzebniCesta_ID = ' . $params ->addParameter((int)$this ->id);

        $cursor = $database ->getSqlResult($sql, $params);
        $result = !!$cursor ->fetch();
        $cursor ->close();

        return $result;
    }


    /**
     * @param Database $database
     * @return bool
     * @throws Exception
     */
    function kontrolaPredVyuctovanim($database)
    {
        if (!$this ->jsouVyplnenePovinne($database)) {
            return false;
        }

        if (!RonPortalSettings::getIntValue(self::SETTINGS_KONTROLA_DOKUMENTU)) {
            // kontrola vlozeni dokumentu se neprovadi
            return true;
        }

        if (RonPortalSettings::getIntValue(self::SETTINGS_KONTROLA_DOKUMENTU) == 1  &&  !$this ->obsahujeNahrady($database)) {
            // neni radek NVV => dokument nemusi byt prilozen
            return true;
        }

        if ($this ->obsahujeDokument($database)) {
            return true; // kontrola OK, muze se vyuctovat
        }

        return MessageManager::addErrorText('Nelze_vyuctovat_chybi_dokument');
    }



    function zobrazZkracenouHlavicku()
    {
        require('ronportal/sluzebnicesty/view_zkracena_hlavicka.php');
    }



    function GetMistaProVzdalenost() {
        $startStr = null;
        $cilStr = null;

        switch (RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_VYPOCET_VZDALENOSTI)) {
            case 1 : // prednostne podle lookupu
                $startStr = $this ->mistoZacatkuPopis ?: $this ->popisZacatku; // lookup nebo text
                $cilStr = $this ->cilPopis ?: $this ->popisCile; // lookup nebo text
                break;

            case 2 : // prednostne podle popisu
                $startStr = $this ->popisZacatku ?: $this ->mistoZacatkuPopis; // text nebo lookup
                $cilStr = $this ->popisCile ?: $this ->cilPopis; // text nebo lookup
                break;
        }

        if ($startStr  &&  $cilStr) {
            return [$startStr, $cilStr, $this ->pres];
        }

        return null;
    }


//    /**
//     * Nacte predpokladane naklady zadane uzivatelem. Seznam predpokladanych nakladu jiz musi byt nacten!
//     * @deprecated
//     */
//    function loadPostPredpokladaneNaklady()
//    {
//        foreach ($this ->predpokladaneNaklady as $index => $predpokladanyVydaj) {
//            if ( isset($_POST['PV_PocetDnu_' . $predpokladanyVydaj ->typ])  ||  isset($_POST['PV_Castka_' . $predpokladanyVydaj ->typ]) ) {
//                $pocetStr = $_POST['PV_PocetDnu_' . $predpokladanyVydaj ->typ];
//                $predpokladanyVydaj ->pocetDnu = (trim($pocetStr) === '') ? null : (int)$pocetStr;
//
//                $predpokladanyVydaj ->castkaStr = $_POST['PV_Castka_' . $predpokladanyVydaj ->typ];
//                $predpokladanyVydaj ->castka = (trim($predpokladanyVydaj ->castkaStr) === '')
//                    ? null
//                    : StringUtils::stringToFloat($predpokladanyVydaj ->castkaStr);
//
//                $menaStr = $_POST['PV_Mena_' . $predpokladanyVydaj ->typ];
//                $predpokladanyVydaj ->kodMeny = (trim($menaStr) === '') ? null : $menaStr;
//
//            } else {
//                $predpokladanyVydaj ->castka = null;
//                $predpokladanyVydaj ->castkaStr = '';
//                $predpokladanyVydaj ->pocetDnu = null;
//                $predpokladanyVydaj ->kodMeny = null;
//            }
//        }
//    }


//    /**
//     * @throws Exception
//     */
//    function zkontrolujZadaneUdaje($database)
//    {
//        // Provede kontroly
//        // kontrola formatu casu
//        try {
//            $datumOd = DateUtils::dateStringToTimestamp($this->datumOdStr);
//        } catch (Exception $e) {
//            return MessageManager::addErrorMessage(ronText('Bad_date_format') . " (" . ronText('Zacatek') . ")", 'DatumCasOd');
//        }

//        if ( !RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_CASY_AUTOMATICKY) ) {
//            try {
//                $datumOd = DateUtils::timeStringToTimestamp($this->casOdStr, $datumOd);
//            } catch (Exception $e) {
//                return MessageManager::addErrorMessage(ronText('Bad_time_format') . ' (' . ronText('Zacatek') . ')');
//            }
//        }

//        $pocetDnu = RonPortalSettings::getIntValue(self::SETTINGS_VKLADANI_POCET_DNU);
//        if ( $pocetDnu  &&   DateUtils::startOfTheDay($datumOd) != DateUtils::startOfTheDay($this ->datumCasOd) ) {
//            // je zakazano vkladat stare SC - zkontroluje, jestli uzivatel neposunul datum (z nebo do obdobi pred ...)
//            $pomDatum = $datumOd;
//            if ($this ->datumCasOd  &&  $this ->datumCasOd < $pomDatum) $pomDatum = $this ->datumCasOd;
//
//            if (DateUtils::incDay($pomDatum, $pocetDnu) < DateUtils::startOfTheDay(time()) ) {
//                return MessageManager::addErrorMessage( sprintf(ronText('Nelze_editovat_zacatek_sc'), $pocetDnu), 'DatumCasOd' );
//            }
//        }
//
//        $this ->datumCasOd = $datumOd;

//        try {
//            $datumDo = DateUtils::dateStringToTimestamp($this->datumDoStr);
//        } catch (Exception $e) {
//            return MessageManager::addErrorMessage(ronText('Bad_date_format') . ' (' . ronText('Konec') . ")", 'DatumCasDo');
//        }

//        if ( !RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_CASY_AUTOMATICKY) ) {
//            try {
//                $datumDo = DateUtils::timeStringToTimestamp($this->casDoStr, $datumDo);
//            } catch (Exception $e) {
//                return MessageManager::addErrorMessage(ronText('Bad_time_format') . ' (' . ronText('Konec') . ')');
//            }
//        }
//        $this ->datumCasDo = $datumDo;

//        if ($datumDo < $datumOd) {
//            return MessageManager::addErrorMessage( ronText('Pocatecni_datum_vetsi_nez_koncove'), 'DatumCasDo');
//        }

//        if (!RonPortalSettings::getIntValue(self::SETTINGS_EDITACE_V_UZAVRENEM)  &&  Obdobi::jeObdobiUzavreno($database, 'ADS', $datumOd, $datumDo)) {
//            return MessageManager::addErrorMessage( ronText('Obdobi_uzavreno') );
//        }

//        Prava::nastavObdobiProPrava($datumOd, $datumDo);
//
//        if (!$this ->f_PP ->vyberNactenyPP($database, Prava::vratPrava('sluzebnicesty', $this ->zahranicni ? 'sluzebnicesty_Z' : null))) {
//            return MessageManager::getInstance() ->addError( ronText('Nemate_pravo') );
//        }

//        if ( RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_ZADAVAT_DATUM_KURZU, 1) ) {
//            if ($this ->datumKurzuStr) {
//                try {
//                    $this->datumKurzu = DateUtils::dateStringToTimestamp($this->datumKurzuStr);
//                } catch (Exception $e) {
//                    return MessageManager::addErrorMessage( ronText('Bad_date_format'), 'DatumKurzu');
//                }
//            }
//            else {
//                $this ->datumKurzu = null;
//            }
//        }
//
//        //return MessageManager::addErrorMessage( 'Povinny: ' . RonPortalSettings::getIntValue('povinnypopisslcesty'));
//        if (RonPortalSettings::getIntValue('povinnypopisslcesty')  &&  !$this ->popis) {
//            return MessageManager::addErrorMessage( ronText('Neni_zadan_popis_sc'), 'Popis' );
//        }

//        if (RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_ROZDELENI_POVINNE) && !isset($this ->rozdeleni)) {
//            return MessageManager::addErrorMessage( ronText('Neni_zadano_rozdeleni_sc'), 'Rozdeleni' );
//        }

//        if (RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_MENIT_SAZBU_KAPESNEHO)) {
//            if ($this ->sazbaKapesnehoStr != '') {
//                if (!StringUtils::isFloat($this ->sazbaKapesnehoStr)) {
//                    return MessageManager::addErrorMessage(ronText('Spatna_hodnota_pro') . ronText('Sazba_kapesneho'), 'SazbaKapesneho');
//                }
//                else $this ->sazbaKapesneho = StringUtils::stringToFloat($this ->sazbaKapesnehoStr);
//            }
//            else $this ->sazbaKapesneho = 0;
//        }
//        else if (RonPortalSettings::getIntValue('sazbakapesnehopodlestatu')) {
//            // nacte sazbu kapesneho podle ciloveho statu
//
//        }
//        else $this ->sazbaKapesneho = 0;

//        // zkontroluje, jestli jsou vyplnene vsechny povinne udaje
//        if (!SluzebniCestyUtils::getVychoziStatOsoby($database, $this ->f_PP, $this ->datumCasOd)) {
//            if (!$this ->f_stat) return MessageManager::addErrorMessage(ronText('Neni_zadan_stat'), 'Stat');
//        }

//        if (RonPortalSettings::getIntValue(self::SETTINGS_POVINNY_UCEL) && !$this ->ucel) {
//            return MessageManager::addErrorMessage(ronText('Neni_zadan_ucel_sc'), 'Ucel');
//        }

//        if (!$this ->cil) {
//            // cil neni zadan - zjisti, jestli je pro zadany ucel povinny a pripadne zobrazi chybu
//            if (SluzebniCesta::jePovinnyCilProUcel($database, $this ->ucel)) {
//                return MessageManager::addErrorMessage(ronText('Neni_zadan_cil_sc'), 'Cil');
//            }
//        }

//        try {
//            $this->zkontrolujPrekryvaniSC($database);
//        } catch (Exception $e) {
//            return MessageManager::addErrorMessage($e, 'DatumCasOd');
//        }

//        return true;
//    }


//    /**
//     * @param Database $database
//     * @return bool
//     * @throws DBException
//     */
//    function loadPost($database)
//    {
//        Prava::nastavObdobiProPrava(time(), time());

        // Nacte data z POST
//        $this ->id = $_POST['Id'];
//
//        $this ->zahranicni = isset($_POST['Zahranicni']) && $_POST['Zahranicni'];
//
//        $this ->datumOdStr = $_POST['DatumCasOd'];
//        if (!RonPortalSettings::getIntValue(self::SETTINGS_CASY_AUTOMATICKY)) {
//            $this ->casOdStr = $_POST['DatumCasOd_time'];
//        }
//
//        $this ->datumDoStr = $_POST['DatumCasDo'];
//        if (!RonPortalSettings::getIntValue(self::SETTINGS_CASY_AUTOMATICKY)) {
//            $this ->casDoStr = $_POST['DatumCasDo_time'];
//        }
//
//
//        if (!RonPortalSettings::getValue(self::SETTINGS_STAT)) {
//            $this ->f_stat = $_POST['Stat'];
//        }
//
//        if (  RonPortalSettings::getIntValue(self::SETTINGS_ZACATEK_NEMENIT) ) {
//            $this ->mistoZacatku = RonPortalSettings::getValue(self::SETTINGS_ZACATEK);
//        }
//        else {
//            $this ->mistoZacatku = $_POST['MistoZacatku'];
//        }

//        $this ->popisZacatku = $_POST['PopisMistaZacatku'];
//        $this ->cil = $_POST['Cil'];
//        $this ->popisCile = $_POST['PopisCile'];
//        $this ->pres = $_POST['Pres'];

//        if ($this ->zahranicni) {
//            $this ->cilovyStat = $_POST['CilovyStat'];
//        }
//        else {
//            // neni zahranicni => nastavi se stejne jako vychozi
//            $this ->cilovyStat = $this ->f_stat;
//        }

//        if (trim($this ->cilovyStat) === '') {
//            $this ->cilovyStat = null;
//        } else {
//            $params = $database ->createParameters();
//            $this ->cilovyStatPopis = DBUtils::getSqlValue($database,
//                'SELECT Popis FROM Stat WHERE Kod = ' . $params ->addParameter($this ->cilovyStat),
//                $params);
//
//            $this ->cilovyStatPopis = TextManager::_('db_stat_popis_' . $this ->cilovyStat, $this ->cilovyStatPopis);
//        }

//        if ( RonPortalSettings::getIntValue(self::SETTINGS_TYP_ROZDELENI) ) {
//            $this ->rozdeleni = $_POST['Rozdeleni'];
//            if ( isset($this ->rozdeleni)  &&  $this ->rozdeleni != '') {
//                $this ->kodTypuRozdeleni = RonPortalSettings::getIntValue(self::SETTINGS_TYP_ROZDELENI);
//            }
//            else {
//                $this ->rozdeleni = null;
//                $this ->kodTypuRozdeleni = null;
//            }
//        }

//        // rozdeleni 2 - muze byt ruzny typ rozdeleni pro tuzemske a zahranicni!
//        if (  RonPortalSettings::getIntValue(self::SETTINGS_TYP_ROZDELENI2)  &&  (!$this ->zahranicni  ||  RonPortalSettings::getIntValue(self::SETTINGS_TYP_ROZDELENI2) == RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_TYP_ROZDELENI2Z))  ) {
//            // sluzebni cesta neni zahranicni, nebo se pouziva pro zahranicni SC stejny typ rozdeleni jako pro tuzemske
//            $this ->rozdeleni2 = $_POST['Rozdeleni2'] != '' ? $_POST['Rozdeleni2'] : null;
//            if ( isset($this ->rozdeleni2)  &&  $this ->rozdeleni2 != '') {
//                $this ->kodTypuRozdeleni2 = RonPortalSettings::getIntValue(self::SETTINGS_TYP_ROZDELENI2);
//            }
//            else {
//                $this ->rozdeleni2 = null;
//                $this ->kodTypuRozdeleni2 = null;
//            }
//        }
//        else if ( RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_TYP_ROZDELENI2Z)  &&  $this ->zahranicni ) {
//            // sluzebni cesta je zahranicni a pouziva se jiny typ rozdeleni
//            $this ->rozdeleni2 = $_POST['Rozdeleni2Z'];
//            if ( isset($this ->rozdeleni2)  &&  $this ->rozdeleni2 != '') {
//                $this ->kodTypuRozdeleni2 = RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_TYP_ROZDELENI2Z);
//            }
//            else {
//                $this ->rozdeleni2 = null;
//                $this ->kodTypuRozdeleni2 = null;
//            }
//        }

//        $this ->ucel = $_POST['Ucel'];

//        if ( RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_ZADAVAT_DATUM_KURZU, 1) ) {
//            $this ->datumKurzuStr = $_POST['DatumKurzu'] ?? '';
//        }

//        if ( RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_PRENASET_DO_DOCHAZKY, 1) == 1  &&  isset($_POST['TypPrenosuDoDochazky'])) {
//            $this ->prenasetDoDochazky = (int)$_POST['TypPrenosuDoDochazky'] >= 0;
//            if ($this ->prenasetDoDochazky) {
//                $this ->typPrenosuDoDochazky = (int)$_POST['TypPrenosuDoDochazky'];
//            }
//        }

//        if ( RonPortalSettings::getIntValue(self::SETTINGS_CASY_PODLE_RADKU) == -1) {
//            // nastaveni vypoctu podle radku urcuje primo uzivatel
//            $this ->pocatekKonecPodleRadku = (isset($_POST['PocatekKonecPodleRadku'])  &&  $_POST['PocatekKonecPodleRadku']) ? 1 : 0;
//        }

//        $this ->sazbaKapesnehoStr = $_POST['SazbaKapesneho'] ?? '';

//        $this ->popis = $_POST['Popis'];

//        if (RonPortalSettings::getValue(SluzebniCesta::SETTINGS_UZIVATELSKA1)  &&  isset($_POST['Uzivatelska1'])) {
//            $this ->uzivatelska1 = $_POST['Uzivatelska1'];
//        }
//        if (RonPortalSettings::getValue(SluzebniCesta::SETTINGS_UZIVATELSKA2)  &&  isset($_POST['Uzivatelska2'])) {
//            $this ->uzivatelska2 = $_POST['Uzivatelska2'];
//        }
//        if (RonPortalSettings::getValue(SluzebniCesta::SETTINGS_UZIVATELSKA3)  &&  isset($_POST['Uzivatelska3'])) {
//            $this ->uzivatelska3 = $_POST['Uzivatelska3'];
//        }
//        if (RonPortalSettings::getValue(SluzebniCesta::SETTINGS_UZIVATELSKA4)  &&  isset($_POST['Uzivatelska4'])) {
//            $this ->uzivatelska4 = $_POST['Uzivatelska4'];
//        }
//        if (RonPortalSettings::getValue(SluzebniCesta::SETTINGS_UZIVATELSKA5)  &&  isset($_POST['Uzivatelska5'])) {
//            $this ->uzivatelska5 = $_POST['Uzivatelska5'];
//        }

//        if (isset($_POST['DopravniProstredek'])) {
//            $this ->dopravniProstredek = $_POST['DopravniProstredek'];
//        }
//        if (isset($_POST['RegistracniZnacka'])) {
//            $this ->registracniZnacka = $_POST['RegistracniZnacka'] != ''
//                ? $_POST['RegistracniZnacka']
//                : null;
//        }

//        $this ->poznamka = $_POST['Poznamka'];

//        $this ->vyplatitHotove = (int)$_POST['VyplatitHotove'];
//        $this ->menaProVyplaceni = ($_POST['MenaProVyplaceni'] != '')
//            ? $_POST['MenaProVyplaceni']
//            : null;

//        $this ->pozadovanaZaloha = (isset($_POST['PozadovanaZaloha'])  &&  $_POST['PozadovanaZaloha']) ? 1 : 0;
//        $this ->pozadovanaZalohaHotovost = (trim($_POST['PozadovanaZalohaHotovost']) != '')
//            ? StringUtils::stringToFloat($_POST['PozadovanaZalohaHotovost'])
//            : null;
//
//        $this ->pozadovanaZalohaHotovostMena = ($_POST['PozadovanaZalohaHotMena'] != '')
//            ? $_POST['PozadovanaZalohaHotMena']
//            : null;
//
//        $this ->pozadovanaZalohaUcet = (trim($_POST['PozadovanaZalohaUcet']) != '')
//            ? StringUtils::stringToFloat($_POST['PozadovanaZalohaUcet'])
//            : null;
//
//        $this ->pozadovanaZalohaUcetMena = ($_POST['PozadovanaZalohaUcetMena'] != '')
//            ? $_POST['PozadovanaZalohaUcetMena']
//            : null;

//        $this ->pozadovanaZalohaIBAN = ($_POST['PozadovanaZalohaIBAN'] != '')
//            ? $_POST['PozadovanaZalohaIBAN']
//            : null;
//
//        $this ->pozadovanaZalohaSWIFT = ($_POST['PozadovanaZalohaSWIFT'] != '')
//            ? $_POST['PozadovanaZalohaSWIFT']
//            : null;
//
//        $this ->cisloUctuProZalohu = ($_POST['CisloUctuProZalohu'] != '')
//            ? $_POST['CisloUctuProZalohu']
//            : null;
//
//        $this ->menaUctuProZalohu = ($_POST['MenaUctuProZalohu'] != '')
//            ? $_POST['MenaUctuProZalohu']
//            : null;

//        $this ->urceneDenniStravne = null;
//        $this ->urceneDenniStravneMena = null;
//        try {
//            $poma = SluzebniCestyUtils::vratMaximalniDenniStravneProStat($database, $this->datumCasOd, $this->cilovyStat, $this->f_stat);
//
//            if ($poma) {
//                $this ->urceneDenniStravne = $poma['sazba']; // (trim($_POST['UrceneDenniStravne']) != '') ? stringtofloat($_POST['UrceneDenniStravne']) : null;
//                $this ->urceneDenniStravneMena = $poma['mena'];
//            }
//        } catch (DBException $e) {
//            throw $e;
//        } catch (Exception $e) {
//            // nedela nic (sazba nenalezena)
//        }

//        $this ->urceneKapesne = (trim($_POST['UrceneKapesne']) != '')
//            ? StringUtils::stringToFloat($_POST['UrceneKapesne'])
//            : null;
//        $this ->urceneKapesneMena = ($_POST['UrceneKapesneMena'] != null)
//            ? $_POST['UrceneKapesneMena']
//            : null;

//        $this ->loadPostPredpokladaneNaklady();

//        $this ->f_PP = new PracovniPomer();

//        if (!isset($_POST['osoba']) || !$_POST['osoba']) {
//            return MessageManager::addErrorMessage( ronText('Nutno_vybrat_osobu'), 'osoba');
//        }

//        if (!$this ->f_PP ->nactiPPPodleId($database, $_POST['osoba'])) {
//            return MessageManager::addErrorMessage('Chyba! Zadany pracovni pomer nebyl nalezen!', 'osoba');
//        }
//
//        return $this ->zkontrolujZadaneUdaje($database);
//    }


//    /**
//     * @param Database $database
//     * @return RonPortalDBRecord
//     * @throws DBException
//     * @deprecated
//     */
//    function createDBRecord($database, $logDescription)
//    {
//        $rec = new RonPortalDBRecord($database, 'SluzebniCesta', $logDescription);

//        $rec ->addField('ID', 'int', true, 0, $this ->id); // readonly = true
//
//        $rec ->addField('RC', '', false, 15, $this ->f_PP ->rc);
//        $rec ->addField('OsobniCislo', '', false, 15, $this ->f_PP ->osobniCislo);
//        $rec ->addField('DatumNastupu', 'date', false, 0, $this ->f_PP ->datumNastupu);
//
//        $rec ->addField('', '', true, 0, '   ' . $this ->f_PP ->jmenoPrijmeni); // jen pro zalogovani

//        $rec ->addField('DatumCasOd', 'datetime', false, 0, $this ->datumCasOd);
//        $rec ->addField('DatumCasDo', 'datetime', false, 0, $this ->datumCasDo);

//        $rec ->addField('MistoZacatku', '', false, 30, $this ->mistoZacatku);
//        $rec ->addField('PopisMistaZacatku', '', false, 160, $this ->popisZacatku);
//        $rec ->addField('Cil', '', false, 30, $this ->cil);
//        $rec ->addField('PopisCile', '', false, 160, $this ->popisCile);
//        $rec ->addField('Pres', '', false, 160, $this ->pres);
//        $rec ->addField('CilovyStat', '', false, 10, $this ->cilovyStat);

//        $rec ->addField('Ucel', '', false, 30, $this ->ucel);

//        // zjisti, jestli je prednastaven stat (bud hodnotou, nebo podle rozdeleni)
//        $vychoziStatOsoby = SluzebniCestyUtils::getVychoziStatOsoby($database, $this ->f_PP, $this ->datumCasOd);
//        if (!$vychoziStatOsoby) {
//            $rec->addField('Stat', '', false, 10, $this->f_stat);
//        } else {
//            // stat meni jen v pripade, ze neni prednastaven globalne a neni podle rozdeleni
//            $rec->addField('Stat', '', true, 10, $vychoziStatOsoby);
//        }

//        $rec ->addField('Zahranicni', 'int', false, 0, (int)$this ->zahranicni);
//        if ( RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_ZADAVAT_DATUM_KURZU, 1) ) {
//            $rec ->addField('DatumKurzu', 'date', false, 0, $this ->datumKurzu);
//        }

//        $rec ->addField('Popis', '', false, 160, $this ->popis);
//        //$rec ->addField('VlastniVozidlo', 'int', false, 0, $_POST['VlastniVozidlo'] ? 1 : 0);
//        $rec ->addField('DopravniProstredek', '', false, 30, $this ->dopravniProstredek);
//        $rec ->addField('RegistracniZnacka', '', false, 30, $this ->registracniZnacka);

//        if (RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_TYP_ROZDELENI)) {
//            $rec ->addField('KodTypuRozdeleni', 'int', false, 0, $this ->kodTypuRozdeleni);
//            $rec ->addField('Rozdeleni', '', false, 30, $this ->rozdeleni);
//        }

//        if ( (!$this ->zahranicni  &&  RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_TYP_ROZDELENI2)) ||
//            ( $this ->zahranicni  &&  RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_TYP_ROZDELENI2Z)) )  {
//            $rec ->addField('KodTypuRozdeleni2', 'int', false, 0, $this ->kodTypuRozdeleni2);
//            $rec ->addField('Rozdeleni2', '', false, 30, $this ->rozdeleni2);
//        }

//        if (RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_PRENASET_DO_DOCHAZKY, 1) == 1) // podle volby uzivatele
//        {
//            $rec ->addField('PrenasetDoDochazky', 'int', false, 0, $this ->prenasetDoDochazky ? 1 : 0);
//            if ($this ->typPrenosuDoDochazky >= 0) {
//                $rec ->addField('TypPrenosuDoDochazky', 'int', false, 0, (int)$this ->typPrenosuDoDochazky);
//            }
//        } else {
//            // pouze read only pro vkladani
//            $rec ->addField('PrenasetDoDochazky', 'int', true, 0, RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_PRENASET_DO_DOCHAZKY, 1) >= 0 ? 1 : 0);
//            if ( RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_PRENASET_DO_DOCHAZKY, 1) >= 2 ) {
//                $rec ->addField('TypPrenosuDoDochazky', 'int', true, 0, RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_PRENASET_DO_DOCHAZKY, 1) - 2);
//            }
//        }

//        if (RonPortalSettings::getIntValue(self::SETTINGS_CASY_PODLE_RADKU) == -1) {
//            // nastaveni "pocatek konec podle radku" provede uzivatel
//            $rec ->addField('PocatekKonecPodleRadku', 'int', false, 0, $this ->pocatekKonecPodleRadku);
//        } else {
//            $rec ->addField('PocatekKonecPodleRadku', 'int', true, 0, RonPortalSettings::getIntValue(self::SETTINGS_CASY_PODLE_RADKU));
//        }

//        // read-only - pouze pro vkladani
//        $rec ->addField('TypVypoctuCN', 'int', true, 0, RonPortalSettings::getIntValue(self::SETTINGS_TYP_VYPOCTU));

//        if (RonPortalSettings::getIntValue(self::SETTINGS_MENIT_SAZBU_KAPESNEHO)) {
//            // Sazbu kapesneho urcuje uzivatel sam.
//            $rec ->addField('SazbaKapesneho', 'float', false, 0, $this ->sazbaKapesneho);
//        } else if (RonPortalSettings::getIntValue('sazbakapesnehopodlestatu')) {
//            // Sazba kapesneho podle statu
//            $sazba = $this ->cilovyStat ? SluzebniCestyUtils::sazbaKapesnehoProStat($database, $this ->cilovyStat) : 0;
//            $rec ->addField('SazbaKapesneho', 'float', false, 0, $sazba);
//        } else {
//            $rec ->addField('SazbaKapesneho', 'float', true, 0, RonPortalSettings::getFloatValue(self::SETTINGS_VYCHOZI_SAZBA_KAPESNEHO));
//        }

//        if (RonPortalSettings::getValue(self::SETTINGS_UZIVATELSKA1)) {
//            $rec ->addField('Uzivatelska1', '', false, 100, $this ->uzivatelska1);
//        }
//        if (RonPortalSettings::getValue(self::SETTINGS_UZIVATELSKA2)) {
//            $rec ->addField('Uzivatelska2', '', false, 100, $this ->uzivatelska2);
//        }
//        if (RonPortalSettings::getValue(self::SETTINGS_UZIVATELSKA3)) {
//            $rec ->addField('Uzivatelska3', '', false, 100, $this ->uzivatelska3);
//        }
//        if (RonPortalSettings::getValue(self::SETTINGS_UZIVATELSKA4)) {
//            $rec ->addField('Uzivatelska4', '', false, 100, $this ->uzivatelska4);
//        }
//        if (RonPortalSettings::getValue(self::SETTINGS_UZIVATELSKA5)) {
//            $rec ->addField('Uzivatelska5', '', false, 100, $this ->uzivatelska5);
//        }

//        $rec ->addIntField('VyplatitHotove', false, $this ->vyplatitHotove);
//        $rec ->addStringField('ManaProVyplaceni', false, 10, $this ->menaProVyplaceni);

//        $rec ->addField('PozadovanaZaloha', 'int', false, 0, $this ->pozadovanaZaloha);
//        $rec ->addField('PozadovanaZalohaHotovost', 'float', false, 0, $this ->pozadovanaZalohaHotovost);
//        $rec ->addField('PozadovanaZalohaHotMena', '', false, 10, $this ->pozadovanaZalohaHotovostMena);
//        $rec ->addField('PozadovanaZalohaUcet', 'float', false, 0, $this ->pozadovanaZalohaUcet);
//        $rec ->addField('PozadovanaZalohaUcetMena', '', false, 10, $this ->pozadovanaZalohaUcetMena);
//
//        $rec ->addField('CisloUctuProZalohu', '', false, 30, $this ->cisloUctuProZalohu);
//        $rec ->addField('MenaUctuProZalohu', '', false, 10, $this ->menaUctuProZalohu);
//        $rec ->addField('IBANUctuProZalohu', '', false, 40, $this ->pozadovanaZalohaIBAN);
//        $rec ->addField('SWIFTUctuProZalohu', '', false, 40, $this ->pozadovanaZalohaSWIFT);

//        $rec ->addField('UrceneDenniStravne', 'float', false, 0, $this ->urceneDenniStravne);
//        $rec ->addField('UrceneDenniStravneMena', '', false, 10, $this ->urceneDenniStravneMena);
//        $rec ->addField('UrceneKapesne', 'float', false, 0, $this ->urceneKapesne);
//        $rec ->addField('UrceneKapesneMena', '', false, 10, $this ->urceneKapesneMena);

//        if (RonPortalSettings::getIntValue(self::SETTINGS_EDITACE_SCHVALENE_NADRIZENYM, 1) == 2) {
//            // pri editaci se vymaze schvaleni nadrizeneho (pokud needituje primo nadrizeny)
//
//            //if (!Prava::lzeZobrazitPP('slcesty_nadriz4', $this ->f_PP ->idPP)) {
//            if (!$this ->jePravoNaSluzebniCestu('slcesty_nadriz4')) {
//                // uzivatel nema pravo na schvaleni nadrizenym 4 => schvaleni 4 se zrusi ...
//                $f = $rec ->addIntField('SchvalenoNadrizenym4', false, 0);
//                $f ->updateLog = true;
//
//                // ... a zkontroluji se i dalsi urovne
//                //if (!Prava::lzeZobrazitPP('slcesty_nadriz3', $this ->f_PP ->idPP)) {
//                if (!$this ->jePravoNaSluzebniCestu('slcesty_nadriz3')) {
//                    // zrusi schvaleni urovni 3
//                    $f = $rec ->addIntField('SchvalenoNadrizenym3', false, 0);
//                    $f ->updateLog = true;
//
//                    //if (!Prava::lzeZobrazitPP('slcesty_nadriz2', $this ->f_PP ->idPP)) {
//                    if (!$this ->jePravoNaSluzebniCestu('slcesty_nadriz2')) {
//                        // zrusi schvaleni urovni 2
//                        $f = $rec ->addIntField('SchvalenoNadrizenym2', false, 0);
//                        $f ->updateLog = true;
//
//                        //if (!Prava::lzeZobrazitPP('slcesty_nadriz', $this ->f_PP ->idPP)) {
//                        if (!$this ->jePravoNaSluzebniCestu('slcesty_nadriz')) {
//                            // zrusi schvaleni urovni 1
//                            $f = $rec ->addIntField('SchvalenoNadrizenym', false, 0);
//                            $f ->updateLog = true;
//                        }
//                    }
//                }
//            }
//        }
//
//        $rec ->addField('Poznamka', 'memo', false, 0, $this ->poznamka);
//
//        return $rec;
//    }


    /**
     * @param Database $database
     * @throws DBException
     */
    function upravCasyPodleRadkuSC($database)
    {
        $params = $database ->createParameters();
        $sql =
            'SELECT MIN(DatumCasOd), MAX(DatumCasOd) FROM RadekSluzebniCesty '.
            ' WHERE SluzebniCesta_ID = ' . $params ->addParameter((int)$this ->id);

        $cursor = $database ->getSqlResult($sql, $params);

        $row = $cursor ->fetch();
        if (!$row) {
            return;
        }

        if (!$row[0]) {
            return;
        }

        $casOd = $database ->stringToTimestamp($row[0]);
        if (DateUtils::startOfTheDay($casOd) === DateUtils::startOfTheDay($this ->datumCasOd)) {
            $this ->datumCasOd = $casOd;
        }

        $casDo = $database ->stringToTimestamp($row[1]);
        if (DateUtils::startOfTheDay($casDo) === DateUtils::startOfTheDay($this ->datumCasDo)) {
            $this ->datumCasDo = $casDo;
        }
    }


//    /**
//     * @param Database $database
//     * @param int $idKopirovaneSC
//     * @return void
//     * @throws DBException
//     * @deprecated
//     */
//    function upravCasyPodleKopirovaneSC($database, $idKopirovaneSC)
//    {
//        $params = $database ->createParameters();
//        $sql =
//            'SELECT SluzebniCesta.DatumCasOd, MIN(RadekSluzebniCesty.DatumCasOd), MAX(RadekSluzebniCesty.DatumCasOd)' .
//            ' FROM SluzebniCesta, RadekSluzebniCesty'.
//            ' WHERE RadekSluzebniCesty.SluzebniCesta_ID = SluzebniCesta.Id' .
//            ' AND SluzebniCesta.Id = ' . $params ->addParameter($idKopirovaneSC) .
//            ' GROUP BY (SluzebniCesta.DatumCasOd)';
//
//        $cursor = $database ->getSqlResult($sql, $params);
//
//        $row = $cursor ->fetch();
//        if (!$row  ||  !$row[1]) { // SC nenalezena, nebo nema zadne radky
//            return;
//        }
//
//        $casSCOd = $database ->stringToTimestamp($row[0]);
//        $casRadkuOd = $database ->stringToTimestamp($row[1]);
//        $casRadkuDo = $database ->stringToTimestamp($row[2]);
//
//        // vypocita pocet dnu mezi starou a novou SC
//        $dateAdd = DateUtils::daysBetween(DateUtils::startOfTheDay($casSCOd), DateUtils::startOfTheDay($this ->datumCasOd));
//
//        if (DateUtils::startOfTheDay($casSCOd) === DateUtils::startOfTheDay($casRadkuOd)) {
//            // prvni radek puvodni SC je ve stejny den jako zacatek puvodni SC => nastavim cas nove SC podle casu radku
//            $this ->datumCasOd = DateUtils::startOfTheDay($this ->datumCasOd) + DateUtils::timeOf($casRadkuOd);
//        }
//
//        // prepocte cas posledniho radku pro novou sluzebni cestu
//        $casDo = DateUtils::incDay($casRadkuDo, $dateAdd);
//        if ($casDo > $this ->datumCasDo) {
//            // posune cas konce podle posledniho radku
//            $this ->datumCasDo = $casDo;
//        } else if (DateUtils::startOfTheDay($casDo) === DateUtils::startOfTheDay($this ->datumCasDo)) {
//            $this ->datumCasDo = $casDo;
//        }
//    }


    /**
     * @param Database $database
     * @param string|object $logDescription
     * @throws DBException
     */
    function updateCasy($database, $logDescription)
    {
        $this ->upravCasyPodleRadkuSC($database);

        $rec = new RonPortalDBRecord($database, 'SluzebniCesta', $logDescription);

        $rec ->addField('', '', true, 0, 'Automaticke nastaveni casu pocatku a konce podle radku');
        $rec ->addField('ID', 'int', true, 0, $this ->id); // readonly = true

        $rec ->addField('RC', '', true, 15, $this ->f_PP ->rc);
        $rec ->addField('OsobniCislo', '', true, 15, $this ->f_PP ->osobniCislo);
        $rec ->addField('DatumNastupu', 'date', true, 0, $this ->f_PP ->datumNastupu);

        $rec ->addField('DatumCasOd', 'datetime', false, 0, $this ->datumCasOd);
        $rec ->addField('DatumCasDo', 'datetime', false, 0, $this ->datumCasDo);

        $params = $database ->createParameters();
        $rec ->setWhere('Id = ' . $params ->addParameter($this ->id), $params);

        $rec ->loadAndUpdateRecord();
    }



//    /**
//     * @param Database $database
//     * @param string|object $logDescription
//     * @return bool
//     * @throws DBException
//     * @throws Exception
//     * @deprecated
//     */
//    function updateRecord($database, $logDescription)
//    {
//    }


}
