<?php

/**
 * Stanislav Elbl, 3.10.2014
 */

namespace RonPortal\SluzebniCesty;

use Ron\DateUtils;
use Ron\DB\DBUtils;
use Ron\Http\Csrf;
use Ron\MessageManager;
use Ron\StringUtils;
use Ron\TextManager;
use RonPortal\RonPortalSettings;

/** @var RadekSluzebniCestyFormular $this

/** @var RadekSluzebniCesty[]  $radky */
$radky = $this -> radkyProZobrazeni();

MessageManager::getInstance() ->showMessages();

$jeZahranicni = $this ->sluzebniCesta ->zahranicni;

if (!$jeZahranicni) {
    // jeste overi, jestli uz na SC neni nejaky radek s jinou nez vychozi zemi (pro kompatibilitu se starsi verzi)
    $params = $this ->database ->createParameters();
    $jinyStat = DBUtils::getSqlValue($this ->database,
        'SELECT CisloRadku FROM RadekSluzebniCesty ' .
        ' WHERE SluzebniCesta_ID = ' . $params ->addParameter((int)$this ->sluzebniCesta ->id) .
        '   AND Stat <> ' . $params->addParameter($this ->sluzebniCesta ->f_stat),
        $params);

    if ($jinyStat) {
        $jeZahranicni = true;
    }
}

// form se zobrazuje i v readonly rezimu, aby fungovala tlacitka "vydaje"
?>

<form method="POST" name="radky_sc_form" id="radky_sc_form" action="?menuid=sluzebnicesty&action=editovatradkysluzebky&record=<?= $this ->sluzebniCesta ->id ?>" >

    <?php if (!$this -> readOnly) { ?>
        <input type="submit" class="position-absolute" style="left: -100%" name="zapsat" value="<?= \Ron\ronText('Zapsat') ?>" /> <!-- default akce pri stisku enter -->
    <?php } ?>

    <?= Csrf::csrfHiddenInput() ?>

    <input type="hidden" name="zobrazitVydajeProDen" value="" />

    <table id="radky_sc_editace" class="browser radkySC<?= $this ->sluzebniCesta ->zahranicni ? ' radkyZahranicniSC' : '' ?> keyInputMove"
           data-operace-sc="<?= StringUtils::htmlTextConvert(RonPortalSettings::getValue(SluzebniCestyController::SETTINGS_PORADI_OPERACI)) ?>"
           data-stat-sc="<?= StringUtils::htmlTextConvert($this ->sluzebniCesta ->f_stat) ?>"
           data-cilovy-stat-sc="<?=
            StringUtils::htmlTextConvert(
                $this ->sluzebniCesta ->zahranicni && $this ->sluzebniCesta ->cilovyStat
                    ? $this ->sluzebniCesta ->cilovyStat
                    : $this ->sluzebniCesta ->f_stat
            ) ?>"
           data-cas-pocatku="<?= $this ->sluzebniCesta ->casOdStr ?>"
        >
    <thead>
        <tr>
            <th><?= \Ron\ronText('Date') ?></th>
            <th><?= \Ron\ronText('Cas') ?></th>

            <?php if ( SluzebniCestyController::getZobrazitOperaceSC() ) { ?>
                <th class="radekSC_operace"><?= \Ron\ronText('Operace_sc') ?></th>
            <?php } ?>

            <?php if ($this ->zobrazitMisto) { ?>
                <th class="radekSC_misto"><?= \Ron\ronText('Misto_sc') ?></th>
            <?php } ?>

            <th class="radekSC_popis"><?= \Ron\ronText('Popis_radku_sc') ?></th>
            <?php if ($jeZahranicni) { ?>
                <th class="radekSC_stat"><?= \Ron\ronText('Stat') ?></th>
            <?php } ?>
            <th class="radekSC_dopravniprostredek"><?= \Ron\ronText('Dopravni_prostredek') ?></th>
            <th class="radekSC_button"></th>
            <th class="radekSC_snidane"><?= \Ron\ronText('Pocet_snidani') ?></th>
            <th class="radekSC_obed"><?= \Ron\ronText('Pocet_obedu') ?></th>
            <th class="radekSC_vecere"><?= \Ron\ronText('Pocet_veceri') ?></th>

            <?php if (!$this ->readOnly) { /* editacni ikony */ ?>
            <th class="radekSC_editace"></th>
            <?php } ?>

            <th class="radekSC_vydaje"></th> <!-- tlacitko vydaje -->
        </tr>

    </thead>
    <tbody>
    <?php
        $datum = 0;
        $indexhtml = 0;
        $posledniStat = null; // pokud se zmeni stat, zobrazuje checkboxy na jidlo

        foreach($radky as $index => $radek) {
            $prvniRadekProDen = DateUtils::startOfTheDay($radek ->datumCasOd) != $datum;
            $datum = DateUtils::startOfTheDay($radek ->datumCasOd);

            $indexhtml ++;
            $this ->zobrazRadek($radek, $indexhtml, $prvniRadekProDen, $jeZahranicni, $radek ->stat && $posledniStat != $radek ->stat);
            if ($radek ->stat) $posledniStat = $radek ->stat;
        }
    ?>
    </tbody>
    </table>

<?php if (!$this -> readOnly) { ?>
    <input type="hidden" name="jezahranicni" value="<?= $jeZahranicni ? '1' : 0 ?>" />
    <input type='hidden' name='pocetradku' value='<?= $indexhtml ?>' />
    <input type='hidden' name='editace_radku_sluzebky' value='1'/>
    <input type='hidden' name='smazat_radek_sluzebky' value=''/>

    <div class='buttons'>
        <input type='submit' class='submitbutton' name='zapsat' value='<?= \Ron\ronText('Zapsat') ?>' />
        <input type='submit' class='submitbutton' name='OK' value='<?= \Ron\ronText('OK') ?>' />
        <input type='button' id='stornoRadkuSC' class='button confirmQuestion' name='storno' value='<?= \Ron\ronText('Cancel') ?>'
               data-ron-confirm-text="<?= TextManager::_('SC_Opravdu_storno') ?>"
               data-ron-href="?menuid=sluzebnicesty&action=zobrazslcestu&record=<?= $this ->sluzebniCesta ->id ?>" />
    </div>
<?php } ?>

</form>

<?php if ($this -> readOnly) { ?>
    <br/>
    <div class="linkslist"><a href="?menuid=sluzebnicesty&action=zobrazslcestu&record=<?= $this ->sluzebniCesta ->id ?>"><?= \Ron\ronText('Zpet') ?></a></div>
<?php } ?>
