<?php
/**
 * stanislav.elbl, 23.02.2021
 */

namespace RonPortal\System;

/**
 * Definice probihajici ulohy
 * Class TaskManagerTask
 * @package Ron\RonPortal
 */
class TaskManagerTask
{
    /** @var string     Id prirazuje TaskManager */
    public $id;

    public $caption;

    public $isRunning;
    /** @var bool       Priznak, ze uloha podporuje Abort */
    public $abortAvailable;
    /** @var integer    Cas posledniho zjisteni stavu */
    public $lastUpdateTime;

    /** @var integer */
    public $progressMax;
    /** @var integer */
    public $progressCurrent;
    /** @var string */
    public $progressMessage;
    /** @var string */
    public $errorMessage;

    // Udaje z executoru, napr. z Agent managera
    public $executorParams = [];


    public function __construct()
    {

    }

    public function storeToArray()
    {
        return [
            //'handle' => $this ->handle,
            'isRunning' => $this ->isRunning,
            'abortAvailable' => $this ->abortAvailable,
            'progressMax' => $this ->progressMax,
            'progressCurrent' => $this ->progressCurrent,
            'progressMessage' => $this ->progressMessage,
            'errorMessage' => $this ->errorMessage,
            'executorParams' => $this ->executorParams,
            'caption' => $this ->caption
        ];
    }

    public static function createFromArray($array, $id)
    {
        $result = new static();
        $result ->id = $id;
        $result ->isRunning = $array['isRunning'];
        $result ->abortAvailable = $array['abortAvailable'];
        $result ->progressMax = $array['progressMax'];
        $result ->progressCurrent = $array['progressCurrent'];
        $result ->progressMessage = $array['progressMessage'];
        $result ->errorMessage = $array['errorMessage'];
        $result ->executorParams = $array['executorParams'] ?: [];
        $result ->caption = $array['caption'];

        return $result;
    }
}
