<?php

namespace RonPortal\Testy;

use Ron\DB\Database;
use RonPortal\RonPortalDBRecord;


class PripraveneTemaHodnoceniDBRecord extends RonPortalDBRecord
{
    /**
     * @param Database $database
     * @param int $druhHodnoceni
     * @param int $temaCislo
     * @param object|string $logDescription
     */
    public function __construct(Database $database, $druhHodnoceni, $temaCislo, $logDescription)
    {
        parent::__construct($database, 'PripraveneTemaHodnoceni', $logDescription);

        $this ->addField('ID', 'serial', true);

        // odkaz na sablonu (TemaHodnoceni)
        $this ->addIntField('DruhHodnoceni',true, $druhHodnoceni);
        $this ->addIntField('TemaCislo', true, $temaCislo);

        $this ->addTimestampField('DatumHodnoceni', false, time());
        $this ->addIntField('Stav', true, 1); // povinne pole - nastaveno na "Probiha"
    }


}
