<?php

/**
 * Renderuje dialog pro editaci otazek testu/ankety
 */

namespace RonPortal\Testy;

use Ron\Controls\Dialog;
use Ron\Controls\DialogButton;
use Ron\MVC\Renderer;
use Ron\MVC\TextViewObject;
use Ron\TextManager;

$editovatBody = $editovatBody ?? true;

?>
<div class="d-flex">
    <!-- seznam otazek -->
    <div class="padding-all-2">
        <ul class="linkslist">
            <li><a id="test_new_content" class="clickLink"><?= TextManager::_('Pridat_otazku_testu') ?></a></li>
        </ul>

        <ul class="items-list menu-list context-menu-container seznam-otazek-testu" id="test_obsah_list" data-context-menu-item-selector="li" data-context-menu="#test_otazky_menu" data-context-menu-attach-to-element="1">
        </ul>

        <div><a id="hromadnyImportLink" class="clickLink"><?= TextManager::_('Vlozit_otazky_hromadne') ?></a></div>
    </div>

    <!-- editace vybrane otazky -->
    <div class="form large-form">
        <div class="form-content" id="editace_otazky">
            <div class="row">
                <div class="col-2 caption"><label for="kodOtazky"><?= TextManager::_('Kod') ?></label></div>
                <div class="col-10">
                    <input name="kodOtazky" id="kodOtazky" maxlength="10">
                    <span id="otazka_buttons" class="float-right">
                        <a id="otazka_cancel" href="#"><i class="fa inline-glyph glyph-button glyph-cancel"></i></a>
                        <a id="otazka_save" href="#"><i class="fa inline-glyph glyph-button glyph-ok"></i></a>
                    </span>
                </div>
            </div>
            <div class="row">
                <div class="col-2 caption">
                    <label for="popisOtazky"><?= TextManager::_('Text_otazky') ?></label>
                </div>
                <div class="col-10">
                    <input class="form-control priloha-target" name="popisOtazky" id="popisOtazky" maxlength="250">
                </div>
            </div>
            <div class="row">
                <div class="col-2 caption">
                    <label for="upresnujiciPopis"><?= TextManager::_('Pokracovani_textu_otazky') ?></label>
                </div>
                <div class="col-10">
                    <textarea class="form-control editor priloha-target" name="upresnujiciPopis" id="upresnujiciPopis" rows="5"></textarea>
                </div>
            </div>
            <div class="row">
                <div class="col-2 caption">
                    <label for="povinnaOdpoved"><?= TextManager::_('Povinna_odpoved') ?></label>
                </div>
                <div class="col-10">
                    <input type="checkbox" name="povinnaOdpoved" id="povinnaOdpoved">
                </div>
            </div>
            <?php if ($editovatBody) { ?>
            <div class="row">
                <div class="col-2 caption">
                    <label for="bodovaVaha"><?= TextManager::_('Bodova_vaha') ?></label>
                </div>
                <div class="col-10">
                    <input name="bodovaVaha" id="bodovaVaha" maxlength="5" size="5">
                </div>
            </div>
            <?php } ?>
            <div class="row">
                <div class="col-2 caption">
                    <label for="typRozsahu"><?= TextManager::_('Zpusob_odpovedi') ?></label>
                </div>
                <div class="col-10">
                    <select name="typRozsahu" id="typRozsahu"></select>
                </div>
            </div>

            <?php if ($editovatBody) { ?>
            <div class="spravneOdpovedi" id="spravnaHodnotaBody">
                <div class="row">
                    <!-- editace spravne hodnoty -->
                    <div class="col-2 caption">
                        <label for="spravnaHodnota"><?= TextManager::_('Spravna_odpoved') ?></label>
                    </div>
                    <div class="col-10">
                        <input type="text" class="form-control" id="spravnaHodnota"/>
                    </div>
                </div>
            </div>
            <?php } ?>

            <div class="spravneOdpovedi" id="vycetOdpovediHeader">
                <div class="row">
                    <div class="col-2"></div>
                    <div class="col"><?= TextManager::_('Text_odpovedi') ?></div>
                    <div class="col-1"><?= TextManager::_('Hodnota') ?></div>
                    <?php if ($editovatBody) { ?>
                    <div class="col-1"><?= TextManager::_('Koeficient') ?></div>
                    <?php } ?>
                    <div class="col-1"><!-- tlacitka atd. --></div>
                </div>
            </div>

            <div class="spravneOdpovedi" id="vycetOdpovedi">
            </div>

            <div class="spravneOdpovedi" id="tlacitkaOdpovedi">
                <div class="row">
                    <div class="col-2"></div>
                    <div class="col-10">
                        <a id="pridatOdpoved" href="#"><?= TextManager::_('Pridat_odpoved') ?></a>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

<?php Renderer::startRenderer(); ?>
    <div><?= TextManager::_('Zadejte_texty_otazek_a_odpovedi') ?></div>
    <div><textarea id="importOtazekText" cols="90" rows="15"></textarea></div>
    <div id="nahledImportuOtazek" class="borders margin-top light-borders"><?= TextManager::_('Nahled_otazek') ?></div>
<?php
$dialogContent = Renderer::renderToString();

(new Dialog())
    ->setId('importOtazek')
    ->setTitle('Import_otazek')
    ->setView(new TextViewObject($dialogContent))
    ->addButton(
        (new DialogButton())
            ->setValue('Importovat_otazky')
            ->setId('btnImportOK')
            ->setClass('submitbutton')
    )
    ->addButton(DialogButton::cancelButton('btnImportStorno'))
    ->render();
?>

<ul id="test_otazky_menu" class="popupmenu">
    <li data-context-menu-event="editovat-otazku"><?= TextManager::_('Editovat_otazku') ?></li>
    <li data-context-menu-event="odstranit-otazku"><?= TextManager::_('Odstranit_otazku') ?></li>
</ul>

