<?php

namespace RonPortal\Uchazeci;

use Ron\DB\Database;
use Ron\MessageManager;

/**
 * Trida reprezentuje zaznam z tabulky DokumentUchazece
 * Class DokumentUchazece
 * @package RonPortal\Uchazeci
 */
class DokumentUchazece
{
    /** @var string */
    public $idUchazece;
    /** @var int */
    public $idDokumentu;

    /** @var string */
    public $nazevDokumentu;
    /** @var string */
    public $popisDokumentu;

    /** @var int */
    public $datumVlozeniDokumentu;



    /**
     * @param Database $database
     * @param $row
     */
    private function nactiZaznamZRadku($database, $row)
    {
        $this->idUchazece = $row[4];
        $this->idDokumentu = (int)$row[0];

        $this->nazevDokumentu = $row[1];
        $this->popisDokumentu = $row[2];

        $this->datumVlozeniDokumentu = $database->stringToTimestamp($row[3]);
    }

    /**
     * @param Database $database
     * @param $rc
     * @return DokumentUchazece[]
     * @throws \Exception
     */
    public static function nactiDokumentyUchazece($database, $rc)
    {
        $params = $database->createParameters();

        $sql =
            'SELECT Dokument.Id, Dokument.JmenoSouboru, Dokument.Popis, Dokument.Datum,' .
            '  DokumentUchazece.IdUchazece' .
            ' FROM DokumentUchazece, Dokument' .
            ' WHERE DokumentUchazece.ID = Dokument.Id' .
            '  AND DokumentUchazece.IdUchazece = ' . $params->addParameter($rc) .
            ' ORDER BY Dokument.id DESC, Dokument.datum  DESC';

        $seznamDokumentu = [];

        $cursor = $database ->getSqlResult($sql,$params);
        while($row = $cursor->fetch())
        {
            $dokument = new DokumentUchazece();
            $dokument ->nactiZaznamZRadku($database, $row);

            $seznamDokumentu[] = $dokument;
        }
        $cursor ->close();

        return $seznamDokumentu;
    }
}

