<?php

namespace RonPortal\Uchazeci;

use Ron\DB\Database;
use Ron\MessageManager;

/**
 * Trida reprezentuje zaznam z tabulky RozdeleniUchazece
 * Class RozdeleniUchazece
 * @package RonPortal\Uchazeci
 */
class RozdeleniUchazece
{
    /** @var string */
    public $rc;
    /** @var int */
    public $kodTypuRozdeleni;
    /** @var string */
    public $kodRozdeleni;

    /** @var string */
    public $popisRozdeleni;

    /** @var string */
    public $typRozdeleni;

    /**
     * @param $row
     */
    private function nactiZaznamZRadku($row)
    {
        $this ->rc = $row[0];
        $this ->kodTypuRozdeleni = (int)$row[1];
        $this ->kodRozdeleni = $row[2];

        $this->popisRozdeleni = $row[3];
        $this->typRozdeleni = $row[4];
    }

    /**
     * @param Database $database
     * @param $rc
     * @return RozdeleniUchazece[]
     * @throws \Exception
     */
    public static function nactiRozdeleniUchazece($database, $rc)
    {
        $params = $database->createParameters();

        $sql =
            'SELECT RozdeleniUchazece.RC, RozdeleniUchazece.KodTypuRozdeleni,' .
            '  Rozdeleni.Kod, Rozdeleni.Popis, TypRozdeleni.Popis' .
            ' FROM Rozdeleni, RozdeleniUchazece, TypRozdeleni' .
            ' WHERE RozdeleniUchazece.RC = ' . $params->addParameter($rc) .
            '  AND RozdeleniUchazece.Rozdeleni = Rozdeleni.Kod' .
            '  AND RozdeleniUchazece.KodTypuRozdeleni = Rozdeleni.KodTypuRozdeleni' .
            '  AND Rozdeleni.KodTypuRozdeleni = TypRozdeleni.Kod' .
            '  AND TypRozdeleni.VyberoveRizeni = 1' .
            ' ORDER BY TypRozdeleni.Kod';

        $seznamRozdeleni = [];

        $cursor = $database->getSqlResult($sql, $params);
        while ($row = $cursor->fetch()) {
            $uchazecRozdeleni = new static();
            $uchazecRozdeleni->nactiZaznamZRadku($row);
            $seznamRozdeleni[] = $uchazecRozdeleni;
        }
        $cursor ->close();

        return $seznamRozdeleni;
    }
}