<?php
/**
 * pavel.rudol, 19.8.2022 10:38
 */

namespace RonPortal\Vyroba;

use Ron\Controls\FormField;
use Ron\TextManager;
use RonPortal\Controls\RonPortalForm;
use RonPortal\Controls\UserLoginFormField;

class VyrobniCinnostFormular extends RonPortalForm
{
    public function __construct($database, $formAction)
    {
        parent::__construct($database, $formAction);

        $this->title = $this->isInsert() ? TextManager::_('Vyroba_nova_cinnost') : TextManager::_('Vyroba_editace_cinnosti');

        $this ->sqlTableName = 'VyrobniCinnost';

        $this->code = 'formvyrobnicinnost';

        $this->setXmlEventsName('VYROBNI_CINNOST');

        $this->sqlSelectPart =
            'VyrobniCinnost.kod, VyrobniCinnost.popis, VyrobniCinnost.Aktivni, '. // 0 - 2
            'VyrobniCinnost.DruhZpracovani, VyrobniCinnost.Typ, ' . $database->castWideMemo('VyrobniCinnost.Poznamka') . ', '. // 3 - 5
            'VyrobniCinnost.Insert_UserName, VyrobniCinnost.Insert_Timestamp, VyrobniCinnost.Update_UserName, VyrobniCinnost.Update_Timestamp'; //6 - 9

        $this->addField()
            ->setSqlFieldName('kod')->setSqlFieldIndex(0)->setCaption('Kod')->setFieldName('kod')->setMaxLength(30)
            ->setCode('field-kod')->setPrimary(true)->setRequired(true);

        $this->addField()
            ->setSqlFieldName('popis')->setSqlFieldIndex(1)->setCaption('Popis')->setFieldName('popis')->setMaxLength(60)
            ->setCode('field-popis')->setRequired(true);

        $this->addField(FormField::FIELD_TYPE_CHECK)
            ->setSqlFieldName('Aktivni')->setSqlFieldIndex(2)->setRequired(true)->setCaption('Vyroba_aktivni')->setCode('field-aktivni')
            ->setDefaultValue(true)->setFieldName('aktivni');

        $this ->addField(FormField::FIELD_TYPE_SELECT)
            ->setFieldName('DruhZpracovani') ->setCaption('vyroba_druh_zpracovani')->setRequired(true)
            ->setCode('field-druh-zpracovani')
            ->setTranslationPrefix('db_s_druhzpracovanicinnosti_popis_')
            ->setSelectSql(
                'SELECT Kod, Popis FROM S_DruhZpracovaniCinnosti' .
                ' WHERE %FILTER%' .
                ' ORDER BY %ORDER%',
                "1 = 1",
                'Kod'
            );

        $this ->addField(FormField::FIELD_TYPE_SELECT)
            ->setFieldName('Typ') ->setCaption('vyroba_typ_cinnosti')
            ->setCode('field-typ-cinnosti')
            ->setTranslationPrefix('db_typvyrobnicinnosti_popis_')
            ->setSelectSql(
                'SELECT Kod, Popis FROM TypVyrobniCinnosti' .
                ' WHERE %FILTER%' .
                ' ORDER BY %ORDER%',
                "1 = 1",
                'Popis'
            );

        $this ->addField(FormField::FIELD_TYPE_SELECT)
            ->setFieldName('Status') ->setCaption('vyroba_status_cinnosti')
            ->setCode('field-status-cinnosti')
            ->setTranslationPrefix('db_statusvyrobnicinnosti_popis_')
            ->setSelectSql(
                'SELECT Kod, Popis FROM StatusVyrobniCinnosti' .
                ' WHERE %FILTER%' .
                ' ORDER BY %ORDER%',
                "1 = 1",
                'Popis'
            );

        $this ->addField(FormField::FIELD_TYPE_MEMO)
            ->setFieldName('Poznamka') ->setCaption('Poznamka')->setSqlFieldIndex(5)
            ->setCode('field-poznamka');

        $this->addField(FormField::FIELD_TYPE_ACTUAL_TIME)
            ->setSqlFieldName('Update_Timestamp')->setFieldName('Update_Timestamp')->setReadOnly(false);
        $this->addField(new UserLoginFormField(false));

        $this->addField( FormField::FIELD_TYPE_ACTUAL_TIME)
            ->setSqlFieldName('Insert_Timestamp')->setFieldName('Insert_Timestamp')->setReadOnly(true);
        $this->addField(new UserLoginFormField(true));
    }

}