<?php
/**
 * stanislav.elbl, 24.05.2021 15:32
 */

namespace RonPortal\XML\Classes;

use Ron\StringUtils;
use Ron\TextManager;
use RonPortal\XML\XMLFormElement;

/**
 * Class XMLFormElementBrowserPart
 * Implementace xml tagu <browserfield>, <browsersql>, <browserlink>, <browserdetail>
 */
class XMLElementBrowserPart extends XMLFormElement
{
    // browsersql
    var $sqlText;

    // browserfield, browserlink
    var $link;
    // browserfield
    var $sqlIndex;
    var $caption;
    var $format;
    var $style;
    var $text;
    var $code;

    // browserdetail
    var $col;
    var $detailText;

    protected function loadXMLElement($xmlReader)
    {
        parent::loadXMLElement($xmlReader);

        switch ($this ->elementName) {
            case 'browsersql' :
                $this ->sqlText = StringUtils::fromUTF8($this ->loadXMLValue($xmlReader));
                break;

            case 'browserfield' :
                $this ->sqlIndex = $this ->getAttributeValue('sqlindex');
                $this ->caption = TextManager::_(StringUtils::fromUTF8($this ->getAttributeValue('caption')));
                $this ->format = $this ->getAttributeValue('format');
                $this ->style = $this ->getAttributeValue('style');
                $this ->link = $this ->getAttributeValue('link');
                $this ->text = null !== $this ->getAttributeValue('text') ? StringUtils::fromUTF8($this ->getAttributeValue('text')) : null;
                $this ->code = $this ->getAttributeValue('code');
                break;

            case 'browserlink' :
                $this ->link = StringUtils::fromUTF8($this ->loadXMLValue($xmlReader));
                break;

            case 'browserdetail' :
                $this ->col = (int)$this ->getAttributeValue('col');
                $this ->detailText = StringUtils::fromUTF8($this ->loadXMLValue($xmlReader) );
                break;
        }
    }
}
