<?php

/**
 * Implementace XML tagu <dialog> - renderuje HTML dialog, ktery lze zobrazit pomoci javascriptu
 */

namespace RonPortal\XML\Classes;

use Ron\Controls\Dialog;
use Ron\Controls\DialogButton;
use Ron\MVC\Renderer;
use RonPortal\XML\XMLFormElement;

class XmlElementDialog extends XMLFormElement
{
    function getHTMLOutput()
    {
        $dialog = new Dialog();

        $dialog
            ->setId($this ->nahradPromenne($this ->getAttributeValue('id')))
            ->setTitle($this ->nahradPromenne($this ->getAttributeValue('caption')));

        $content = '';

        foreach ($this->elements as $element) {
            if ($this->xmlForm->exit) {
                // dale nepokracuje
                break;
            }

            if ($element ->elementName === 'dialogbutton') {
                $button = new DialogButton();
                $button
                    ->setId($this ->nahradPromenne($element ->getAttributeValue('id')))
                    ->setValue($this ->nahradPromenne($element ->getAttributeValue('text')));

                $dialog ->addButton($button);
            } else {
                $content .= $element->getHTMLOutput();
            }
        }

        $dialog ->setHtmlContent($content);

        if ($this ->getBoolAttribute('addcancelbutton')) {
            $dialog ->addButton(DialogButton::cancelButton());
        }

        // vyrenderuje dialog do retezce
        $renderer = new Renderer(null);
        $renderer ->start();

        $dialog ->render();

        return $renderer ->stop();
    }
}

/*
//DOC
PAGE dialog
<pre>
PRE
   <dialog id="id_dialogu" caption="nadpis_dialogu" addcancelbutton="1">
     ... obsah ...

     <dialogbutton id="id_tlacitka" text="nadpis_tlacitka" />
   </dialog>
PREEND
</pre>

//END
*/
