<?php
/**
 * stanislav.elbl
 * 22.05.2021 20:34
 */

namespace RonPortal\XML\Classes;

use Ron\MessageManager;
use RonPortal\XML\XMLFormElementCommand;

/**
 * Class XMLElementExpression
 * @package RonPortal\XML\Classes
 * Implementace tegu <expression>
 */
class XMLElementExpression extends XMLFormElementCommand
{
    /** @var string */
    protected $expression;
    /** @var string */
    protected $name;
    /** @var bool */
    protected $copy;


    function loadXML($xmlReader)
    {
        parent::loadXML($xmlReader);

        $this->name = $this->getAttributeValue('name');
        $this->expression = $this->getTextContent(false);
        $this->copy = self::getBoolValue($this ->getAttributeValue('copy', '1')); // defaultne se kopiruje cely tag
    }


    function evalError($expression)
    {
        $errorInfo = error_get_last();
        $errorMsg = ($errorInfo && isset($errorInfo['message']))
            ? $errorInfo['message']
            : '';
        $this->xmlForm->addErrorMsg("Chyba v tagu <expression>!\nVyhodnocovany vyraz: $expression\n" . $errorMsg);
    }


    function doCommand()
    {
        $name = $this->nahradPromenne($this->name);

        if (!$this ->copy  &&  $name) {
            $value = $this->variableValue($name);
            if (isset($value)) {
                // copy=false a promenna uz je nastavena => nic nedela
                return;
            }
        }

        $expression = $this->nahradPromenne($this->expression);

        MessageManager::addDebugLog("XMLDebug&gt; Tag expression - vyhodnocuji vyraz ($name): $expression");

        /** @noinspection PhpUnusedLocalVariableInspection */
        $xmlform = $this->xmlForm; // pouziva se ve formularich (napr. $xmlform ->database)!

        $oldReporting = error_reporting(E_PARSE | E_ERROR); // upraveno SE 28.3.2017 - kdyz tu byla 0, tak se nezobrazovaly chyby a neslo zjistit, kde je problem

        if ($name) {
            $value = null;
            $ok = eval('$value = ' . $expression . ';');
            if ($ok === false) {
                $this->evalError($expression);
            } else {
                $this->setVariableValue($name, $value);
            }

            MessageManager::addDebugLog("Tag expression - vysledek: $value");
        } else {
            $ok = eval($expression);
            if ($ok === false) {
                $this->evalError($expression);
            }
        }

        error_reporting($oldReporting);
    }


    // TODO: function writeXMLOutput($xmlWriter) - osetrit parametr "copy"

    function process()
    {
        if (!$this ->copy) {
            // tag se ma provadet jen jednou
            $name = $this->nahradPromenne($this->name);
            if ($name) {
                parent::process();
                $this ->xmlForm ->addDataVariable($name);
            }
        } else {
            parent::process();
        }
    }
}


/*
//DOC
PAGE expression
<pre>
PRE
  <expression name="promenna1" copy="0">PHP vyraz s promennymi</expression>
PREEND
</pre>

//END
*/
