<?php
/**
 * stanislav.elbl, 18.09.2018
 */

namespace RonPortal\XML\Classes;

use Exception;
use Ron\StringUtils;
use RonPortal\System\AgentManager;
use RonPortal\XML\XMLFormElementCommand;

/**
 * Implementace tagu <script>
 * Class XMLFormElementScript
 * @package RonPortal\XML\Classes
 */
class XMLElementScript extends XMLFormElementCommand
{
    public function doCommand()
    {
        $scriptCategory = StringUtils::fromUTF8($this ->getAttributeValue('scriptcategory'));
        $scriptName = StringUtils::fromUTF8($this ->getAttributeValue('scriptname'));

        $parameter = StringUtils::fromUTF8($this ->getAttributeValue('scriptparameter'));
        $parameter = $this ->nahradPromenne($parameter);

        $app = $this ->getAttributeValue('app', 'ads'); // person/jidelna/cokoliv jineho=ads
        $background = $this ->getBoolAttribute('background');
        // TODO: doplnit parametr background

        try {
            AgentManager::executeScript($scriptCategory, $scriptName, $parameter, $app);
            $hodnota = 1;
        } catch (Exception $e) {
            $hodnota = 0;
            $this ->xmlForm ->addErrorMsg($e ->getMessage());
        }

        $variableName = $this ->getAttributeValue('variablename');
        if ($variableName) {
            $this ->setVariableValue($variableName, $hodnota);
        }
    }
}

/*
//DOC
PAGE script
<pre>
PRE
  <script scriptcategory="kategorie_skriput" scriptname="jmeno_skriptu" app="ads" scriptparameter="parametry_skriptu" variablename="ScriptResult" />
PREEND
</pre>

//END
*/
