<?php
/*
 * Stanislav Elbl, 08-2014
 */

namespace RonPortal\XML\Classes;

use Ron\StringUtils;
use RonPortal\XML\XMLFormElement;

/**
 * Implementace XML tagu <showxmllog> - zobrazi obsah LOG z vyplneneho XML formulare
 */
class XMLElementShowXMLLog extends XMLFormElement
{
    function getHTMLOutput()
    {
        $result = '';
        $name = $this ->nahradPromenne($this ->getAttributeValue('name'));

        foreach ($this ->xmlForm ->logItems as $logItem) {
            if (!$name  ||  $logItem ->name == $name) {
                if ($this->isEmpty && !$this->elements) {
                    $attrs = $this->setHTMLAttributes(['class' => 'dotaznik_starsiodpoved']);
                    $attrs_str = $this->getHTMLAttributes($attrs);

                    $result .=
                        "<div $attrs_str>" .
                        '<span class="dotaznik_jmeno">' . $logItem ->time . ' - ' . StringUtils::htmlTextConvert($logItem ->userName) . ': </span>' .
                        '<span class="dotaznik_xmllog">' . StringUtils::longTextToHtml($logItem ->value, true). '</span>' .
                        '</div>';
                } else {
                    // element ma vnoreny obsah = vlastni format zobrazeni historie
                    $this
                        ->setVariableValue('xmllog_name', $logItem ->name)
                        ->setVariableValue('xmllog_time', $logItem ->time)
                        ->setVariableValue('xmllog_username', $logItem ->userName)
                        ->setVariableValue('xmllog_value', $logItem ->value)
                        ->setVariableValue('xmllog_value_br', StringUtils::longTextToHtml($logItem ->value))
                        ->setVariableValue('xmllog_poradipredavani', $logItem ->poradiPredavani)
                        ->setVariableValue('xmllog_urovenpredavani', $logItem ->urovenPredavani);

                    $result .=
                        $this->getElementsHTMLOutput();
                }
            }
        }

        return $result;
    }
}

/*
//DOC
PAGE showxmllog
<pre>
PRE
  <showxmllog name="jmeno">format</showxmllog>
PREEND
</pre>
//END
*/
