<?php
/**
 * stanislav.elbl, 22.06.2021 21:46
 */

namespace RonPortal\XML\Classes;

use RonPortal\Log;
use RonPortal\XML\XMLFormElementCommand;

class XMLElementSQLAction extends XMLFormElementCommand
{

    var $sqlText;

    function loadXML($xmlReader)
    {
        parent::loadXML($xmlReader);
        $this ->sqlText = $this ->getTextContent(false);
    }


    function doCommand()
    {
        $sqlVar = $this ->getAttributeValue('sqltextvariable');

        $sql = $sqlVar
            ? $this ->variableValue($sqlVar)
            : $this ->sqlText; // convert = false

        $sql = $this ->nahradPromenneSQL($sql);

//        try {
            $this->xmlForm->database->sql($sql); // nevraci zadne radky
            Log::logSQL($this ->xmlForm ->database, $sql, 'XMLAkce (' . $this ->xmlForm -> popis . ')');
//        } catch (\Exception $e) {
//            $this ->xmlForm ->addErrorMsg("Chyba v SQL dotazu! \n" . $sql, $this ->xmlForm ->database ->lastErrorText());
//            $this ->xmlForm ->addErrorMsg($e);
//        }
    }
}


/*
//DOC

PAGE sqlaction
<pre>
PRE
  <sqlaction sqltextvariable="promenna s sql vyrazem">SQL vyraz</sqlaction>
PREEND
</pre>

//END
*/
