<?php
/**
 * stanislav.elbl, 26.02.2022 22:41
 */

namespace RonPortal\XML\Classes;

use Ron\MVC\BaseViewObject;
use Ron\MVC\MessageManagerViewObject;
use Ron\MVC\TextViewObject;
use RonPortal\XML\XMLFormElement;

/**
 * Implementace tagu <viewobject> a <errormessages> - nezobrazi se primo, ale prida k formulari View object.
 * Lze pouzit napriklad pro zobrazeni view z PHP souboru.
 * Class XMLFormElementViewObject
 */
class XMLElementViewObject extends XMLFormElement
{
    protected function getView() {
        if ($this ->elementName == 'errormessages') {
            $this ->xmlForm ->showErrorMessages = false; // uz jsou zobrazeny
            return new MessageManagerViewObject();
        }

        $src = $this ->getAttributeValue('viewsource');
        if ($src) {
            return new BaseViewObject($src);
        }

        return new TextViewObject(
            parent::getElementsHTMLOutput(), null, null); // zadny wrap Element - muze byt primo v XML, takze neni duvod ho tady pridavat
    }


    function getHTMLOutput()
    {
        $view = $this ->getView();
        $this ->xmlForm ->viewObjects[] = $view;
        return $this ->xmlForm ->viewObjectPlaceholder;
    }
}

/*
//DOC
PAGE errormessages
<pre>
PRE
  <errormessages/>
PREEND
</pre>

PAGE viewobject
<pre>
PRE
  <viewobject viewsource="my_view_object_source.php"/>
PREEND
</pre>
//END
*/
