<?php
/**
 * stanislav.elbl, 24.05.2021 15:09
 */

namespace RonPortal\XML;

use Ron\MessageManager;
use RonPortal\Dochazka\DochazkaBrowser;
use RonPortal\Kalendar;

class XMLDochazkaBrowser extends DochazkaBrowser
{
    var $sql;


    function __construct($database)
    {
        parent::__construct($database, '');
    }


    function setFilterForm()
    {
        // parent::setFilterForm(); - nevolat
    }


    function nactiData()
    {
        MessageManager::addDebugMessage('XMLDochazkaBrowser::NactiOperaceDochazky: ' . $this ->sql);
        return $this ->database ->getSqlResult($this ->sql);
    }


    function vratTextKZaznamu($zaznam, $posledni)
    {
        $result = date('H:i', $this ->database ->stringToTimestamp($zaznam[0])) . ' ' . $zaznam[1];

        for ($i = 2; $i < count($zaznam); $i++) {
            if ($zaznam[$i]) {
                $result .= '<DIV class="poznamka">' . $zaznam[$i] . '</DIV>';
            }
        }

        return $result;
    }


    function getDataHTML()
    {
        $result = '';

        foreach ($this ->data as $index => $radek) {
            $cssClass = Kalendar::getStyleForDate($this ->database, $radek ->datum, $this ->nacistSvatky, $this ->kalendar);
            $class_str = $cssClass
                ? "class='$cssClass'"
                : '';

            $result .=
                "<tr $class_str>" .
                $this ->vratHlavickuRadku($this ->data[$index]) .
                $this ->vratTextProHodnoty($index) .
                "</tr>\n";
        }

        return $result;
    }


    function getHTML()
    {
        $result =
            '<table ' .
            ($this ->cssClass ? ' class="' . $this ->cssClass . '"' : '') .
            ($this ->tableId ? ' id="' . $this ->tableId . '"' : '') .
            ">\n" .
            "<tbody>\n";

        $this ->load();

        $result .= $this ->getDataHTML();

        $result .= "</tbody>\n</table>\n";

        return $result;
    }

}
