<?php
/*
 * Stanislav Elbl, 08-2014
 */

namespace RonPortal\XML;


use Ron\StringUtils;

/**
 * Zajistuje zpracovani textu nebo CDATA v XML formulari
 */
class XMLFormElementTextNode extends XMLFormElement
{
    // text nebo CDATA primo v XML
    var $text;

    /* @param \XMLReader $xmlReader */
    function loadXML($xmlReader)
    {
        //$this ->f_text = $xmlReader ->value;


        if ($xmlReader->nodeType == \XMLReader::CDATA) {
            $this->text = $xmlReader->value;
        } else {
            // TODO: otestovat!
            $this->text = $xmlReader->value;
            //$this ->f_text = $xmlReader ->readOuterXml(); // zajisti ponechani napr. &lt; - bohuzel nefunguje pro CDATA  - Poznamka: PROC? Pak nefunguji SQL Dotazy
        }


        //$this ->f_text = $xmlReader ->value;
        //$this ->f_text = $xmlReader ->readInnerXml();
        //$this ->f_text = $xmlReader ->readOuterXml(); - nefunguje pro CDATA
        $xmlReader->read();
    }


    function getTextContent($recursive)
    {
        return $this ->getOwnText();
    }


    /**
     * Vraci obsah
     * @return string
     */
    function getOwnText()
    {
        return StringUtils::fromUTF8($this->text);
    }


    function getHTMLOutput()
    {
        return $this->nahradPromenne( StringUtils::fromUTF8($this->text), 'html' );
    }


    function writeXMLOutput($xmlWriter)
    {
        $xmlWriter->text($this->text);
    }

    function copyXML($xmlWriter)
    {
        $xmlWriter->text($this->text);
    }
}
