<?php

/**
 * Pavel Rudol, RON Software
 *  4.9.2015
 */

namespace RonPortal\Zamestnanci;

use Ron\DB\SqlStatement;
use RonPortal\RozdeleniUtils;


///**
// * Class IDMediumFilterForm
// * @package Ron\RonPortal\Zamestnanci
// */
//class IDMediumField extends BrowserField
//{
//    private $volnaMedia;
//    private $vyrazenaMedia;
//
//    /**
//     * IDMediumFilterForm constructor.
//     * @param Database $database
//     * @param bool $volnaMedia
//     * @param $vyrazenaMedia
//     */
//    function __construct($database, $volnaMedia, $vyrazenaMedia)
//    {
//        parent::__construct($database);
//
//        $this->volnaMedia = $volnaMedia;
//        $this->vyrazenaMedia = $vyrazenaMedia;
//        $this->header = \Ron\ronText('identifikacni_medium');
//        $this->align = 'center';
//        $this->ordering = 1;
//    }
//
//    function getViewText($value, $rowNumber, $recordId, $rowData)
//    {
//        $result = '';
//
//        if($rowData[8] != ''){
//
//            if($this->volnaMedia) {
//                $result .=
//                    //Zobrazi odkaz v pripade ze jiz je karta k dane osobe pridelena
//                    '<a href="?menuid=zamestnanec&action=prirazenikarty&formaction=edit&volnamedia=' . ($this->vyrazenaMedia ? 1 : 0) . '&osoba=' . $rowData[0] . '&kodkarty=' . $rowData[7] .
//                    '&datumprideleni=' . $this->database->stringToTimestamp($rowData[9]) . '" >';
//                $result .= $rowData[8];
//                $result .= '</a>';
//            } else {
//                $result .=
//                    //Zobrazi odkaz v pripade ze jiz je karta k dane osobe pridelena
//                    '<a title="' . \Ron\ronText('nejsou_dalsi_volna_media') . '" href="?menuid=zamestnanec&action=prirazenikarty&formaction=edit&volnamedia=' . ($this->vyrazenaMedia ? 1 : 0) . '&osoba=' . $rowData[0] . '&kodkarty=' . $rowData[7] .
//                    '&datumprideleni=' . $this->database->stringToTimestamp($rowData[9]) . '" >';
//                $result .= $rowData[8];
//                $result .= '</a>';
//            }
//
//        }else {
//            if ($this->volnaMedia) {
//                $result .=
//                    '<a href="?menuid=zamestnanec&action=prirazenikarty&formaction=new&volnamedia=' . ($this->vyrazenaMedia ? 1 : 0) . '&osoba=' . $rowData[0] . '" >';
//                $result .= \Ron\ronText('vydani_media');
//                $result .= '</a>';
//            } elseif ($this->vyrazenaMedia) {
//                //$vyrazenaMedia
//                $result .= '<a title="' . \Ron\ronText('nejsou_volna_nebo_obnovit') . '" href="?menuid=zamestnanec&action=obnovenimedia&formaction=edit">' . \Ron\ronText('nejsou_volna_media') . '</a>';
//            } else {
//                $result .= '';
//            }
//        }
//        return $result;
//    }
//}

class SeznamPPBrowser extends SeznamZamestnancuBrowser
{
    public function __construct($database, $action)
    {
        parent::__construct($database, $action, true); // pracovni pomer = true

        $this->code = 'browserppomery';
        $this->tableId = 'browserppomery';

        $this->browserUrl = '?menuid=zamestnanec&action=seznampp&';

        //TODO: nechat, nebo uplne presunout do formulare zamestnance?
        /*global $enable_seznamPP;
        if ($enable_seznamPP)
        $this->addField(new IDMediumField($this->database, $this->dotazNaVolnaMedia(), $this->dotazNaVyrazenaMedia()));*/

    }


    public function loadColumnConfiguration($colSettings)
    {
        // kontrola, jestli neni zobrazeni sloupce v seznamu osob vypnuto
        if (isset($colSettings['pracovnipomery'])  &&  !$colSettings['pracovnipomery']) {
            return;
        }

        parent::loadColumnConfiguration($colSettings);
    }


    function getSQLFilter()
    {
        $params = $this ->database ->createParameters();

        $result = $this ->filterForm ->buildSqlFilter($params);

        $datumOd = $this ->filterForm ->getFilterValue('datumod') ?? time();
        $datumDo = $this ->filterForm ->getFilterValue('datumod', 'datumDo') ?? $datumOd;

        $result .=
            ($result ? ' AND ' : '') .
            '(' . $this->pravaZobrazit->sqlFiltr('PracovniPomer', $datumOd, $datumDo, $params) . ')';



        if ($this ->filterForm instanceof SeznamZamestnancuFilterForm) {
            switch ($this->filterForm->getFilterValue('stavpp')) {
                case 'aktivni' :
                    $result .=
                        ' AND PracovniPomer.DatumNastupu <= ' . $params ->addDateParameter($datumDo) .
                        ' AND ((PracovniPomer.DatumUkonceni >= ' . $params->addDateParameter($datumOd) . ') OR (PracovniPomer.DatumUkonceni IS NULL))';
                    break;

                case 'neaktivni' :
                    $result .=
                        ' AND PracovniPomer.DatumUkonceni IS NOT NULL' .
                        ' AND (PracovniPomer.DatumUkonceni <= ' . $params->addDateParameter($datumOd) . ')';
                    break;

                default :
            }

            if ($this ->filterForm ->getFilterValue('typzamestnance') !== null) {
                $result .=
                    ' AND (PracovniPomer.Zamestnanec = ' . $params ->addParameter((int)$this ->filterForm ->getFilterValue('typzamestnance')) . ')';
            }
        }

        foreach ($this ->filterForm ->getRozdeleniFilters() as $rozdeleniFilter) {
            if ($rozdeleniFilter ->getValue() !== null) {
                $filtrRozdeleni = RozdeleniUtils::sqlFilterRozdeleniPP($this->database, 'PracovniPomer',
                    $rozdeleniFilter ->getTypRozdeleni(), $rozdeleniFilter ->getValue(),
                    $this ->filterForm ->getOmezitObdobiOd(), $this ->filterForm ->getOmezitObdobiDo(),
                    $rozdeleniFilter ->getValue('vcetnePodrizenych'),
                    $params);

                if ($filtrRozdeleni) {
                    $result .=
                        ($result ? ' AND ' : '') .
                        $filtrRozdeleni;
                }
            }
        }

        return new SqlStatement($result, $params);
    }
}
