<?php

namespace RonPortal\Zamestnanci;

use Ron\DB\Database;

/**
 * Reprezentuje zaznam z tabulky TypNahlaseneZmeny
 */
class TypNahlaseneZmeny
{
    /** @var string */
    public $kod;

    /** @var string */
    public $popis;

    /** @var int */
    public $vyzadovatSchvaleni;

    /** @var int */
    public $povolitVIntrawebu;

    /**
     * Vraci asociativni pole typu nahlasenych zmen
     * @param Database $database
     * @return TypNahlaseneZmeny[]
     */
    public static function nactiTypyZmen(Database $database)
    {
        $result = [];

        $cursor = $database ->getSqlResult(
            'SELECT Kod, Popis, VyzadovatSchvaleni, PovolitVIntrawebu FROM TypNahlaseneZmeny',
            $database ->createParameters());

        while ($row = $cursor ->fetch()) {
            $zmena = new static();
            $zmena ->nactiRadek($row);
            $result[strtolower($zmena ->kod)] = $zmena;
        }

        return $result;
    }


    private function nactiRadek($row)
    {
        $this ->kod = $row[0];
        $this ->popis = $row[1];
        $this ->vyzadovatSchvaleni = (int)$row[2];
        $this ->povolitVIntrawebu = (int)($row[3] ?? 1); // pokud je null, nastavi 1
    }
}
