

(function() {
    let
        zdrojPoctuBenefituChange = function() {
            let val = $('input[name=ZdrojPoctuBenefitu]:checked').val();

            $("#row_sablona_benefitu_cs").toggleClass("d-none", val == 0);
            $("#row_sablona_benefitu_pocet").toggleClass("d-none", val != 0);
        },


        zobrazPodrobnostiBenefitu = function(data) {
            $(".podrobnosti-benefitu").each(function() {
               let
                   $this = $(this),
                   name = $this.data("nazev-pole");
               $this.text(data[name]);
            });

            let $pocetBodu = $(".benefit_pocet_bodu");
            $pocetBodu
                .val(data.hodnotaVBodech);

            if (data.variabilniHodnotaVBodech == 1) {
                $pocetBodu.removeAttr("readonly");
            } else {
                $pocetBodu.attr("readonly", "readonly");
            }

            $(".benefit_pocet_benefitu")
                .data("doplatekcastka", data.doplatekCastka)
                .data("hodnotavbodech", data.hodnotaVBodech)
                .trigger("change");
        },

        nactiDokumentySablony = function (idBenefitu) {
            $("#dokumenty_sablony_benefitu").dynamicHtml("?menuid=benefity&action=dokumentybenefitu&id=" + idBenefitu);
        },

        nactiPodrobnostiBenefitu = function() {
            let idBenefitu = 0;
            let $hidden = $('input[name="IdBenefitu"]');

            if ($hidden.length > 0) {
                idBenefitu = $hidden.val();
            } else {
                idBenefitu = $(this).val();
            }

            $.ajax("?menuid=benefity&action=podrobnostibenefitu&id=" + idBenefitu)
                .done(function(resultData) {
                    if (resultData.result == 'error') {
                        ron.showError(resultData);
                        return;
                    }

                    zobrazPodrobnostiBenefitu(resultData);
                })
                .fail(ron.ajaxErrorFunction);

            nactiDokumentySablony(idBenefitu);
        },

        pocetBenefituChange = function() {
            let
                $this = $(this),
                doplatekStr = $this.data('doplatekcastka'),
                hodnotaVBodechStr = $this.data('hodnotavbodech'),
                doplatekSelector = $this.data('doplatek-selector'),
                pocetBoduSelector = $this.data('pocetbodu-selector');

            if (doplatekStr) {
                let
                    doplatek = doplatekStr ? parseFloat(doplatekStr) : null,
                    hodnotaBodu = hodnotaVBodechStr ? parseInt(hodnotaVBodechStr) : null,
                    pocet = parseInt($this.val());

                if (pocet && doplatek) {
                    $(doplatekSelector).val(doplatek * pocet);
                }

                if (pocet &&  hodnotaBodu) {
                    let $pocet = $(pocetBoduSelector);

                    if ($pocet.attr("readonly")) {
                        $pocet.val(hodnotaBodu * pocet);
                    }
                }
            }
        };


    $(function() {
        let $form = $("#sablona_benefitu_form");

        if ($form.length) {
            $form
                .on("change", "input[name=ZdrojPoctuBenefitu]", zdrojPoctuBenefituChange)
                .on("change", "#sablona_idbenefitu", nactiPodrobnostiBenefitu)
                .on("change", "#sablona_pocetbenefitu", pocetBenefituChange);

            zdrojPoctuBenefituChange();
            nactiPodrobnostiBenefitu();

            let $benefit = $('#sablona_id_benefitu');
            if ($benefit.length) {
                nactiDokumentySablony($benefit.val());
            }
        }
        let $formPohyb = $("#pohyb_benefitu_form");

        if ($formPohyb.length) {
            $formPohyb
                .on("change", "#pohyb_idbenefitu", nactiPodrobnostiBenefitu)
                .on("change", '#pohyb_benefitu_pocetbenefitu', pocetBenefituChange);

            nactiPodrobnostiBenefitu();

            let $benefit = $('#pohyb_id_benefitu');
            if ($benefit.length) {
                nactiDokumentySablony($benefit.val());
            }
        }
    });
})();
//})();