

ronPortal.elearning = {
    storeTimeout: 10, // 15,
    forceStoreTimeout: 30, // 60

    ObsahKurzu: function() {
        this.id = 0;
        this.poradi = 0;
        this.nazev = '';
        this.obsah = '';

        this.kodStrany = '';
        this.zobrazitHlavicku = 1;
        this.zobrazitPaticku = 1;
        this.temaCislo = undefined;

        this.povolitPokracovatBezTestu = 0;

        this.insertUserName = '';
        this.insertTimestamp = '';
        this.updateUserName = '';
        this.updateTimestamp = '';
        this.$menuItem = null;  // odkaz na polozku v seznamu stranek
    },

    TestKurzu: function() {
        this.druhHodnoceni = 0;
        this.temaCislo = 0;
        this.kod = '';
        this.popis = '';
    },

    DataEditace: function() {
        this.id = 0;     // id kurzu
        this.revize = 0; // id revize kurzu
        this.obsahKurzu = [];
        this.testy = [];
    }
};



(function() {
    function onZobrazitPrilohu() {
        $(this).closest(".media-list").mediaViewer( {
            initialItem: this
        });
    }

    function onSmazatPrilohu() {
        let $this = $(this);

        $this.trigger("delete-media",
            function() {
                $this.remove();
            });
    }

    $(function() {
        $("#kurz_prilohy")
            .on("zobrazit-prilohu","li", onZobrazitPrilohu)
            .on("odstranit-prilohu", "li", onSmazatPrilohu);
    });

})();
ronPortal.elearning.initEditaceKurzu = function(dataEditace, initialTab) {
    console.log("initEditaceKurzu", dataEditace);
    var aktualniStrana = -1;

    var editor = null;
    var saveButton = null;
    var pridejZalozku = function(index) {
        var strana = dataEditace.obsahKurzu[index];

        strana.$menuItem = $("<li/>")
            .html("<span>" + strana.poradi + '. ' + strana.nazev + "</span>")
            .data("ron-poradi", strana.poradi)
            .data("ron-id", strana.id)
            .data("ron-index", index)
            .appendTo("#kurz_obsah_list");

        return strana.$menuItem;
    };
    var zobrazZalozky = function(strany) {
        $("#kurz_obsah_list").empty();

        for (var i = 0;  i < strany.length;  i++) {
            pridejZalozku(i);
        }
    };
    function najdiStranku(id) {
        for (let i = 0;  i < dataEditace.obsahKurzu.length;  i++) {
            if (dataEditace.obsahKurzu[i].id == id) {
                return dataEditace.obsahKurzu[i];
            }
        }

        return null;
    }


    function pridejNovouStranku(strana) {
        if (!strana) {
            return;
        }

        dataEditace.obsahKurzu[dataEditace.obsahKurzu.length] = strana;
        let $li = pridejZalozku(dataEditace.obsahKurzu.length - 1);

        zobrazZalozku($li);
    }
    function newContent() {
        $.ajax({
                url: "?menuid=kurzy&action=newcontent",
                type: "POST",
                data: {
                    idRevize: dataEditace.revize,
                    csrfkey: $("#kurz_new_content").data("csrfkey")
                }
        })
            .done( function(data) {
                if (data.result === "OK") {
                    pridejNovouStranku(data.obsah);
                } else {
                    ron.showError(data);
                }
            })
            .fail( function(jqXHR) {
                ron.logAjaxError(jqXHR, "Pri vkladani nove stranky doslo k chybe!");
            });
    }


    function updateDirty() {
        if (saveButton) {
            saveButton.disabled(!editor.isDirty());
        }
    }
    function saveContent(index) {
        if (!editor) {
            return;
        }

        dataEditace.obsahKurzu[index].obsah = editor.getContent();
        let strana = dataEditace.obsahKurzu[index];

        $.ajax(
            {
                url: "?menuid=kurzy&action=savecontent",
                type: "POST",
                data: {
                    id: strana.id,
                    obsah: strana.obsah,
                    csrfkey: $("#kurz_editace").data("csrfkey")
                }
            })
            .done( function(data) {
                if (data.result === "OK") {
                } else {
                    ron.showError(data);
                }
            }).fail( function(jqXHR) {
                ron.logAjaxError(jqXHR, "Pri ukladani stranky doslo k chybe!");
            });

        editor.isNotDirty = true;
        updateDirty();
    }
    let
        forceStoreTimer = null,
        storeTimer = null;
    function onStoreTimer() {
        storeTimer = null;

        if (forceStoreTimer) {
            clearTimeout(forceStoreTimer);
            forceStoreTimer = null;
        }

        saveContent(aktualniStrana);
    }
    function onForceStoreTimer() {
        forceStoreTimer = null;

        if (storeTimer) {
            clearTimeout(storeTimer);
            storeTimer = null;
        }

        saveContent(aktualniStrana);
    }

    function clearTimers() {
        if (storeTimer) {
            clearTimeout(storeTimer);
            storeTimer = null;
        }

        if (forceStoreTimer) {
            clearTimeout(forceStoreTimer);
            forceStoreTimer = null;
        }
    }
    function storeContent() {
        if (aktualniStrana < 0  ||  !editor  ||  !editor.isDirty()) {
            return;
        }

        if (storeTimer) {
            clearTimeout(storeTimer);
        }

        storeTimer = setTimeout(onStoreTimer, ronPortal.elearning.storeTimeout * 1000);

        if (!forceStoreTimer) {
            forceStoreTimer = setTimeout(onForceStoreTimer, ronPortal.elearning.forceStoreTimeout * 1000);
        }
    }
    function pageProperties(index) {
        let
            strana = dataEditace.obsahKurzu[index],
            $select = $("#test_obsahu");

        $("#kurz_page_title")
            .val(strana.nazev);

        $("#kurz_page_code")
            .val(strana.kodStrany);

        $select.empty();

        $("<option/>")
            .val("")
            .text("")
            .appendTo($select);

        for (let i = 0;  i < dataEditace.testy.length;  i++) {
            $("<option/>")
                .val(dataEditace.testy[i].temaCislo)
                .text(dataEditace.testy[i].popis)
                .appendTo($select);
        }

        $select.val(strana.temaCislo ? strana.temaCislo : "");

        $("#kurz_page_show_header").prop('checked', strana.zobrazitHlavicku);
        $("#kurz_page_show_footer").prop('checked', strana.zobrazitPaticku);
        $("#kurz_page_povolit_pokracovat").prop('checked', strana.povolitPokracovatBezTestu);
    }



    function zobrazStranu(index) {
        if (index < 0  ||  index >= dataEditace.obsahKurzu.length) {
            return;
        }

        clearTimers();

        if (aktualniStrana >= 0  &&  aktualniStrana < dataEditace.obsahKurzu.length) {
            if (editor.isDirty()) {
                saveContent(aktualniStrana);
            }
        }

        aktualniStrana = index;

        pageProperties(index);

        $("#kurz_editace").val(dataEditace.obsahKurzu[index].obsah);

        if (editor ) {
            editor.load(); // nacte obsah z textarea

            updateDirty();
        }
    }
    $("#elearning_tabs").rontabs({ initialPage: initialTab });
    function tinymceSetup(setupEditor) {
        editor = setupEditor;

        function onChangeText() {
            updateDirty();
            storeContent();
        }

        setupEditor.on("change", onChangeText);
        setupEditor.on("nodeChange", onChangeText );
        setupEditor.on("keyup", onChangeText );

        let saveBtn = {
            text: '<i class="fa glyph-ok"></i>',
            tooltip: ron._('Save'),
            onAction: function () {
                clearTimers();
                saveContent(aktualniStrana);
            },
            onPostrender: function() {
                saveButton = this;
            }
        };


        setupEditor.ui.registry.addButton('ron_save', saveBtn);
    }
    zobrazZalozky(dataEditace.obsahKurzu);
    function savePagePropertiesClick() {
        if (!editor) {
            return;
        }

        let strana = dataEditace.obsahKurzu[aktualniStrana];
        strana.nazev = $("#kurz_page_title").val();
        strana.kodStrany = $("#kurz_page_code").val();

        strana.zobrazitHlavicku = $("#kurz_page_show_header").prop('checked') ? 1 : 0;
        strana.zobrazitPaticku = $("#kurz_page_show_footer").prop('checked') ? 1 : 0;
        strana.povolitPokracovatBezTestu = $("#kurz_page_povolit_pokracovat").prop('checked') ? 1 : 0;
        strana.temaCislo = $("#test_obsahu").val();

        $.ajax(
            {
                url: "?menuid=kurzy&action=saveproperties",
                type: "POST",
                data: {
                    id: strana.id,
                    nazev: strana.nazev,
                    kodStrany: strana.kodStrany,
                    zobrazitHlavicku: strana.zobrazitHlavicku,
                    zobrazitPaticku: strana.zobrazitPaticku,
                    povolitPokracovatBezTestu: strana.povolitPokracovatBezTestu,
                    temaCislo: strana.temaCislo,
                    csrfkey: $(this).data("csrfkey")
                }
            })
            .done( function(data) {
                if (data.result === "OK") {
                    strana.$menuItem
                        .text(strana.poradi + '. ' + strana.nazev);
                } else {
                    ron.showError(data);
                }
            }).fail( function(jqXHR) {
                ron.logAjaxError(jqXHR, "Pri ukladani vlastnosti stranky doslo k chybe!");
            });
    }
    function onUploadImage(blobInfo, success, failure) {
        console.log("onUploadImage", blobInfo, success, failure);

        function successUpload(data) {
            if (success) {
                success(data.location);
            }
        }

        $("#elearning_prilohy")
            .fileuploader("uploadfile", blobInfo.blob(), blobInfo.filename(), successUpload);
    }
    var createLinklist = function(callback) {
        var list = [
            {text: ron._("Nasledujici_strana"), value:"%NEXT_PAGE%"},
            {text: ron._("Predchozi_strana"), value:"%PREV_PAGE%"},
            {text: ron._("Prvni_strana"), value:"%FIRST_PAGE%"},
            {text: ron._("Posledni_strana"), value:"%LAST_PAGE%"}
        ];

        for (var i = 0;  i < dataEditace.obsahKurzu.length;  i++) {
            if (dataEditace.obsahKurzu[i].kodStrany) {
                list[list.length] = { text: dataEditace.obsahKurzu[i].nazev, value: "%PAGE#" + dataEditace.obsahKurzu[i].kodStrany + "%" }
            }
        }

        list[list.length] = { text: ron._('Zavrit_okno_kurzu'), value:"%CLOSE%" };
        list[list.length] = { text: ron._('Certifikat'), value:"%CERTIFIKAT%" };

        callback(list);
    };
    tinymce.init({
        mode: "exact",
        selector: "#kurz_editace",
        language: ron._('TinyMCE_Lang_Code'),

        menubar: "edit insert view format table tools",
        statusbar: true,
        resize: "both",

        content_css: 'script/ronmce.css',

        height: "100%",

        style_formats_merge: true,
        style_formats: [
            {
                title: 'Image Left',
                selector: 'img',
                styles: {
                    'float': 'left',
                    'margin': '5px 10px'
                }
            },
            {
                title: 'Image Right',
                selector: 'img',
                styles: {
                    'float': 'right',
                    'margin': '5px 10px'
                }
            },
            {
                title: 'Image Inline',
                selector: 'img',
                styles: {
                    'float': 'none'
                }
            },
            {
                title: 'Asset',
                inline: 'span',
                classes: 'asset'
            }
        ],

        paste_data_images: true,
        images_upload_handler: onUploadImage,
        plugins: [
            "advlist autolink lists link charmap print preview anchor",
            "searchreplace visualblocks fullscreen",
            "insertdatetime table paste", // contextmenu
            "code image imagetools media table charmap" // textcolor colorpicker asset
        ],
        toolbar: "undo redo ron_save searchreplace | styleselect fontsizeselect | bold italic | forecolor backcolor | alignleft aligncenter alignright alignjustify | bullist numlist outdent indent | link image table charmap | fullscreen code",
        setup: tinymceSetup,

        link_list : createLinklist

    });
    var zobrazZalozku = function($li, tabId) {
        $("#kurz_obsah_list")
            .children().toggleClass("selected", false);

        $li
            .toggleClass("selected", true);

        zobrazStranu( $li.data("ron-index") );

        var $tabs = $("#elearning_tabs");

        if (tabId) {
            $tabs.rontabs("selectPage", tabId);
        } else {
            if (!$tabs.rontabs("getSelectedPageId") || $tabs.rontabs("getSelectedPageId") == "kurz_basic" || $tabs.rontabs("getSelectedPageId") == "kurz_testy") {
                $tabs.rontabs("selectPage", "kurz_text");
            }
        }
    };
    var osnovaClick = function(e) {
        zobrazZalozku( $(this) );
    };


    var odstranStranku = function(strana) {
        var index = $.inArray(strana, dataEditace.obsahKurzu);
        if (index < 0) {
            console.log('odstranStranku: zadana strana nebyla nalezena!');
            return;
        }
        dataEditace.obsahKurzu.splice(index, 1);
        if (aktualniStrana == index) {
            aktualniStrana = -1;
        }
        zobrazZalozky(dataEditace.obsahKurzu);
        if (dataEditace.obsahKurzu.length > index) {
            zobrazZalozku(dataEditace.obsahKurzu[index].$menuItem);
        } else if (!dataEditace.obsahKurzu.length) {
            $("#elearning_tabs").rontabs("selectPage", "kurz_basic");
        } else {
            zobrazZalozku(dataEditace.obsahKurzu[index - 1].$menuItem)
        }

    };


    function deletePage(index) {
        let strana = dataEditace.obsahKurzu[index];

        if ( !ron.confirm( ron._("Opravdu_smazat_stranku") + " " + strana.nazev + "?") ) {
            return;
        }

        $.ajax(
            {
                url: "?menuid=kurzy&action=deletecontent",
                type: "POST",
                data: {
                    id: strana.id,
                    csrfkey: $("#kurz_obsah_list").data("csrfkey")
                }
            })
            .done( function(data) {
                if (data.result === "OK") {
                    odstranStranku(strana)
                } else {
                    ron.showError(data);
                }
            }).fail( function(jqXHR) {
                ron.logAjaxError(jqXHR, "Pri mazani stranky doslo k chybe!");
            });
    }
    var nastavPoradiStranek = function(poradiStranek) {
        if (!poradiStranek) return;
        for (var i = 0;  i < poradiStranek.length;  i++) {
            var stranka = najdiStranku(poradiStranek[i].id);
            if (stranka) {
                stranka.poradi = poradiStranek[i].poradi;
            }
        }
    };


    function osnovaPreusporadana(e, ui) {
        let
            indexStrany = ui.item.data("ron-index"),
            strana = dataEditace.obsahKurzu[indexStrany],
            newIndex = ui.item.index(),
            novePoradi = dataEditace.obsahKurzu[newIndex].poradi;
        $.ajax(
            {
                url: "?menuid=kurzy&action=changeorder",
                type: "POST",
                data: {
                    id: strana.id,
                    newindex: novePoradi, // newIndex + 1 // (poradi je cislovane od 1)
                    csrfkey: $(this).data('csrfkey')
                }
            })
            .done( function(data) {
                if (data.result === "OK") {
                    nastavPoradiStranek(data.poradiStranek);
                    dataEditace.obsahKurzu.splice(indexStrany, 1);
                    dataEditace.obsahKurzu.splice(newIndex + (newIndex > indexStrany ? 1 : 0), 0, strana);
                    for (let i = 0;  i < dataEditace.obsahKurzu.length;  i++) {
                        dataEditace.obsahKurzu[i].$menuItem.data("ron-index", i);
                    }
                } else {
                    ron.showError(data);
                }
            }).fail( function(jqXHR) {
                ron.logAjaxError(jqXHR, "Pri zmene poradi stranek doslo k chybe!");
            });

    }

    function onEditovatText() {
        zobrazZalozku( $(this), "kurz_text" );
    }

    function onVlastnostiStranky() {
        zobrazZalozku( $(this), "kurz_podrobnosti_stranky" );
    }

    function onOdstranitStranku() {
        deletePage($(this).data("ron-index"));
    }


    $("#kurz_new_content")
        .on("click", newContent);

    $("#kurz_obsah_list")
        .on("click", "li", osnovaClick)
        .on("editovat-text", "li", onEditovatText)
        .on("vlastnosti-stranky", "li", onVlastnostiStranky)
        .on("odstranit-stranku", "li", onOdstranitStranku)
        .ronsortable( {
            axis: "y",
            stop: osnovaPreusporadana
        } )
    ;


    function onPrilohaUploaded($e, data) {
        editor.isNotDirty = false;
    }


    function onPageUploaded($e, data) {
        onPrilohaUploaded($e, data);

        $("#kurz_prilohy").zobrazPrilohy(data.prilohy);

        if (data  &&  data.strana) {
            pridejNovouStranku(data.strana);
        }
    }


    var onResize = function() {
    };
    var zobrazTesty = function() {
        var $tbody = $("#seznamPripojenychTestu");

        $tbody.empty();

        for (var i = 0;  i < dataEditace.testy.length;  i++) {
            $("<tr/>")
                .attr("class", (i % 2) ? "browsercolor1" : "browsercolor2")
                .append( $("<td/>").text(dataEditace.testy[i].kod) )
                .append( $("<td/>").text(dataEditace.testy[i].popis) )
                .append( $("<td/>")
                    .append( $("<a/>")
                        .attr("href", "?menuid=testy&action=show&idrevize=" + dataEditace.revize + "&druhhodnoceni=" + dataEditace.testy[i].druhHodnoceni + "&temacislo=" + dataEditace.testy[i].temaCislo)
                        .text( ron.translate('Editovat'))
                        .attr("target", "_blank")) )
                .appendTo($tbody);
        }
    };

    zobrazTesty();

    function novyTestError(error) {
        $("#novyTestOK").removeAttr("disabled");
        ron.showError(error);
    }


    function novyTestOK() {
        let $btn = $("#novyTestOK");

        $btn.attr("disabled", "disabled");

        let
            kod = $("#kodNovehoTestu").val(),
            popis = $("#popisNovehoTestu").val();

        if (kod === '') {
            novyTestError( ron.translate('Neni_zadan_kod_testu') );
            return false;
        }

        if (popis === '') {
            novyTestError( ron.translate('Neni_zadan_popis_testu') );
            return false;
        }


        $.ajax(
            {
                url: "?menuid=kurzy&action=newtest",
                type: "POST",
                data: {
                    idRevize: dataEditace.revize,
                    kod: kod,
                    popis: popis,
                    csrfkey: $btn.data("csrfkey")
                }
            })
            .done( function(data) {
                if (data.result === "OK") {
                    $("#novyTestDialog").dialog("close");

                    dataEditace.testy = data.testy;
                    zobrazTesty();
                } else {
                    novyTestError(data);
                }
            }).fail( function(jqXHR) {
                ron.logAjaxError(jqXHR, "Pri vytvareni noveho testu doslo k chybe!");
                novyTestError("Pri vytvareni noveho testu doslo k chybe!");
            });
    }

    function novyTest() {
        $("#novyTestOK").removeAttr("disabled"); // pri predchozim pouziti byl disabled

        $("#novyTestDialog").dialog ({
            modal : true,
            width: "auto",
            height: "auto"
        });
    }
    $("#pripojitNovyTest").on("click", novyTest);
    $("#novyTestOK").on("click", novyTestOK);


    $("#btn_podrobnosti_strany_OK")
        .on("click", savePagePropertiesClick);

    $("#elearning_prilohy")
        .on("fileuploaded", onPrilohaUploaded);
    $("#elearning_osnova")
        .on("fileuploaded", onPageUploaded);


    $( window)
        .on("resize", onResize);

    zobrazStranu(0);
};



(function($) {
    function onPrilohaUploaded($e, data) {
        $("#kurz_prilohy").zobrazPrilohy(data.prilohy);
    }
    function onDeletePriloha($e, afterDeleteCallback) {
        let
            idPrilohy = $($e.target).data("ron-id"),
            $list = $($e.delegateTarget),
            idRevize = $list.data("id-revize");

        if (!confirm( ron.translate('Opravdu_smazat_prilohu'))) {
            return false;
        }
        $.ajax({
            url: "?menuid=kurzy&action=deletepriloha", // &id=' + idPrilohy + '&revize=' + idRevize,
            type: "POST",
            data: {
                id: idPrilohy,
                revize: idRevize,
                csrfkey: $list.data("delete-csrf-token")
            }
        }).done(
            function(data) {
                if (data.result === "OK") {
                    if (afterDeleteCallback) {
                        afterDeleteCallback();
                    }
                } else {
                    ron.showError(data);
                }
            }).fail( function(jqXHR) {
                ron.logAjaxError(jqXHR, "Pri odstranovani prilohy doslo k chybe!");
            });

        return true;
    }


    $(function() {
        $("#kurz_prilohy")
            .on("delete-media", ".media-item", onDeletePriloha);

        $("#elearning_prilohy")
            .on("fileuploaded", onPrilohaUploaded);
    });
})(jQuery);


(function($) {
    function ulozHlavickuTestu() {
        ron.showWorkingInfo( ron._('Probiha_ukladani_dat'));

        let
            $container = $("#elearning_container"), // element .editace-testu
            baseUrl = $container.data('base-url'),
            druhHodnoceni = $container.data("druh-hodnoceni"),
            temaCislo = $container.data("tema-cislo");


        $.ajax( {
            url: baseUrl + '&action=updatetest',
            type: "POST",
            data: {
                idRevize : $("#idRevize").val(), // dataEditace.testEKurzu ? dataEditace.testEKurzu.idRevize : null,
                druhHodnoceni: druhHodnoceni,
                temaCislo: temaCislo,
                kod: $("#kodTestu").val(),
                popis: $("#popisTestu").val(),
                poznamka: $("#poznamkaTestu").val(),
                minPocetBodu: $("#minPocetBodu").val(),
                maxPocetBodu: $("#maxPocetBodu").val(),
                pocetPokusu : $("#pocetPokusu").val(),
                casovyLimit : $("#casovyLimit").val(),
                sirkaSloupce: $("#sirkaSloupce").val(),
                editovatPoznamku: $("#editovatPoznamku").prop("checked") ? 1 : 0,
                zobrazitOdpovediUspesne : $("#zobrazitOdpovediUspesne").val(),
                zobrazitOdpovediNeuspesne : $("#zobrazitOdpovediNeuspesne").val()
            }
        })
            .done( function(resultData) {
                ron.hideWorkingInfo();

                if (resultData.result === "OK") {

                } else {
                    ron.showError(resultData);
                }
            }).fail( function(jqXHR) {
            ron.hideWorkingInfo();
            ron.logAjaxError(jqXHR, "Pri ukladani hlavicky testu doslo k chybe!");
        });

        return false;
    }


    $(function() {
        $(document.body)
            .on("click", "#ulozitHlavickuTestu", ulozHlavickuTestu);
    });
})(jQuery);


$(function() {
    let
        $nadpis = $("#elearning_nadpis"),
        top = $nadpis.offset().top + $nadpis.outerHeight();

    $("#elearning_container")
        .css("top", top);
});

