

(function() {
    var schvalOsobyPlanovani = function(seznamOsob, defaultParams) {
        if (!seznamOsob.length) {
            return;
        }

        let $progressbar = $("#schvaleni_progress_bar");

        $progressbar.
            progressbar("max", seznamOsob.length).
            progressbar("value", 0);

        $("#schvaleni_errors").empty();

        $("#schvaleni_kapacit_progress").dialog( {
            modal: true,
            closeOnEscape: false,
            width: "auto",
            height: "auto"
        });

        var
            infoText = "",
            index = 0,
            cancel = false;

        var cancelClick = function() {
            cancel = true;
            $(this)
                .val( ron._('Ukoncuji'))
                .attr("disabled", "disabled");
        };

        var handleFinished = function() {
            if ($("#schvaleni_errors").children().length > 0) {
                $("#schvaleni_storno")
                    .val(ron._('Zavrit'))
                    .removeAttr("disabled")
                    .off("click")
                    .on("click", function() { window.location = "?menuid=kapacity"; });
            } else {
                window.location = "?menuid=kapacity";
            }
        };

        $("#schvaleni_storno")
            .off("click")
            .on("click", cancelClick);

        var schvalDalsiOsobu = function() {
            if (cancel  ||  index >= seznamOsob.length) {
                handleFinished();
                return;
            }

            var idpp = seznamOsob[index];
            index++;

            $progressbar.progressbar("value", index);

            if (idpp == "") {
                setTimeout(schvalDalsiOsobu, 0);
                return;
            }

            var params = "idpp=" + idpp;
            if ( $("#pk_zmenitschvaleni1").val() == "1" ) {
                params += "&schvaleni1=" + $("#pk_schvaleni1").val();
            }
            if ( $("#pk_zmenitschvaleni2").val() == "1" ) {
                params += "&schvaleni2=" + $("#pk_schvaleni2").val();
            }
            if ( $("#pk_zmenitschvaleni3").val() == "1" ) {
                params += "&schvaleni3=" + $("#pk_schvaleni3").val();
            }

            $.ajax("?menuid=kapacityjs&action=schvaleni&" + defaultParams + "&" + params)
                .done( function(resultData) {
                    if (resultData.errors) {
                        for (var i = 0;  i < resultData.errors.length; i++) {
                            $("<div/>")
                                .text(resultData.errors[i].errorText)
                                .addClass("errortext")
                                .appendTo("#schvaleni_errors");

                            $("#schvaleni_kapacit_progress").dialog( "option", "height", "auto" );
                        }
                        ron.showError(resultData.error);
                    }
                    if (resultData.jmeno) {
                        $("#schvaleni_progress_info").html(resultData.jmeno);
                    }
                    schvalDalsiOsobu();
                })
                .fail( function(jqXHR) {
                    ron.showAjaxError(jqXHR, "Pri schvalovani doslo k chybe!");
                });
        };

        schvalDalsiOsobu();
    };


    var schvalPlanovani = function() {
        let
            $this = $(this),
            seznamStr = $this.data("seznam-pp"),
            defaultParams = $this.data("params");

        if (seznamStr) {
            schvalOsobyPlanovani(seznamStr.split(";"), defaultParams);
            return false; // zabrani submit
        } else {
            if (!$this.data("kodRozdeleni")) {
                return false; // neprovede submit (neni co zapsat)
            }
        }
    };


    var zmenitSchvaleni = function() {
        let
            $this = $(this),
            index = $this.data("ron-index"),
            newValue = $this.data("ron-new-value"),

            $edit = $("#pk_schvaleni" + index),
            $cal = $("#pk_schvaleni_btn" + index);

        $edit.css("display", "inline");
        $cal.css("display", "inline-block");

        if (typeof newValue != "undefined") {
            $edit.val(newValue);
        }

        $("#pk_zmenitschvaleni" + index)
            .val("1");
        $("#pk_linkzmenitschvaleni" + index)
            .css("display", "none");
        $("#pk_ulozitschvaleni")
            .css("display", "inline");

        $("#pk_neulozitschvaleni")
            .css("display", "inline");

        return false;
    };


    $(function() {
        $("#schvaleni_progress_bar")
            .progressbar();

        $(".zmenitschvaleni")
            .on("click", zmenitSchvaleni);

        $("#pk_ulozitschvaleni")
            .on("click", schvalPlanovani);
    });
})();


$(function() {
    var zvyrazniOsobu = function($e) {
        var $table = $($e.delegateTarget);
        var $this = $(this);
        var idPP = $this.data("ron-id");

        $table.find(".planovani_osoba").toggleClass("vybrana_osoba", false);
        $table.find(".planovani_osoba").filter("div[data-ron-id='" + idPP + "']").toggleClass("vybrana_osoba", true);
    };


    $(".planovanidlesmen")
        .on("click", ".planovani_osoba", zvyrazniOsobu);
});
