


$(function() {

    var
        naplnSeznamOsob = function(data) {
            $("#osobaLoading").addClass("d-none");

            if (data && data.options) {
                var
                    $osoba = $("#osoba"),
                    originalValue = $osoba.val(),
                    valueFound = false;

                $osoba.empty();

                for (var i = 0; i < data.options.length; i++) {
                    if (data.options[i].key == originalValue) {
                        valueFound = true;
                    }

                    $("<option/>")
                        .attr("value", data.options[i].key)
                        .html(data.options[i].value)
                        .data("jmeno", data.options[i]["data-jmeno"])
                        .data("osobni-cislo", data.options[i]["data-osobni-cislo"])
                        .data("datum-nastupu", data.options[i]["data-datum-nastupu"])
                        .attr("class", data.options[i].cssClass)
                        .appendTo($osoba);
                }

                $osoba.ronselect("reloadItems");
                if (valueFound) {
                    $osoba.ronselect("value", originalValue);
                } else if (data.options.length) {
                    $osoba.ronselect("value", data.options[0].key);
                } else {
                    $osoba.ronselect("value", "");
                }
            }
        },


        naplnComboRozdeleni = function($combo, options) {
            var
                originalValue = $combo.val(),
                valueFound = false;

            $combo.empty();

            for (var i = 0; i < options.length; i++) {
                if (options[i].key === originalValue) {
                    valueFound = true;
                }

                $("<option/>")
                    .attr("value", options[i].key)
                    .text(options[i].value)
                    .attr("title", options[i].value)
                    .attr("class", options[i].cssClass)
                    .appendTo($combo);
            }

            $combo.ronselect("reloadItems");
            if (valueFound) {
                $combo.ronselect("value", originalValue);
            } else if (options.length) {
                $combo.ronselect("value", options[0].key);
            } else {
                $combo.ronselect("value", "");
            }
        },
        naplnSeznamRozdeleni = function(data) {
            $("#rozdeleniLoading").addClass("d-none");

            if (data  &&  data.optionsPopis) {
                naplnComboRozdeleni($("#rozdeleni_popis"), data.optionsPopis);
            }

            if (data  &&  data.optionsKod) {
                naplnComboRozdeleni($("#rozdeleni_kod"), data.optionsKod);
            }
        },
        nactiSeznamy = function(nacistRozdeleni) {
            var
                $selectOsoba = $("#osoba"),
                jenRozdeleni = $("#jenRozdeleni").prop("checked"),
                vcetnePodrizenych = $("#vcetnePodrizenych").prop("checked"),
                kodRozdeleni = null,
                obdobi = null,
                ctvrtleti = null,
                rok = null,
                datumOd = null,
                datumDo = null;

            if (!$selectOsoba.length) {
                return;
            }


            if ($("#typObdobi0").prop("checked")) {
                obdobi = $("#obdobiMesic").val();
            } else if ($("#typObdobi1").prop("checked")) {
                ctvrtleti = $("#obdobiCtvrtleti").val();
            } else if ($("#typObdobi2").prop("checked")) {
                rok = $("#obdobiRok").val();
            } else if ($("#typObdobi3").prop("checked")) {
                datumOd = $("#obdobiOd").val();
                datumDo = $("#obdobiDo").val();
            }

            if (jenRozdeleni) {
                kodRozdeleni = $("#rozdeleni_popis").val();
            }

            $("#osobaLoading").removeClass("d-none");

            var reportName = $("#reportName").val();
            $.ajax(
                "?menuid=reports&action=nactiosoby" +
                "&report=" + reportName +
                "&jenRozdeleni=" + (jenRozdeleni ? "1" : "0") +
                "&rozdeleni=" + kodRozdeleni +
                "&vcetnePodrizenych=" + (vcetnePodrizenych ? "1" : "0") +
                "&obdobi=" + (obdobi ? obdobi : '') +
                "&ctvrtleti=" + (ctvrtleti ? ctvrtleti : '') +
                "&rok=" + (rok ? rok : '') +
                "&datumOd=" + (datumOd ? datumOd : '') + "&datumDo=" + (datumDo ? datumDo : '')
            )
                .done(naplnSeznamOsob);

            if (nacistRozdeleni) {
                $("#rozdeleniLoading").removeClass("d-none");

                $.ajax(
                    "?menuid=reports&action=nactirozdeleni" +
                    "&report=" + reportName +
                    "&obdobi=" + (obdobi ? obdobi : '') +
                    "&ctvrtleti=" + (ctvrtleti ? ctvrtleti : '') +
                    "&rok=" + (rok ? rok : '') +
                    "&datumOd=" + (datumOd ? datumOd : '') + "&datumDo=" + (datumDo ? datumDo : '')
                )
                    .done(naplnSeznamRozdeleni);
            }
        };
    var onRozdeleniClick = function() {
        nactiSeznamy(false);
    };

    var onObdobiClick = function() {
        nactiSeznamy(true);
    };


    $("#reportDialogForm")
        .on("click", "#jenRozdeleni", onRozdeleniClick)
        .on("click", "#vcetnePodrizenych", onRozdeleniClick)
        .on("change", "#rozdeleni_popis", onRozdeleniClick)
        .on("click", ".typObdobi", onObdobiClick)
        .on("change", ".obdobiInput", onObdobiClick)
    ;
});
