


var ronPortal = {
    zkontrolujPravo : function (idPP, typPrava) {
        var callback = null;
        var typPrava2 = undefined;

        for (var i = 0; i < arguments.length; i++) {
            if (typeof(arguments[i]) == 'function') callback = arguments[i];
            else typPrava2 = arguments[i];
        }

        var url =
            "?menuid=utils&action=prava&idpp=" + idPP + "&typprava=" + typPrava +
            (typPrava2 ? "&typprava2=" + typPrava2 : "");

        var result = false;

        $.ajax(url, {
            async: (callback ? true : false)
        }).done(function (data) {
            if (callback) callback(data.result);
            else result = data.result;
        }).fail(function (jqXHR) {
            ron.showAjaxError(jqXHR, "Pri nacitani prav doslo k chybe!");
        });

        return callback ? true : result;
    },


    getClassSchvaleniAbsence : function(schvaleni) {
        switch (schvaleni) {
            case 1 :    // schvalena
            case 5 :    // zadost o zruseni zamitnuta
                return 'absence-schvalena';

            case 2 :
                return 'absence-zamitnuta'

            case 3 :
                return 'absence-zadostozruseni';

            case 4 :
                return 'absence-zrusena';

            case 0 :    // bez urceni
            default :
                return 'absence-neschvalena';
        }
    }

};
function zkontrolujPravo(idPP, typPrava, callBack) {
    console.log('FUNKCE zkontrolujPravo je deprecated! Pouzijte ronPortal.zkontrolujPravo');
    return ronPortal.zkontrolujPravo(idPP, typPrava, callBack);
}
function VyberRozdeleni(sender)
{
    var value = sender.value;

    sender.form.rozdeleni.value = value;
    sender.form.rozdeleni_kod.value = value;

    sender.form.submit();
}
ronPortal.dateStringFromRC = function () {
    var elementRC = $(this);
    var rodneCislo = $(this).val().toString();
    var rodneCisloToDatumNarozeni = function (rodneCislo) {
        var year = Number();
        var month = Number();
        var day = Number();
        var rc = '';
        var index = Number();
        var currentYear = new Date().getFullYear();

        var result = 0;
        rc = rodneCislo.replace(/[/\\\-\s]/g, ''); //odstraneni mezer, lomitek, pomlcek

        if (rc.length < 9) throw rodneCislo + ' nesplnuje minimalni delku';

        if (isNaN(rc)) throw rodneCislo + ' nelze prevest na cislo';

        if (rc.length > 6) {
            year = parseInt('19' + rc.substr(0, 2));

            if ((year < 1954) && (rc.length > 9))
                year = year + 100;
        }
        else {
            year = parseInt('20' + rc.substr(0, 2));
            if (year > currentYear)
                year = year - 100;
        }

        try {
            month = parseInt(rc.substr(2, 2));
            if (month > 50)
                month = month - 50;
            day = parseInt(rc.substr(4, 2));

            if (isValidDate(year, month, day)) {
                ron.debugLog('rok: ' + year, 'mesic: ' + month, 'den: ' + day);
                result = new Date(year, month-1, day);
            }
        }
        catch (err) {
            throw rodneCislo + ' nelze prevest na datum narozeni.' + '\n' + err.toString();
        }

        $(elementRC).val(rc);
        return result;
    };
    var isValidDate = function (year, month, day) {
        if (!((month >= 1) && (month <= 12))) {
            throw month + " neni platny mesic";
        }
        if (!((day >= 1) && (day <= 31))) {
            throw day + " neni platny den";
        }

        var datum = new Date();
        try {
            datum.setFullYear(year);
            datum.setMonth(month);
            datum.setDate(day);
        }
        catch (err) {
            throw "Chybny format data." + err.toString();
        }

        return true;
    };


    $(elementRC).removeClass('app_input_error').prop('title','');

    try {
        $('input[name=' + $(elementRC).data('ronrc-inputdatename') + ']').val(ron.utils.dateToString(rodneCisloToDatumNarozeni(rodneCislo)));
    }
    catch (err) {
        ron.showError(err);
        $(elementRC).addClass('app_input_error').prop('title',err);
    }
};

ronPortal.disableInputs = function (cssClass) {
    var stopPropagation = function (e) {
        e.stopImmediatePropagation();
        return false;
    };

    $('.' + cssClass + ' input:text')
        .prop('readonly', true)
        .addClass('form_readonly');

    $('.' + cssClass + ' input:checkbox')
        .prop('disabled', true);

    $('.' + cssClass + ' .app_combo')
        .prop('disabled', true)
        .addClass('form_readonly');

    $('.' + cssClass + ' .showcalendar')
        .on('click', stopPropagation);

    $('.' + cssClass + ' .js')
        .on('click', stopPropagation);

};


(function() {
    var
        $div = null,

        zobrazNahled = function () {
            var
                $this = $(this),
                url = $this.data("foto-url"),
                alt = $this.data("foto-alt");

            if (!url) {
                return;
            }

            if (!$div) {
                $div = $('<div class="ronInfoFoto_full"></div>');
            } else {
                $div
                    .detach()
                    .empty();
            }

            var
                $img = $('<img/>')
                    .attr("src", url)
                    .attr("alt", alt ? alt : '');

            $div
                .append($img)
                .appendTo($this)
                .show();
            var
                windowRight = $(window).scrollLeft() + $(window).width(),
                boxRight = $this.offset().left + $img.width();

            $div.css('left', (boxRight > windowRight) ? -$img.width() : 'auto');
            var
                bottomView = $(window).scrollTop() + $(window).height(),
                bottomBox = $this.offset().top + $this.height() + $img.height();

            if (bottomBox > bottomView) {
                $div.css('top', -$img.height() - $this.height());
            } else {
                $div.css('top', 'auto');
            }
        },

        skryjNahled = function() {
            if ($div) {
                $div.hide().detach();
            }
        };

    $(function() {
        $("body")
            .on('mouseenter', '.ronInfoFoto', zobrazNahled)
            .on('mouseout', '.ronInfoFoto', skryjNahled);
    });
})();


ronPortal.ronCombo = {
    onComboChange : function(index, options) {
        var $this = $(this);

        var keyField = 'kod';
        var fieldsData = $this.data('ron-combo-fields');

        if (fieldsData !== undefined) {
            keyField = fieldsData.split(';')[0];
        }

        var hiddenInputName = $this.data('ron-combo-code');

        var newValue = null;
        if (index !== null) {
            newValue = options.items[index][keyField];
        }

        $('[name="' + hiddenInputName + '"]').val(newValue);
    },
    nactiData : function ($elems, callback, comboBoxChange) {
        var $firstElem = $elems.first();
        var url = $firstElem.data('ron-combo-url');

        var fields = ['kod', 'popis'];
        var fieldsData = $firstElem.data('ron-combo-fields');

        if (fieldsData !== undefined) {
            fields = fieldsData.split(';');
        }

        var textField = 'popis';
        var textFieldData = $firstElem.data('ron-combo-text-field');

        if (textFieldData !== undefined) {
            textField = textFieldData;
        }

        var onChangeEvent = ronPortal.ronCombo.onComboChange;
        if (comboBoxChange)
            onChangeEvent = comboBoxChange;

        if (url) {
            $elems.toggleClass("loading", true);
            $.ajax(url)
                .done(function (data) {
                    $elems.each(function () {
                        var $this = $(this);

                        var hiddenInputName = $this.data('ron-combo-code');
                        var $hiddenInput    = $('[name="' + hiddenInputName + '"]');
                        var puvodniHodnota = $hiddenInput.val();
                        if (($this.data('ron-combo-default-value') !== '') && (puvodniHodnota === '')) {
                            puvodniHodnota = $this.data('ron-combo-default-value');
                        }

                        if (data.result === "OK") {
                            if ($this.data('ron-combo-selectfirst') && (puvodniHodnota === '') && (data.items.length === 1)) {
                                puvodniHodnota = data.items[0].kod;
                                $hiddenInput.val(puvodniHodnota)
                            }
                            $this.toggleClass('loading', false);
                            $this.ronselect({
                                items: data.items,
                                columns: fields,
                                maxVisibleRows: 30,
                                textColumn: textField,
                                valueColumn: "kod",
                                onChange: onChangeEvent,
                                initialValue: puvodniHodnota
                            });
                        } else {
                            ron.showError(data);
                        }
                    });
                    if (callback)
                        callback.call();
                })
                .fail(function () {

                });

        }
    },
    nastavCombo : function () {
        var $selectCombo = $(".ron_select_combo");

        var comboGroup = '';
        var groups = [];

        if ($selectCombo.length > 0) {
            $selectCombo.each(function () {
                comboGroup = $(this).data('ron-combo-group');

                if ($.inArray(comboGroup, groups) === -1) {
                    groups.push(comboGroup);
                }
            });
            $(groups).each(function () {
                ronPortal.ronCombo.nactiData($selectCombo.filter("input[data-ron-combo-group='" + this + "']"));
            });
        }
    }

};

$( function() {

    var showFoto = function() {
        var url = $(this).attr("href");

        ron.showImage(url);
        return false;
    };


    $("body")
        .on("change", 'input.ronRC', ronPortal.dateStringFromRC) //pro vsechny inputy s tridou ronRC aktivuje prevod RC na datum do inputu definovaneho v data-ronrc-inputdatename
        .on("click", ".link_foto", showFoto)  // zobrazeni obrazku po kliknuti
        ;//.on('mouseover', '.ronInfoFoto', ronPortal.ronFoto.zobrazNahled)

    ronPortal.ronCombo.nastavCombo();
    (function() {
        var logoutTime = null;
        var $logout_info_message = null;
        var $logout_info_time = null;
        var timeVisible = false;
        var showTimeFunc = function() {
            if (!timeVisible) return;

            var remaining = logoutTime - Date.now();
            if (remaining > 0) {
                $logout_info_time.text(ron.utils.secondsToString(Math.floor((logoutTime - Date.now()) / 1000)));
                setTimeout(showTimeFunc, 1000);
            } else {
                $logout_info_time.text(ron.utils.secondsToString(0));
                window.location.replace(window.location);
            }
            timeVisible = true;
        };


        var resetTimer = function() {
            $.ajax('?menuid=utils&action=resetTimer')
                .done(handleLastAccessResult);
        };

        var timer = null;

        var setRemainingTimer = function() {
            var showTime = false;

            if (timer) {
                clearTimeout(timer);
                timer = null;
            }

            if (logoutTime - Date.now() > 600000) {
                timer = setTimeout(logoutTimerFunc, 300000);
            } else if (logoutTime - Date.now() > 360000) {
                timer = setTimeout(logoutTimerFunc, logoutTime - Date.now() - 300000);
            } else if (logoutTime - Date.now() > 120000) {
                timer = setTimeout(logoutTimerFunc, logoutTime - Date.now() - 120000);
            } else if (logoutTime - Date.now() > 20000) {
                showTime = true;
                timer = setTimeout(logoutTimerFunc, 10000);
            } else {
                showTime = true;
                timer = setTimeout(logoutTimerFunc, logoutTime - Date.now());
            }

            if (showTime) {
                if (!$logout_info_message) {
                    $logout_info_message = $("<div/>")
                        .attr("class", "app_info_bubble")
                        .attr("id", "logout_info_message")
                        .html(ron.translate("Automaticke_odhlaseni_info"))
                        .on("click", resetTimer)
                        .appendTo($(document.body));

                    $logout_info_time = $("#logout_info_time");
                }

                if (!timeVisible) {
                    timeVisible = true;
                    showTimeFunc();
                }
                $logout_info_message.show();
            } else {
                if ($logout_info_message) $logout_info_message.hide();
                timeVisible = false;
            }
        };
        var handleLastAccessResult = function(data) {
            if (!data.logoutTimer) return;

            logoutTime = Date.now() + 1000 * data.remaining;
            if (data.valid) {
                setRemainingTimer();
            }
        };
        var logoutTimerFunc = function()
        {
            $.ajax('?menuid=utils&action=lastAccess')
                .done(handleLastAccessResult);
        };

        setTimeout(logoutTimerFunc, 5000);
    })();
    let $topMenu = $("#floatingmenulist");

    if ($topMenu.length) {
        ron.floatingMenu($topMenu, {
            $originalElement: $("#topmenu"),
            $parentElement: $("#floatingmenu"),
            itemSelector: '.appselect-item'
        });
    }

});

$(function() {

    var
        pscInputChange = function() {
            let
                $this = $(this),
                mestoSelector = $this.data("mesto-input-selector");

            if (mestoSelector) {
                let
                    $mesto = $(mestoSelector),
                    ronSelect = $mesto.ronselect("instance");

                ronSelect.setDropDownFilter($this.val());
            }
        },

        mestoInputActivate = function(event, data) {
            console.log(data.item);
            if (!data  || !data.item) {
                return;
            }

            let
                $this = $(this),
                pscSelector = $this.data("psc-input-selector"),
                obecSelector = $this.data("obec-input-selector");

            if (pscSelector  &&  data.item.psc) {
                $(pscSelector).val(data.item.psc);
            }

            if (obecSelector  &&  data.item.obec) {
                console.log("nastavuji obec", data.item.obec);
                $(obecSelector).ronselect("instance").value(data.item.obec);
            }

            $this.ronselect("instance").setDropDownFilter();
        };

    $("body")
        .on("input", ".psc-input", ron.delayedLaunch(1000, pscInputChange, true))
        .on("itemactivate", ".mesto-input", mestoInputActivate);
});
ronPortal.decodePersonalDocument = function(data) {
    if (!data) {
        return {
            error : 'Nebyla nactena zadna data!'
        }
    }

    let
        decode2LinesData = function(lines) {
            let result = {};
            result.idType = lines[0].substring(0, 2).replaceAll("<", "");
            result.issuingState = lines[0].substring(2, 5).replaceAll("<", "");
            let
                hlpStr = lines[0].substring(5),
                hlpPos = hlpStr.indexOf("<<");

            if (hlpPos >= 0) {
                result.surname = hlpStr.substring(0, hlpPos).replaceAll("<", " ").trim();
                result.name = hlpStr.substring(hlpPos + 1, hlpStr.length - 1).replaceAll("<", " ").trim();
            } else {
                result.surname = hlpStr.replaceAll("<", " ").trim();
                result.name = "";
            }

            result.surname = ron.utils.capitalizeFirstLetters(result.surname.toLowerCase());
            result.name = ron.utils.capitalizeFirstLetters(result.name.toLowerCase());
            result.idNumber = lines[1].substring(0, 9).replaceAll("<", "");
            result.nationality = lines[1].substring(10,13).replaceAll("<", "");
            result.birthDateStr = lines[1].substring(13, 19);
            result.gender = lines[1].substring(20, 21);
            result.expirationStr = lines[1].substring(21, 27);

            return result;
        },

        decode3LinesData = function(lines) {
            let result = {};
            result.idType = lines[0].substring(0, 2).replaceAll("<", "");
            result.issuingState = lines[0].substring(2, 5).replaceAll("<", "");
            let
                hlpStr = lines[0].substring(5),
                hlpPos = hlpStr.indexOf("<");

            result.idNumber = hlpPos >= 0
                ? hlpStr.substring(0, hlpPos)
                : hlpStr;   // tohle je zrejme chyba, ale nebudeme to hrotit - nemelo by nastat
            result.birthDateStr = lines[1].substring(0, 6);
            result.gender = lines[1].substring(7, 8);
            result.expirationStr = lines[1].substring(8, 14);
            result.nationality = lines[1].substring(15,18).replaceAll("<", "");
            hlpPos = lines[2].indexOf("<<");
            if (hlpPos >= 0) {
                result.surname = lines[2].substring(0, hlpPos).replaceAll("<", " ").trim();
                result.name = lines[2].substring(hlpPos + 1, lines[2].length - 1).replaceAll("<", " ").trim();
            } else {
                result.surname = lines[2].replaceAll("<", " ").trim();
                result.name = "";
            }

            result.surname = ron.utils.capitalizeFirstLetters(result.surname.toLowerCase());
            result.name = ron.utils.capitalizeFirstLetters(result.name.toLowerCase());

            ron.debugLog("decode3LinesData result", result);
            return result;
        };


    let lines = (typeof(data) == "string")
        ? data.split("\n")
        : data;

    ron.debugLog("decodePersonalDocument - data k parsovani:", lines);

    if (lines[0].substring(0, 3) === 'RON') {
        let
            replaceGt = lines[0].replace(/</g, ""),
            IDMedia = replaceGt.replace("RON", "");

        return {
            idNumber: IDMedia
        }
    }


    lines = lines.filter((str) => str.trim() !== '');

    if (lines.length === 1  &&  lines[0].length === 90) {
        return decode3LinesData([
            lines[0].substring(0, 30),
            lines[0].substring(30, 60),
            lines[0].substring(60, 90)
        ]);
    }

    if (lines.length < 2  ||  !lines[0]  ||  !lines[1]) {
        return { error: 'Spatny format nactenych dat. Data musi obsahovat nejmene 2 radky!' };
    }

    if (lines.length >=3 && lines[2]) {
        return decode3LinesData(lines);
    }

    return decode2LinesData(lines);
};


(function() {
    let
        $cteckaDokladuDialog = null,
        $cteckaDokladuInput = null,
        $initiator = null;


    function processData(lines)
    {
        let result = ronPortal.decodePersonalDocument(lines);

        if (!result.error) {
            let $element = $initiator ? $initiator : $cteckaDokladuInput;
            $element.trigger("documentreader", result);
            $cteckaDokladuDialog.dialog("close");
        } else {
            ron.showError(result.error);
        }
    }
    function keyPress($e) {
        let $this = $(this);

        if ($e.keyCode === 13) {
            let lines =  $this.val().split("\n");

            if (lines.length >= 3) {
                processData(lines);
            } else if (lines.length === 2  &&  lines[0].length >= 36  &&  lines[1].length >= 36) {
                processData(lines);
            } else if (lines.length  &&  lines[0].length === 90) {
                processData(lines);
            }
        }
    }
    function okClicked() {
        let lines =  $cteckaDokladuInput.val().split("\n");
        processData(lines);
    }

    function cteckaDokladuClick() {
        $initiator = $(this);

        if (!$cteckaDokladuDialog) {
            $cteckaDokladuDialog = $("<div class='rondialog'/>")
                .attr("title", ron._("Ctecka_dokladu"))
                .append(
                    $("<div/>").html(ron._("navstevy_nacist_doklad_a_potvrdit"))
                );

            $cteckaDokladuInput =
                $("<textarea/>")
                    .addClass("form-control")
                    .attr("rows", 4)
                    .attr("cols", 70)
                    .appendTo($cteckaDokladuDialog)
                    .on("keypress", keyPress);

            $("<div/>")
                .addClass("buttons")
                .appendTo($cteckaDokladuDialog)
                .append(
                    $("<button/>")
                        .html(ron._("OK"))
                        .addClass("submitbutton")
                        .on("click", okClicked)
                )
                .append(
                    $("<button/>")
                        .html(ron._("Cancel"))
                        .addClass("button cancel")
                );
        }

        $cteckaDokladuInput.val("");

        $cteckaDokladuDialog
            .dialog({
                modal: true,
                resizable: false,
                width: "auto",
                height: "auto"
            });

        $cteckaDokladuInput
            .focus();
    }


    function onDocumentReader($e, documentData) {
        let $this = $(this);

        if (documentData  &&  documentData.surname  &&  $this.data("prijmeni-input")) {
            $($this.data("prijmeni-input")).val(documentData.surname);
        }

        if (documentData  &&  documentData.name  &&  $this.data("jmeno-input")) {
            $($this.data("jmeno-input")).val(documentData.name);
        }

        if (documentData  &&  documentData.idNumber  &&  $this.data("doklad-input")) {
            $($this.data("doklad-input")).val(documentData.idNumber);
        }
    }

    $(function() {
        $("body")
            .on("click", ".ctecka-dokladu", cteckaDokladuClick)
            .on("documentreader", ".ctecka-dokladu", onDocumentReader);
    })

}());


$(function() {

    ronPortal.dokumentDialog = function(options) {

    };
});

var vlozitDokumentResult = null; // volano z vnoreneho iframe


(function() {
    function vyberStarsihoDokumentu() {
        if (this.value) {
            this.form.soubor.value = null;
        }
    }
    function updateBrowser(updateBrowserSelector, updatedData) {
        if (!updateBrowserSelector) {
            return;
        }

        let $browser = $(updateBrowserSelector);

        if (!$browser.length) {
            return;
        }
        let $tr = $("<tr>");

        console.log(updatedData);

        $browser.append($tr);

        $("<td/>")  // datum
            .text(updatedData.den)
            .appendTo($tr);

        $("<td/>")  // typ
            .text(updatedData.popisTypu)
            .appendTo($tr);

        $("<td/>")  // popis
            .text(updatedData.popis)
            .appendTo($tr);

        $("<td/>")  // nazev souboru
            .append(
                $("<a/>")
                    .text(updatedData.jmenoSouboru)
                    .attr("href", $browser.data("download-link") + updatedData.id)
                    .attr("target", "_blank")
            )
            .appendTo($tr);

        if ($browser.data('update-columns') !== '') {
            let columns = $browser.data('update-columns').split(';');
            $(columns).each(function (key, value) {
                $("<td/>")  // doplnene sloupce v browseru
                    .text(updatedData[value])
                    .appendTo($tr);
            });
        }

        $("<td/>")  // TODO: odkaz na smazani
            .appendTo($tr);

        $tr.appendTo($browser);
    }


    function uploadingFinished() {
        let $dialog = $("#novydokument");
        console.log("uploadingFinished");

        if ($dialog.data("action") === "reload") {
            let url = $dialog.data("redirect-url");
            if (!url) {
                url = window.location;
            }

            console.log("redirect to:", url);

            window.location = url;
            return;
        }

        $dialog.dialog("close");
    }


    function handleUploadForm($form) {
        let
            url= $form.attr("action"),
            data = new FormData($form.get(0));

        $.ajax({
            type: "POST",
            url: url,
            data: data,
            contentType: false, // aby to fungovalo s FormData
            processData: false
        }).done(function (data) {
            if (data.result === "OK") {
                let $novyDokument = $("#novydokument");
                $novyDokument.trigger("fileuploaded", data);
                uploadingFinished();
                updateBrowser($novyDokument.data("update-browser"), data);
            } else {
                ron.showError(data);
            }
        }).fail(function (jqXHR) {
            ron.showError("Pri nahravani souboru doslo k chybe!");
            ron.logAjaxError(jqXHR, "Pri nahravani souboru doslo k chybe!");
        }).always(function() {
            $("#novydokument_progressrow").hide();
        });
    }


    function vlozitNovyDokument() {
        let
            $form = $(this.form),
            $fileInput = $(this.form.soubor);

        $("#novydokument_buttonsrow").hide();
        $("#novydokument_error").html("");

        $("#novydokument_progressrow").show();

        if ($form.attr("target")) {
            console.log("target je nastaveno => pouziju stary zpusob odesilani s pomocnym frame");
            $form.submit();
        } else {
            handleUploadForm($form);
            return false;
        }


        return true;
    }

    $(function() {
        $("#novydokument")
            .on("change", "#vyberStarsihoDokumentu", vyberStarsihoDokumentu)
            .on("click", "#vlozitNovyDokumentBtn", vlozitNovyDokument);
    });
    ronPortal.showDokumentDialog = function (afterUploadCallback) {
        let redirectUrl = null;

        vlozitDokumentResult = null;

        if (typeof afterUploadCallback == 'function') {
            vlozitDokumentResult = afterUploadCallback;
        } else if (afterUploadCallback) {
            redirectUrl = afterUploadCallback;
        }

        let $dialog = $("#novydokument");

        if (!vlozitDokumentResult  &&  !redirectUrl  &&  $dialog.data('redirect-url')) {
            redirectUrl = $dialog.data('redirect-url');
        }

        if (redirectUrl) {
            vlozitDokumentResult = function(result) {
                processDokumentResult(result, redirectUrl);
            };
        }

        $dialog
            .dialog({
                modal: true,
                resizable: false,
                width: "auto",
                height: "auto"
            });
    };
})();
function processDokumentResult(result, urlOK) {
    if (result  &&  result.result === 'OK') {
        if (urlOK) window.location.replace(urlOK);
        return true;
    }
    else {
        if (!result) {
            console.log('Nebyla prijata zadna data po spusteni Agenta!'); // nastane v pripade, ze se pousti primo exe
            if (urlOK) window.location.replace(urlOK);
        } else {
            ron.showError(result, '#novydokument_error');
        }

        $("#novydokument_buttonsrow").show();
        $("#novydokument_progressrow").hide();
        return false;
    }
}

$(function() {
    let
        deleteDocument = function() {
            let idField = $("#deleteDocumentId");

            if (idField.length) {
                idField.val(this.data("document-id"));
                idField.closest("form").submit();
            } else {
                alert('Chyba ve funkci deleteDocument - neexistuje pole deleteDocumentId!');
            }
        },

        onDeleteDocumentClick = function() {
            ron.confirmQuestion( $(this), deleteDocument );
        },

        onShowDokumentDialogClick = function() {
            let
                $this = $(this),
                $dialog = $("#novydokument"),
                fields = $this.data("fields");

            if (fields) {
                fields = fields.split(";");

                for (let i = 0;  i < fields.length;  i++) {
                    let $field = $dialog.find(".documentUploadInput[name=" + fields[i] + "]");
                    $field.val($this.data("field-" + fields[i].toLowerCase())); // nazvy atributu maji byt lowercase (HTML5 spec.)
                }
            }

            ronPortal.showDokumentDialog();
            return false;
        };


    $("body")
        .on("click", ".delete-document-post", onDeleteDocumentClick)
        .on("click", ".show-dokument-dialog", onShowDokumentDialogClick);
});

(function($) {

    let
        provedPrepocetDPH = function() {
            let
                $this = $(this),
                selectorBezDPH = $this.data("selector-bez-dph"),
                selectorSDPH = $this.data("selector-s-dph"),
                selectorDPH = $this.data("selector-dph"),
                selectorSazbaDPH = $this.data("selector-sazba-dph"),
                sazbaDPHStr = $this.data("sazba-dph"),
                sazbaDPH = null;
            if (!sazbaDPHStr  &&  selectorSazbaDPH) {
                let
                    $sazbaDPH = $(selectorSazbaDPH);

                sazbaDPHStr = $sazbaDPH.is("input,select")
                    ? $sazbaDPH.val()
                    : $sazbaDPH.text();
            }

            if (sazbaDPHStr != '') {
                sazbaDPH = ron.utils.stringToFloat(sazbaDPHStr);
            }

            if (sazbaDPH == null) {
                return;
            }

            let
                dph = null,
                srcValueStr = $this.val(),
                srcValue = srcValueStr.trim() != ''
                    ? ron.utils.stringToFloat(srcValueStr.trim())
                    : null;

            if (selectorSDPH) {
                dph = srcValue != null
                    ? srcValue * sazbaDPH / 100
                    : null;

                $(selectorSDPH).val(srcValue != null
                    ? ron.utils.formatFloat(srcValue * (100 + sazbaDPH) / 100)
                    : ''
                );
            } else if (selectorBezDPH) {
                dph = srcValue != null
                    ? srcValue * sazbaDPH / (100 + sazbaDPH)
                    : null;

                $(selectorBezDPH).val(srcValue != null
                    ? ron.utils.formatFloat(srcValue / (100 + sazbaDPH) * 100)
                    : ''
                );
            }

            if (selectorDPH) {
                let
                    $DPH = $(selectorDPH),
                    dphStr = srcValue != null
                        ? ron.utils.formatFloat(srcValue / (100 + sazbaDPH) * 100)
                        : '';

                if ($DPH.is("input,select")) {
                    $DPH.val(ron.utils.formatFloat(dph))
                } else {
                    $DPH.text(ron.utils.formatFloat(dph))
                }
            }
        };


    $(function() {
        $("body")
            .on("change", ".prepocet-dph", provedPrepocetDPH);
    })
})(jQuery);
(function($) {
    function forEachRow($form, prefix, sloupec, callback) {
        let cnt = $form.find("input[name=" + prefix + "POCET_RADKU]").val();

        for (let i = 0;  i < cnt;  i ++ ) {
            let
                idpp = $form.find("input[name=" + prefix + "IdPP_" + i + "]").val(),
                $input = $('input[name="' + prefix + idpp + '_' + sloupec + '"]');
                callback($input);
        }
    }
    function prepocitejSoucet($form, prefix, sloupec, timeFormat) {
        let
            limit = $form.find("input[name=" + prefix + "limit_" + sloupec + "]").val(),
            soucet = 0;

        forEachRow($form, prefix, sloupec, function($input) {
            let
                hodnotaStr = $input.val(),
                hodnota = timeFormat
                    ? ron.utils.timeStringToFloat( hodnotaStr )
                    : ron.utils.stringToFloat( hodnotaStr );
            if ( hodnota ) {
                soucet = soucet + hodnota;
            }
        });

        let
            $div = $("#" + prefix + 'soucet_' + sloupec),
            digitsStr = $div.data('digits'),
            digits = digitsStr ? parseInt(digitsStr) : 2;

        $div.html(
            "<b>" +
            (timeFormat
                ? ron.utils.floatToTimeString(soucet)
                : ron.utils.formatFloat(soucet, digits)) +
            "</b>");

        if (limit != -1) {
            let zbyva = limit - soucet;

            $("#" + prefix + "zbyvadolimitu_" + sloupec).text(ron.utils.formatFloat(zbyva, digits));

            $("#" + prefix + "limit_" + sloupec).toggleClass("errorcolor", soucet > limit);
        }
    }
    function zapisPuvodniHodnotu($element) {
        if ($element.data('puvodni-hodnota') === null  ||  $element.data('puvodni-hodnota') === undefined) {
            let val = $element.val();

            if (val === undefined ||  val === null) {
                val = "";
            }
            $element.data('puvodni-hodnota', val );
        }
    }
    function editace($e) {
        let $this = $(this); // edit

        $this.addClass("mesicniEditovana");

        let
            timeFormat = $this.is(".inputTime"),
            $table = $this.closest("table"),
            prefix = $table.data("ron-prefix"),
            $form = $this.closest("form"),
            sloupec = $this.data('ron-index');

        prepocitejSoucet($form, prefix, sloupec, timeFormat);
    }


    function editacePoznamky($e) {
        $(this).addClass("mesicniEditovana");
    }


    function headerMenu() {
        let
            $menu = $("#editaceHromadnaMenu"),
            $that = $(this); // bunka zahlavi, na kterou se kliklo


        function onMenuItemClick() {
            let
                index = $that.data("index"),
                $form = $that.closest("form"),

                $table = $that.closest("table"),
                prefix = $table.data("ron-prefix"),

                $this = $(this), // polozka menu

                timeFormat = false;


            function nastavZadanouHodnotu() {
                let
                    jenPrazdne = $("#editaceHromadnaDialogJenPrazdne").prop("checked"),
                    hodnota = $("#editaceHromadnaDialogHodnota").val();

                forEachRow($form, $table.data("ron-prefix"), index, function($element) {
                    if (!$element.is('[readonly]')) {
                        zapisPuvodniHodnotu($element);
                        if (!jenPrazdne || $element.val() == "") {
                            $element
                                .val(hodnota)
                                .addClass("mesicniEditovana");
                        }
                    }
                });
            }


            function provedAkci() {
                switch ($this.data("ron-action")) {
                    case "original" :
                        forEachRow($form, $table.data("ron-prefix"), index, function ($element) {
                            if ($element.is(".inputTime")) {
                                timeFormat = true;
                            }

                            if ($element.data("puvodni-hodnota") !== null && $element.data("puvodni-hodnota") !== undefined) {
                                $element
                                    .val($element.data("puvodni-hodnota"))
                                    .removeClass("mesicniEditovana");
                            }
                        });
                        break;

                    case "smazat" :
                        forEachRow($form, $table.data("ron-prefix"), index, function($element) {
                            if (!$element.is('[readonly]')) {
                                if ($element.is(".inputTime")) {
                                    timeFormat = true;
                                }

                                zapisPuvodniHodnotu($element);
                                $element
                                    .val("")
                                    .addClass("mesicniEditovana");
                            }
                        });
                        break;

                    case 'nastavit' :
                        nastavZadanouHodnotu();
                        break;
                }

                prepocitejSoucet($form, prefix, index, timeFormat);
            }



            if ($this.data("ron-question")) {
                ron.confirm($this.data("ron-question"), provedAkci);
            } else if ($this.data("ron-action") === "nastavit") {
                let $menuItem = $this;

                $("#editaceHromadnaDialogNazevSloupce").text($that.text());
                $("#editaceHromadnaDialogHodnota").val("");

                $("#editaceHromadnaDialogOK")
                    .off("click")
                    .on("click", function() {
                        $("#editaceHromadnaDialogSloupec").dialog("close");
                        provedAkci.call($menuItem);
                    });

                $("#editaceHromadnaDialogSloupec").dialog({
                    modal: true,
                    width: "auto",
                    height: "auto"
                });
            } else {
                provedAkci($this.data("ron-action"));
            }
        }

        $menu.ronPopupMenu({
            attachToElement: $that,
            onClick: onMenuItemClick
        });
    }

    function initForm() {
        let $this = $(this);

        $this
            .on("click", ".menuHromadne", headerMenu)
            .on("focus", ".editaceMP, .editaceMV, .editacePoznamky", function() { zapisPuvodniHodnotu($(this)); })
            .on("change", ".editaceMP", editace)
            .on("change", ".editaceMV", editace)
            .on("change", ".editacePoznamky", editacePoznamky);

    }


    $(function() {
        $(".editaceMesicnichHromadna").each(initForm);
    });
})(jQuery);

$(function() {

    var
        vyhledatOborVzdelaniClick = function() {
            console.log("JSME TU");
            let
                url = "https://www.obory-vzdelani.cz",
                $this = $(this),
                $mistoStudia = $($this.data("misto-studia-selector")),
                $kodVzdelani = $($this.data("kod-vzdelani-selector")),
                $datumUkonceni = $($this.data("datum-ukonceni-selector")),
                zahranici = $mistoStudia.val() == "1";


            url += zahranici
                ? "/misto-Z"
                : "/misto-CR";

            let
                rok = $datumUkonceni.val().split('.')[2];

            if (rok) {
                url += "/rok-" + rok;

                let
                    kod = $kodVzdelani.val(),
                    typVzdelani = kod
                        ? parseInt(kod)
                        : null;

                if (typVzdelani) {
                    switch (parseInt(typVzdelani)) {
                        case 3:
                        case 4:
                        case 5:
                        case 6:
                        case 7:
                            url += zahranici ? "/typ-SSC" : "/typ-SSB";
                            break;

                        case 8:
                        case 9:
                        case 10:
                            url += zahranici ? "/typ-SSC" : "/typ-SSS";
                            break;

                        case 11:
                            url += zahranici ? "/typ-VSC" : "/typ-VOS";
                            break;

                        case 12:
                            url += zahranici ? "/typ-VSC" : "/typ-VSB";
                            break;

                        case 13:
                            url += zahranici ? "/typ-VSC" : "/typ-VSM";
                            break;

                        case 14:
                            url += zahranici ? "/typ-VSC" : "/typ-VSD";
                            break;
                    }
                }
            }

            window.open(url, "_blank");
            $($this.data("data-obor-vzdelani-ispv-selector")).focus();
        };

    $("body")
        .on("click", ".vyhledat-obor-vzdelani", vyhledatOborVzdelaniClick);
});
(function($) {

    function Priloha() {
        this.id = 0;        // id v ramci kurzu
        this.nazev = '';
        this.type = ''; // image/document/video/audio/unknown
    }


    function zobrazPrilohy(prilohy) {
        let
            $this = $(this),
            url = $this.data("download-url");
        function zobrazPrilohu(priloha) {
            $("<li/>")
                .text(priloha.nazev)
                .addClass("media-item")
                .data("ron-id", priloha.id)
                .data("ron-url", url + "&%DOWNLOAD%&priloha=" + priloha.id)
                .data("ron-type", priloha.type)
                .appendTo($this)
            ;
        }


        $this.empty();

        for (let i = 0; i < prilohy.length; i++) {
            zobrazPrilohu(prilohy[i]);
        }
    }
    function loadPrilohy() {
        let
            $this = $(this),
            url = $this.data("prilohy-url");

        $.ajax(url)
            .done(function(data) {
                if (data.result === "OK") {
                    $this.zobrazPrilohy(data.prilohy);
                } else {
                    ron.showError(data);
                }
            })
            .fail( function(jqXHR) {
                ron.logAjaxError(jqXHR, "Pri nacitani priloh doslo k chybe!");
            });
    }


    $.fn.extend({
        loadPrilohy: loadPrilohy,
        zobrazPrilohy: zobrazPrilohy
    });

    $(function() {
        $(".prilohy-container")
            .each(loadPrilohy);
    });
})(jQuery);
(function($) {
    let $prilohaTargetFocus = null;

    function onInputFocus() {
        let $this = $(this);

        $prilohaTargetFocus = $this.is(".priloha-target")
            ? $this
            : null;
    }
    function insertHtmlIntoTextInput() {
        let
            text,
            $this = $(this),
            id = $this.data("ron-id"),
            typPrilohy = $this.data("ron-type"),
            url = $this.data("ron-url");

        if (!id) {
            return;
        }

        if (typPrilohy  &&  url) {
            switch (typPrilohy) {
                case "image" :
                    text = '<img src="' + url + '"/>';
                    break;

                case "video" :
                    break;

                default :
                    text =
                        '<a target="_blank" href="' + url + '">' +
                        ron._('Stahnout_prilohu') +
                        '</a>';
            }
        }

        if (text) {
            let originalText = $prilohaTargetFocus.val();
            $prilohaTargetFocus.val(
                originalText.substring(0, $prilohaTargetFocus.get(0).selectionStart) +
                text +
                originalText.substring($prilohaTargetFocus.get(0).selectionStart)
            );
        }
    }


    function insertNodeIntoEditor(editorId) {
        let
            $this = $(this),
            id = $this.data("ron-id");

        if (!id) {
            return;
        }

        let
            ed = tinyMCE.get(editorId),
            range = ed.selection.getRng(),
            newNode = null,
            url = $this.data("ron-url");

        switch ($this.data("ron-type")) {
            case "image" :
                newNode = ed.getDoc().createElement("img");
                newNode.src = url;
                break;

            case "video" :
                newNode = ed.getDoc().createElement ( "video" );
                newNode.controls = "controls";
                newNode.width = 640;
                newNode.height = 480;

                let sourceNode = ed.getDoc().createElement ( "source" );
                sourceNode.src = url;
                newNode.appendChild(sourceNode);
                break;

            default :
                newNode = ed.getDoc().createElement("a");
                newNode.href = url;
                newNode.textContent = ron._('Stahnout_prilohu');
                newNode.target = "_blank";
        }

        range.insertNode(newNode);

    }
    function prilohaDblClick() {
        let
            $this = $(this),
            editorId = $this.parent().data("editor-id");

        if (editorId) {
            insertNodeIntoEditor.call(this, editorId);
        } else if ($prilohaTargetFocus  &&  $prilohaTargetFocus.length) {
            insertHtmlIntoTextInput.call(this);
        }
    }

    $(function() {
        $(document.body)
            .on("focus", "input", onInputFocus)
            .on("focus", "textarea", onInputFocus)
            .on("dblclick", ".prilohy-container li", prilohaDblClick);
    });
})(jQuery);

$(function() {
    var
        nastavPriznaky = function($priznaky, data) {
            $priznaky
                .removeClass("pritomen")
                .removeClass("nepritomen");

            $priznaky.each(function() {
                let
                    $this = $(this),
                    idpp = $this.data("idpp"),
                    cssClass = "";

                if (data[idpp]) {
                    cssClass = data[idpp].pritomnost ? "pritomen" : "nepritomen";
                }

                if (cssClass) {
                    $this
                        .addClass(cssClass)
                        .prop("title", data[idpp].popisoperace + ": " +  data[idpp].datumcasoperace);
                }
            });
        },

        nactiPritomnost = function($container, callBack) {
            let
                $priznaky = $container.find(".pritomnost_info"),
                url = $container.data('ron-pritomnost-url');

            if (!$priznaky.length) {
                if (callBack) {
                    setTimeout(callBack, 1);
                }
                return;
            }

            if (url) {
                $.ajax(url)
                    .done(function (data) {
                        nastavPriznaky($priznaky, data.data);
                    })
                    .fail(function (jqXHR) {
                        console.log(jqXHR.responseText);
                    })
                    .always(function () {
                        if (callBack) {
                            callBack();
                        }
                    });

            }
        },

        $containers = $(".pritomnost-container"),
        index = null,

        nactiDalsiPritomnost = function() {
            index = (index == null) ? 0 : index + 1;

            if (index < $containers.length) {
                nactiPritomnost($containers.eq(index), nactiDalsiPritomnost);
            } else {
                index = null;
                setTimeout(nactiDalsiPritomnost, 120000);
            }
        };


    if ($containers.length) {
        setTimeout(nactiDalsiPritomnost, 2000);
    }

});

$(function() {
    var
        $cardInputs = $(".rd-reader"),
        kodIdMedia = "",
        kodMediaTimer = null,
        kodMediaTimeout = 200,
        minimalCodeLength = 5,
        readMediumTimeout = function() {
            kodIdMedia = "";
        },


        setReaderTimeout = function(calculateTimeout) {
            if (calculateTimeout) {
                var $timeOutStr = $cardInputs.data('timeout');
                if ($timeOutStr) {
                    kodMediaTimeout = parseInt($timeOutStr);
                }
            }

            kodMediaTimer = setTimeout(readMediumTimeout, kodMediaTimeout);
        },

        clearReaderTimeout = function() {
            if (kodMediaTimer) {
                clearTimeout(kodMediaTimer);
                kodMediaTimer = null;
            }
        },


        readerAutoSubmit = function() {
            var $minimalLengthStr = $cardInputs.data('minimal-code-length');

            minimalCodeLength = $minimalLengthStr
                ? parseInt($minimalLengthStr)
                : 0;
            if (kodIdMedia.length >= minimalCodeLength) {
                $cardInputs.val(kodIdMedia);
                var $autoSubmitInput = $cardInputs.filter("[data-ron-autosubmit]").first();
                if ($autoSubmitInput.length) {
                    $autoSubmitInput.closest("form").submit();
                }
            }
        },


        readerInputKeyPress = function(e) {
            clearReaderTimeout();

            if (e.which == 13) {
                readerAutoSubmit();
                kodIdMedia = "";
            } else {
                setReaderTimeout(kodIdMedia == ""); // pokud se jedna o prvni znak, tak zjisti minimalni timeout
                kodIdMedia = kodIdMedia + e.key;
            }
        };
    if ($cardInputs.length) {
        $("body")
            .on("keypress", readerInputKeyPress);
    }
});


(function() {
    let $zobrazenyNahled = null; // SE - doplneno skryti obrazku, pokud se zobrazi jiny

    function hideFoto() {
        $(this).hide();
        $zobrazenyNahled = null;
        return false;
    }


    function ronFotoClick() {
        if ($zobrazenyNahled) {
            $zobrazenyNahled.hide();
        }

        let
            $this = $(this),
            $imgElement = $this.find("img"),
            $boxElement = $this.data("ronfoto-box-element");

        if (!$boxElement) {
            $boxElement = $("<div/>")
                .addClass("ronFoto_full")
                .append(
                    $("<img/>")
                        .attr("src", $imgElement.prop("src"))
                        .attr("alt",$imgElement.prop("alt"))
                )
                .on('click', hideFoto);

            $this.before($boxElement);
            $this.data("ronfoto-box-element", $boxElement);
        }

        $boxElement
            .show()
            .css('left', $this.position().left - (($boxElement.width() - $this.width()) / 2))
            .css('top', $this.position().top - (( $boxElement.height() - $this.height()) / 2))

        $zobrazenyNahled = $boxElement;
    }

    $(function() {
        $("body")
            .on("click", ".ronFoto", ronFotoClick);
    })
})();
// });