<?php
/**
 * User: stanislav.elbl, 7.2.2015
 */

namespace RonPortal;

use Ron\Controls\ComboBox;
use Ron\DebugException;
use Ron\GuiUtils;
use Ron\Http\App;
use Ron\Http\Csrf;
use Ron\MessageManager;
use Ron\StringUtils;
use RonPortal\Dokumenty\DokumentUploadForm;
use RonPortal\Dokumenty\DokumentyUtils;

/** @var DokumentUploadForm $this */

if (!$this || !$this ->database) {
    throw new DebugException('Chyba ve formulari pro vlozeni noveho dokumentu - neni nastavena database!');
}

?>

        <?= Csrf::csrfHiddenInput($this ->csrfRequestId, ['class' => 'documentUploadInput']) ?>

        <?php
            if ($this ->hiddenFields)
                foreach($this ->hiddenFields as $fieldName => $fieldValue) {
        ?>
                <input type="hidden" class="documentUploadInput" name="<?= $fieldName ?>" value="<?= $fieldValue ?>" />
        <?php
                }
        ?>

        <div>
            <?php if (is_null($this->typDokumentu)) { ?>
            <div class="row">
                <div class="col col-12 col-sm-4 caption required"><?= \Ron\ronText('Typ') ?></div>
                <div class="col col-12 col-sm-8">
                    <?php
                        $combo = new ComboBox('typ');
                        $combo ->dataTypeComparison = false;
                        try {
                            if (is_null($this->kategorieDokumentu)) {
                                $combo->loadData($this->database, 'SELECT Kod, Popis FROM TypDokumentu WHERE ZobrazitNaIntrawebu = 1 AND Kod >= 0 ORDER BY Kod', null);
                            } else {
                                $params = $this->database->createParameters();
                                $combo->loadData($this->database,
                                    'SELECT Kod, Popis FROM TypDokumentu' .
                                    ' WHERE ZobrazitNaIntrawebu = 1 AND Kod >= 0 AND KategorieDokumentu = ' . $params->addParameter($this->kategorieDokumentu) .
                                    ' ORDER BY Kod',
                                    null, $params);
                            }
                        } catch (\Exception $exception) {
                            MessageManager::addErrorMessage(StringUtils::fromUTF8('Chyba pri nacitani typu dokumentu. ') . $exception->getMessage());
                        }
                        $combo ->className .= ' documentUploadInput form-input';
                        $combo ->render();
                    ?>
                </div>
            </div>
            <?php } ?>

            <div class="row">
                <div class="col col-12 col-sm-4 caption required"><?= \Ron\ronText('Popis') ?></div>
                <div class="col col-12 col-sm-8">
                    <input type="text" class="documentUploadInput form-input ronform-field" name="popis" data-ronform-default-value="" maxlength="160"/>
                </div>
            </div>

            <div class="row">
                <div class="col col-12 col-sm-4 caption"><?= \Ron\ronText('Nahrat_soubor') ?></div>
                <div class="col col-12 col-sm-8">
                    <input type="file" id="dokument_filename" class="form-input ronform-field" name="soubor" data-ronform-default-value="" <?= DokumentyUtils::fileInputAcceptAttribute() ?>>
                </div>
            </div>

            <?php if ($this ->sqlPripojeniStarsiho) { ?>
                <div class="row" id="dokument_pripojit_nebo">
                    <div class="col col-0 col-sm-4"></div>
                    <div class="col col-12 col-sm-8"><?= \Ron\ronText('Nebo') ?></div>
                </div>
                <div class="row" id="dokument_pripojit_starsi">
                    <div class="col col-12 col-sm-4 caption"><?= \Ron\ronText('Pripojit_starsi_dokument') ?></div>
                    <div class="col col-12 col-sm-8">
                        <?php
                            $combodata = [' '];
                            try {
                                $cursor = $this->database->getSqlResult($this->sqlPripojeniStarsiho);
                                while ($row = $cursor ->fetch()) {
                                    $combodata[$row[0]] = StringUtils::format('date', $cursor ->stringToTimestamp($row[2])) . ' - ' . $row[1];
                                }
                                $cursor ->close();
                            } catch (\Exception $exception) {
                                MessageManager::addErrorMessage('Chyba pri nacitani zaznamu pro pripojeni dokumentu. ' . $exception->getMessage());
                            }

                            ComboBox::renderComboFromArray($combodata, 'pripojitdokument', '', ['id' => 'vyberStarsihoDokumentu', 'class' => 'form-input documentUploadInput']);
                        ?>
                    </div>
                </div>

            <?php } ?>

            <?php if( $this  &&  method_exists($this, 'dalsiRadkyKDokumentu') ) {
                $this ->dalsiRadkyKDokumentu();
            } ?>
        </div>
